;----------------------------------------------------
; Disassembly of the Thayer's Quest ROMs
;       by Jeff Kulczycki, Jun 19, 2001
;----------------------------------------------------
;
;----------------------------------------------------
;    RAM VARIABLES (8k RAM at A000-BFFF)
;----------------------------------------------------
;    Address      Description
;----------------------------------------------------     
;   A000          OUT (4) Speech Register 0: Duration/Phonetic 
;   A100          OUT (3) Speech Register 1: Inflection 
;   A200          OUT (2) Speech Register 2: Speech Rate
;   A300          OUT (1) Speech Register 3: Amplitude
;   A400          OUT (0) Speech Register 4: Filter Frequency
;   A500          Holds Copy of A000
;----------------------------------------------------
;   A604-A605     Temp pointer to start of Speech Buffer
;   A608-A609     Pointer to A400
;   A60A-A60B     Unknown
;   A60E          Unknown
;   A612-A613     Save Phoneme entry starting location
;   A614          Number of characters in Speech Buffer 
;   A615          Unknown - speech, characters, timer
;   A618          Marker (0,1)
;   A619
;   A61C          Z_Adder (+1,-1)
;   A61D          X_Adder (+1,-1)
;   A61F          A100 Speech Control Code (F0-FF)
;   A620          Backslash Flag (1 = backslash in speech buffer, 0 = no backslash)
;   A621          Question Flag, checks occurance of "WH" in speech buffer
;   A630          Unknown
;   A63A          Equations: Number of chacters to the right of the equals sign
;   A641          Pointer to End of Speech Buffer
;   A64A          Length of Player's (full) Name 
;   A64B-A68A     String containing Player's (full) Name
;   A68B          Length of Player's First Name
;   A68C-A6CA     String containing Player's First Name
;   A6CB-A6CE     Copy of score
;   A6CF          Word Properties (Plural, Inflection Level, etc.)
;   A6D0-A6D2     Speakable number (n) in digits
;   A6D3          Unknown
;   A6D4-A6D5     Previous phrase pointer to avoid repeating same phrase
;   A6D6          Ring Buffer 0-3 to keep track of repeated phrases
;   A6D9          Temp location:  Save Timer
;                                 Save word length for vulgarities
;   A782    .0
;           .1
;           .5
;           .7 
;   A783    .4    Coin Counter Hardware Increment 
;           .5    Set LDPlayer data bus as Input
;           .6    LDPlayer ENTER
;           .7    LDPlayer INT/EXT
;   A784          Command Byte to LDPlayer
;   A787          Number of SEARCH Retries
;   A788          Attract Mode Count (1-8)
;   A7B5-A7B7     BCD, Number after converted to BCD
;   A794-A796     Number awaiting conversion to BCD
;   A79A    .3    0 = PR-7820, 1 = LD-V1000
;         
; ---------------------------------------------------
;  Saved Game Banks 
; ---------------------------------------------------
;   A800-A9FF     SAVED GAME Bank 1
;   AA00-ABFF     SAVED GAME Bank 2
;   AC00-ADFF     SAVED GAME Bank 3
;   AE00-AFFF     SAVED GAME Bank 4
;   B000-B1FF     SAVED GAME Bank 5
;   B200-B3FF     SAVED GAME Bank 6
;   B400-B5FF     SAVED GAME Bank 7
;   B600-B7FF     SAVED GAME Bank 8
;   B800-B9FF     SAVED GAME Bank 9
;   BA00-BBFF     SAVED GAME Bank 10
; ---------------------------------------------------
;    Current Working BANK area        
; ---------------------------------------------------
;   BC00          Bank Number of current SAVED GAME 
;   BC01          Unknown
;   BC03          Buffer pointer to 32
;   BC24-BC64     Player's Full Name? LABEL
;   BC65-BC6A     6 bytes get copied from BE27
;   BC6B-BC71     6 bytes get copied from BE27
;   BC80    .0    0 = Audio Track1, 1 = Audio Track2
;   BC81          Scene Index
;   BC82
;   BC83-BC84     Scene Jumpers
;   BC85-BC86     Scene Jumpers
;   BC87-BC9F     Scene Jumpers (BC83)
;   BCA0-BCBA     Items in Inventory
;           .0    1 = Item is valid (has key associated)
;           .1    1 = Item Held
;           .2    1 = ?
;   BCC0          inventory2?
;   BCE0          Index to Health Table (C97E) <Default 08h>
;   BCE1          Wounds/Health
;   BCE2-BCE4     Score
;   BCE5          xxx Timer Control Register
;           .0    1 = Timer ON, 0 = Timer OFF
;           .1    1 = Timer Expired, 0 = Not expired
;   BCE6-BCE7     xxx Timer Value
;   BCE8          Number of Lives
;   BCF0-BDFF     Hints given to player
; ---------------------------------------------------
;   BE00          Index to Routine (Table1) 1 thru 8
;   BE01    .0    1 = Exit Main Loop
;           .1    1 = SAVE GAME in progress
;           .2 
;           .6    Audio Status 0 = Single Channel,1 = Stereo 
;           .7    Audio Source 0 = AUDIO1, 1 = AUDIO2
;   BE02          Index to Routine (Table2)
;   BE03    .0    1 = Reset Main Loop
;           .1    REPLAY
;           .2    1 = Combine Mode enabled, waiting for object selection
;           .3    1 = Drop Mode enabled, waiting for object selection        
;           .4     0 = Audio Track1, 1 = Audio Track2
;   BE04          Game Timer Control Register
;           .0    1 = Timer ON, 0 = Timer OFF
;           .1    1 = Timer Expired, 0 = Not expired
;   BE05-BE06     Game Timer Value
;   BE07          Programmable Timer Control Register
;           .0    1 = Timer ON, 0 = Timer OFF
;           .1    1 = Timer Expired, 0 = Not expired
;   BE08-BE09     Programmable Timer Value
;   BE0A          Keyboard Character Pressed
;   BE0B    .0    Keyboard Buffer Indicator
;           .1    Unknown
;   BE0C    .0-.4 Unknown
;           .5-.7 Unknown
;   BE0D          Number of Credits, Tens/Ones
;   BE0E          Number of Credits, Hundreds
;   BE0F          Hold DIP Switch A
;   BE10          Coin Slot 1 Debounce
;   BE11          Coin Slot 2 Debounce
;   BE12          Unknown
;   BE13-BE14     Number of
;   BE15-BE16     Temp BANK address 
;   BE17    .0    Unknown
;           .7    Unknown
;   BE18          Temporary RAM Spot
;   BE23          DecisionTimer Control Register
;           .0    1 = Timer ON, 0 = Timer OFF
;           .1    1 = Timer Expired, 0 = Not expired
;   BE24-BE25     DecisionTimer Value    
;   BE27-BC2C     Unknown -important-
;   BE2D-BE2F     Initials - "RDI"
;   BE30
;   BE31-BE37     Unknown
;   BE44-BE46     score, ranking?
;   BE48          Timer Register
;           .0
;           .7    ??
; ---------------------------------------------------
;  Scoreboard Output Port is F6/F7, Data as follows
;  where x is the digit to store
; ---------------------------------------------------
;   0x   Player1 Game time Remaining 1
;   1x   Player1 Game time Remaining 10
;   2x   Player1 Game time Remaining 100
;   3x   Player1 Game time Remaining 1000
;   4x   Player1 Game time Remaining 10000
;   5x   Player1 Game time Remaining 100000
;   6x   Credits 10
;   7x   Credits 1
;  x = [0,1,2,3,4,5,6,7,8,9]
; ---------------------------------------------------
; INPUT/OUTPUT PORTS 
; ---------------------------------------------------
;     Address      Description
;       00          Unknown
;       01          Unknown
;       02          Unknown
;       03          Unknown
;       04          Unknown
;       20          Unknown
;       80          Unknown
;       C0          Reset Keyboard Input Ready
;       A0          Unknown
;       E0          Unknown
;       F0          Input Byte from LDPlayer
;       F1          DIP Switch B/Coin Slots/READY Status
;       F2          DIP Switch A
;       F3          Interrupt Request
;       F4          Output Byte to LDPlayer
;       F5          Hardware
;          .4       Coin Counter Hardware Increment       
;          .5       Set LDPlayer data bus as Input
;          .6       LDPlayer ENTER
;          .7       LDPlayer INT/EXT
;       F6          Scoreboard
;       F7          Scoreboard
; ---------------------------------------------------
;       KEYBOARD CHARACTERS
; ---------------------------------------------------
;        F1 (080h)  CLEAR
;        F2 (081h)  none
;        F3 (082h)  ENTER
;        F4 (083h)  SPACE  
; ---------------------------------------------------
;       DEFINES
; ---------------------------------------------------

        org     0000h
        CPU     = Z180
        globals on


 


; ---------------------------------------------------
;                   Start of RESET
; ---------------------------------------------------
Reset:        
L0000:  DI                      ; Disable Interrupts 
        IM      1               ; Set Interrupt Mode 1
        LD      SP,0BFFFh       ; Set Stack Pointer to end of RAM
        OUT     (0C0h),A        ; Reset Keyboard Data Ready Interrupt
        OUT     (0A0h),A
        XOR     A               ; A = 0
        LD      (0BE43h),A      ; 
        LD      A,010h          ;
        LD      (0BE0Ch),A      ;
        OUT     (020h),A        ; Set Keyboard to Output

        LD      B,0FFh          ; 
L0017:  LD      A,(0BFFFh)      ;
        DJNZ    L0017           ; 

        CALL    L1247           ; Initialize Speech Chip
        LD      HL,0BE2Dh       ; Set up pointer to initials
        CALL    L003B           ; Check if initials are "RDI"
        JP      NZ, L00BA       ; Not RDI, so jump ahead
        LD      A,0F5h
        OUT     (080h),A        ; Write to Keyboard Interface (COP421L)
        LD      HL,0BE17h
        SET     7,(HL)
        JP      L0095           ;

; ---------------------------------------------------
;                  Not Used
; ---------------------------------------------------
        DB   0FFh, 0FFh, 0FFh, 0FFh   

; ---------------------------------------------------
;             IM 1 INTERRUPT JUMP POINT
; ---------------------------------------------------
L0038:  JP      L01B1           ; Goto IM 1 Interrupt Routine

; ---------------------------------------------------
;         Check if initials are "RDI"
;     HL   = Start of Initials  
; ---------------------------------------------------
L003B:  LD      A,'R'           ; Check for "R"
        CP      (HL)            ; Is first initial a "R"?
        RET     NZ              ; No, so return
        INC     HL              ; Point to next initial
        LD      A,'D'           ; Check for "D"
        CP      (HL)            ; Is middle initial a "D"?
        RET     NZ              ; No, so return
        INC     HL              ; Point to next initial
        LD      A,'I'           ; Check for "I"
        CP      (HL)            ; Is last initial a "I"?
        RET                     ; Return

; ---------------------------------------------------
;                       Not Used
; ---------------------------------------------------
    DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh 
    DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh 
    DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh 
    DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh

        HALT    



; ---------------------------------------------------
;              UNKNOWN Check for F5 in BE27          
; ---------------------------------------------------
L0067:  CALL    L21B3           ; Check if Programmable Timer expired 
        JR      Z,L0067         ; Still running so just loop
        LD      HL,0BE17h
        RES     7,(HL)
        BIT     0,(HL)
        RET     Z
        RES     0,(HL)
        CALL    L169E
        LD      HL,0BE27h
        LD      B,006h          ; Loop = 6
        LD      A,0F5h          ; Check for an F5
L0080:  CP      (HL)            ; Was there an F5?
        JR      Z,L0087         ; Yes, so erase all bytes        
        INC     HL              ; Check next byte
        DJNZ    L0080           ; Loop until all 6 bytes are checked        
        RET                     ; Not found so return
; ---------------------------------------------------
;   F5 is in important bytes so reset them to zero          
; ---------------------------------------------------
L0087:  XOR     A               ; Reset to zero
        LD      B,006h          ; Loop = 6
        LD      HL,0BE27h       ;
L008D:  LD      (HL),A          ; Reset to zero
        INC     HL              ;
        DJNZ    L008D           ; Loop until all bytes cleared        
        CALL    L16D8           ;
        RET                     ;





L0095:  LD      DE,00005h       ; Programmable Timer = 5
        CALL    L21A7           ; Set Programmable Timer
        EI                      ; Enable Interrupts 
        CALL    L0067           ; Wait until Timer expires..?
        LD      HL,0BE01h       ; Get GAME STATUS Register
        BIT     1,(HL)          ; Is there a game waiting to be saved?
        CALL    NZ,L0E10        ; Yes, so call Save Game


; ---------------------------------------------------
;       Clear out all 10 SAVED GAME Banks.
; ---------------------------------------------------
        LD      B,00Ah          ; Loop = 10
        LD      DE,00200h       ; DE = 200h
        LD      IY,0A800h       ; IY = Start of Game Banks
L00B0:  RES     7,(IY+001h)     ; Clear bit 7 of A801
        ADD     IY,DE           ; IY = IY + 200h
        DJNZ    L00B0           ; Loop until all banks marked                       
        JR      L00FD           ; Jump ahead


; ---------------------------------------------------
;         Clear Out RAM (A000-BFFF)
; ---------------------------------------------------
L00BA:  LD      HL,0A000h       ; Setup loop pointer A000
        LD      DE,0A001h       ; Setup Loop pointer A000+1
        LD      BC,01FFFh       ; Loop size is 2K
        LD      (HL),000h       ; Clear out RAM location
        LDIR                    ; Loop until all locations cleared

; ---------------------------------------------------
;         Label SAVED GAME Banks 1-10
; ---------------------------------------------------
        LD      DE,00200h       ; DE = 200, Size of Bank
        LD      A,001h          ; A = 1, First label
        LD      B,00Ah          ; Loop = 10, Number of Banks
        LD      IY,0A800h       ; IY = A800,AA00,AC00,etc. Start of Banks
L00D2:  LD      (IY+000h),A     ; Store label 
        INC     A               ; A = A + 1, Increment label
        ADD     IY,DE           ; IY = IY + 200h, Point to next Bank
        DJNZ    L00D2           ; Loop until all banks labeled
                          
        LD      A,0F5h          ;
        OUT     (080h),A        ; Write to Keyboard Interface (COP421L)
        LD      HL,0BE17h
        SET     7,(HL)
        LD      DE,00005h       ; Programmable Timer = 5
        CALL    L21A7           ; Set Programmable Timer
        EI                      ; Enable Interrupts

        CALL    L0067
        LD      HL,0A782h
        LD      (HL),0C1h
; ---------------------------------------------------
;                Store RDI initials
; ---------------------------------------------------
        LD      HL,0BE2Dh       ; Point to initials
        LD      (HL),'R'        ; Store "R" in first spot
        INC     HL              ; Point to next spot
        LD      (HL),'D'        ; Store "D" in next spot
        INC     HL              ; Point to next spot
        LD      (HL),'I'        ; Store "I" in next spot

; ---------------------------------------------------
;                 Blank out Scoreboard
; ---------------------------------------------------
L00FD:  LD      B,008h          ; Loop = 8
        LD      A,00Fh          ; A = 0F,1F,2F,3F,4F,5F,6F,7F
L0101:  OUT     (0F6h),A        ; Write A to F6
        OUT     (0F7h),A        ; Write A to F7
        ADD     A,010h          ; A = A + 10h
        DJNZ    L0101           ; Loop unit B = 0

; ---------------------------------------------------
;         Set Scoreboard Credits to "00"
; ---------------------------------------------------
        LD      A,060h          ; Send "0" to Credit Tens
        OUT     (0F7h),A        ; Output to Scoreboard
        LD      A,070h          ; Send "0" to Credit Ones
        OUT     (0F7h),A        ; Output to Scoreboard

; ---------------------------------------------------
;            Store DIP Switch reading
; ---------------------------------------------------
        IN      A,(0F2h)        ; Get DIP Switch A
        LD      (0BE0Fh),A      ; Store DIP A
; ---------------------------------------------------
;              Initialize Variables
; ---------------------------------------------------
        XOR     A               ; A = 0
        LD      B,A             ; B = 0
        LD      C,A             ; C = 0
        LD      (0BE04h),A      ; Clear Game Timer Control Register
        LD      (0BE05h),BC     ; Clear Game Timer
        LD      (0BE0Dh),A      ; Clear Number of Credits, Tens/Ones
        LD      (0BE0Eh),A      ; Clear Number of Credits, Hundreds
        LD      (0BE48h),A      ; Clear Timer Register

        CALL    0C08Bh          ; Wait until System is Initialized

        IN      A,(0F1h)        ; Get DIP Switch B
        BIT     0,A             ; Test B1, Diagnostic Mode
        JP      Z,L1F9B         ; Diagnostic Mode ON, so begin Diagnostics 
        JP      L0136           ; Jump ahead one line

; ---------------------------------------------------
;      Main Loop, Start with attract and cycle
;      thru all routines in the table
; ---------------------------------------------------
L0136:  CALL    LC07F           ; Start Running the Main Loop
        JR      L0136           ; Just loop here







; ---------------------------------------------------
;                Setup the Main Loop
; ---------------------------------------------------
L013B:  LD      HL,0BE00h       ; Routine Pointer
        LD      (HL),000h       ; Reset Main loop to 1st routine (attract mode)
; ---------------------------------------------------
;            HL = Pointer to Routine Table
; ---------------------------------------------------
L0140:  LD      A,(HL)          ; Get A from HL
        SLA     A               ; Multiply A by 2
        LD      HL,0C03Dh       ; Get Pointer to Jump table
        ADD     A,L             ; Add Index
        LD      L,A             ; Create new pointer
        JR      NC,L014B        ; Check if carry is clear
        INC     H               ; Create new pointer
; ---------------------------------------------------
;            Get Routine Address from Table A
; ---------------------------------------------------
L014B:  LD      E,(HL)          ; E = Jump Address (low byte)
        INC     HL              ; Point to next spot
        LD      D,(HL)          ; D = Routine Address (high byte)
        EX      DE,HL           ; Put Routine Address in HL
; ---------------------------------------------------
;                 Execute the Routine
; ---------------------------------------------------
        CALL    L01AF           ; Execute Routine
; ---------------------------------------------------
;       Check if we need to reset the Main Loop
; ---------------------------------------------------
        LD      HL,0BE01h       ; Get GAME STATUS Register
        BIT     0,(HL)          ;
        JR      Z,L0164         ;               
        RES     0,(HL)          ;
        XOR     A               ;
        LD      (0A64Ah),A      ; Clear Length of Full Name
        LD      (0A68Bh),A      ; Clear Length of First Name
        JR      L013B           ; Reset Main Loop
; ---------------------------------------------------
;            Loop through all the routines
; ---------------------------------------------------
L0164:  LD      HL,0BE00h       ; Get Routine
        INC     (HL)            ; Point to next Routine
        LD      A,008h          ; Total Number of Routines is 8
L016A:  CP      (HL)            ; Have we done all 8 Routines?
        JP      NZ,L0140        ; No, so execute the Routine
        LD      (HL),003h       ; Yes, so start over at Routine #3
        JP      L0140           ; Execute Routine







; ---------------------------------------------------
;            Get Jump Address from Table B
; ---------------------------------------------------
L0173:  LD      HL,0BE03h       ; 
        RES     1,(HL)          ;
        RES     3,(HL)          ; Clear Drop Mode
; ---------------------------------------------------
;                Stop DecisionTimer
; ---------------------------------------------------
        LD      HL,0BE23h       ; Get DecisionTimer Control Register
        LD      (HL),000h       ; Stop DecisionTimer
        LD      HL,0BE02h       ;
        LD      (HL),000h       ;                               
L0184:  LD      A,(HL)          ; Get Routine B Pointer
        SLA     A               ; Multiply by 2
        LD      HL,0C04Dh       ; Get Jump Table B
        ADD     A,L             ;
        LD      L,A             ;
        JR      NC,L018F        ;        
        INC     H               ;
L018F:  LD      E,(HL)          ;
        INC     HL              ;
        LD      D,(HL)          ;
        EX      DE,HL           ; Put Routine Address in HL
        CALL    L01AF           ; Execute Routine
        LD      HL,0BE03h       ; Get Register
        BIT     0,(HL)          ; Should we leave the main loop?
        JR      Z,L01A0         ; No, continue loop        
        RES     0,(HL)          ; Process request to leave loop 
        RET                     ; Leave main loop

L01A0:  LD      HL,0BE02h       ; Get Routine Index
        INC     (HL)            ; Point to next Routine
        LD      A,019h          ; There are #25 Routines
        CP      (HL)            ; Have we run all 25?
        JP      NZ,L0184        ; No, so keep looping
        LD      (HL),00Bh       ; Yes, so start over at Routine #11
        JP      L0184           ; Loop back




; ---------------------------------------------------
;           Jump to Address in HL           
; ---------------------------------------------------
L01AF:  JP      (HL)            ; Jump to address in HL
L01B0:  RET                     ; No need to return : Routine #7







; ---------------------------------------------------
;             IM 1 Interrupt Routine           
; ---------------------------------------------------
;    Save all registers before entering interrupt
; ---------------------------------------------------
L01B1:  PUSH    BC              ; Save BC Register
        PUSH    DE              ; Save DE Register
        PUSH    HL              ; Save HL Register
        PUSH    AF              ; Save AF Register
        PUSH    IX              ; Save IX Register
        PUSH    IY              ; Save IY Register
        IN      A,(040h)        ; Get Interrupt Request Status
        BIT     3,A             ; Are there interrupts pending?
        JR      NZ,L01C8        ; Yes, begin Interrupt routines
        XOR     A               ; A = 0
        OUT     (0E0h),A        ; Reset interrupt
        NOP                     ; Pause
        IN      A,(0E0h)        ; Reset interrupt
        JP      L0352           ; Jump to end of interrupt

; ---------------------------------------------------
;            Begin Interrupt Functions
; ---------------------------------------------------
L01C8:  BIT     4,A             ; Test for timer interrupt
        JP      NZ,L02AE        ; No timer interrupt, so do next check
        CALL    L0416           ; Decrement All Timers
        LD      A,(0BE13h)      ; Get Coin Counter Debounce
        OR      A
        JR      Z,L0213                 
        LD      C,A             ; C 
        LD      A,(0BE14h)
        BIT     7,A
        JR      Z,L01FB                 
L01DE:  DEC     A
        LD      (0BE14h),A
        AND     00Fh
        JR      NZ,L0213                
        LD      A,(0A783h)
        RES     4,A             ; Clear Coin Counter
        LD      (0A783h),A
        OUT     (0F5h),A        ; Write to Coin Counter Hardware
        XOR     A
        LD      (0BE14h),A
        DEC     C
        LD      A,C
        LD      (0BE13h),A
        JR      L0213                   
L01FB:  OR      A               ; Coin Counter Debounce at zero?
        JR      NZ,L020F        ; No, so skip ahead
        LD      A,083h
        LD      (0BE14h),A
        LD      A,(0A783h)      ;
        SET     4,A             ; Increment Coin Counter
        LD      (0A783h),A
        OUT     (0F5h),A        ; Write to Coin Counter Hardware
        JR      L0213                   

L020F:  LD      C,001h
        JR      L01DE                   

L0213:  LD      A,(0BE0Fh)      ; Get DIP Switch A 
        AND     007h            ; Test for Free Play
        JR      Z,L0282         ; Free Play set so skip ahead
        LD      HL,0BE04h       ; Get Game Timer Control Register
        BIT     1,(HL)          ; Has Game Timer expired?
        JR      NZ,L0249        ; No, so start new game        
        BIT     0,(HL)
        JR      Z,L0282                 
        LD      A,(0BE0Eh)
        OR      A
        JR      NZ,L0282                
        LD      A,(0BE0Dh)
        CP      003h
        JR      NC,L0282                
        LD      HL,0BE12h
        DEC     (HL)
        BIT     4,(HL)
        JR      Z,L0244
; ---------------------------------------------------
;                Blank out scoreboard 
; ---------------------------------------------------                         
        LD      A,06Fh          ; Blank in Credit Tens
        OUT     (0F7h),A        ; Output to Scoreboard
        LD      A,07Fh          ; Blank in Credit Ones
        OUT     (0F7h),A        ; Output to Scoreboard
        JR      L0282           ;        

L0244:  CALL    L0287           ; Update Credits on scoreboard
        JR      L0282             
L0249:  LD      (HL),001h       ; Start Game Timer
; ---------------------------------------------------
;     Get Time Units for Credit per DIP Settings
; ---------------------------------------------------
        LD      HL,002A0h       ; Point to Time Units Table
L024E:  DEC     A               ; Check DIP Setting
        JR      Z,L0255         ; Correct DIP Setting so award Time
        INC     HL              ; Increment Table Pointer
        INC     HL              ; Increment Table Pointer
        JR      L024E           ; Loop until DIP Setting found
; ---------------------------------------------------
;                 Award Time Units
; ---------------------------------------------------
L0255:  LD      A,(HL)          ; Get Time Unit Value
        INC     HL              ; Point to next spot
        LD      H,(HL)          ; Get Time Unit Value
        LD      L,A             ; HL = Time Unit Value
        LD      (0BE05h),HL     ; Update Game Timer
; ---------------------------------------------------
;             Subtract 1 Credit         
; ---------------------------------------------------
        LD      A,(0BE0Dh)      ; Get Number of Credits, Tens/Ones
        SUB     001h            ; Subtract 1 credit
        DAA                     ; Make into a decimal number
        LD      (0BE0Dh),A      ; Store Number of Credits, Tens/Ones
        LD      C,A             ; C = Number of Credits
        LD      A,(0BE0Eh)      ; Get Number of Credits, Hundreds
        SBC     A,000h          ; Subtract one if carry is set
        DAA                     ; Make into a decimal number
        LD      (0BE0Eh),A      ; Store Number of Credits, Hundreds
        OR      C               ; A = A OR C
        LD      C,A             ; C = A, Store Credits temporarily
        CALL    L0287           ; Update Credits on scoreboard
        LD      A,C             ; A = C, Get Credits
        OR      A               ; Any Credits?
        JR      NZ,L0282        ; Yes, some credits remain, so jump ahead         
; ---------------------------------------------------
;                No Credits Left
; ---------------------------------------------------
        LD      HL,0BE48h
        SET     7,(HL)
        LD      HL,0BE04h
        LD      (HL),000h       ; Stop Timer3

L0282:  OUT     (0A0h),A
        JP      L0352           ; Jump to end of interrupt




; ---------------------------------------------------
;        Send Number of Credits to Scoreboard           
; ---------------------------------------------------
L0287:  LD      A,(0BE0Dh)      ; Get Number of Credits
        AND     00Fh            ; Get lower nibble
        OR      070h            ; Store in Ones
        OUT     (0F7h),A        ; Output to Scoreboard
        LD      A,(0BE0Dh)      ; Get Number of Credits
        SRL     A               ; Shift byte right
        SRL     A               ; Shift byte right
        SRL     A               ; Shift byte right
        SRL     A               ; Shift byte right
        OR      060h            ; Store in Tens
        OUT     (0F7h),A        ; Output to Scoreboard
        RET                     ; Return




; ---------------------------------------------------
;               Time Unit Table   
; ---------------------------------------------------
L02A0:  .word   305  ;  30 seconds
        .word   458  ;  45 seconds
        .word   610  ;  60 seconds
        .word   712  ;  70 seconds
        .word   814  ;  80 seconds
        .word   966  ;  95 seconds
        .word  1119  ; 110 seconds
                  

; ---------------------------------------------------
;  Check for interrupts from Speech Chip and Keyboard   
; ---------------------------------------------------
L02AE:  BIT     2,A             ; Interrupt from Speech Chip?
        JR      NZ,L02B8        ; No, so skip speech stuff
        CALL    L1269           ; Send data to Speech Chip
        JP      L0352           ; Jump to end of interrupt
L02B8:  BIT     5,A             ; Interrupt from Keyboard?
        JR      NZ,L02C2        ; No, so skip keyboard stuff
        CALL    L0384           ; Process Keyboard Input
        JP      L0352           ; Jump to end of Interrupt

; ---------------------------------------------------
;              Check Coin Slots
; ---------------------------------------------------
L02C2:  IN      A,(0F1h)        ; Get DIP Switch B
        LD      C,A             ; C = DIP Switch B
        LD      HL,0BE10h       ; Coin Slot 1 Debounce Count
        BIT     4,C             ; Test Coin Slot 1
        CALL    L02D9           ; Call Coin Check
        LD      HL,0BE11h       ; Coin Slot 2 Debounce Count
        BIT     5,C             ; Test Coin Slot 2 
        CALL    L02D9           ; Call Coin Check
        OUT     (0F3h),A        ; Request External Interrupt?
        JR      L0352           ; Jump to end of Interrupt


; ---------------------------------------------------
;          Debounce Coin Slots
; ---------------------------------------------------
; Coin Slot must be pressed for 3 consecutive
; readings to register a coin insertion.
; ---------------------------------------------------
;      A = BE10, Debounce Coin Slot 1 Count
;      A = BE11, Debounce Coin Slot 2 Count
; ---------------------------------------------------
L02D9:  LD      A,(HL)          ; Get Debounce Count
        JR      Z,L0319         ; Coin Slot pressed, so skip ahead
        OR      A               ; Does Debounce Count = 0?
        RET     Z               ; Yes, so return
        CP      002h            ; Debounce = 2?
        JR      NZ,L02E4        ; No, so check if it is 3
L02E2:  INC     (HL)            ; Increment Debounce Count
        RET                     ; Return
L02E4:  CP      003h            ; Debounce = 3?
        JR      NZ,L0316        ; No, so skip ahead
        LD      A,003h          ; Add 3 Credits
        CALL    L0320           ; Award Credits and Time
        IN      A,(0F2h)        ; Get DIP Switch A
        BIT     3,A             ; Test A4, Coins per Credit
        JR      NZ,L030F            
        LD      A,(0BE0Eh)
        OR      A
        JR      NZ,L030F
        LD      A,(0BE0Dh)
        CP      006h            ; Are there 6 credits left?
        JR      NC,L030F 
        LD      A,(0BE04h)
        BIT     0,A             ; Timer3 still running?
        JR      NZ,L030F        ; Yes, so skip ahead
        LD      A,060h          ; Send "0" to Credit Tens
        OUT     (0F7h),A        ; Output to Scoreboard
        LD      A,070h          ; Send "0" to Credit Ones
        OUT     (0F7h),A        ; Output to Scoreboard
L030F:  LD      A,(0BE13h)      ; Get Number of Coins
        INC     A               ; Add 1 Coin
        LD      (0BE13h),A      ; Store Number of Coins  
L0316:  LD      (HL),000h       ; Reset Debounce Count to zero
        RET                     ; Return

L0319:  CP      002h
        JR      C,L02E2                 
        JR      NZ,L0316                
        RET     




; ---------------------------------------------------
;            Award Credits and Time
; ---------------------------------------------------
;      A = Number of Credits to add
; ---------------------------------------------------
L0320:  PUSH    BC              ; Save BC Register
        PUSH    HL              ; Save HL Register
        LD      C,A             ; C = A
        LD      A,(0BE0Dh)      ; Get Number of Credits
        ADD     A,C             ; Add to Number of Credits
        DAA                     ; Make into a decimal number
        LD      (0BE0Dh),A      ; Store number of credits
        LD      A,(0BE0Eh)      ; Get Number of Credits, hundreds
        ADC     A,000h          ; Add carry
        DAA                     ; Make into decimal number
        LD      (0BE0Eh),A      ; Store number of credits, hundreds
        CALL    L0287           ; Update Credits on scoreboard
        LD      A,(0BE0Fh)      ; Get DIP Switch A
        AND     007h            ; Test for Free Play
        JR      Z,L034F         ; Free Play set so skip ahead
; ---------------------------------------------------
;    Get Time Units for Credit per DIP Settings
; ---------------------------------------------------
        LD      HL,002A0h       ; Point to Time Units Table
L0341:  DEC     A               ; Check DIP Setting
        JR      Z,L0348         ; Correct DIP Setting so award Time
        INC     HL              ; Increment Table Pointer
        INC     HL              ; Increment Table Pointer
        JR      L0341           ; Loop until DIP Setting found
; ---------------------------------------------------
;                 Award Time Units
; ---------------------------------------------------
L0348:  LD      A,(HL)          ; Get Time Unit Value
        INC     HL              ; Point to next spot
        LD      H,(HL)          ; Get Time Unit Value
        LD      L,A             ; HL = Time Unit Value
        LD      (0BE05h),HL     ; Update Game Timer
L034F:  POP     HL              ; Restore HL Register
        POP     BC              ; Restore BC Register
        RET                     ; Return

; ---------------------------------------------------
;     Restore all registers upon leaving interrupt
; ---------------------------------------------------
L0352:  POP     IY              ; Restore IY Register
        POP     IX              ; Restore IX Register
        POP     AF              ; Restore AF Register
        POP     HL              ; Restore HL Register
        POP     DE              ; Restore DE Register
        POP     BC              ; Restore BC Register
        EI                      ; Enable Interrupts
        RETI                    ; Return from Interrupt









; ---------------------------------------------------
;              Read Keyboard Status
; ---------------------------------------------------
;     HL = ?
; ---------------------------------------------------
L035D:  SET     0,(HL)
        LD      A,(0BE0Ch)
        AND     01Fh
        OR      020h
        LD      (0BE0Ch),A
        OUT     (020h),A        ; Set Keyboard Mode to Input (20h)

L036B:  IN      A,(080h)        ; Get Data from Keyboard
        CP      0FAh            ; Is keyboard ready?
        JR      NZ,L036B        ; Wait here until ready
                
        OUT     (0C0h),A        ; Reset Keyboard Data Ready Interrupt
        LD      A,0F5h
        OUT     (080h),A        ; Write to Keyboard Interface (COP421L)
        LD      A,(0BE0Ch)
        AND     01Fh
        OR      000h
        LD      (0BE0Ch),A
        OUT     (020h),A
        RET     





; ---------------------------------------------------
;               Process Keyboard Input
; ---------------------------------------------------
L0384:  LD      HL,0BE17h
        BIT     7,(HL)
        JR      NZ,L035D        ; Keyboard not ready so diagnose
        LD      A,(0BE0Ch)
        AND     0E0h
        CP      080h
        JP      Z,L03DD
        CP      040h
        JP      Z,L03F7
        LD      HL,0BE0Bh       ; Get Keyboard Buffer
        RES     1,(HL)          
        IN      A,(080h)        ; Get character from Keyboard
        CP      0F0h
        JR      Z,L03BC                
        CP      0F5h
        JR      NZ,L03AD        
        SET     2,(HL)
        JR      L03BC                   
L03AD:  CP      0F3h
        JR      NZ,L03B5                
        RES     2,(HL)
        JR      L03BC                   
L03B5:  SET     1,(HL)          ; 
        SET     0,(HL)          ; Mark Keyboard buffer full
        LD      (0BE0Ah),A      ; Store character in Keypress location
L03BC:  LD      A,(0BE0Ch)      ;
        AND     01Fh
        OR      020h
        LD      (0BE0Ch),A
        OUT     (020h),A        ; Set Keyboard Mode to Input (20h)
L03C8:  IN      A,(080h)        ; Get character from Keyboard
        CP      0FAh
        JR      NZ,L03C8
        LD      A,(0BE0Ch)
        AND     01Fh
        OR      000h
        LD      (0BE0Ch),A
        OUT     (0C0h),A        ; Reset Keyboard Data Ready Interrupt
        OUT     (020h),A
        RET     

L03DD:  LD      HL,0BE17h
        SET     0,(HL)
        LD      A,(0BE0Ch)
        AND     01Fh
        OR      0A0h
        LD      (0BE0Ch),A
        OUT     (020h),A
L03EE:  IN      A,(080h)        ; Get character from Keyboard
        CP      0FAh
        JR      NZ,L03EE                
        OUT     (0C0h),A        ; Reset Keyboard Data Ready Interrupt
        RET     

L03F7:  LD      HL,0BE17h
        SET     0,(HL)
        IN      A,(080h)        ; Get character from Keyboard
        LD      (0BE26h),A
        LD      A,(0BE0Ch)
        AND     01Fh
        OR      020h
        LD      (0BE0Ch),A
        OUT     (020h),A        ; Set Keyboard Mode to Input (20h)

L040D:  IN      A,(080h)        ; Get status from Keyboard
        CP      0FAh            ; Check if keyboard ready
        JR      NZ,L040D        ; Keyboard not ready so loop
                
        OUT     (0C0h),A        ; Reset Keyboard Data Ready Interrupt
        RET                     ; Return







; ---------------------------------------------------
;               Decrement All Timers
; ---------------------------------------------------
L0416:  LD      HL,0BE23h       ; Point to DecisionTimer
        CALL    L0458           ; Decrement DecisionTimer
        LD      HL,0BE07h       ; Point to Programmable Timer
        CALL    L0458           ; Decrement Programmable Timer
        LD      HL,0BE04h       ; Point to Insert Coin Timer
        CALL    L0458           ; Decrement Insert Coin Timer 
; ---------------------------------------------------
;
; ---------------------------------------------------
        LD      HL,0BCE5h
        BIT     0,(HL)
        RET     Z
        CALL    L0458           ; Decrement Timer
        LD      HL,0BCE5h
        BIT     1,(HL)
        RET     Z
        RES     1,(HL)
        LD      HL,001D6h
        LD      (0BCE6h),HL

        LD      B,00Fh          ; 15 markers to check
        LD      HL,0BC9Fh       ;
L0444:  BIT     0,(HL)          ;
        DEC     HL              ;
        JR      Z,L0454         ;        
        CP      (HL)            ;
        JR      Z,L0454         ;        
        DEC     (HL)            ;
        PUSH    HL              ;
        LD      HL,0BCE5h
        SET     0,(HL)          ; Start timer
        POP     HL
L0454:  DEC     HL
        DJNZ    L0444           ; Loop until all markers checked        
        RET                     ; Return





; ---------------------------------------------------
;           Decrement Timer Routine
; ---------------------------------------------------
;      HL   = Pointer to Timer Control Register
;             where:
;                    00 = Timer Off
;                    01 = Timer Enabled
;                    02 = Timer Expired
;      HL+1 = Timer (Low Byte)
;      HL+2 = Timer (High Byte)
; ---------------------------------------------------
L0458:  BIT     0,(HL)          ; Is timer enabled?
        RET     Z               ; Timer not enabled so just leave
        XOR     A               ; Check if timer is zero
        INC     HL              ; Point to next Timer Byte
        CP      (HL)            ; Is Timer byte at zero?
        INC     HL              ; Point to next Timer Byte
L045F:  JR      NZ,L0469        ; Byte not at zero so decrement
        CP      (HL)            ; Next byte at zero?
        JR      NZ,L0469        ; Byte not at zero so decrement
        DEC     HL              ; Get Timer Control Register
L0465:  DEC     HL              ; Get Timer Control Register
        LD      (HL),002h       ; Mark Timer as "expired"
        RET                     ; Return
; ---------------------------------------------------
;     Timer is enable and running so decrement it
; ---------------------------------------------------
L0469:  LD      D,(HL)          ; Get MSB of Timer
        DEC     HL              ; Next byte
        LD      E,(HL)          ; Get LSB of Timer
        DEC     DE              ; Decrement Timer
        LD      (HL),E          ; Store LSB of Timer
        INC     HL              ; Next byte
        LD      (HL),D          ; Store MSB of Timer
        RET                     ; Return







; ---------------------------------------------------
;   Table A Routine #3:  Get Scene Data
; ---------------------------------------------------
;         BC81h = Scene Index
; ---------------------------------------------------
L0471:  LD      A,(0BC81h)      ; Get Scene Index
L0474:  LD      L,A             ; L = A
        XOR     A               ; A = 0
        LD      H,A             ; HL = Scene Index
        ADD     HL,HL           ; HL = HL * 2
        ADD     HL,HL           ; HL = HL * 2
        ADD     HL,HL           ; HL = HL * 2
        ADD     HL,HL           ; HL = HL * 2
        LD      C,L             ; Move pointer into BC
        LD      B,H             ; BC = HL * 16
; ---------------------------------------------------
;     Check which Audio Track is being used
; ---------------------------------------------------
        LD      HL,0BE03h       ; Get MODE Register 
        BIT     4,(HL)          ; Check which Audio Track
        JP      NZ,L04A3        ; Use Audio Track 2, so skip ahead
; ---------------------------------------------------
;              Use Audio Track 1 Data
; ---------------------------------------------------         
        LD      HL,0D000h       ; HL = Start of Scene Data (Audio Track 1)
        ADD     HL,BC           ; Add Scene Index
        PUSH    HL              ; Move Scene Pointer into IX
        POP     IX              ; IX = Scene Data + Scene Index
        LD      A,(IX+00Ah)     ; Get Val10
        AND     0E0h            ; Is bit set?
        JR      Z,L04AA         ;       
        CP      060h            ; Does Room require an item?
        LD      HL,0BC9Fh       ; Load Pointer to inventory
        JP      Z,L04D1         ; No item required, jump ahead
        CP      020h            ; Does Room contain an item?
        LD      HL,0BCC0h       ; Load Pointer to inventory2
        JP      Z,L04D1         ; Yes, Room has item, jump ahead
; ---------------------------------------------------
;             Use Audio Track 2 Data
; ---------------------------------------------------
L04A3:  LD      HL,0D800h       ; HL = Start of Scene Data (Audio Track 2)
        ADD     HL,BC           ; Add Scene Index
        PUSH    HL              ; Move Scene Pointer into IX
        POP     IX              ; IX = Scene Data + Scene Index
L04AA:  LD      HL,0BE03h       ;
        BIT     1,(HL)          ;
        JR      NZ,L04E3        ; 
        BIT     4,(IX+00Bh)     ; Is player dead?
        JR      Z,L04E3         ; Yes, so just return
        BIT     6,(IX+002h)
        JR      NZ,L04E3                
        LD      D,(IX+00Dh)     ; D = Wound value
        LD      A,(0BCE0h)      ; Get Health Pointer 
        SUB     D               ; Subtract health
        LD      (0BCE0h),A      ; Store new Health Pointer
        DEC     A
        JP      P,L04E3
        LD      A,(IX+00Ch)     ; Next scene
        JP      L0474           ; 

L04D1:  LD      A,(IX+00Ah)     ; Get Item needed
        AND     01Fh            ; Extract pertinent information
        ADD     A,L             ; Add item index to inventory index
        LD      L,A             ; Point to inventory
        JR      NC,L04DB        ; Skip for carry
        INC     H               ; Point to inventory
L04DB:  BIT     0,(HL)          ; Is item on 1 or 2?
        JP      NZ,L04A3        ; Yes, so use Scene Index2
        JP      L04AA           ; No, so continue with Index1
L04E3:  RET                     ; Return







; ---------------------------------------------------
;   Routine #15:  Check if Decision Timer is running 
; ---------------------------------------------------
L04E4:  BIT     7,(IX+00Bh)     ; Is scene timed? (Var0B)
        RET     Z               ; No, so return
        LD      HL,0BE23h       ; Get DecisionTimer Control Register
        BIT     1,(HL)          ; Is DecisionTimer running?
        RET     Z               ; No, so just return
        LD      (HL),000h       ; Stop DecisionTimer
        LD      A,(IX+00Ch)     ; Get next scene
        LD      (0BC81h),A      ;
        LD      HL,0BE03h       ;
        SET     0,(HL)          ;
        RES     4,(HL)          ; Set Audio Track 1
        RET                     ; Return





; ---------------------------------------------------
;                Start DecisionTimer
; ---------------------------------------------------
;           Load  Value and Start Timer
; ---------------------------------------------------
L04FF:  BIT     7,(IX+00Bh)     ; Is scene timed (Var0B)?
        RET     Z               ; No, so return
        LD      L,(IX+00Dh)     ; Get Timer Value (Var0D)
        LD      H,000           ; HL = Timer Value
        SLA     L               ; HL = HL * 2
        RL      H               ; Multiply Timer Value by 2
        LD      (0BE24h),HL     ; Store DecisionTimer Value
        LD      HL,0BE23h       ; Point to DecisionTimer Control Register
        LD      (HL),001h       ; Start DecisionTimer
        RET                     ; Return





; ---------------------------------------------------
;         Add Var09 to Scene Index? Unknown
; ---------------------------------------------------
L0516:  LD      A,(IX+009h)     ;
        AND     0F0h
        RET     Z
        SRL     A
        SRL     A
        SRL     A
        RES     0,A
        LD      HL,0BC81h       ; HL = Scene Index
        ADD     A,L
        LD      L,A
        JR      NC,L052C               
        INC     H
L052C:  RES     0,(HL)
        RES     1,(HL)
        DEC     HL
        LD      (HL),000h
        CALL    L05AC           ; A = Number of something
        CP      000h
        RET     NZ
        LD      HL,0BCE5h       ;
        LD      (HL),A          ;
        INC     HL              ;
        LD      (HL),A          ;
        INC     HL              ;
        LD      (HL),A          ;
        RET                     ;








; ---------------------------------------------------
;          Check (Routine #8)
; ---------------------------------------------------
L0542:  LD      A,(IX+009h)
        AND     00Fh
        RET     Z
        LD      B,A
        LD      HL,0C986h
        ADD     A,L
        LD      L,A
        JR      NC,L0551                
        INC     H
L0551:  LD      A,(HL)
        LD      C,A
        LD      A,B
        LD      HL,0BC81h
        SLA     A
        ADD     A,L
        LD      L,A
        JR      NC,L055E                
        INC     H
L055E:  BIT     0,(HL)
        RET     NZ
        DEC     HL
        LD      (HL),C
        INC     HL
        SET     0,(HL)
        RES     1,(HL)
        CALL    L05AC
        CP      001h
        RET     NZ
        LD      HL,0BCE5h
        SET     0,(HL)
        RET     






; ---------------------------------------------------
;   Table B Rountine #16:  Unknown
;     Check Locatons
;        BC82h-BC9Fh  
; ---------------------------------------------------
L0574:  XOR     A               ; A = 0
        LD      B,00Fh          ; B = 15 Loop
        LD      HL,0BC9Fh       ; HL = End of Marker
L057A:  BIT     0,(HL)          ; Test bit0 of Marker?
        DEC     HL              ; Point to previous Marker
        JR      Z,L0582         ; Bit0 is off, so next marker        
        CP      (HL)            ; Is next Marker zero?
        JR      Z,L0586         ; Yes, so jump ahead
L0582:  DEC     HL              ; Point to next marker
        DJNZ    L057A           ; Have all 8 Marker's been checked?       
        RET                     ; Return

; ---------------------------------------------------
;                Marker Match  B = 00 - 0F
; ---------------------------------------------------
L0586:  INC     HL
        RES     0,(HL)          ; Mark as set
        LD      HL,0C995h       ; Get Pointer to Marker Table
        LD      A,B             ; Index into Table 
        ADD     A,L             ; HL = HL + B
        LD      L,A             ; HL = HL + B
        JR      NC,L0592        ; HL = HL + B        
        INC     H               ; HL = HL + B
L0592:  LD      A,(HL)          ; Get new scene index from table
        LD      (0BC81h),A      ; Store new Scene Index 
        LD      HL,0BE03h
        SET     0,(HL)
        RES     4,(HL)          ; Set Audio Track 1
        CALL    L05AC
        CP      000h
        RET     NZ

        LD      HL,0BCE5h
        LD      (HL),A
        INC     HL
        LD      (HL),A
        INC     HL
        LD      (HL),A
        RET     








; ---------------------------------------------------
;       Count Number of something
; ---------------------------------------------------
;     Return A = Number of occurances of bit 0
; ---------------------------------------------------
L05AC:  XOR     A               ; Number= 0
        LD      B,00Fh          ; Loop = 15
        LD      HL,0BC83h
L05B2:  BIT     0,(HL)
        INC     HL
        INC     HL
        JR      Z,L05B9                 
        INC     A
L05B9:  DJNZ    L05B2                  
        RET     






; ---------------------------------------------------
;  Rountine #6:  Healing Place gives Full Strength
; ---------------------------------------------------
L05BC:  BIT     4,(IX+002h)     ; Is this is healing place?
        RET     Z               ; No, so return
        LD      A,(0BCE0h)      ; Get Health Pointer
        CP      008h            ; Is player full health?
        RET     Z               ; Yes, so return
        LD      A,008h          ; Make full health
        LD      (0BCE0h),A      ; Save Health Pointer
        LD      DE,0805Dh       ; Phrase="You Have Been Healed"
        CALL    L1363           ; Call Speech Routine (phrase)
        RET                     ; Return





; ---------------------------------------------------
;  Table B Rountine #20:  Check Button: REPLAY
; ---------------------------------------------------
L05D3:  LD      HL,0BE0Bh       ; Check Keyboard Buffer
        BIT     0,(HL)          ; Has a key been pressed?
        RET     Z               ; No, so return
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        CP      035h            ; Check if "REPLAY (5)" Pressed
        RET     NZ              ; Not pressed, so return
        RES     0,(HL)          ; Clear Keyboard Buffer

        BIT     7,(IX+00Bh)     ; Is scene timed? (Var0B)
        RET     NZ              ; Yes, so action is not allowed here

        LD      HL,0BE03h       ; 
        SET     0,(HL)          ;
        SET     1,(HL)          ;
        RET                     ;





; ---------------------------------------------------
; Table B Rountine #4:  Award Points????
; ---------------------------------------------------
L05EE:  LD      A,(0BE03h)
        BIT     1,A
        RET     NZ
        LD      A,(0BC81h)
        LD      HL,0BCF0h
        ADD     A,L
        LD      L,A
        JR      NC,L05FF                
        INC     H
L05FF:  LD      A,(HL)
L0600:  BIT     7,(IX+002h)
        JR      NZ,L0613                
        AND     00Fh
        CALL    L0622
        LD      A,(HL)
        AND     00Fh
        CP      00Fh
        RET     Z
        INC     (HL)
        RET     


L0613:  AND     0F0h
        CALL    L0622
        AND     0F0h
        CP      0F0h
        RET     Z

        LD      A,(HL)
        ADD     A,010h
        LD      (HL),A
        RET     


L0622:  PUSH    HL
        JP      NZ,L0661
        CALL    L0668           ; Award Points
        LD      A,(IX+008h)     ; Get Scene Bonus
        CP      0C9h            ; Is Bonus = 201?
        JR      NZ,L064F                
        LD      HL,0BE48h       ; Get Timer Register
        BIT     0,(HL)
        JR      NZ,L064F         
; ---------------------------------------------------
;                Award Bonus Time
; ---------------------------------------------------               
        LD      HL,0BE04h       ; Get Timer Register
        RES     0,(HL)          ; Stop Timer3
        CALL    L0287           ; Update Credits on scoreboard
        LD      DE,0009Fh       ; Phrase = "Congratulations (*) You Have Won Bonus Time"
        CALL    L1363           ; Call Speech Routine (phrase)
        LD      A,001h          ; Add 1 Credit
        CALL    L0320           ; Award Credits and Time
        LD      HL,0BE04h       ; Point to Timer3 Register
        SET     0,(HL)          ; Start Timer3

L064F:  LD      HL,0BE01h       ; Get GAME STATUS Register
        RES     7,(HL)
L0654:  BIT     3,(IX+007h)     ; Check if scene requires single AUDIO
        RES     6,(HL)          ; Set Single Channel AUDIO
        JR      Z,L065E         ; Single audio required so skip ahead        
        SET     6,(HL)          ; Enable both AUDIO Channels

L065E:  POP     HL
        LD      A,(HL)
        RET     

L0661:  LD      HL,0BE01h       ; Get GAME STATUS Register
        SET     7,(HL)
        JR      L0654           ; Loop back




; ---------------------------------------------------
;        Award Bonus by adding it to score
; ---------------------------------------------------
;       L066B:    A = Bonus Value
; ---------------------------------------------------
L0668:  LD      A,(IX+008h)     ; Get Bonus
L066B:  LD      HL,0BCE4h       ; Get Score
        ADD     A,(HL)          ; Add Bonus to Score LSB
        LD      (HL),A          ; Store in Score
        DEC     HL              ; Point to next Score byte
        LD      A,(HL)          ;
        ADC     A,000h          ;
        LD      (HL),A          ;
        DEC     HL              ;
        LD      A,(HL)          ;
        ADC     A,000h          ;
        LD      (HL),A          ;
        RET                     ; Return






; ---------------------------------------------------
;  Routine #7:  Drop all items, Restore Spells
; ---------------------------------------------------
L067B:  BIT     5,(IX+002h)     ;
        RET     Z               ;
        LD      B,01Ah          ; 26 items to check
        LD      HL,0BCA0h       ; Point to inventory
        LD      DE,LC95F        ; Point to Item Property Table
L0688:  BIT     1,(HL)          ; Is item being held?
        JR      Z,L0696         ; Not held so skip
        EX      DE,HL           ; Set to check property
        BIT     3,(HL)          ; Is item property a spell?
        EX      DE,HL           ; Set to check property
        JR      Z,L069F         ;        
        SET     0,(HL)          ;
L0694:  RES     1,(HL)          ; Drop item from inventory
L0696:  INC     HL              ; Next inventory item
        INC     DE              ; Next item property
        DJNZ    L0688           ; Loop until all items checked
        XOR     A               ; Strength = 0
        LD      (0BCE1h),A      ; Set Strength to 0
        RET                     ; Return

L069F:  SET     2,(HL)          ; Mark item as used (no longer available)
        JR      L0694           ; Go back and check remaining items






; ---------------------------------------------------
;  Routine #4:      Check for Wounds
; ---------------------------------------------------
L06A3:  BIT     4,(IX+00Bh)     ; Is player dead?
        RET     Z               ; Yes, so just return 
        LD      HL,0C97Eh       ; Point to health table
        LD      A,(0BCE0h)      ; Get Health Index
        ADD     A,L             ; Add Index to Health Table
        LD      L,A             ; Add Index
        JR      NC,L06B3        ; Carry not set
        INC     H               ; Add Index
L06B3:  LD      A,(0BCE1h)      ; Get Strength
        CP      (HL)            ; Compare Strenght to Health Table
        JP      M,L0723         ; Player is wounded 
        JR      Z,L0723         ; Player is woudded
        LD      DE,00033h       ; Phrase="(%) You Are Wounded"
        CALL    L1363           ; Call Speech Routine (phrase)
; ---------------------------------------------------
;     Player not strong enough, must drop item
; ---------------------------------------------------
L06C2:  LD      DE,00034h       ; Phrase="Choose The Item You Want To Drop (%)"
        CALL    L1363           ; Call Speech Routine (phrase)
; ---------------------------------------------------
;    Yell WAKEUP if player doesn't respond in time
; ---------------------------------------------------
        LD      DE,000FFh       ; Programmable Timer = FFh
        CALL    L21A7           ; Set Programmable Timer
L06CE:  CALL    L21B3           ; Check if Programmable Timer expired
        JR      Z,L06D8         ; Timer still running so skip ahead
        CALL    L085E           ; Send a "Wake Up!" message to player
        JR      L06C2           ; Loop back and tell player to drop an item   
             
L06D8:  LD      HL,0BE48h
        BIT     7,(HL)
        RET     NZ
        CALL    L0DBF           ; Check Keyboard
        LD      HL,0BE0Bh       ; Get Keyboard Buffer
        BIT     0,(HL)          ; Has a key been pressed?
        JR      Z,L06CE         ; No, so loop back and wait
        RES     0,(HL)          ; Clear Keyboard Buffer
        LD      HL,0BE07h       ; Get Programmable Timer Control Register
        LD      (HL),000h       ; Stop Programmable Timer
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        BIT     6,A             ; Was an item selected?
        JR      NZ,L0705        ; Yes, so goto Dropping Items
        CP      032h            ; Was the "2" (Inventory) key pressed?
        JR      NZ,L06C2        ; No, so tell player to choose another item
        CALL    L0CFA           ; Inventory key pressed so goto Speak or Show Inventory
        LD      HL,0BE03h
        BIT     0,(HL)
        RET     NZ
        JR      L06C2           ; Go back and Drop Item

L0705:  CALL    LC0A9           ; Do Dropping Items
        LD      HL,0C97Eh       ; HL = Pointer to Health Table
        LD      A,(0BCE0h)      ; Get 
        ADD     A,L             ;
        LD      L,A             ;
        JR      NC,L0713        ;
        INC     H               ;
; ---------------------------------------------------
;          Check player's strength
; ---------------------------------------------------
L0713:  LD      A,(0BCE1h)      ; Get Strength
        CP      (HL)            ; Does player have enough strength?
        JR      Z,L071C         ; Yes, enough strength so continue
        JP      P,L072B         ; Must drop another item

L071C:  LD      DE,0007Ah       ; Phrase="You Can Continue Now (%)"
        CALL    L1363           ; Call Speech Routine (phrase)
        RET                     ; Leave Wounded Routine

L0723:  LD      DE,00033h       ; Phrase="(%) You Are Wounded"
        CALL    L1363           ; Call Speech Routine (phrase)
        JR      L071C           ; Let player continue
; ---------------------------------------------------
;            Must drop another item
; ---------------------------------------------------
L072B:  LD      DE,000A2h       ; Phrase = "Press Any Key To Continue"
        CALL    L1363           ; Call Speech Routine (phrase)
        JR      L06C2           ; Loop back and drop another item






; ---------------------------------------------------
;                 Check Dropping Items 
; ---------------------------------------------------                   
L0733:  LD      A,(0BE0Ah)      ; Get Keyboard Character
        AND     01Fh            ; Extract pertinent information
        LD      (0BE18h),A      ; Store Item Number
        CALL    L11DF           ; HL Points to Item in inventory
        XOR     A               ; Check if zero
        CP      (HL)            ; Is the item available?
        RET     Z               ; No, not available so return
        BIT     1,(HL)          ; Is item in inventory?
        JR      NZ,L0767        ; Yes, so go to Drop Routine        
        CALL    L136C           ; Clear Speech Buffer
        LD      DE,00030h       ; Phrase="Sorry (%) You Don't Have"
        CALL    L1383           ; Get Phrase from Table
        LD      A,(0BE18h)      ; Get Item Number
        LD      E,A             ; Point to Item Word
        LD      D,080h          ; DE = Item
        CALL    L1383           ; Get Phrase from Table
        CALL    L21C1           ; Command Speech Chip to speak buffer
        LD      HL,0BCA0h       ; HL = Start of Inventory
        CALL    L12F6           ; Speak Inventory
        LD      DE,000FFh       ; Programmable Timer = 0FFh
        CALL    L21A7           ; Set Programmable Timer
        RET                     ; Return

; ---------------------------------------------------
;                    Drop Item
; ---------------------------------------------------
L0767:  CALL    L136C           ; Clear Speech Buffer
        LD      DE,00036h       ; Phrase="(%) You Have Dropped"
        CALL    L1383           ; Get Phrase from Table
        LD      A,(0BE18h)      ; Get Item Number to drop
        LD      E,A             ; Point to Item Word 
        LD      D,080h          ; DE = Item Word
        CALL    L1383           ; Get Phrase from Table
        CALL    L21C1           ; Command Speech Chip to speak buffer
        LD      A,(0BE18h)      ; Get Item Number to drop
        LD      DE,0C95Eh       ; Add item number to Table start
        ADD     A,E             ; Do addition
        LD      E,A             ; Do addition
        JR      NC,L0787        ; Do addition
        INC     D               ; DE = Table + Item Number
L0787:  EX      DE,HL           ; HL = Item Properties
        BIT     4,(HL)          ; Check item's properties
        EX      DE,HL           ; HL = Inventory Item
        JR      Z,L07A7         ; Not heavy, skip ahead        
        SET     0,(HL)          ; Mark item as previously picked up
L078F:  RES     1,(HL)          ; Mark item as dropped
; ---------------------------------------------------
;    Adjust player's strength after dropping item
; ---------------------------------------------------
        LD      A,(DE)          ; Get Item Property
        AND     007h            ; Get Item Weight
        LD      B,A             ; B = Item Weight
        LD      A,(0BCE1h)      ; Get Strength
        SUB     B               ; Adjust Strength with dropped item
        LD      (0BCE1h),A      ; Save new Strength
        LD      HL,0BE07h       ; Get Programmable Timer Control Register
        RES     0,(HL)          ; Disable Programmable Timer
        LD      HL,0BE03h       ;
        RES     3,(HL)          ; Clear Drop Mode
        RET                     ; Return

; ---------------------------------------------------
;   
; ---------------------------------------------------
L07A7:  SET     2,(HL)          ;
        JR      L078F           ;
        




                           



; ---------------------------------------------------
; Routine #14:  Check if player pressed an ITEM key
; ---------------------------------------------------
L07AB:  LD      HL,0BE0Bh       ; Get Keyboard Buffer
        BIT     0,(HL)          ; Has a key been pressed?
        RET     Z               ; No, so return
        LD      A,(0BE0Ah)      ; Get keyboard character
        BIT     6,A             ; Is keypress an item?
        RET     Z               ; No, so return
; ---------------------------------------------------
;            Check if item is in inventory
; ---------------------------------------------------
        AND     01Fh            ; Get item number
        LD      (0BE18h),A      ; Save item number
        CALL    L11DF           ; Point to Item in Inventory
        XOR     A               ; Check item status
        CP      (HL)            ; Is item in inventory?
        JR      NZ,L07C9        ; Yes, so skip ahead
        LD      HL,0BE0Bh       ; Get Keyboard Buffer
        RES     0,(HL)          ; Clear keyboard buffer
        RET                     ; Return
; ---------------------------------------------------
;            Check for COMBINE Item Mode
; ---------------------------------------------------
L07C9:  LD      HL,0BE03h       ; Get MODE Register
        BIT     2,(HL)          ; Are we in COMBINE Mode?
        JR      Z,L07D4         ; No, so check next mode       
        CALL    LC0AC           ; Do Combining Items
        RET                     ; Return
; ---------------------------------------------------
;              Check for DROP Item Mode
; ---------------------------------------------------
L07D4:  BIT     3,(HL)          ; Are we in DROP Mode?
        JR      Z,L07E1         ; No do skip ahead       
        CALL    LC0A9           ; Do Dropping Items
        LD      HL,0BE0Bh       ; Get Keyboard Buffer
        RES     0,(HL)          ; Clear keyboard buffer
        RET                     ; Return
; ---------------------------------------------------
;           Check for automatic pick up
; ---------------------------------------------------
L07E1:  BIT     7,(IX+002h)     ; Does location utilize item?
        JR      Z,L0800         ; No, so skip ahead 
        LD      A,(IX+00Ah)     ; Get item located in room
        LD      B,A             ; B = Item to be picked up
        AND     060h            ;
        CP      060h            ; Is the item automatically picked up?
        JR      NZ,L07F5        ; Yes, so jump ahead        
        CALL    LC0AF           ; Using or Picking up items
        RET                     ; Return

; ---------------------------------------------------
;           
; ---------------------------------------------------
L07F5:  LD      A,B             ; Get item to be picked up
        AND     020h            ;
        CP      020h            ;
        JR      NZ,L0800        ;        
        CALL    LC0B2           ;
        RET                     ; Return

; ---------------------------------------------------
;              Item not used here
; ---------------------------------------------------
L0800:  LD      HL,0BE0Bh       ; Get Keyboard Buffer
        RES     0,(HL)          ; Clear Keyboard Buffer
        CALL    L136C           ; Clear Speech Buffer
        LD      A,(0BE18h)      ; Get item being used
        LD      E,A             ; Make item into word
        LD      D,080h          ; Setup word to speak
        CALL    L1383           ; Get Phrase from Table
        LD      A,(0BE18h)      ; Get item being used
        CALL    L11DF           ; Point to Item in Inventory
        BIT     1,(HL)          ; Is item in inventory?
        LD      DE,00031h       ; Phrase="Won't Work Here (%)"
        JR      NZ,L0821        ; Item in inventory so skip ahead        
; ---------------------------------------------------
;              Item not in inventory
; ---------------------------------------------------
        LD      DE,00078h       ; Phrase="Is Not Here (%)"
L0821:  CALL    L1383           ; Get Phrase from Table
        CALL    L21C1           ; Command Speech Chip to speak buffer
        RET                     ; Return








; ---------------------------------------------------
;  Table B Rountine #19:  Check Button: DROP ITEM
; ---------------------------------------------------
L0828:  LD      HL,0BE03h       ; Check Register
        BIT     3,(HL)          ; Are we in Drop Mode?
        JR      NZ,L0854        ; Yes we are so jump ahead
        LD      HL,0BE0Bh       ; Check Keyboard Buffer
        BIT     0,(HL)          ; Has a key been pressed?
        RET     Z               ; No, so return
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        CP      033h            ; Check if "DROP ITEM (3)" was pressed
        RET     NZ              ; Not pressed, so return
        RES     0,(HL)          ; Clear Keyboard Buffer
        BIT     7,(IX+00Bh)     ; Is this scene timed? (Var0B)
        RET     NZ              ; Yes, so action is not allowed here
L0842:  LD      DE,00034h       ; Phrase="Choose The Item You Want To Drop (%)"
        CALL    L1363           ; Call Speech Routine (phrase)
        LD      DE,000FFh       ; Programmable Timer = 0FFh
        CALL    L21A7           ; Set Programmable Timer
        LD      HL,0BE03h       ; Get Register
        SET     3,(HL)          ; Set Drop Mode
        RET                     ; Return
; ---------------------------------------------------
;             Drop Mode enable
; ---------------------------------------------------
L0854:  CALL    L21B3           ; Check if Programmable Timer expired
        RET     Z               ; Programmable Timer still running so return
        CALL    L085E           ; Timed-out, so send Wake Up message to player
        JR      L0842           ; Ask Player which item to drop        
        RET                     ; Return



; ---------------------------------------------------
;         Speak "Wake Up" Message to player
; ---------------------------------------------------
L085E:  PUSH    AF              ; Save AF Register
        LD      IY,L12AF        ; Random Phrase = "Act Lively"
        CALL    L15EE           ; Speak Random Phrase
        POP     AF              ; Restore AF Register
        RET                     ; Return






;----------------------------------------------------
; Routine #2:  
;----------------------------------------------------
L0868:  CALL    LC082           ; Enter Name in Keyboard
        LD      HL,0BE48h       ;
        BIT     7,(HL)          ;
        JR      Z,L0880         ;       
        RES     7,(HL)          ;
        LD      DE,0009Eh       ; Phrase="Your Time Is Up (*)"
        CALL    L1363           ; Call Speech Routine (phrase)
L087A:  LD      HL,0BE01h       ; Get GAME STATUS Register
        SET     0,(HL)          ; Request Exit Main Loop
        RET                     ; Return

L0880:  CALL    LC088           ; Look for a Saved Game
        CP      000h            ; Have we found a saved game match?
        JR      Z,L0892         ; Yes, a saved game was found so skip ahead      
        CALL    LC085           ; Check if First Name Basis is okay
        XOR     A               ;
        LD      (0BCE9h),A      ;
        CALL    LC091           ;
        RET                     ;
; ---------------------------------------------------
;               A Saved Game was found
; ---------------------------------------------------
L0892:  CALL    LC08E           ; Welcome Player Back, Check lives
        LD      A,001h          ;
        CALL    LC09D           ;
        CALL    LC0A3           ; Retrieve Saved BANK data
        RET                     ; Return






; ---------------------------------------------------
; Cycle Routine #5:  Wait until System is Initialized
; ---------------------------------------------------
L089E:  CALL    L1C67           ; Initialize System
        JR      C,L089E         ; Loop until System Initialized
        RET                     ; Return





; ---------------------------------------------------
;         HL = HL + A * 2
;         DE = (new HL), BC = 0         
; ---------------------------------------------------
L08A4:  SLA     A               ;
        ADD     A,L             ;
        LD      L,A             ;
        JR      NC,L08AB        ;
        INC     H               ;
L08AB:  LD      E,(HL)          ;
        INC     HL              ;
        LD      D,(HL)          ;
        INC     HL              ;
        LD      BC,00000h       ;
        RET                     ;




; ---------------------------------------------------
; Cycle Routine #6:  Call all BATCH 2 routines
; ---------------------------------------------------
L08B3:  CALL    LC094           ; #8
        CALL    LC097           ;
        CALL    LC09A           ; #10 Initialize data in a Game BANK
        CALL    LC09D           ; #11 routine
        CALL    LC0A0           ;
        CALL    LC0A3           ; #13 Retrieve Saved BANK data
        RET                     ; Return





; ---------------------------------------------------
;          Welcome Player Back, Check lives
; ---------------------------------------------------
L08C6:  PUSH    IY              ; Save IY Register 
        LD      IY,012CBh       ; Random Phrase = "Nice To Have You Here Again (#)"
        CALL    L15EE           ; Speak Random Phrase
        POP     IY              ; Restore Save BANK address
        CALL    LC0A3           ; Retrieve Saved BANK data
        PUSH    IY              ; Save BANK address (IY)
        CALL    LC085           ; Check if First Name Basis is okay
        POP     IY              ; Restore BANK address (IY)
        LD      A,(0BCE8h)      ; Get Number of Lives
        CP      000h            ; Any lives left?
        JR      NZ,L08EA        ; Yes, so skip ahead
        LD      DE,00075h       ; Phrase="Last Time You Played You Lost All Your Lives For I Will Start You Over"
        CALL    L1363           ; Call Speech Routine (phrase)
        JR      L0916           ; Initial a BANK and retreive saved game        






; ---------------------------------------------------
;        Copy Score into speakable number
; ---------------------------------------------------
L08EA:  LD      HL,0BCE2h       ; HL = Pointer to Score
        LD      DE,0A6D0h       ; Location of speakable number
        LD      BC,00003h       ; Copy 3 bytes to (n) speakable number
        LDIR                    ; Perform byte copy
        LD      DE,00076h       ; Phrase="Last Time You Played Your Score Was (n)"
        CALL    L1363           ; Call Speech Routine (phrase)
        CALL    L0DAD           ; "Out Of A Possible (n)"
        LD      HL,0BE0Bh       ; Check Keyboard Buffer
L0901:  RES     0,(HL)          ; Clear Keyboard Buffer
        LD      DE,00061h       ; Phrase="Do You Want To Continue Your Game (%)"
        CALL    L1363           ; Call Speech Routine (phrase)
        CALL    L19E7           ; Check for "YES" or "NO"
        JR      C,L08EA         ; Timed out so repeat question        
        JR      Z,L091D         ; "YES" so jump ahead and continue
; ---------------------------------------------------
;              Do Not Continue Game
; ---------------------------------------------------                 
        LD      DE,00062h       ; Phrase="O K (%) I Will Start You Over Again"
        CALL    L1363           ; Call Speech Routine (phrase)
L0916:  CALL    LC09A           ; Initialize data in a Game BANK
L0919:  CALL    LC0A3           ; Retrieve Saved BANK data
        RET                     ; Return

; ---------------------------------------------------
;               Continue Game
; ---------------------------------------------------                 
L091D:  LD      HL,0BE03h       ;
        SET     1,(HL)          ;
        JR      L0919           ;         







; ---------------------------------------------------
;         Copy Name Data (transfer, clear)
; --------------------------------------------------- 
L0924:  PUSH    IY              ; Save BANK address
        LD      DE,08000h       ; Phrase = "Thayer's Quest"
        CALL    L136C           ; Clear Speech Buffer
        CALL    L1383           ; Get Phrase from Table
        LD      A,(0A614h)      ; Get number of characters in buffer
        INC     A               ; Add one character
        CP      021h            ; Are there more than 32 characters in buffer?
        JR      C,L0939         ; No, so continue        
        LD      A,020h          ; Limit buffer size to 32 characters
; ---------------------------------------------------
;         Copy Speech Buffer into BANK
; ---------------------------------------------------
L0939:  LD      (IY+003h),A     ; Save number of characters in buffer into BANK
        LD      HL,0A000h       ; HL = Start of Speech Buffer
        LD      B,020h          ; 32 characters to copy
        INC     IY
L0943:  LD      A,(HL)          
        LD      (IY+003h),A
        INC     IY
        INC     HL
        DJNZ    L0943
        POP     IY
        CALL    L169E
; ---------------------------------------------------
;          Copy 6 bytes into memory 
; --------------------------------------------------- 
        PUSH    IY              ; IY + 6B = Destination
        LD      HL,0BE27h       ; BE27-BE2D Source to copy from
        LD      B,006h          ; Loop = 6 bytes
L0958:  LD      A,(HL)          ; Get Data bytes
        LD      (IY+06Bh),A     ; Store the byte
        INC     IY              ; Point to next spot
        INC     HL              ; Point to next spot
        DJNZ    L0958           ; Loop until all 6 bytes transferred

        POP     IY              ; 
        PUSH    IY              ; 


; ---------------------------------------------------
;          Copy Name Data to memory 
; --------------------------------------------------- 
        LD      HL,0A64Ah       ; Point to start of name data
        LD      B,041h          ; Loop = 65 bytes 
L096A:  LD      A,(HL)          ; Get Name Data
        LD      (IY+024h),A     ; Copy name data to BANK
        INC     IY              ; Point to next spot
        INC     HL              ; Point to next spot
        DJNZ    L096A           ; Loop until all name data copied

        POP     IY              ; Restore BANK address  
        RET                     ; Return








; ---------------------------------------------------
; Cycle Routine #4:  Look for a Saved Game
; ---------------------------------------------------
;       Check to see if the Player's Name shows up
;       in any of the 10 Saved Game Banks.
; ---------------------------------------------------
;     RETURN A  = Save Game Bank to use (default = 1)
;            IY = Start of Bank Address (default = BA00)
; ---------------------------------------------------
L0976:  LD      IY,0A800h       ; IY = Start of Game Banks
        LD      B,00Ah          ; Loop = 10 banks
        LD      DE,00200h       ; DE = Size of each bank
L097F:  PUSH    BC              ; Save Loop
        PUSH    IY              ; Save Start of Game Banks
        LD      B,041h          ; Loop = Size of space for Player's Name
        LD      HL,0A64Ah       ; Point to start of Length of Name
L0987:  LD      A,(IY+024h)     ; Get name character from bank
        CP      (HL)            ; See if the character matches
        JR      NZ,L0992        ; No match, so try next bank
        INC     HL              ; Check next character
        INC     IY              ; Check next character
        DJNZ    L0987           ; Loop back and check all characters
; ---------------------------------------------------
;             See if a match was found
; ---------------------------------------------------      
L0992:  POP     IY              ; IY = Start of the Saved Bank
        LD      A,B             ; A = character left to check
        POP     BC              ; BC = Bank number that matches
        CP      000h            ; Have all characters been matched?
        RET     Z               ; Yes, so we have a match.  Return.
; ---------------------------------------------------
;     Check remaining Banks
;     then use default A = 1, IY = BA00
; ---------------------------------------------------
        ADD     IY,DE           ; Skip to the next bank
        DJNZ    L097F           ; Loop back until all 10 banks are checked         
        LD      A,001h          ; No match so use Bank 1
        RET                     ; Return









; ---------------------------------------------------
;     #11
; ---------------------------------------------------
L09A0:  CALL    L169E           ;
        PUSH    IY              ; Save IY Register before copy
        LD      HL,0BE27h       ;
        LD      B,006h          ; Loop = 6
L09AA:  LD      A,(HL)          ;
        LD      (IY+065h),A     ;
        INC     IY              ;
        INC     HL              ;
        DJNZ    L09AA           ; Loop until all 6 checked      
        POP     IY              ; Restore IY Register after copy
        LD      A,(IY+071h)     ;
        INC     A               ;
        RET     Z               ;

        LD      (IY+071h),A
        RET     



L09BE:  PUSH    IY
        POP     HL
        INC     HL
        INC     HL
        LD      D,H
        LD      E,L
        INC     DE
        LD      BC,001FDh
        LD      (HL),000h
        LDIR    
        RET     







; ---------------------------------------------------
;           Retrieve Saved BANK data
; ---------------------------------------------------
;         IY = BANK location to copy from
; ---------------------------------------------------
L09CE:  PUSH    IY              ; Copy BANK address(IY) to HL
        POP     HL              ; Location to copy from
        LD      DE,0BC00h       ; Location to copy to
        LD      BC,00200h       ; Number of bytes to copy
        LDIR                    ; Copy all bytes
        RET                     ; Return








; ---------------------------------------------------
;   BATCH 2:  #8 Check all BANKs for ?   
; ---------------------------------------------------
L09DA:  LD      HL,0BE18h       ;
        LD      (HL),064h       ; 100
        LD      IY,0A800h       ; Start of game BANKS
        LD      B,00Ah          ; Loop = 10 banks
L09E5:  LD      A,(IY+001h)     ; Get
        CP      000h            ; does bank need checking?
        JR      NZ,L09EF        ; No, so skip ahead       
        CALL    LC0A6           ; check bank
L09EF:  LD      DE,00200h       ; DE = Size of BANK
        ADD     IY,DE           ; Go to next BANK
        DJNZ    L09E5           ; Loop until all banks checked
        LD      IY,(0BE15h)     ;
        RET                     ; Return




; ---------------------------------------------------
;      check if bank data matches BE18-BE1C
; ---------------------------------------------------
L09FB:  LD      HL,0BE18h       ;
        LD      A,(IY+065h)     ;
        CP      (HL)            ;
        JR      Z,L0A07         ;        
        JR      C,L0A2B         ;        
        RET                     ; Return
; ---------------------------------------------------
;      6 loop
; ---------------------------------------------------
L0A07:  INC     HL              ;
        LD      A,(IY+066h)     ;
        CP      (HL)            ;
        JR      Z,L0A11         ;        
        JR      C,L0A2B         ;        
        RET                     ;

; ---------------------------------------------------
;      6 loop
; ---------------------------------------------------
L0A11:  INC     HL              ;
        LD      A,(IY+067h)     ;
        CP      (HL)            ;
        JR      Z,L0A1B         ;        
        JR      C,L0A2B         ;        
        RET                     ;

; ---------------------------------------------------
;      6 loop
; ---------------------------------------------------
L0A1B:  INC     HL              ;
        LD      A,(IY+069h)     ;
        CP      (HL)            ;
        JR      Z,L0A25         ;        
        JR      C,L0A2B         ;        
        RET                     ;

; ---------------------------------------------------
;      6 loop
; ---------------------------------------------------
L0A25:  INC     HL              ;
        LD      A,(IY+06Ah)     ;
        CP      (HL)            ;
        RET     NC              ;
                                
; ---------------------------------------------------
;      6 loop
; ---------------------------------------------------
L0A2B:  LD      A,(IY+065h)
        LD      (0BE18h),A
        LD      A,(IY+066h)
        LD      (0BE19h),A
        LD      A,(IY+067h)
        LD      (0BE1Ah),A
        LD      A,(IY+069h)
        LD      (0BE1Bh),A
        LD      A,(IY+06Ah)
        LD      (0BE1Ch),A
        LD      (0BE15h),IY
        RET                     ; Return








; ---------------------------------------------------
;        Initialize data in a New Game BANK
; ---------------------------------------------------
L0A4E:  PUSH    IY              ; Transfer BANK address to DE
        POP     DE              ; DE = Saved BANK address
; ---------------------------------------------------
;       Clear BANK game data section BC80 - BDFF
; ---------------------------------------------------
        LD      HL,0080h        ; Point to section of BANK
        ADD     HL,DE           ; Add 80h to BANK address
        LD      D,H             ; Transfer sum back to DE
        LD      E,L             ; Transfer sum back to DE
        INC     DE              ; Add 1 to DE
        LD      BC,0017Fh       ; Loop = 383 bytes
        LD      (HL),000h       ; Setup clearing bytes
        LDIR                    ; Loop until all bytes are cleared
; ---------------------------------------------------
;               Setup lives and health      
; ---------------------------------------------------
        LD      A,(LC000)       ; Get initial number of lives
        PUSH    IY              ; Setup BANK pointer
        LD      BC,0080h        ; Point to lives/health area
        ADD     IY,BC           ; Add to BANK pointer
        LD      (IY+060h),008h  ; BCE0: Index to health table
        LD      (IY+068h),A     ; BCE8: Number of lives
; ---------------------------------------------------
;     Determine which keys have no items associated      
; ---------------------------------------------------
        POP     IY              ; Get BANK address 
        PUSH    IY              ; Transfer BANK address to DE
        POP     DE              ; DE = BANK address
        LD      HL,000A0h       ; Point to section of BANK
        ADD     HL,DE           ; Add A0h to BANK address
        LD      DE,LC95F        ; Point to item property table
        LD      B,01Ah          ; Loop = 26 items to check
L0A7E:  EX      DE,HL           ; Switch register
        BIT     6,(HL)          ; Does key have an item associated?
        EX      DE,HL           ; Switch register
        JR      NZ,L0A86        ; Key has no item, so skip ahead       
        LD      (HL),001h       ; Mark item as valid
L0A86:  INC     HL              ; Check next item property
        INC     DE              ; Check next inventory location
        DJNZ    L0A7E           ; Loop until all items checked

; ---------------------------------------------------
;         Setup initial item inventory BCA0-BCBA      
; ---------------------------------------------------                                          
        PUSH    IY              ; Save BANK address
        PUSH    IY              ; Save BANK address
        POP     DE              ; DE = BANK address
        LD      HL,000E1h       ; Point to section of BANK
        ADD     HL,DE           ; Add E1h to BANK address
        EX      DE,HL           ; DE = Pointer to Strength (BCE1)
        LD      B,01Ah          ; Loop = 26 items to check
        LD      HL,LC95F        ; Point to Item Property Table
L0A99:  BIT     5,(HL)          ; Does player start game with this item?
        JR      Z,L0AB7         ; Do not start with this item, so skip ahead
; ---------------------------------------------------
;  Ajust player's strength when taking initial items      
; ---------------------------------------------------
        LD      A,(HL)          ; Get item property
        AND     007h            ; Get item weight
        LD      C,A             ; C = Item weight
        LD      A,(DE)          ; Get Strength
        ADD     A,C             ; Add weight to Strength
        LD      (DE),A          ; Save Strength
; ---------------------------------------------------
;             Update inventory with item      
; ---------------------------------------------------
        PUSH    IY              ; Save 
        PUSH    BC              ;
        LD      BC,00080h       ; Point to section of BANK
        ADD     IY,BC           ; Add 80h to BANK address
        RES     0,(IY+020h)     ; BCA0
        SET     1,(IY+020h)     ; BCA0
        POP     BC              ;
        POP     IY              ;
L0AB7:  INC     HL              ;
        INC     IY              ;
        DJNZ    L0A99           ; Loop until all items are checked
                
; ---------------------------------------------------
;         Setup      
; ---------------------------------------------------
        POP     IY              ; 
        PUSH    IY
        POP     DE
        LD      HL,000C0h
        ADD     HL,DE
        LD      B,020h          ; Loop = 32
L0AC7:  LD      (HL),001h
        INC     HL
        DJNZ    L0AC7                   
        LD      A,(IY+072h)
        INC     A
        RET     Z
        LD      (IY+072h),A
        RET     







; ---------------------------------------------------
; Table B Routine #5:  Get Scene Frame Number/Scene Play Timer
; ---------------------------------------------------
;   (IX+0Fh)(IX+0Eh) = Scene Play Time
;   (IX+01h)(IX+00h) = Starting Frame Number
; ---------------------------------------------------
L0AD5:  LD      C,(IX+00Eh)     ; Get BC
        LD      B,(IX+00Fh)     ; BC = Scene Play Time
        LD      HL,0BE03h
        BIT     1,(HL)
        JR      NZ,L0AE8              
        BIT     5,(IX+00Bh)
        JR      NZ,L0AF2        ; No, so skip ahead
L0AE8:  LD      E,(IX+000h)     ; Get DE
        LD      D,(IX+001h)     ; DE = Starting Frame Number for scene
        CALL    L1BE3           ; PLAY Scene with Timer
        RET                     ; Return

L0AF2:  CALL    L1CB0           ; Send 2 PLAY commands
        RET                     ; Return





; ---------------------------------------------------
;    Store Speakable Number for Speech
;         A = Number (0-9)
; ---------------------------------------------------
L0AF6:  LD      (0A6D2h),A      ; Store A in Ones
        XOR     A               ; A = 0
        LD      (0A6D1h),A      ; Store zero in other spots
        LD      (0A6D0h),A      ; Store zero in other spots
        RET                     ; Return






; ---------------------------------------------------
;  Routine2: #3  Check if Player has Died
; ---------------------------------------------------
L0B01:  BIT     4,(IX+00Bh)     ; Test if Player died
        JR      Z,L0B7A         ; Yes, Player dead
        BIT     6,(IX+002h)
        RET     Z
; ---------------------------------------------------
;                  No lives left
; ---------------------------------------------------
        LD      A,R             ; A = Random Number
        AND     003h            ; A = number between 0-3
        LD      DE,08043h       ; Phrase="(%) You Just Died"
        ADD     A,E             ; Add Random Number
        LD      E,A             ; Store Message Pointer
        CALL    L1363           ; Call Speech Routine (phrase)           
        XOR     A               ; Number of Lives = 0
        LD      (0BCE8h),A      ; Set Number of Lives to zero
L0B1C:  LD      DE,00062h       ; Phrase="O K (%) I Will Start You Over Again"
        CALL    L1363           ; Call Speech Routine (phrase)           
        CALL    L0C00           ; Show Ranking and Speak Score
L0B25:  LD      A,(0BCE9h)
        LD      (0BE18h),A
        LD      IY,0BC00h       ; Initialize start of Working BANK
        CALL    LC09A           ; Initialize data in a Game BANK
        LD      A,(0BE0Fh)      ; Get DIP Switch A
        BIT     4,A             ; Test A5, Lives per Game
        JR      NZ,L0B3E        ; 3 Lives, so skip ahead
        LD      HL,0BCE8h       ; HL = Number of Lives
        LD      (HL),005h       ; Set Number of Live to 5
L0B3E:  LD      A,(0BE18h)
        LD      (0BCE9h),A
        LD      HL,0BE0Bh       ; Check Keyboard Buffer
        RES     0,(HL)          ; Clear keyboard buffer

L0B49:  LD      DE,00096h       ; Programmable Timer = 096h
        CALL    L21A7           ; Set Programmable Timer
        LD      DE,00090h       ; Phrase="Press Any Key To Continue"
        CALL    L1363           ; Call Speech Routine (phrase)
L0B55:  LD      HL,0BE0Bh       ; Get Keyboard Buffer
        BIT     0,(HL)          ; Has key been pressed?
        JR      NZ,L0B6B        ; Yes, key pressed to skip ahead        
        LD      HL,0BE48h       ; Check Timer register
        BIT     7,(HL)          ; Has timer expired?
        JP      NZ,L087A
        CALL    L21B3           ; Check if Programmable Timer expired
        JR      Z,L0B55                 
        JR      L0B49           ; Reset timer        

L0B6B:  RES     0,(HL)
        LD      A,001h
        LD      (0BC81h),A
        LD      HL,0BE03h
        RES     4,(HL)          ; Set Audio Track 1
        SET     0,(HL)
        RET     

; ---------------------------------------------------
;           Player died, lose one life
; ---------------------------------------------------
L0B7A:  BIT     6,(IX+002h)
        RET     Z
        LD      A,R             ; A = Random Number
        AND     003h            ; A = number between 0-3
        LD      DE,08043h       ; Phrase="(%) You Just Died"
        ADD     A,E             ; Add Random number
        LD      E,A             ; Store Message Pointer
        CALL    L1363           ; Call Speech Routine (phrase)          
        LD      HL,0BCE8h       ; Get Number of Lives
        DEC     (HL)            ; Subtract 1
        LD      A,(HL)          ; A = Number of Lives
        CP      001h            ; 1 life left?
        JR      Z,L0BA5         ; One life, so skip ahead
        CALL    L0AF6           ; n = Number of Lives
        LD      DE,0006Eh       ; Phrase="You Have (n) Lives Left"
        CALL    L1363           ; Call Speech Routine (phrase)
        LD      A,(0BCE8h)      ; Get Number of Lives
        CP      000h            ; Are there zero lives left?
        JP      Z,L0B1C         ; No lives, so start over
L0BA5:  LD      DE,0007Fh       ; Phrase = "?" <last life>
        CALL    Z,L1363         ; Call Speech Routine (phrase)
        LD      A,(IX+003h)
        LD      (0BC81h),A
        LD      HL,0BE03h
        SET     0,(HL)
        RES     4,(HL)          ; Set Audio Track 1
        RET                     ; Return




; ---------------------------------------------------
;   Check for Game Over (Play Clock Timer Expires)
; ---------------------------------------------------
L0BB9:  LD      HL,0BE48h       ; Get Play Clock Register
        BIT     7,(HL)          ; Test if Play Clock has expired
        RET     Z               ; Clock still running, so return
        RES     7,(HL)          ; Stop Play Clock
        LD      DE,0009Eh       ; Phrase="Your Time Is Up (*)"
        CALL    L1363           ; Call Speech Routine (phrase)
        CALL    L0C00           ; Show Ranking and Speak Score
        CALL    L0DF9           ; Do Save Game
        LD      HL,0BE03h
        SET     0,(HL)
        LD      HL,0BE01h       ; Get GAME STATUS Register
        SET     0,(HL)          ; Request Exit Main Loop
        RET                     ; Return






; ---------------------------------------------------
;   Routine #5:  Finished 1st part of Game 
; ---------------------------------------------------
L0BD8:  BIT     3,(IX+00Bh)
        RET     Z
        LD      HL,0BCE8h
        LD      (HL),000h
        LD      BC,0000h        ; Scene Play Time = 0
        LD      DE,(0C01Dh)     ; Get Message "Congrats, mastered 1st part"
        CALL    L1BE3           ; PLAY Scene with Timer  
        LD      DE,00096h       ; Programmable Timer = 96h
        CALL    L21A7           ; Set Programmable Timer
L0BF2:  CALL    L21B3           ; Check if Programmable Timer expired
        JR      Z,L0BF2         ; Wait until Timer expires
        CALL    L0DFF           ; Automatically save game
        CALL    L0C00           ; Show Ranking and Speak Score
        JP      L0B25






; ---------------------------------------------------
;         Show Ranking and Speak Score
; ---------------------------------------------------
L0C00:  CALL    L0C15           ; A = Player Ranking
        LD      HL,0BE01h       ; Get GAME STATUS Register
        RES     7,(HL)
        LD      HL,0CA05h       ; HL = Start of Player Rankings
        CALL    L08A4           ; DE = Pointer to scene (HL+A*2)
        CALL    L0D7A           ; Play scene and timer
        CALL    L0D9C           ; Speak Score
        RET                     ; Return






; ---------------------------------------------------
;          Determine Player Ranking
; ---------------------------------------------------
;     Return A = Player Ranking (0 - 17)
; ---------------------------------------------------
L0C15:  LD      A,(0BCE2h)      ;
        PUSH    AF              ;
        LD      HL,(0BCE3h)     ;
        PUSH    HL              ;
        LD      A,(0BC71h)      ;
        CP      003h            ;
        JR      C,L0C2C         ;
; ---------------------------------------------------
;      Award 200 point Bonus for each ...
; ---------------------------------------------------
        LD      B,A             ; B = number of seconds remaining
L0C25:  LD      A,0C8h          ; Bonus = 200 points for each second
        CALL    L066B           ; Add Bonus to Score
        DJNZ    L0C25           ; Loop until all bonus is awarded

; ---------------------------------------------------
;        Check how many hints were given
; ---------------------------------------------------
L0C2C:  LD      HL,0BCF0h       ;
        LD      C,000h          ;
L0C31:  BIT     7,C
        JR      NZ,L0C47                
        SET     7,C
        LD      A,(HL)
        SRL     A
        SRL     A
        SRL     A
        SRL     A
        CP      002h
        CALL    NC,L0CC2        ;
        JR      L0C31           ;        

L0C47:  RES     7,C
        LD      A,(HL)
        INC     HL
        AND     00Fh
        CP      002h
        CALL    NC,L0CC2
        DJNZ    L0C31            
; ---------------------------------------------------
;    Transfer score to temp location for calculation
; ---------------------------------------------------               
        LD      HL,0BE44h       ; Point to temp location
        LD      (HL),000h       ; Clear temp location
        INC     HL              ; Next location
        LD      A,(0BCE2h)      ; Get score byte
        LD      (HL),A          ; Save in temp location (BE45)
        INC     HL              ; Next location
        LD      A,(0BCE3h)      ; Get score byte
        LD      (HL),A          ; Save in temp location (BE46)
        INC     HL              ; Next locatoin
        LD      A,(0BCE4h)      ; Get score byte
        LD      (HL),A          ; Save in temp locatoin (BE47)
; ---------------------------------------------------
;               Multiply score by 16
; ---------------------------------------------------
        XOR     A               ; Clear carry
        RLD                     ; left 4 bits
        DEC     HL
        RLD     
        DEC     HL
        RLD     
        DEC     HL
        RLD     

        INC     HL
        INC     HL
        INC     HL
        SLA     (HL)            ; m=m*2
        DEC     HL
        RL      (HL)            ; Rotate Left
        DEC     HL
        RL      (HL)            ; Rotate Left
        DEC     HL
        RL      (HL)            ; Rotate Left

        LD      C,000h          ; Start at lowest ranking
        OR      A               ; Loop = 0

L0C85:  LD      HL,0BE46h       ; Point to temp location
        LD      A,(HL)          ; Get adjusted score
        INC     HL              ; Next location
        LD      L,(HL)          ; Get adjusted score
        LD      H,A             ; HL = Adjusted Score

        LD      A,(0C005h)      ; Get total possible points
        LD      E,A             ; DE = total possible points
        LD      A,(0C004h)      ; Get total possible points
        LD      D,A             ; DE = total possible points

        SBC     HL,DE           ; HL = HL - total possible points
; ---------------------------------------------------
;         Save the difference
; ---------------------------------------------------
        LD      A,H
        LD      (0BE46h),A
        LD      A,L
        LD      (0BE47h),A
        JR      NC,L0CB0                
        LD      HL,0BE45h
        LD      A,(HL)
        SUB     001h
        LD      (HL),A
        JR      NC,L0CB0                
        DEC     HL
        LD      A,(HL)
        SUB     001h
        LD      (HL),A
        JR      C,L0CB3                 

L0CB0:  INC     BC              ; Improve ranking by one
        JR      L0C85           ; Jump back and check other data        

; ---------------------------------------------------
;         Save new score and return ranking
; ---------------------------------------------------
L0CB3:  POP     HL              ; HL is score
        LD      (0BCE3h),HL     ; Save score
        POP     AF              ; AF is score
        LD      (0BCE2h),A      ; Save Score
        LD      A,C             ; A = Ranking 
        CP      020h            ; Is ranking greater than 32?
        RET     C               ; No, so return
        LD      A,01Fh          ; Ranking = 32
        RET                     ; Return

; ---------------------------------------------------
;                 Award Bonus
; ---------------------------------------------------
L0CC2:  PUSH    BC
        PUSH    HL
        DEC     B
        LD      HL,0D000h       ; HL = Start of Scene Data (Audio Track 1)
        BIT     7,C
        JR      NZ,L0CCF               
        LD      HL,0D800h       ; HL = Start of Scene Data (Audio Track 2)
L0CCF:  LD      DE,00010h
L0CD2:  INC     B
        JR      C,L0CD8                 
        ADD     HL,DE
        JR      L0CD2                   
L0CD8:  LD      DE,00008h
        ADD     HL,DE
        BIT     7,(HL)          ; Do scene have bonus????
        JR      Z,L0CE4         ; No, so skip ahead        
        LD      A,(HL)          ; Get Bonus
        CALL    L066B           ; Add Bonus to Score
L0CE4:  POP     HL              ; Restore HL Register
        POP     BC              ; Restore BC Register
        RET                     ; Return








; ---------------------------------------------------
;   Table B Rountine #17:  Check Button: ITEMS
; ---------------------------------------------------
L0CE7:  LD      HL,0BE0Bh       ; Check Keyboard Buffer
        BIT     0,(HL)          ; Has a key been pressed?
        RET     Z               ; No, so return
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        CP      032h            ; Check if "ITEMS (2)" is Pressed
        RET     NZ              ; "2" not pressed so return
        RES     0,(HL)          ; Clear Keyboard Buffer
        BIT     7,(IX+00Bh)     ; Is this scene timed? (Var0B)
        RET     NZ              ; Yes, so action is not allowed here
; ---------------------------------------------------
;         Speak Inventory or Show Inventory?
; ---------------------------------------------------
L0CFA:  LD      DE,00063h       ; Phrase="Do You Want To See Your Item (%)"
        CALL    L1363           ; Call Speech Routine (phrase)
        CALL    L19E7           ; Check for "YES" or "NO"
        JR      C,L0CFA         ; Timed out so repeat question
        JR      Z,L0D0E         ; "YES" so check inventory
        LD      HL,0BCA0h       ; HL = Start of Inventory
        CALL    L12F6           ; Speak Inventory
        RET                     ; Return
L0D0E:  CALL    L0D12           ; Show Inventory 
        RET                     ; Return





; ---------------------------------------------------
;             Show Player's Inventory
; ---------------------------------------------------
L0D12:  LD      HL,0A782h       ;
        SET     5,(HL)          ;
        LD      A,(0BE01h)      ;
        PUSH    AF              ;
        RES     7,A             ;
        LD      (0BE01h),A      ;
; ---------------------------------------------------
;      Scan inventory to see if empty handed
; ---------------------------------------------------
        LD      HL,0BCA0h       ; HL = Point to start of inventory
        LD      B,01Ah          ; Number of items = A - Z (26)
L0D25:  BIT     1,(HL)          ; Is item being held?
        JR      NZ,L0D38        ; Yes, so show items
        INC     HL              ; Check next item
        DJNZ    L0D25           ; Loop until all items checked
; ---------------------------------------------------
;    No items being held, show "You Have Nothing"
; ---------------------------------------------------
        LD      HL,(0C039h)     ; Get Pointer to Item Table
        XOR     A               ; A=0, "You Have Nothing"
        CALL    L08A4           ; DE = Pointer to scene (HL+A*2)
        CALL    L0D7A           ; Show Freeze Frame of Item
        JR      L0D69           ; Jump to end 

L0D38:  LD      HL,(0C039h)     ; Get Pointer to Item Table A
        INC     HL              ; Point to next
        INC     HL              ; Point to next, HL = HL + 2
        XOR     A               ; A = 0, "You have acquired the following..."
        CALL    L08A4           ; DE = Pointer to scene (HL+A*2)
        CALL    L0D7A           ; Show Freeze Frame of Message
        LD      B,01Ah          ; 26 items to check
        LD      HL,0BCA0h       ; HL = Start of Inventory
        LD      DE,(LC039)      ; DE Points to Item Table A
        INC     DE              ; Skip Inventory message frames
        INC     DE              ; Skip Inventory message frames
        INC     DE              ; Skip Inventory message frames
        INC     DE              ; Skip Inventory message frames
        XOR     A               ; A = 0, first item
L0D52:  BIT     1,(HL)          ; Is item in inventory?
        JR      Z,L0D65         ; Not in inventory, so skip ahead
; ---------------------------------------------------
;      Item is in inventory so show picture
; ---------------------------------------------------
        PUSH    HL              ; Save HL Register
        PUSH    DE              ; Save DE Register
        PUSH    BC              ; Save BC Register
        PUSH    AF              ; Save AF Register
        EX      DE,HL           ; HL = DE
        CALL    L08A4           ; DE = Pointer to scene (HL+A*2)
        CALL    L0D7A           ; Show Freeze Frame of Item
        POP     AF              ; Restore AF Register
        POP     BC              ; Restore BC Register
        POP     DE              ; Restore DE Register
        POP     HL              ; Restore HL Register

L0D65:  INC     HL              ; Check next item
        INC     A               ; Next item
        DJNZ    L0D52           ; Loop until all items checked

L0D69:  LD      HL,0A782h
        RES     5,(HL)          ;
        LD      HL,0BE03h       ;
        SET     0,(HL)
        SET     1,(HL)
        POP     AF
        LD      (0BE01h),A
        RET     



; ---------------------------------------------------
;     Play Message Frame from Disc for 2 seconds
;        DE = Frame Number of Scene
; ---------------------------------------------------
L0D7A:  CALL    L1BE3           ; PLAY Scene with Timer
        LD      DE,0003Ch       ; Load Programmable Timer = 3Ch
        CALL    L21A7           ; Set Programmable Timer
L0D83:  CALL    L21B3           ; Check if Programmable Timer expired
        JR      Z,L0D83         ; Loop until timer expires
        RET                     ; Return









; ---------------------------------------------------
;  Rountine #18:   Check Button: GIVE SCORE
; ---------------------------------------------------
L0D89:  LD      HL,0BE0Bh       ; Get Keyboard Buffer
        BIT     0,(HL)          ; Has a key been pressed?
        RET     Z               ; No, so return
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        CP      034h            ; Check if "GIVE SCORE (4)" Pressed
        RET     NZ              ; Not pressed, so return
        RES     0,(HL)          ; Clear Keyboard Buffer
        BIT     7,(IX+00Bh)     ; Is scene timed? (Var0B)
        RET     NZ              ; Yes, so action is not allowed here
; ---------------------------------------------------
;      Speak Score out of Possible Range
; ---------------------------------------------------
L0D9C:  LD      HL,0BCE2h       ; HL = Pointer to Score
        LD      DE,0A6D0h       ; DE = Speakable Number (n)
        LD      BC,00003h       ; Loop = 3 numbers to copy
        LDIR                    ; Copy numbers to speak
        LD      DE,00038h       ; Phrase="(%) Your Score Is (n)"
        CALL    L1363           ; Call Speech Routine (phrase)
L0DAD:  LD      HL,0C003h       ; Get Total Possible Score
        LD      DE,0A6D0h       ; DE = Speakable Number (n)
        LD      BC,00003h       ; Loop = 3
        LDIR                    ; Copy all digits
        LD      DE,0007Dh       ; Phrase="Out Of A Possible (n)"
        CALL    L1363           ; Call Speech Routine (phrase)
        RET                     ; Return







; ---------------------------------------------------
;   Table B Rountine #12:  Check Keyboard
; ---------------------------------------------------
L0DBF:  CALL    L2190           ; Keyboard check routine
        RET     C               ; No keypress, so return
        LD      (0BE0Ah),A      ; Put Keypress in buffer
        LD      HL,0BE0Bh       ; Check Keyboard buffer 
        SET     0,(HL)          ; Set buffer to full
        RET                     ; Return




; ---------------------------------------------------
; Table B Rountine #24:  Check Button:  HINT
; ---------------------------------------------------
L0DCC:  LD      HL,0BE0Bh       ; Check Keyboard Buffer
        BIT     0,(HL)          ; Has a key been pressed?
        RET     Z               ; No, so return
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        CP      039h            ; Check if "HINT (9)" Pressed
        RET     NZ              ; Not pressed, so return
        RES     0,(HL)          ; Clear Keyboard Buffer
        BIT     7,(IX+00Bh)     ; Is scene timed? (Var0B)
        RET     NZ              ; Yes, so action is not allowed here
        LD      DE,0008Dh       ; Phrase="(%) I Only Give Pointer When You Need Them"
        CALL    L1363           ; Call Speech Routine (phrase)
        RET                     ; Return




; ---------------------------------------------------
;  Routine #22:   Check Button:  SAVE GAME
; ---------------------------------------------------
L0DE6:  LD      HL,0BE0Bh       ; Check Keyboard Buffer
        BIT     0,(HL)          ; Has a key been pressed?
        RET     Z               ; No, so return
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        CP      037h            ; Check if "SAVE GAME (7)" Pressed
        RET     NZ
        RES     0,(HL)
        BIT     7,(IX+00Bh)     ; Is scene timed? (Var0B)
        RET     NZ              ; Yes, so action is not allowed here

; ---------------------------------------------------
;              Do Save Game
; ---------------------------------------------------
L0DF9:  LD      DE,0007Bh       ; Phrase="I Have Saved Your Game"
        CALL    L1363           ; Call Speech Routine (phrase)
L0DFF:  LD      HL,0BC80h       ; Get Audio Track
        LD      (HL),000h       ; Reset Audio Track
        BIT     7,(IX+002h)     ; Check Audio Track from data
        JR      Z,L0E0C         ; Audio Track 1 selected, skip ahead   
        SET     0,(HL)          ; Select Audio Track 2
L0E0C:  CALL    L0E10           ; Call SAVE GAME
        RET                     ; Return








; ---------------------------------------------------
;                  SAVE GAME     
; ---------------------------------------------------
;   Copy Location BC00-BDFF to new SAVED GAME Bank
;        BC00 = Bank number where to save game
; ---------------------------------------------------
L0E10:  LD      A,(0BC00h)      ; A = Index to correct Bank
        LD      B,A             ; Loop = A
        LD      HL,0A600h       ; HL = A600h
        LD      DE,00200h       ; DE = 200h
L0E1A:  ADD     HL,DE           ; HL = HL + 200h
        DJNZ    L0E1A           ; Loop until correct Bank            
; ---------------------------------------------------
;          Copy BC00-BDFF to correct Bank         
; ---------------------------------------------------
        EX      DE,HL           ; DE = Bank Address
        LD      HL,0BE01h       ; Get GAME STATUS Register
        SET     1,(HL)          ; SAVE in progress, set bit1
        LD      HL,0BC00h       ; HL = BC00
        LD      BC,00200h       ; Loop = 200
        LDIR                    ; Copy Bank
        LD      HL,0BE01h       ; HL = BE01
        RES     1,(HL)          ; SAVE complete, clear bit1
        RET                     ; Return






; ---------------------------------------------------
; Table B Rountine #23:  Check Button:  UPDATE
; ---------------------------------------------------
L0E31:  LD      HL,0BE0Bh       ; Check Keyboard Buffer
        BIT     0,(HL)          ; Has a key been pressed?
        RET     Z               ; No, so return
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        CP      038h            ; Check if "UPDATE (8)" Pressed
        RET     NZ              ; Key not pressed, so return
        RES     0,(HL)          ; Clear Keyboard Buffer
        BIT     7,(IX+00Bh)     ; Is scene timed? (Var0B)
        RET     NZ              ; Yes, so action is not allowed here
        LD      DE,00089h       ; Phrase="You Need A Voice Print To Update (%)"
        CALL    L1363           ; Call Speech Routine (phrase)
        RET                     ; Return



; ---------------------------------------------------
;      Starting Number of Lives, Audio Track         
; ---------------------------------------------------
L0E4B:  LD      A,(0BE0Fh)      ; Get DIP Switch A
        BIT     4,A             ; Test A5, Lives per Game
        JR      NZ,L0E58        ;
        LD      A,(LC001)       ; Get Number of Lives (3)
        LD      (0BCE8h),A      ; Store Number of Lives
L0E58:  LD      HL,0BC80h       ;
        BIT     0,(HL)          ; Check which Audio Track to use
        LD      HL,0BE03h       ;
        RES     4,(HL)          ; Set Audio Track 1
        RET     Z               ; Audio Track 1 selected so return
        SET     4,(HL)          ; Set Audio Track 2
        RET                     ; Return






; ---------------------------------------------------
;   Table B Rountine #1:  Giving Hints
; ---------------------------------------------------
L0E66:  LD      A,(0BC81h)      ; Get Scene Index
        LD      HL,0BCF0h       ; Point to RAM Hint Table
        ADD     A,L             ; Add Scene Index to table
        LD      L,A             ; Add Scene Index to table
        JR      NC,L0E71        ; Add        
        INC     H               ; HL = Pointer to spot in Hint RAM
L0E71:  LD      A,(HL)          ; A = Hint RAM
        BIT     7,(IX+002h)     ; Var02 = Which Hint Table to use
        JR      NZ,L0E8B        ; Use upper nibble RAM        
        AND     00Fh            ; Use lower nibble RAM
L0E7A:  LD      C,A             ; C = RAM Hint
        LD      A,(0BC81h)      ; Get Scene Index
        LD      B,A             ; B = Scene Index
; ---------------------------------------------------
;       Determine which Hint Table to use
;       based on bit in Var02 of Scene Data
; ---------------------------------------------------
        SCF                     ; Carry = 1, Hint Table 2
        BIT     7,(IX+002h)     ; Var02 = Which Hint Table to use
        JR      NZ,L0E87        ; Clear so jump ahead
        CCF                     ; else Carry = 0, use Hint Table (Audio Track 1)
L0E87:  CALL    L1629           ; Hint Request Processing
        RET                     ; Return

L0E8B:  AND     0F0h            ; Get upper nibble
        SRL     A               ; Shift upper nibble to lower
        SRL     A               ; Shift upper nibble to lower
        SRL     A               ; Shift upper nibble to lower
        SRL     A               ; Shift upper nibble to lower
        JR      L0E7A           ; Jump back





; ---------------------------------------------------
;   Routine #21     Check Button:  COMBINE ACTION
; ---------------------------------------------------
L0E97:  LD      HL,0BE0Bh       ; Check Keyboard Buffer
        BIT     0,(HL)          ; Has a key been pressed?
        RET     Z               ; No, so return
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        CP      036h            ; Check if "COMBINE ACTION (6)" is Pressed
        RET     NZ              ; Not pressed to return
; ---------------------------------------------------
;            Check if COMBINE is available
; ---------------------------------------------------
        LD      A,(IX+00Bh)     ;
        AND     007h            ;
        JR      NZ,L0EB2        ;        
        LD      DE,00032h       ; Phrase="You Don't Have That Choice Here (%)"
        CALL    L1363           ; Call Speech Routine (phrase)
        JR      L0EC7           ; Leave routine
; ---------------------------------------------------
;          Reset COMBINE work area (6 bytes)
; ---------------------------------------------------
L0EB2:  LD      DE,00077h       ; Phrase="Choose The Item To Combine"
        CALL    L1363           ; Call Speech Routine (phrase)
        LD      HL,0BE03h       ; Get MODE Register 
        SET     2,(HL)          ; Enter COMBINE MODE
        LD      B,006h          ; Loop = 6
        LD      HL,0BE31h       ; Point to combine work area
        XOR     A               ; Clear COMBINE ITEMS first
L0EC3:  LD      (HL),A          ; Clear work area
        INC     HL              ; Point to next location
        DJNZ    L0EC3           ; Loop until work area cleared        
; ---------------------------------------------------
;         Clear keyboard buffer then return
; ---------------------------------------------------
L0EC7:  LD      HL,0BE0Bh       ; Get Keyboard Buffer
        RES     0,(HL)          ; Clear Keyboard Buffer
        RET                     ; Return






; ---------------------------------------------------
;                Combining Items
; ---------------------------------------------------
L0ECD:  LD      HL,0BE0Bh       ; Check Keyboard Buffer
        RES     0,(HL)          ; Clear keyboard buffer
        CALL    L0F50           ; Point to row based on scene (C9A5)
        INC     HL              ; HL = C9A5+8*x
        LD      A,(HL)          ;
        LD      (0BE30h),A      ;
        INC     HL              ; HL = 
        LD      B,001h          ;
L0EDD:  LD      A,(0BE0Ah)      ; Get Keyboard Character
        AND     01Fh            ; Get item number
        CP      (HL)            ; Is item in table?
        JR      Z,L0F04         ; No, so skip ahead
        LD      A,(0BE30h)      ;
        CP      B               ;
        JR      Z,L0EEF         ;        
        INC     HL              ;
        INC     B               ;
        JR      L0EDD           ;        

L0EEF:  CALL    L0F50           ; Get HL pointer to row (C9A5)
        LD      A,(HL)          ; HL = C9A5+8*x
        LD      (0BC81h),A      ;
        LD      HL,0BE03h       ; Get MODE Register
        SET     0,(HL)          ; Reset Main Loop
        RES     2,(HL)          ; Cancel COMBINE MODE
        LD      DE,00032h       ; Phrase="You Don't Have That Choice Here (%)"
        CALL    L1363           ; Call Speech Routine (phrase)
        RET                     ; Return






; ---------------------------------------------------
;               Speak KeyPress Item           
; ---------------------------------------------------
L0F04:  LD      A,(0BE0Ah)      ; Get Keyboard Character
        SUB     041h            ; Subtract 65d
        LD      E,A             ; DE = Character Value
        LD      D,000h          ; DE = Character Value
        LD      HL,08001h       ; HL = Voice Message Table
        ADD     HL,DE           ; Index to Key Message
        EX      DE,HL           ; DE = Phrase for KeyPress
        CALL    L1363           ; Call Speech Routine (phrase)           
        LD      HL,0BE31h
        LD      A,B
        DEC     A
        JR      Z,L0F20         ; 
        ADD     A,L
        LD      L,A
        JR      NC,L0F20        ; 
        INC     H
L0F20:  LD      A,(HL)
        CP      001h            ; Has Item been picked up?
        RET     Z

        INC     (HL)
        LD      HL,0BE31h
        LD      A,(0BE30h)
        LD      B,A
        XOR     A
L0F2D:  CP      (HL)
        RET     Z

        INC     HL
        DJNZ    L0F2D                   
        LD      HL,0BE03h
        RES     2,(HL)
        LD      A,(IX+00Bh)
        AND     007h
        ADD     A,01Ah
        ADD     A,040h
        LD      (0BE0Ah),A
        SUB     040h
        CALL    L11DF           ; Point to Item in Inventory
        SET     1,(HL)
        LD      HL,0BE0Bh       ; Get Keyboard Buffer   
        SET     0,(HL)
        RET     


; ---------------------------------------------------
;                    Unknown
; ---------------------------------------------------
;         IX+0Bh =  Scene Index + something
;      Return HL =  Address to row of 8 zeros
; ---------------------------------------------------
L0F50:  LD      HL,LC9A5        ; Point to start of table
        LD      A,(IX+00Bh)     ;
        AND     007h            ;
        CP      001h            ;
        RET     Z               ;
        DEC     A               ;
        LD      B,A             ; B = Loop
        LD      DE,00008h       ; Point to next row
L0F60:  ADD     HL,DE           ; Add to pointer
        DJNZ    L0F60           ; Loop until correct row is found
        RET                     ; Return






; ---------------------------------------------------
;            Check if player has item
; ---------------------------------------------------
L0F64:  LD      A,(0BE0Ah)      ; Get Keyboard Character
        AND     01Fh            ; Get item number
        LD      (0BE26h),A      ; Save item selected
        CALL    L11DF           ; Point to Item in Inventory
        BIT     1,(HL)          ; Check if item is in inventory
        JR      NZ,L0F79        ; Item is held so jump ahead        
        CALL    L120F           ; Tell Player they don't have said item
        JP      L0FF8           ; Skip to end
; ---------------------------------------------------
;            Check if Item can be Swapped
; ---------------------------------------------------
L0F79:  CALL    L11E7           ; Go to last byte of swap data
        LD      A,00Bh          ; Point to last byte
        ADD     A,L             ; Point to last byte
        LD      L,A             ; Point to last byte
        JR      NC,L0F83        ; Point to last byte        
        INC     H               ; Adjust pointer to end of row
                                
L0F83:  LD      B,006h          ; Loop = 6 possible swap senarios
L0F85:  LD      A,(HL)          ; Check byte for swap data
        CP      000h            ; Is there swap data here?
        DEC     HL              ; Data empty so skip next byte
        PUSH    HL              ; Save swap pointer
        JR      Z,L0F95         ; No data, so jump ahead and continue loop
; ---------------------------------------------------
;  Swap is possible, check if correct item was used
; ---------------------------------------------------                
        LD      A,(HL)          ; Get required item data
        AND     01Fh            ; Get required item value
        LD      HL,0BE26h       ; Point to item selected    
        CP      (HL)            ; Is selected item the reqired item needed?        
        JR      Z,L0F9F         ; Yes, so jump ahead and allow swap        
L0F95:  POP     HL              ; Get swap pointer
        DEC     HL              ; Go to next swap senario
        DJNZ    L0F85           ; Loop until all 6 swap senarios are checked
; ---------------------------------------------------
;        Incorrect item, item has no use here
; ---------------------------------------------------                
        CALL    L11FA           ; Tell player that item won't work here
        JP      L0FF8           ; Clear keyboard buffer and return

; ---------------------------------------------------
;                Prepare to swap Items
; ---------------------------------------------------
L0F9F:  POP     HL              ; Get swap pointer
        BIT     6,(HL)
        JR      Z,L0FD5                 
        BIT     7,(HL)
        PUSH    HL              ; Save swap pointer
        JR      Z,L0FB6                 
        LD      A,(0BE26h)      ; Get item selected
        CP      01Bh            ; Is it one of 26 items
        JR      C,L0FC8         ; No, it's more than 26        
        CALL    L102A           ; Drop combined items
        POP     HL              ; Get swap pointer
        JR      L0FD5                   

L0FB6:  LD      A,(0BE26h)      ; Get item selected
        CP      01Bh
        JR      C,L0FC3         ; Item is only dropped                 
        CALL    L0FFE
        POP     HL
        JR      L0FD5                   
L0FC3:  CALL    L11C7           ; Remove item from inventory 
        JR      L0FCB                   
L0FC8:  CALL    L11D2           ; Mark item as used
L0FCB:  LD      A,(0BE26h)      ; Get item selected
        CALL    L1224           ; Get Item's Weight
        CALL    L1230           ; Decrease Strength with item weight
        POP     HL
L0FD5:  BIT     5,(HL)
        PUSH    HL
        JR      Z,L0FEB                 
        LD      A,(IX+00Ah)     ; Get item located in room
        AND     01Fh            ; Isolate item number
        LD      HL,0BCC0h
        ADD     A,L
        LD      L,A
        JR      NC,L0FE7                
        INC     H

L0FE7:  RES     0,(HL)
        SET     1,(HL)

L0FEB:  POP     HL
        INC     HL
        LD      A,(HL)
        LD      (0BC81h),A
        LD      HL,0BE03h
        SET     4,(HL)          ; Set Audio Track 2
        SET     0,(HL)

L0FF8:  LD      HL,0BE0Bh       ; Get Keyboard Buffer
        RES     0,(HL)          ; Clear Keyboard Buffer
        RET                     ; Return






; ---------------------------------------------------
;                   Unknown
; ---------------------------------------------------
L0FFE:  LD      HL,0C99Eh       ;
        LD      A,(IX+00Bh)     ;
        AND     007h            ;
        SLA     A               ;
        SLA     A
        SLA     A
        ADD     A,L
        LD      L,A
        JR      NC,L1011                
        INC     H
L1011:  LD      A,(HL)
        LD      B,A
        INC     HL
L1014:  LD      A,(HL)
        PUSH    HL
        PUSH    AF
        CALL    L11DF           ; Point to Item in Inventory
        RES     1,(HL)
        SET     0,(HL)
        POP     AF
        CALL    L1224           ; Get Item's Weight
        CALL    L1230           ; Decrease Strength with item weight
        POP     HL
        INC     HL
        DJNZ    L1014
        RET     






; ---------------------------------------------------
;        Drop Multiple Items that are combined
; ---------------------------------------------------
L102A:  LD      HL,0C99Eh       ; Point to Item Table
        LD      A,(IX+00Bh)     ; Get row, 8 bytes per row
        AND     007h            ; Row Number between 0-7
        SLA     A               ; multiply by 2 (*2)
        SLA     A               ; multiply by 2 (*4)
        SLA     A               ; multiply by 2 (*8)
        ADD     A,L             ; Index into table
        LD      L,A             ; Index into correct row
        JR      NC,L103D        ; Check carry         
        INC     H               ; Index into row
; ---------------------------------------------------
;         Drop all Items that are in table
; ---------------------------------------------------
L103D:  LD      A,(HL)          ; Get Number of items from table
        LD      B,A             ; B = Number of items to drop
        INC     HL              ; Point to item in table
L1040:  LD      A,(HL)          ; Get item number from table
        PUSH    HL
        PUSH    AF
        CALL    L11DF           ; Point to Item in Inventory  
        RES     0,(HL)
        RES     1,(HL)          ; Drop item from inventory
        SET     2,(HL)
        POP     AF
        CALL    L1224           ; Get Item's Weight
        CALL    L1230           ; Decrease Strength with item weight
        POP     HL
        INC     HL              ; Next item in table
        DJNZ    01040h          ; Loop until all items dropped
        RET                     ; Return






; ---------------------------------------------------
;             Using or Picking up Items
; ---------------------------------------------------
L1058:  LD      A,(0BE0Ah)      ; Get Keyboard Character
        AND     01Fh            ; Isolate item number
        LD      HL,0BE26h       ; Temp save location 
        LD      (HL),A          ; Save item selected
        LD      A,(IX+00Ah)     ; Check item located in room
        AND     01Fh            ; Isolate item number
        CP      (HL)            ; Is item in room to be picked up?
        JR      NZ,L109E        ; No, so check if item is being used

; ---------------------------------------------------
;            Picking up an item from a room
; ---------------------------------------------------                
        BIT     0,(IX+00Dh)     ; Can we pick up items here?
        JR      Z,L1095         ; No, so skip ahead        
        CALL    L123C           ; HL = Health Pointer
        PUSH    HL              ; Save Health Pointer
; ---------------------------------------------------
;     Check if player is strong enough to take item
; ---------------------------------------------------
        LD      A,(0BE26h)      ; Get item selected
        CALL    L1224           ; Get Item's Weight
        LD      HL,0BCE1h       ; Get Strength 
        ADD     A,(HL)          ; Decrease player's strength
        LD      (0BE18h),A      ; Save new strength temporarily
        POP     HL              ; Point to Health
        LD      A,(HL)          ; Get Health
        LD      HL,0BE18h       ; Point to new strength
        CP      (HL)            ; Are they strong enough to pick up item?
        JP      C,L11A6         ; No, the player must drop something
        LD      A,(0BE18h)      ; Get new stregth
        LD      (0BCE1h),A      ; Save player's adjusted strength
        LD      A,(0BE26h)      ; Get item selected
        CALL    L11BF           ; Put item in inventory

L1095:  LD      A,(IX+00Ch)     ; Get next scene
        LD      (0BC81h),A      ; Store Scene Index
        JP      L1199           ; Update then return



; ---------------------------------------------------
;           Use an Item to get another Item
; ---------------------------------------------------
L109E:  LD      A,(0BE26h)      ; Get item selected
        CALL    L11DF           ; Point to Item in Inventory
        BIT     1,(HL)          ; Is item in inventory?
        JR      NZ,L10AE        ; Yes, so skip ahead        
        CALL    L120F           ; Tell Player they don't have said item
        JP      L11A0           ; Clear Keyboard Buffer and Return
; ---------------------------------------------------
;          Get Item Swap Properties from table
; ---------------------------------------------------
L10AE:  LD      HL,LC743        ; Start of Item Swap table
        LD      A,(IX+00Ah)     ; Get item located in room
        AND     01Fh            ; Get item number
        CP      001h            ; Is it the first item?
        JR      Z,L10C2         ; Yes, so row is set       
        DEC     A               ; Subtract 1
        LD      B,A             ; Loop = Item row
        LD      DE,00006h       ; Skip row (6 bytes)
L10BF:  ADD     HL,DE           ; Point to next row
L10C0:  DJNZ    L10BF           ; Loop until Item Use row found      
; ---------------------------------------------------
;            Check if Item can be Swapped
; ---------------------------------------------------
L10C2:  LD      A,005h          ; Go to last byte of swap data
        ADD     A,L             ; Point to last byte
        LD      L,A             ; Point to last byte
        JR      NC,L10C9        ; Point to last byte
        INC     H               ; Point to last byte

L10C9:  LD      B,003h          ; Loop = 3 possible swap senarios
L10CB:  LD      A,(HL)          ; Check byte for swap data
        CP      000h            ; Is there swap data here?
        JR      NZ,L10D4        ; Yes, so skip ahead and check for item match
        DEC     HL              ; Data empty so skip next byte
        PUSH    HL              ; Save swap pointer
        JR      L10DF           ; Jump ahead and continue loop
; ---------------------------------------------------
;  Swap is possible, check if correct item was used
; ---------------------------------------------------
L10D4:  DEC     HL              ; Point to required item data
        LD      A,(HL)          ; Get required item data
        AND     01Fh            ; Get required item value
        PUSH    HL              ; Save swap pointer
        LD      HL,0BE26h       ; Point to item selected
        CP      (HL)            ; Is selected item the reqired item needed?
        JR      Z,L10E9         ; Yes, so jump ahead and allow swap        
L10DF:  POP     HL              ; Get swap pointer
        DEC     HL              ; Go to next swap senario
        DJNZ    L10CB           ; Loop until all 3 swap senarios are checked
; ---------------------------------------------------
;       Incorrect item, item has no use here
; ---------------------------------------------------                
        CALL    L11FA           ; Tell player that item won't work here
        JP      L11A0           ; Clear Keyboard Buffer and Return

; ---------------------------------------------------
;                Prepare to swap Items
; ---------------------------------------------------
L10E9:  POP     HL              ; Get swap pointer
        BIT     6,(HL)          ; Is it a 1-for-1 swap?
        JP      Z,L115E         ; Yes, so jump ahead
        BIT     5,(HL)          ; Is it a 2-for-1 swap?
        JR      NZ,L110E        ; Yes, so jump ahead
               
        PUSH    HL              ; Save swap pointer
        CALL    L11C7           ; Remove item from inventory
        LD      A,(0BE26h)      ; Get item selected
        CALL    L1224           ; Get Item's Weight
        CALL    L1230           ; Decrease Strength with item weight
        POP     HL              ; Get swap pointer
        BIT     7,(HL)          ; Does the item expire after use?
        JP      Z,L1194         ; No, so skip ahead and play successful swap scene
; ---------------------------------------------------
;        Mark item as used, play successful scene
; ---------------------------------------------------
        PUSH    HL              ; Save swap pointer
        CALL    L11D2           ; Mark item as used 
        POP     HL              ; Get swap pointer
        JP      L1194           ; Play successful swap scene

; ---------------------------------------------------
;                        
; ---------------------------------------------------
L110E:  PUSH    HL              ; Save swap pointer
        LD      A,(0BE26h)      ; Get item selected
        CALL    L1224           ; Get Item's Weight
        LD      (0BE18h),A
        LD      A,(0BCE1h)
        LD      HL,0BE18h
        SBC     A,(HL)
        LD      (0BE18h),A
        LD      A,(IX+00Ah)     ; Get item located in room
        AND     01Fh            ; Isolate item number
        CALL    L1224           ; Get Item's Weight
        LD      HL,0BE18h       ; Point to player strength
        ADD     A,(HL)          ; Add weight to player's strength
        LD      (0BE18h),A      ; Save player's strength temporarily
        CALL    L123C           ; HL = Health Pointer
        LD      A,(HL)          ; Get Health
        LD      HL,0BE18h       ; Point to new strength
        CP      (HL)            ; Are they strong enough to pick up item?
        JR      NC,L113F        ; Yes, so skip ahead         
        POP     HL              ; Get swap pointer
        JP      L11A6           ; Tell player to drop something before picking up

L113F:  LD      A,(0BE18h)
        LD      (0BCE1h),A
        CALL    L11C7           ; Remove item from inventory
        POP     HL
        BIT     7,(HL)
        JR      Z,L1152                 
        PUSH    HL
        CALL    L11D2           ; Mark item as used
        POP     HL              ; Get swap pointer
; ---------------------------------------------------
;            Put new item into inventory
; ---------------------------------------------------
L1152:  PUSH    HL              ; Save swap pointer
        LD      A,(IX+00Ah)     ; Get item located in room
        AND     01Fh            ; Isolate item number
        CALL    L11BF           ; Put item in inventory
        POP     HL              ; Get swap pointer
        JR      L1194           ; Play successful swap scene        



; ---------------------------------------------------
;                        
; ---------------------------------------------------                       
L115E:  BIT     5,(HL)
        JR      Z,L1194                 
        PUSH    HL              ; Save swap pointer
        LD      A,(0BCE1h)      ; Get Strength
        LD      (0BE18h),A      ; Save Strength temporarily
        LD      A,(IX+00Ah)     ; Get item located in room
        AND     01Fh            ; Isolate item number
        CALL    L1224           ; Get Item's Weight
        LD      HL,0BE18h       ; Point to temporary strength
        ADD     A,(HL)          ; Add to player's strength
        LD      (0BE18h),A      ; Save calculated strength
        CALL    L123C           ; HL = Health Pointer
        LD      A,(HL)
        LD      HL,0BE18h
        CP      (HL)
        JR      NC,L1185                
        POP     HL
        JR      L11A6           ; Tell player to drop something before picking up        
L1185:  LD      A,(0BE18h)
        LD      (0BCE1h),A
        LD      A,(IX+00Ah)
        AND     01Fh
        CALL    L11BF           ; Put item in inventory
        POP     HL              ; Get swap pointer
; ---------------------------------------------------
;           Play successful swap scene
; ---------------------------------------------------
L1194:  INC     HL              ; Point to swap scene byte
        LD      A,(HL)          ; Get swap scene
        LD      (0BC81h),A      ; Store new Scene Index
L1199:  LD      HL,0BE03h       ; Get MODE Register
        SET     0,(HL)          ;
        SET     4,(HL)          ; Set Audio Track 2
L11A0:  LD      HL,0BE0Bh       ; Get Keyboard Buffer
        RES     0,(HL)          ; Clear Keyboard Buffer
        RET                     ; Return






; ---------------------------------------------------
; Tell player to drop something before picking up
; ---------------------------------------------------
L11A6:  CALL    L136C           ; Clear Speech Buffer
        LD      DE,00039h       ; Phrase = "(%) You Must Drop Something To Get"
        CALL    L1383           ; Get Phrase from Table
        LD      A,(IX+00Ah)     ; Get item located in room
        AND     01Fh            ; Get item number
        LD      E,A             ; Turn item number into phrase
        LD      D,080h          ; Phrase = Item Name
        CALL    L1383           ; Get Phrase from Table
        CALL    L21C1           ; Command Speech Chip to speak buffer
        JR      L11A0           ; Clear Keyboard Buffer and Return         


; ---------------------------------------------------
;              Put item in inventory
; ---------------------------------------------------
L11BF:  CALL    L11DF           ; Point to Item in Inventory
        SET     1,(HL)          ; Put item into inventory
        RES     0,(HL)          ; ??
        RET                     ; Return


; ---------------------------------------------------
;             Remove item from inventory
; ---------------------------------------------------
L11C7:  LD      A,(0BE26h)      ; Get item selected
        CALL    L11DF           ; Point to Item in Inventory
        RES     1,(HL)          ; Remove item from inventory
        SET     0,(HL)          ; ??
        RET                     ; Return

; ---------------------------------------------------
;                Mark item as used
; ---------------------------------------------------
L11D2:  LD      A,(0BE26h)      ; Get item selected
        CALL    L11DF           ; Point to Item in Inventory
        SET     2,(HL)          ; Mark item as used
        RES     0,(HL)          ; ??
        RES     1,(HL)          ; Remove item from inventory
        RET                     ; Return



; ---------------------------------------------------
;            Point to Item in Inventory
; ---------------------------------------------------
;                A = Item Number
;      Return:  HL = BC9F + A
; ---------------------------------------------------
L11DF:  LD      HL,0BC9Fh       ;
        ADD     A,L             ;
        LD      L,A             ;
        RET     NC              ;
        INC     H               ;
        RET                     ;
                                




; ---------------------------------------------------
;          Get row data from C7DF ROM
; ---------------------------------------------------
;       Return HL = Pointer to row data
; ---------------------------------------------------
L11E7:  LD      HL,LC7DF        ; Get start of table
        LD      A,(IX+00Ah)     ; Get item located in room
        AND     01Fh            ; Get item number
        CP      000h            ; Is there an item in the room?
        RET     Z               ; No item in room so leave

        LD      B,A             ; Loop = Item row number 
        LD      DE,0000Ch       ; Skip one row of data
L11F6:  ADD     HL,DE           ; Go to next row
        DJNZ    L11F6           ; Loop until correct row is reached        
        RET                     ; Return



; ---------------------------------------------------
;       Tell player that item won't work here
; ---------------------------------------------------
L11FA:  CALL    L136C           ; Clear Speech Buffer
        LD      A,(0BE26h)      ; Get item trying to be used
L1200:  LD      E,A             ; Make item into word
        LD      D,080h          ; Setup word to speak
        CALL    L1383           ; Get Phrase from Table
        LD      DE,00031h       ; Phrase = "Won't Work Here (%)"
        CALL    L1383           ; Get Phrase from Table
        JP      L21C1           ; Command Speech Chip to speak buffer





; ---------------------------------------------------
;       Tell player they don't have said item
; ---------------------------------------------------
L120F:  CALL    L136C           ; Clear Speech Buffer
        LD      DE,00030h       ; Phrase = "Sorry (%) You Don't Have"
        CALL    L1383           ; Get Phrase from Table
        LD      A,(0BE26h)      ; Get Item trying to be used
        LD      E,A             ; Make item into word
        LD      D,080h          ; Set up Word to speak
        CALL    L1383           ; Get Phrase from Table
        JP      L21C1           ; Command Speech Chip to speak buffer






; ---------------------------------------------------
;             Get Item's Weight
; ---------------------------------------------------
;             A = Item Number (1-26)
; ---------------------------------------------------
;      Return A = Item Weight (0-7)
; ---------------------------------------------------
L1224:  LD      HL,0C95Eh       ; Point to Item Property Table
        ADD     A,L             ; Add item pointer
        LD      L,A             ; Add item pointer
        JR      NC,L122C        ; Jump on overflow       
        INC     H               ; Add item pointer
L122C:  LD      A,(HL)          ; Get item property
        AND     007h            ; Get item's weight
        RET                     ; Return





; ---------------------------------------------------
;         Decrease Strength with item weight
; ---------------------------------------------------
;             A = Item Weight (0-7)
; ---------------------------------------------------
L1230:  LD      HL,0BE18h       ; Item Weight
        LD      (HL),A          ; Store Item Weight
        LD      A,(0BCE1h)      ; Get Strength
        SBC     A,(HL)          ; Subtract Weight from Strength
        LD      (0BCE1h),A      ; Save Strength
        RET                     ; Return





; ---------------------------------------------------
;                    Unknown
; ---------------------------------------------------
;          (BCE0)     Health index
;          Return HL  Pointer to Health Value
; ---------------------------------------------------
L123C:  LD      HL,0C97Eh       ; Point to Health Table
        LD      A,(0BCE0h)      ; A = Health setting
        ADD     A,L             ; Add to pointer
        LD      L,A             ; Point to table
        RET     NC              ; Check carry
        INC     H               ; Point to table
        RET                     ; Return



    org  01247h
; ---------------------------------------------------
;               Initialize Speech Chip
; ---------------------------------------------------
L1247:  LD      (0A60Ah),HL     ; Erase any pending data
        LD      (0A608h),HL     ; Erase any pending data
        LD      A,080h          ; Control Code 80?
        OUT     (003h),A        ; Set Speech Chip Register3
        LD      A,0C0h          ; Control Code C0?
        OUT     (000h),A        ; Set Speech Chip Register0
        LD      A,07Bh          ; Control Code 7B?
        OUT     (003h),A        ; Set Speech Chip Register3
        LD      A,0E6h          ; Initial Filter Frequency (0E6h)
        OUT     (004h),A        ; Set Speech Chip Register4
        LD      A,090h          ; Control Code 90?
        OUT     (002h),A        ; Set Speech Chip Register2
        LD      A,046h          ; Initial Inflection (046h)   
        OUT     (001h),A        ; Set Speech Chip Register1
        XOR     A               ; Control Code = PAUSE (00h)
        OUT     (000h),A        ; Set Speech Chip Register0
        RET                     ; Return






; ---------------------------------------------------
;   Interrupt function to send data to Speech Chip
; ---------------------------------------------------
;   A60A is incremented here in the interrupt
;   Once A60A is equal to A608 then we're finished
; ---------------------------------------------------
L1269:  LD      A,(0A608h)      ; Get number of Control Codes to be sent
        LD      HL,(0A60Ah)     ; Get number of codes that have already been sent
        CP      L               ; Are there more control codes to send?
        JR      C,L1288         ; No control codes remaining, skip ahead
        JR      Z,L1288         ; No control codes remaining, skip ahead
; ---------------------------------------------------
;         Send bytes to Speech Chip registers
; ---------------------------------------------------
;        OUT (004h)  <- (A000) Filter Frequency  (ie E7h)
;        OUT (003h)  <- (A100) <AA>  Punctuation Control Codes  (ie 54h,74h)
;        OUT (002h)  <- (A200) <RI>  Character Control Codes (ie A8h)
;        OUT (001h)  <- (A300) <IO>  (ie 68h)
;        OUT (000h)  <- (A400) <OUT> Phoneme Codes (ie D,AH1,UH1)
; ---------------------------------------------------              
        LD      C,004h          ; Output to Speech Registers 4,3,2,1,0
        LD      B,005h          ; Loop = 5 registers
L1278:  LD      A,(HL)          ; Get character/code from message
        OUT     (C),A           ; Send character/code to Speech register
        INC     H               ; Next character/code (A000,A100,A200,...)
        DEC     C               ; Next register (port)
        DJNZ    L1278           ; Loop until all registers are written        
        LD      A,H             ; Get register
        SUB     005h            ; Go back to first register (A0xx)
        LD      H,A             ; Point to byte just sent
        INC     HL              ; Increment to next byte
        LD      (0A60Ah),HL     ; Save number of bytes sent
        RET                     ; Return
; ---------------------------------------------------
; Data packet sent so turn off Speech Chip interrupt
; ---------------------------------------------------
L1288:  LD      A,080h          ; Raise Control bit in Register3
        OUT     (003h),A        ; Send to Speech Chip Register3
        XOR     A               ; Control Code 00?
        OUT     (000h),A        ; Send to Speech Chip Register0
        LD      A,070h          ; Lower Control bit in Register3
        OUT     (003h),A        ; Send to Speech Chip Register3
        XOR     A               ; Control Code 00?
        OUT     (000h),A        ; Send to Speech Chip Register0
        RET                     ; Return





; ---------------------------------------------------
;            Phrase and Word Indexes
; ---------------------------------------------------
L1297:  .word  0686Bh    ; Phrase Index
L1299:  .word  05C7Bh    ; Word Index




; ---------------------------------------------------
;       Table of 1 of 4 Random Phrases
; ---------------------------------------------------
L129B:  DB  000h, 001h, 002h, 003h  ; Type in Name
L129F:  DB  004h, 005h, 006h, 007h  ; Name Too Long
L12A3:  DB  008h, 009h, 00Ah, 00Bh  ; Did I Say Your Name Right?
L12A7:  DB  00Ch, 00Dh, 00Dh, 00Fh  ; Just Letters
L12AB:  DB  010h, 011h, 012h, 013h  ; Enter Yes or No 
L12AF:  DB  014h, 017h, 016h, 015h  ; Act lively
L12B3:  DB  018h, 019h, 01Ah, 01Bh  ; Retype in Name
L12B7:  DB  01Ch, 01Dh, 01Eh, 01Fh  ; Empty-Handed
L12BB:  DB  02Ah, 02Bh, 02Ch, 02Ch  ; No Pointer
L12BF:  DB  02Dh, 02Dh, 02Eh, 02Fh  ; Try A Different Spelling
L12C3:  DB  032h, 03Dh, 03Eh, 01Bh  ; Bad Choice
L12C7:  DB  066h, 067h, 068h, 08Fh  ; Name sounds French
L12CB:  DB  05Eh, 09Ah, 09Bh, 09Ch  ; Nice To Have You Here Again (#)





; ---------------------------------------------------
;     Subtract values for Speaking Score
; ---------------------------------------------------
L12CF:  DB  098h, 096h, 080h  ; 10,000,000
        DB  00Fh, 042h, 040h  ;  1,000,000
        DB  001h, 086h, 0A0h  ;    100,000
        DB  000h, 027h, 010h  ;     10,000
        DB  000h, 003h, 0E8h  ;      1,000
        DB  000h, 000h, 064h  ;        100
        DB  000h, 000h, 00Ah  ;         10
        DB  000h, 000h, 001h  ;          1





; ---------------------------------------------------
;      Speak Score "Teen" Word Pointer Table
; ---------------------------------------------------
L12E7:   DB  02Bh  ; "Thir-"
         DB  004h  ; "Four-"
         DB  02Ch  ; "Fif-"
         DB  006h  ; "Six-"
         DB  007h  ; "Seven-"
         DB  008h  ; "Eight-"
         DB  009h  ; "Nine-"

; ---------------------------------------------------
;      Speak Score "Tens" Word Pointer Table
; ---------------------------------------------------
L12EE:   DB  02Eh  ; "Twen-"
         DB  02Bh  ; "Thir-"
         DB  004h  ; "Four-"
         DB  02Ch  ; "Fif-"
         DB  006h  ; "Six-"
         DB  007h  ; "Seven-"
         DB  008h  ; "Eight-"
         DB  009h  ; "Nine-"
                                 
                





; ---------------------------------------------------
;                 Speak Inventory
; ---------------------------------------------------
;       Count number of items in inventory 
; ---------------------------------------------------
L12F6:  PUSH    HL              ; Save start of inventory
        LD      B,01Ah          ; B = 26 items
        LD      DE,00000h       ; DE = Number of items held (zero)
L12FC:  BIT     1,(HL)          ; Is item being held?
        JR      Z,L1302         ; Not held, so skip ahead       
        INC     D               ; D = D + 1, Count items 
        LD      E,B             ; E = Item Index
L1302:  INC     HL              ; Check next item
        DJNZ    L12FC           ; Loop until all items checked

        POP     HL              ; Restore start of inventory
        LD      A,D             ; A = Number of items held
        OR      A               ; Is player empty-handed?
        JR      NZ,L1313        ; No, player has items so jump ahead

; ---------------------------------------------------
;           There are no items in inventory
; ---------------------------------------------------
        LD      IY,012B7h       ; Random Phrase = "Empty-Handed"
        CALL    L15EE           ; Speak Random Phrase
        JR      L1362           ; Jump to end

L1313:  CP      002h            ; Does player have more than 1 item?
        JR      NC,L132F        ; Yes, more than 1 item so jump ahead
; ---------------------------------------------------
;        Handle only one item in inventory
; ---------------------------------------------------
        CALL    L136C           ; Clear Speech Buffer
        LD      C,E             ;
        LD      DE,00020h       ; Phrase="(%) You Only Have"
        CALL    L1383           ; Get Phrase from Table
        LD      A,01Bh
        SUB     C
        LD      E,A
        LD      D,080h
        CALL    L1383           ; Get Phrase from Table
        CALL    L21C1           ; Command Speech Chip to speak buffer
        JR      L1362           ; Jump to end

; ---------------------------------------------------
;         Handle multiple items in inventory
; ---------------------------------------------------
L132F:  CALL    L136C           ; Clear Speech Buffer
        LD      C,D
        LD      DE,00021h       ; Phrase="(%) You Now Have"
        CALL    L1363           ; Call Speech Routine (phrase)
        LD      B,01Ah          ; Loop = 26 items
L133B:  CALL    L136C           ; Clear Speech Buffer
        BIT     1,(HL)          ; Check if item is being held
        JR      Z,L135F         ; Item not held so skip ahead        
        DEC     C
        JR      NZ,L134B        ; Skip the word AND if it's not the last item       
        LD      DE,00059h       ; Word="And"
        CALL    L13CF           ; Speak One Word
L134B:  LD      A,01Bh          ; Get item pointer
        SUB     B               ; Point to correct item
        LD      E,A             ; DE = item word
        LD      D,080h          ; DE = item word (08001-0801B)
        CALL    L1383           ; Get Phrase from Table
        LD      DE,(0A641h)     ; Get End of Speech Buffer
        DEC     DE              ; Subtract last character
        LD      A,02Ch          ; Character = ","
        LD      (DE),A          ; Add comma
        CALL    L21C1           ; Command Speech Chip to speak buffer 

L135F:  INC     HL              ;
        DJNZ    L133B           ;
L1362:  RET                     ;



; ---------------------------------------------------
;         Speech Routine (Phrase)
; ---------------------------------------------------
;         DE = Phrase #
; ---------------------------------------------------
L1363:  CALL    L136C           ; Clear Speech Buffer
        CALL    L1383           ; Get Phrase from Table
        JP      L21C1           ; Command Speech Chip to speak buffer



; ---------------------------------------------------
;               Clear Speech Buffer
; ---------------------------------------------------
L136C:  PUSH    IY              ; Save IY (Random Number 0-3)
        LD      IY,0A001h       ; Set End of Speech Buffer Pointer
        LD      (0A641h),IY     ; Save End of Speech Buffer Pointer
        LD      A,020h          ; First character is <space>
        LD      (0A000h),A      ; Save first character in buffer
        LD      A,001h          ; Set number of characters in buffer to 1
        LD      (0A614h),A      ; Save number of characters in buffer
        POP     IY              ; Restore IY (Random Number 0-3)
        RET                     ; Return



; ---------------------------------------------------
;       Find Speech Phrase from table
; ---------------------------------------------------
;         DE = Phrase #
; ---------------------------------------------------
L1383:  PUSH    HL              ; Save HL Register
        PUSH    DE              ; Save DE Register 
        PUSH    BC              ; Save BC Register
        BIT     7,D             ; Is DE > 8000h
        LD      HL,(01297h)     ; Get Phrase Table 1
        JR      Z,L1390         ; No, so use Table 1
        LD      HL,(0C01Fh)     ; DE > 8000h so get Phrase Table 2
L1390:  CALL    L1455           ; Check if Phrase # exists
        JR      C,L13C2         ; Phrase doesn't exist, jump to end
        LD      A,D             ; A = D
        AND     030h            
        SRL     A
        SRL     A
        SRL     A
        SRL     A
        LD      C,A
; ---------------------------------------------------
;       HL = DE * 2     Add Phrase Index to Table
; ---------------------------------------------------
        ADD     HL,DE           ; Add Index to table
        ADD     HL,DE           ; Add Index to table again
        LD      A,(HL)
        INC     HL
        LD      H,(HL)
        LD      L,A

; ---------------------------------------------------
;        Speak all words in the phrase
; ---------------------------------------------------
        LD      B,(HL)          ; B = Number of words in phrase
L13A8:  INC     HL
        LD      E,(HL)
        INC     HL
        LD      D,(HL)
        CALL    L13CF           ; Speak One word
        JR      C,L13C2         ; Character Buffer Overflow error, so skip to end                 
        DJNZ    L13A8           ; Loop until all words spoken

        LD      A,C             ; Get exclamation point
        OR      A               ; Was there an exclamation point?
        JR      Z,L13C2         ; No, so skip to end               
        LD      HL,01451h       ; Point to inflection level codes
        ADD     HL,BC           ; Index to proper level code
        LD      A,(HL)          ; Get inflection level code
        LD      HL,(0A641h)     ; Find end of speech buffer
        DEC     HL              ; Subract one from end of speech buffer
        LD      (HL),A          ; Put code on end of speech buffer
        OR      A               ; C = Set 
L13C2:  POP     BC              ; Restore BC Register
        POP     DE              ; Restore DE Register
        POP     HL              ; Restore HL Register
        RET                     ; Return





; ---------------------------------------------------
;             Speech Routine (Word)
; ---------------------------------------------------
L13C6:  CALL    L136C           ; Clear Speech Buffer            
        CALL    L13CF           ; Speak One Word
        JP      L21C1           ; Command Speech Chip to speak buffer









; ---------------------------------------------------
;               Speak One Word
;      DE = Index to Word & Word Properties
; ---------------------------------------------------
L13CF:  PUSH    HL              ; Save HL Register
        PUSH    DE              ; Save DE Register
        PUSH    BC              ; Save BC Register
; ---------------------------------------------------
;      Check for Word Properties by looking at 
;      the bits in the Index to Word, DE
;            DE = 0XXXX000
;                  ||||
;                  |||-
;                  |--- Inflection Level 0-3
;                  |
;                  ---- Plural
; ---------------------------------------------------
        LD      A,D             ; A = D
        AND     078h            ; Strip bits 01111000
        SRL     A               ; Shift bits left -->
        SRL     A               ; Shift bits left -->
        SRL     A               ; Shift bits left -->
        LD      (0A6CFh),A      ; Save Word Properties
        BIT     7,D             ; Determine whether to use Word Table 1 or 2
        LD      HL,(01299h)     ; Get Pointer to Word Table 1 (HL)
        JR      Z,L13E8         ; Word Table 1 is selected so skip ahead
        LD      HL,(0C021h)     ; Get Pointer to Word Table 2 (HL)
L13E8:  CALL    L1455           ; Check if word exists
        JR      C,L144A         ; If word doesn't exist, jump ahead
; ---------------------------------------------------
;            Setup Indexes to the word
; ---------------------------------------------------
        ADD     HL,DE           ; Add Index to Table
        ADD     HL,DE           ; Add Index to Table again
        LD      A,(HL)          ; Pointer to start of word in table
        INC     HL              ; Pointer to start of word in table
        LD      H,(HL)          ; Pointer to start of word in table
        LD      L,A             ; HL = Pointer to start of word
        LD      C,(HL)          ; C = number of characters in word
        LD      A,(0A614h)      ; Number of characters already in buffer
        ADD     A,014h          ; Check for extra room (20 spaces)
        JR      C,L144E         ; Character buffer overflow, skip ahead
        ADD     A,C             ; Check for room to add word 
        JR      C,L144E         ; Character buffer overflow, skip ahead        

        LD      B,000h          ; BC = Number of characters
        INC     HL              ; HL = Point to word characters
        LD      DE,(0A641h)     ; Get Speech Character Buffer start
        SCF                     ; Set carry
        LD      A,(0A6CFh)      ; Get Word Properties
        BIT     0,A             ; Check for Inflection1
        JR      NZ,L1411        ; Yes, do Inflection1 
        LDIR                    ; Copy all characters into Buffer
        JR      L141F           ; Check if word is plural (suffixes)



; ---------------------------------------------------
;             Process Word Properties
; ---------------------------------------------------
L1411:  LDI                     ; LDI Load and Increment    [DE]=[HL],HL=HL+1,#
        DEC     DE              ;
        PUSH    AF              ;
        LD      A,(DE)          ;
        CP      02Fh            ; Check for ending marker "/"
        JR      Z,L141B         ;
        INC     DE              ;
L141B:  POP     AF              ;
        JP      PE,L1411        ;


; ---------------------------------------------------
;                  Check for plural
; ---------------------------------------------------
L141F:  EX      DE,HL           ;
        LD      A,(0A6CFh)      ; Get Word Properties
        SRL     A               ; Shift bits left --->
        LD      (0A6CFh),A      ; Save Word Properties
        BIT     2,A             ; Should word be plural?
        JR      Z,L1432         ; No, so skip ahead
; ---------------------------------------------------
;                   Make Word Plural
; ---------------------------------------------------            
        LD      (HL),027h       ; Add an "'" before making plural
        INC     HL              ; Add character
        LD      (HL),053h       ; Add an "S" on the end to make plural
        INC     HL              ; Add character

; ---------------------------------------------------
;              Check for Inflection Level?
; ---------------------------------------------------
L1432:  LD      A,(0A6CFh)      ; Get Word Properties
        AND     003h            ; Check for Inflection Level
        LD      C,A             ; C = Inflection Level (0-3)
        PUSH    HL
        LD      HL,01451h       ; Get Inflection Table Start
        ADD     HL,BC           ; Point to Inflection Data 
        LD      A,(HL)          ; Get Inflection Data Byte
        POP     HL              ; Get End of Word buffer p
        LD      (HL),A          ; Put Inflection byte on the end of word
        INC     HL              ; Add Inflection character
        LD      (0A641h),HL     ; Save End of Word buffer
        LD      A,L
        DEC     A
        LD      (0A614h),A      ; Save number of characters in Speech buffer
        OR      A               ; Clear Character Buffer Overflow flag
L144A:  POP     BC
        POP     DE
        POP     HL
        RET                     ; Return with no error
; ---------------------------------------------------
;  Too many characters in speech buffer causes error
; ---------------------------------------------------             
L144E:  SCF                     ; Set Character Buffer Overflow error flag
        JR      L144A           ; Restore registers and return       





    
; ---------------------------------------------------
;   Inflection Level  
; ---------------------------------------------------
L1451:     DB   020h   ; " "
           DB   02Dh   ; "-"
           DB   02Ch   ; ","
           DB   03Fh   ; "?"
         




    
; ---------------------------------------------------
;       Check if Speech Phrase exists
;        HL = Phrase Table Size
;        DE = Phrase Number
;        C  = 1, phrase doesn't exist
;        C  = 0, phrase exists
; ---------------------------------------------------
L1455:  LD      A,D             ; A = D
        AND     007h            ; Change to Table 1
        LD      D,A             ; D = A
        LD      A,(HL)          ; A = Table Pointer
        SUB     E               ; Subtract E
        INC     HL              ; Next byte
        LD      A,(HL)          ; A = Table Pointer
        SBC     A,D             ; Subtract D
        INC     HL              ; Next byte
        RET                     ; Return





; ---------------------------------------------------
;                  Speak Score
; ---------------------------------------------------
L1464:  LD      DE,00038h       ; Phrase = "(%) Your Score is (n)"
        CALL    L1363           ; Call Speech Routine (phrase)
        CALL    L136C           ; Clear Speech Buffer
        CALL    L146F           ; Speak Score 
        JP      L21C1           ; Command Speech Chip to speak buffer





; ---------------------------------------------------
;               Speak SCORE (number)
;        HL = Pointer to Player Score
; ---------------------------------------------------
L146F:  LD      B,004h          ; Loop = 4 bytes
        LD      DE,0A646h       ; DE = Temp holding area
        LD      IY,0A6CBh       ; IY = Copy of Score
; ---------------------------------------------------
;    Test Player Score to see if it's zero
; ---------------------------------------------------
        LD      A,(HL)          ; A = First Score byte
        INC     HL              ; Point to next score byte
        OR      (HL)            ; Test for zero
        INC     HL              ; Point to next score byte
        OR      (HL)            ; Test for zero
        DEC     HL              ; Go back to last score byte
        DEC     HL              ; Go back to last score byte
        JR      NZ,L1487        ; Not zero so skip ahead
        LD      DE,L0000        ; Word = "Zero"
        JP      L13CF           ; Speak One Word, then return
; ---------------------------------------------------
;   Clear Out A646-A64A,  Copy Score to A6CB-A6CF
; ---------------------------------------------------
L1487:  XOR     A               ; A = 0
        LD      (DE),A          ; Clear out A646-A64A
        LD      A,(HL)          ; Get Score
        LD      (IY+000h),A     ; Make copy of score
        INC     HL              ; Next byte
        INC     IY              ; Next byte
        INC     DE              ; Next byte
        DJNZ    L1487           ; Loop back B=4
; ---------------------------------------------------
;             Setup Score loop
; ---------------------------------------------------
        LD      DE,0A6CBh       ; Copy of Score
        LD      HL,0A646h       ; Temp spot
        LD      IY,012CFh       ; Place Holder Value table
        LD      B,004h          ; Loop = 4 bytes
; ---------------------------------------------------
;       Check all values 1,000,000 - 1
; ---------------------------------------------------
L149F:  CALL    L15A7           ; Check Place Holder 1,000,000..1
        JR      C,L14A7         ; 
        INC     (HL)            ;
        JR      L149F           ; Loop until finished   

L14A7:  INC     IY              ;
        INC     IY              ;
        INC     IY              ;
        BIT     7,B             ;
        JR      NZ,L14BD        ;
        SET     7,B             ;
        SLA     (HL)            ;
        SLA     (HL)            ;
        SLA     (HL)            ;
        SLA     (HL)            ;
        JR      L149F           ; 

L14BD:  RES     7,B
        INC     HL
        DJNZ    L149F    
; ---------------------------------------------------
;          Speak Score Millions XXX,000,000
; ---------------------------------------------------                       
        LD      HL,0A6CBh
        LD      DE,0A646h
        LD      A,(DE)          ; Get Millions score
        OR      A               ; Test if zero
        JR      Z,L14DC         ; Millions zero so do Thousands
        LD      (HL),000h
        INC     HL
        LD      (HL),A
        DEC     HL
        CALL    L1520
        RET     C
        LD      DE,02032h       ; Word = "Million"
        CALL    L13CF           ; Speak One Word  
        RET     C               ; Character Buffer Overflow error, so return
; ---------------------------------------------------
;      Speak Score Thousands 000,XXX,000
; ---------------------------------------------------
L14DC:  LD      DE,0A647h
        LD      A,(DE)
        LD      B,A
        INC     DE
        LD      A,(DE)
        AND     0F0h
        OR      B
        JR      Z,L1515                
        DEC     DE
        LD      A,(DE)
        SRL     A
        SRL     A
        SRL     A
        SRL     A
        LD      (HL),A
        INC     HL
        LD      A,(DE)
        SLA     A
        SLA     A
        SLA     A
        SLA     A
        LD      B,A
        INC     DE
        LD      A,(DE)
        SRL     A
        SRL     A
        SRL     A
        SRL     A
        OR      B
        LD      (HL),A
        CALL    L1520
        RET     C
        LD      DE,02031h       ; Word = "Thousand"
        CALL    L13CF           ; Speak One Word 
        RET     C
; ---------------------------------------------------
;          Speak Score Hundreds  0,000,XXX
; ---------------------------------------------------
L1515:  LD      HL,0A648h
        LD      DE,0A6CBh
        LD      BC,00002h
        LDIR    
L1520:  PUSH    HL
        PUSH    DE
        PUSH    BC
        LD      HL,0A6CBh
        LD      A,(HL)
        AND     00Fh
        JR      Z,L153B                 
        LD      E,A
        LD      D,008h
        CALL    L13CF           ; Speak One Word
        JR      C,L15A3                 
        LD      DE,00030h       ; Word = "Hundred"
        CALL    L13CF           ; Speak One Word
        JR      C,L15A3                 
L153B:  INC     HL
        LD      A,(HL)
        SRL     A
        SRL     A
        SRL     A
        SRL     A
        JR      Z,L1598                 
        CP      001h
        JR      Z,L156A                 
        LD      E,A
        LD      D,000h
        DEC     DE
        DEC     DE
        LD      IY,012EEh       ; Get start of Score Tens Table
        ADD     IY,DE
        LD      E,(IY+000h)
        LD      D,018h          ; DE = Tens word
        CALL    L13CF           ; Speak One Word 
        JR      C,L15A3                 
        LD      DE,0082Fh       ; Word = "-ty"
        CALL    L13CF           ; Speak One Word 
        JR      C,L15A3                 
        JR      L1598           ; Goto Speak Score One's        

L156A:  LD      A,(HL)
        AND     00Fh
        CP      003h
        JR      NC,L157B                
        ADD     A,028h
        LD      E,A
        LD      D,008h
        CALL    L13CF           ; Speak One Word 
        JR      L15A3                  
L157B:  SUB     003h
        LD      E,A
        LD      D,000h
        LD      IY,012E7h       ; Point to Teens Word Table
        ADD     IY,DE           ; Add DE to table
        LD      E,(IY+000h)     ; DE = Word
        LD      D,018h          ; DE = 1800 + Word
        CALL    L13CF           ; Speak One Word 
        JR      C,L15A3                
        LD      DE,0082Dh       ; Word = "Teen" 
        CALL    L13CF           ; Speak One Word 
        JR      L15A3                  
; ---------------------------------------------------
;          Speak Score: One's place
; ---------------------------------------------------
L1598:  LD      A,(HL)          ; Get Score byte 1
        AND     00Fh            ; Isolate One's place
        JR      Z,L15A3         ; If zero then skip ahead       
        LD      E,A             ; Setup word pointer
        LD      D,008h          ; Word = Score Ones
        CALL    L13CF           ; Speak One Word 
; ---------------------------------------------------
;          Finished with Speak Score
; ---------------------------------------------------
L15A3:  POP     BC              ; Restore BC Register
        POP     DE              ; Restore DE Register
        POP     HL              ; Restore HL Register
        RET                     ; Return from Speak Score








; ---------------------------------------------------
;    Subtract value from temp Score 1,000,000 etc.
;      IY = Pointer to Place Holder (1,000,000 - 1)
;      DE = Temp Score
; ---------------------------------------------------
L15A7:  INC     DE              ; Point to score byte
        INC     DE              ; Point to score byte
        LD      A,(DE)          ; Get score byte
        SUB     (IY+002h)       ; Subtract set value
        LD      (0A645h),A      ; Store result
        DEC     DE              ; Point to next score byte
        LD      A,(DE)          ; Get score byte
        SBC     A,(IY+001h)     ; Subtract set value
        LD      (0A644h),A      ; Store result
        DEC     DE              ; Point to next score byte
        LD      A,(DE)          ; Get score byte
        SBC     A,(IY+000h)     ; Subtract set value
        LD      (0A643h),A      ; Store result
        RET     C               ; Return if Carry is set

        LD      A,(0A643h)
        LD      (DE),A
        INC     DE
        LD      A,(0A644h)
        LD      (DE),A
        INC     DE
        LD      A,(0A645h)
        LD      (DE),A
        DEC     DE
        DEC     DE
        RET     

                   
                                                     
; ---------------------------------------------------
;     Subtract the Price of Hint after Purchase
; ---------------------------------------------------
;          A  = Cost of Hint      
;          HL = Pointer to Score
; ---------------------------------------------------
L15D2:  LD      C,A             ; C = Amount to subtract
        INC     HL              ;
        INC     HL              ;
        LD      A,(HL)          ;
        SUB     C               ; Subtract Cost 
        LD      (HL),A          ;
        DEC     HL              ; 
        LD      A,(HL)          ;
        SBC     A,000h          ;
        LD      (HL),A          ;
        DEC     HL              ;
        LD      A,(HL)          ;
        SBC     A,000h          ;
        LD      (HL),A          ;
        RET     NC              ; Score still positive so return
; ---------------------------------------------------
;     Score is negative so set it to zero
; ---------------------------------------------------
        LD      (HL),000h       ; Store zero in score
        INC     HL
        LD      (HL),000h
        INC     HL
        LD      (HL),000h
        DEC     HL
        DEC     HL
        RET                     ; Return







; ---------------------------------------------------
;          Speak 1 of 4 Random Phrases
;            IY = Phrase Number
; ---------------------------------------------------
L15EE:  PUSH    DE              ; Save DE Register
        LD      A,R             ; Get Random Number
        AND     003h            ; Number between 0 and 3
        LD      D,000h          ; DE = 0000 
        LD      E,A             ; DE = Random Number
        ADD     IY,DE           ; Add Random Number 
        LD      E,(IY+000)      ; Store Phrase Pointer
        CALL    L1363           ; Call Speech Routine (phrase)
        POP     DE              ; Restore DE Register
        RET                     ; Return






; ---------------------------------------------------
;        Speak Ordered Phrase (not random)
; ---------------------------------------------------
;   Routine will speak 1 of 4 phrases in order like:
;   
;         -> 1 -> 2 -> 3 -> 4 -> back to 1
;
;   This is to avoid saying the same phrase over
;   and over again.  Only increment to the next
;   phrase if the same phrase is repeated consecutively.
; ---------------------------------------------------
;          HL = Ordered Phrase to speak
; ---------------------------------------------------
L1600:  PUSH    HL              ; Save HL Register
        PUSH    DE              ; Save DE Register
        LD      DE,(0A6D4h)     ; What was the previous phrase spoken?
        PUSH    HL              ; Save current phrase
        OR      A               ; Clear carry for subtraction
        SBC     HL,DE           ; Compare current phrase with previous phrase
        POP     HL              ; Get current phrase
        JR      Z,L1615         ; Are we repeating the same phrase again?
        LD      A,003h          ; Initialize ring buffer to 3
        LD      (0A6D6h),A      ; Save ring buffer
        LD      (0A6D4h),HL     ; Save ordered phrase pointer
L1615:  LD      A,(0A6D6h)      ; Get ring buffer (0-3)
        INC     A               ; Increment ring buffer
        AND     003h            ; Constrain value between 0 and 3
        LD      (0A6D6h),A      ; Save ring buffer
        LD      E,A             ; DE = Ringer buffer
        LD      D,000h          ; set ring buffer value
        ADD     HL,DE           ; Add ring buffer value to HL pointer
        LD      E,(HL)          ; Get the ordered phrase (DE = phrase)
        CALL    L1363           ; Call Speech Routine (phrase)
        POP     DE              ; Restore DE Register
        POP     HL              ; Restore HL Register
        RET                     ; Return







; ---------------------------------------------------
;           Hint Request Processing
; ---------------------------------------------------
;      B=Scene Index   C=Hint RAM   Carry = Table #
; ---------------------------------------------------
L1629:  LD      HL,(0C023h)     ; Use Hint Table (Audio Track 1)
        JR      NC,L1631        ; skip ahead
        LD      HL,(0C025h)     ; Use Hint Table (Audio Track 2)
L1631:  LD      E,(HL)          ; E = Number of Hints in table
        INC     HL              ; Point to Table
L1633:  LD      A,B             ; A = Scene Index
        CP      (HL)            ; Find hint that goes with Scene
        JR      Z,L1640         ; Scene found in table, so skip ahead      
        INC     HL              ; Go to next Hint
        INC     HL              ; skip byte
        INC     HL              ; skip byte
        INC     HL              ; skip byte
        INC     HL              ; skip byte
        DEC     E               ; Check if any Hints left?
        JR      NZ,L1633        ; Yes, so keep looping
        RET                     ; No match so return

; ---------------------------------------------------
;            Scene found in Hint Table
; ---------------------------------------------------
L1640:  INC     HL              ; Point to Hint RAM
        LD      A,C             ; A = Hint RAM
        CP      (HL)            ; Second byte must match RAM
        JR      Z,L164D         ; Match found, do hint        
        INC     HL              ; skip byte
        INC     HL              ; skip byte
        INC     HL              ; skip byte
        INC     HL              ; HL = Next Hint
        DEC     E               ; Decrement Hint Loop
        JR      NZ,L1633        ; More hints remain so loop
        RET                     ; All hints checked so return


; ---------------------------------------------------
;              Hint found, and is available
; ---------------------------------------------------
L164D:  INC     HL              ; Point to hint cost
        LD      C,(HL)          ; C = Cost of Pointer
        INC     HL              ; Point to Hint Phrase
        LD      E,(HL)          ; DE = Hint Phrase
        INC     HL              ; Point to Hint Phrase
        LD      D,(HL)          ; DE = Hint Phrase
        LD      HL,0BCE2h       ; HL = Pointer to Score
        LD      A,C             ; A = Cost of hint
        OR      A               ; Check if Hint is free
        JR      Z,L1683         ; Yes, it's free so skip ahead
; ---------------------------------------------------
;             Purchasing A Hint 
; ---------------------------------------------------
        PUSH    DE              ; Save DE Hint Phrase
        PUSH    HL              ; Save HL Pointer to Score
        LD      DE,00026h       ; Phrase="I Have A Pointer For You (%)"
        CALL    L1363           ; Call Speech Routine (phrase)
        LD      DE,00028h       ; Phrase="But It Will Cost You"
        CALL    L1363           ; Call Speech Routine (phrase)
        LD      HL,0A6D0h       ; Setup Speakable Number
        LD      (HL),000        ; Number = 00
        INC     HL              ; Next byte           
        LD      (HL),000        ; Number = 0000
        INC     HL              ; Next byte
        LD      (HL),C          ; Number = Cost of Pointer
        DEC     HL              ; Previous byte
        DEC     HL              ; HL points to Speakable Number
; ---------------------------------------------------
;       Ask if player wants to purchase a hint 
; ---------------------------------------------------
        LD      DE,00029h       ; Phrase="(n) Points Do You Want It"
        CALL    L1363           ; Call Speech Routine (phrase)
        CALL    L19E7           ; Check for "YES" or "NO"
        POP     HL              ; Restore HL Pointer to Score
        POP     DE              ; Restore DE Hint Phrase
        JR      C,L168A         ; Timed out, so skip ahead
        JR      NZ,L1691        ; Hint declined, skip ahead
L1683:  CALL    L1363           ; Speak Hint to player       
        LD      A,C             ; A = Cost of Hint
        JP      L15D2           ; Subtract Cost of hint from score

; ---------------------------------------------------
;      Player did not answer to purchase hint 
; ---------------------------------------------------
L168A:  LD      IY,012BBh       ; Random Phrase = "No Pointer"
        CALL    L15EE           ; Speak Random Phrase
L1691:  RET                     ; Return





; ---------------------------------------------------
;                 Unknown Data
; ---------------------------------------------------
L1692:  DB  01Fh, 01Ch, 01Fh, 01Eh, 01Fh, 01Eh
        DB  01Fh, 01Fh, 01Eh, 01Fh, 01Eh, 01Fh






; ---------------------------------------------------
;                      Unknown
; ---------------------------------------------------
L169E:  LD      HL,0BE01h       ; Get GAME STATUS Register
        SET     2,(HL)          ; Set LOOP CHECK
        LD      B,006h          ; Loop = 6
        LD      HL,0BE2Ch       ;
L16A8:  LD      A,(0BE0Ch)      ;
        AND     01Fh
        OR      040h
        LD      (0BE0Ch),A
        OUT     (020h),A
        PUSH    HL
L16B5:  LD      HL,0BE17h
        BIT     0,(HL)
        JR      Z,L16B5                 
        RES     0,(HL)
        POP     HL
        LD      A,(0BE26h)
        LD      (HL),A
        DEC     HL
        DJNZ    L16A8           ; Loop until all checked        

        LD      A,(0BE0Ch)      ;
        AND     01Fh            ;
        OR      000h            ;
        LD      (0BE0Ch),A      ;
        OUT     (020h),A        ;
        LD      HL,0BE01h       ; Get GAME STATUS Register
        RES     2,(HL)          ; Clear LOOP CHECK
        RET                     ; Return





; ---------------------------------------------------
;  Send Important bytes (BE27) to Keyboard Interface
; ---------------------------------------------------
L16D8:  LD      HL,0BE01h       ; Get GAME STATUS Register
        SET     2,(HL)          ;
        LD      B,006h          ; Loop = 6
        LD      HL,0BE27h       ;
L16E2:  LD      A,(HL)          ;
        PUSH    HL              ;
        OUT     (080h),A        ; Write to Keyboard Interface (COP421L)
        LD      A,(0BE0Ch)
        AND     01Fh
        OR      080h
        LD      (0BE0Ch),A
        OUT     (020h),A

L16F2:  LD      HL,0BE17h
        BIT     0,(HL)
        JR      Z,L16F2                 
        RES     0,(HL)
        POP     HL
        INC     HL
        DJNZ    L16E2
                           
        LD      A,(0BE0Ch)
        AND     01Fh
        OR      000h
        LD      (0BE0Ch),A
        OUT     (020h),A
        LD      HL,0BE01h
        RES     2,(HL)
        RET     









; ---------------------------------------------------
; Cycle Routine #3: Check if First Name Basis is okay
; ---------------------------------------------------
;          Find spaces in Player's Name
; ---------------------------------------------------
L1711:  LD      A,(0A64Ah)      ; Get Length of Name
        LD      C,A             ; C = length of name
        LD      B,000h          ; BC = Length of Name
        LD      HL,0A64Bh       ; Point to start of name
        LD      A,' '           ; Load up the ' '(space) character
        LD      DE,00000h       ; Initialize number of spaces in name to 0
L171F:  CPI                     ; Is location empty or at end of name?
        JR      NZ,L1724        ; Location not empty, more spots to check so skip ahead       
        INC     DE              ; Increment number of spaces
L1724:  JP      PE,L171F        ; Loop back until end of name is reached
        XOR     A               ; Length = 0
        LD      (0A68Bh),A      ; Clear length of first name
        LD      A,E             ; Get number of spaces
        OR      A               ; Are there any spaces?
        RET     Z               ; No spaces so return
; ---------------------------------------------------
;   Strip off all characters after the first space
; ---------------------------------------------------
        LD      HL,0A64Bh       ; Set pointer to Start of Name
        LD      A,(0A64Ah)      ; Get Length of Name
        LD      C,A             ; Loop = Length of name
        LD      A,' '           ; Check for space character
        CPIR                    ; Loop until first space or end of name
        LD      DE,0A64Bh       ; Set DE = Start of Name
        OR      A               ; Clear carry for subtraction
        SBC     HL,DE           ; Calculate location of first space in name
        DEC     L               ; L becomes the length up until the first space
        RET     Z               ; Return if the length of name is zero
; ---------------------------------------------------
;            Copy First name to a buffer (A68C)
; ---------------------------------------------------
        LD      C,L             ; Loop = Length of Name (until first SPACE)
        LD      HL,0A64Bh       ; Set pointer to Start of Name
        LD      DE,0A68Ch       ; Set pointer to First name buffer
        LD      A,C             ; A = Length of First Name
        LD      (0A68Bh),A      ; Save the length of the First name
        LDIR                    ; Copy first name to new location
        LD      A,(0A68Bh)      ; Check length of First name
        OR      A               ; Test if the length is zero
        JR      Z,L176B         ; If length of first name is zero then just return       
; ---------------------------------------------------
;        Verify that first name basis is okay
; ---------------------------------------------------
L1754:  LD      DE,00071h       ; Phrase="Can I Call You (*)"
        CALL    L1363           ; Call Speech Routine (phrase)
        CALL    L19E7           ; Check for "YES" or "NO"
        JR      C,L1754         ; Timed out, so repeat question
        JR      Z,L1765         ; "YES", so skip ahead        
        XOR     A               ; Length = 0
        LD      (0A68Bh),A      ; Clear Length of First Name
L1765:  LD      DE,00072h       ; Phrase="O K (*)"
        CALL    L1363           ; Call Speech Routine (phrase)
L176B:  RET                     ; Return










; ---------------------------------------------------
; Cycle Routine #2    Enter Name in Keyboard
; ---------------------------------------------------
L176C:  LD      HL,(0BE05h)     ; Get Game Timer
        LD      (0A6D9h),HL     ; Save Game Timer before starting
; ---------------------------------------------------
;        Give extra time for entering name
; ---------------------------------------------------
        LD      BC,00726h       ; Give 1 additional minute
        ADD     HL,BC           ; Add to Timer
        LD      (0BE05h),HL     ; Store Game Timer
        LD      HL,0BE04h       ; Get Game Timer Control Register
        SET     0,(HL)          ; Start Game Timer
; ---------------------------------------------------
;           Clear name area before beginning
; ---------------------------------------------------
L177E:  XOR     A               ; A = 0
        LD      HL,0A64Ah       ; Point to Name Area
        LD      B,041h          ; Loop = 65 spots to clear 
L1784:  LD      (HL),A          ; Clear name location
        INC     HL              ; Go to next location
        DJNZ    L1784           ; Loop until all of name is erased     
        LD      (0A68Bh),A      ; Clear Length of First Name
        LD      HL,0A64Bh       ; Setup pointer to Player's Name
; ---------------------------------------------------
;     Check if the time to enter name has expired
; ---------------------------------------------------
        LD      A,(0BE48h)      ; Get Timer Register
        BIT     7,A             ; Check if timer has expired
        RET     NZ              ; Timer has expired so simply return

        LD      IY,0129Bh       ; Random Phrase = "Type in Name"
        CALL    L15EE           ; Speak Random Phrase
; ---------------------------------------------------
;               Get name from keyboard
; ---------------------------------------------------
L179B:  CALL    L193C           ; Get keyboard character for name
        JR      C,L177E         ; CLEAR was pressed so re-enter name
        CP      082h            ; Has F3/ENTER been pressed?
        JR      Z,L17B5         ; Yes, so user is finished
        CP      030h            ; Is key a number?
        JR      C,L179B         ; No, so get next key input
        CP      041h            ; Is key between A - Z?
        JR      NC,L179B        ; Yes, so get next key input
; ---------------------------------------------------
;             Reject invalid key input
; ---------------------------------------------------
        LD      IY,012A7h       ; Random Phrase = "Just Letters"
        CALL    L15EE           ; Speak Random Phrase
        JR      L177E           ; Start entering again

; ---------------------------------------------------
;     ENTER pressed, user finished entering name
; ---------------------------------------------------
L17B5:  LD      A,(0A64Ah)      ; Get length of name
        OR      A               ; Check if name left empty
        JR      NZ,L17C4        ; Name not empty so jump ahead       
L17BB:  LD      IY,012B3h       ; Random Phrase = "Retype in Name"
        CALL    L15EE           ; Speak Random Phrase
        JR      L177E           ; Do over again

; ---------------------------------------------------
;          Check name for single letter
; ---------------------------------------------------              
L17C4:  DEC     A               ; Is name length greater that 1?
        JR      Z,L17BB         ; No, so retype in name
; ---------------------------------------------------
;           Check name for vulgarities
; --------------------------------------------------- 
        CALL    L180E           ; Check if name is in bad words list
        JR      NC,L17DE        ; Name is not offensive, so skip ahead

        XOR     A               ; Length = 0
        LD      (0A64Ah),A      ; Clear length of full name
        LD      (0A68Bh),A      ; Clear length of first name
        LD      IY,L12C7        ; Random Phrase = "Name Sounds French"
        CALL    L15EE           ; Speak Random Phrase
        OR      0FFh            ; Set error flag
        JR      L17F2           ; Re-enter name
; ---------------------------------------------------
;        Verify that the name sounds correct
; ---------------------------------------------------
L17DE:  LD      IY,L12A3        ; Random Phrase = "Did I Say Your Name Right?"
        CALL    L15EE           ; Speak Random Phrase
        CALL    L19E7           ; Check for "YES" or "NO" 
        JR      NC,L17F2        ; User responded so check the response
        LD      HL,L12AF        ; Ordered Phrase = "Act Lively"
        CALL    L1600           ; Speak Ordered Phrase
        JR      L17C4           ; Ask the player the question again

L17F2:  JR      NZ,L1804        ; "NO" pressed, so skip ahead
; ---------------------------------------------------
;       Name is fine, expire the timer and return
; ---------------------------------------------------
        LD      HL,(0BE05h)     ; Get Game Timer
        LD      DE,(0A6D9h)     ; Get timer value before name was entered
        OR      A               ; Clear carry for subtraction
        SBC     HL,DE           ; Check to see if all extra time was used
        RET     C               ; All the time was already used so return
        LD      (0BE05h),DE     ; Restore the Game Timer to its original value
        RET                     ; Return
; ---------------------------------------------------
;        Name does not sound right so re-enter
; ---------------------------------------------------
L1804:  LD      IY,L12BF        ; Random Phrase = "Try A Different Spelling"
        CALL    L15EE           ; Speak Random Phrase
        JP      L177E           ; Re-enter name







; ---------------------------------------------------
;     Call Routine to check for offensive name
; ---------------------------------------------------     
;            C = SET   Name is offensive
; --------------------------------------------------- 
L180E:  CALL    L1812           ; Check if name is in list of bad words
        RET                     ; Return






; ---------------------------------------------------
;      Check if name is in list of Bad Words
; ---------------------------------------------------
;   The player's name cannot be a bad word and it 
;   cannot contain a bad word in it anywhere.
; ---------------------------------------------------
;            C = SET   Name is offensive
; ---------------------------------------------------
L1812:  LD      A,(0A64Ah)      ; A = Length of Name
        OR      A               ; Is length of name zero?
        RET     Z               ; Yes, so return
; ---------------------------------------------------
;           Get Bad Words and setup loop
; ---------------------------------------------------
        LD      IY,BadWords     ; Set pointer to Bad Words (1864h)
        LD      E,(IY+000h)     ; E = Number of Bad Words in list
        INC     IY              ; Point to Bad Word List
        LD      B,000h          ; BC = 0 
L1822:  LD      A,(0A64Ah)      ; Get Length of Name
        LD      C,A             ; BC = Length of Name (Loop)
        LD      HL,0A64Bh       ; HL = Pointer to Name
        LD      D,(IY+000h)     ; D = Length of Bad Word
        INC     IY              ; Point to start of Bad Word
        LD      (0A6D7h),IY     ; Save Pointer to Bad Word
        LD      (0A6D9h),DE     ; Save Length of Bad Word and # of Bad Words
; ---------------------------------------------------
;       Check if bad word occurs anywhere in name
; ---------------------------------------------------
L1836:  LD      A,(IY+000h)     ; A = First character of Bad Word
        CPIR                    ; Check the whole name for character
        INC     BC              ; Increment loop
        JR      NZ,L1859        ; No occurance of character, so skip ahead
L183E:  DEC     D               ; Subtract 1 from loop of Bad Word
        JR      Z,L1857         ; All letters were found, jump ahead        
        DEC     C               ; Subtract 1 from loop of Name
        INC     IY              ; Go to next character in bad word
        JR      Z,L1859         ; Whole name was checked without match       
        LD      A,(IY+000h)     ; Get character in bad word
        CP      (HL)            ; Compare characters in both words
        INC     HL              ; Point to next character in Name
        JR      Z,L183E         ; Characters match so check next character
        LD      IY,(0A6D7h)     ; Restore Pointer to Bad Word
        LD      DE,(0A6D9h)     ; Restore Length of Bad Word and # of Bad Words
        JR      L1836           ; Continue looking for occurrence of bad word
; ---------------------------------------------------
;           Bad Word was found so set error 
; ---------------------------------------------------
L1857:  SCF                     ; Set Carry Flag
        RET                     ; Return
; ---------------------------------------------------
;          Setup loop to point to next word
; ---------------------------------------------------
L1859:  INC     IY              ; Move bad word pointer
        DEC     D               ; Count down number of characters in bad word
        JR      NZ,L1859        ; Loop until we reach the next bad word
        DEC     E               ; Decrement # of bad words checked
        XOR     A               ; A = 0
        OR      E               ; Have we checked all the bad words?
        RET     Z               ; Yes, so return
        JR      L1822           ; More Bad Words so check next word









; ---------------------------------------------------
;  This is a list of Bad Words that are not accepted
; ---------------------------------------------------

BadWords:
         DB     39      ; Number of bad words in list
         DB 4
        .STRING "FART"
         DB 4
        .STRING "CUNT"
         DB 4
        .STRING "PISS"
         DB 4
        .STRING "SHIT"
         DB 4
        .STRING "CRAP"
         DB 4
        .STRING "TURD"
         DB 4
        .STRING "DAMN"
         DB 5
        .STRING "PUSSY"
         DB 6
        .STRING "NIGGER"
         DB 4
        .STRING "SPIC"
         DB 4
        .STRING "SPIK"
         DB 4
        .STRING "KIKE"
         DB 4
        .STRING "KYKE"
         DB 5
        .STRING "QUEER"
         DB 5
        .STRING "KWEER"
         DB 7
        .STRING "SCROTUM"
         DB 7
        .STRING "SCROTEM"
         DB 5
        .STRING "KOTEX"
         DB 5
        .STRING "COTEX"
         DB 5
        .STRING "PENIS"
         DB 5
        .STRING "PEENI"
         DB 6
        .STRING "TAMPON"
         DB 6
        .STRING "TAMPAX"
         DB 4
        .STRING "ANUS"
         DB 4
        .STRING "ANIS"
         DB 3
        .STRING "ASS"
         DB 5
        .STRING "PRICK"
         DB 3
        .STRING "FAG"
         DB 5
        .STRING "WHORE"
         DB 5
        .STRING "BITCH"
         DB 7
        .STRING "BASTARD"
         DB 4
        .STRING "SUCK"
         DB 4
        .STRING "COCK"
         DB 3
        .STRING "FUQ"
         DB 3
        .STRING "FUC"
         DB 3
        .STRING "FUK"
         DB 4
        .STRING "PHUC"
         DB 4
        .STRING "PHUQ"
         DB 4
        .STRING "PHUK"






; ---------------------------------------------------
;          Get Keyboard Character for Name
; ---------------------------------------------------
;      C = 1, Clear Name (CLEAR, too long, timeout)
;          0, No Errors
; ---------------------------------------------------
L193C:  CALL    L1989           ; Wait for a Keypress with timeout
        JR      NC,L1954        ; Keypress did not time out so skip ahead
        XOR     A               ; A = 0
        LD      (0A64Ah),A      ; Set Length of Name to zero
        LD      A,(0BE48h)      ; Get Timer Register
        BIT     7,A             ; Check if enter name timer has expired
        JR      NZ,L1952        ; Timer has expired, so note error and return
        LD      HL,L12AF        ; Ordered Phrase = "Act Lively"
        CALL    L1600           ; Speak Ordered Phrase
L1952:  SCF                     ; Set carry flag to clear name and re-enter
        RET                     ; Return

L1954:  CALL    L19B0           ; Speak keypress
; ---------------------------------------------------
;      Check for Function Keys F1,F2,F3,F4
; ---------------------------------------------------
        BIT     7,A             ; Check if key was a Function Key
        JR      Z,L196E         ; Not a function key so skip ahead       
; ---------------------------------------------------
;                   F1 = CLEAR
; ---------------------------------------------------
        CP      080h            ; Check key "F1 = CLEAR" 
        JR      NZ,L1961        ; Not F1 so check for F3       
        SCF                     ; Set the carry bit to signal re-entering name
        RET                     ; Return
; ---------------------------------------------------
;                 F3 = ENTER
; ---------------------------------------------------
L1961:  CP      082h            ; Check key "F3 = ENTER"
        RET     Z               ; ENTER was pressed so return
; ---------------------------------------------------
;                  F2 = PAUSE
; ---------------------------------------------------
        CP      081h            ; Check key "F2"
        JR      NZ,L196C        ; Not F2 so must be F4       
        LD      A,02Fh          ; Add slash character "/"
        JR      L196E           ; Skip ahead to length check       
; ---------------------------------------------------
;                  F4 = SPACE
; ---------------------------------------------------
L196C:  LD      A,020h          ; Character = SPACE
; ---------------------------------------------------
;         Check if name is too long already
; ---------------------------------------------------
L196E:  LD      B,A             ; B = Keyboard Character
        LD      A,(0A64Ah)      ; Get Length of Name
        INC     A               ; Add 1 to Length of Name
        LD      (0A64Ah),A      ; Save new length 
        CP      041h            ; Is Name too long?
        JR      C,L1983         ; No, length is fine, skip ahead        
        LD      IY,0129Fh       ; Random Phrase = "Name Too Long"
        CALL    L15EE           ; Speak Random Phrase
        SCF                     ; Set carry flag to clear name and re-enter
        RET                     ; Return
; ---------------------------------------------------
;       Add keyboard character to end of name
; ---------------------------------------------------
L1983:  LD      C,(HL)          ; Get old name character before replacing new one
        LD      (HL),B          ; Append keyboard character to name
        INC     HL              ; Point to next name spot
        LD      A,B             ; A = keyboard character
        OR      A               ; Clear carry, no errors
        RET                     ; Return








; ---------------------------------------------------
;       Wait for a Keypress with timeout
; ---------------------------------------------------
;          Z = 1, key pressed
;          C = 1, timed out
;          A = Keyboard Character
; ---------------------------------------------------
L1989:  PUSH    HL              ; Save HL Register
        PUSH    DE              ; Save DE Register
; ---------------------------------------------------
;              Setup timeout period 
; ---------------------------------------------------
        LD      DE,001D5h       ; Programmable Timer = 1D5
        CALL    L21A7           ; Set Programmable Timer
        LD      HL,0BE0Bh       ; Get Keyboard Buffer
L1994:  BIT     0,(HL)          ; Has a key been pressed?
        JR      NZ,L19A7        ; Yes, so go get keypress
        LD      A,(0BE48h)      ; Check Timer register
        BIT     7,A             ; Has timer expired?
        JR      NZ,L19A4        ; Yes, timer expired so jump ahead
        CALL    L21B3           ; Check if Programmable Timer expired
        JR      Z,L1994         ; Timer not expired so wait for keypress
L19A4:  SCF                     ; Set carry flag
        JR      L19AD           ; Jump to end of routine
L19A7:  LD      A,(0BE0Ah)      ; Get Keyboard Character
        RES     0,(HL)          ; Clear Keyboard Bufer
        OR      A               ; Z = 1
L19AD:  POP     DE              ; Restore DE Register
        POP     HL              ; Restore HL Register
        RET                     ; Return








; ---------------------------------------------------
;              Speak Key?
;      A = key
; ---------------------------------------------------
L19B0:  PUSH    AF              ; Save AF Register
        PUSH    DE              ; Save DE Register
        PUSH    HL              ; Save HL Register
        BIT     7,A             ; 
        JR      Z,L19C3         ;
        LD      HL,019E3h       ; HL = Pointer to table
        AND     003h            ;
        LD      E,A             ; DE = A
        LD      D,000h          ; DE = 0000 + A
        ADD     HL,DE           ; Point to correct byte
        LD      E,(HL)          ; E = byte from table
        JR      L19DC           ;        
L19C3:  CP      041h            ;
        JR      NC,L19D7        ;        
        SUB     012h            ;
        CP      01Eh            ;
        JR      NZ,L19CF        ;        
        ADD     A,00Ah          ;       
L19CF:  LD      E,A             ; Get word
        LD      D,080h          ; Get word ($8000 + A) second table
        CALL    L1363           ; Call Speech Routine (phrase)           
        JR      L19DF           ; Goto end of subroutine
L19D7:  SUB     037h            ; ..else subtract 37h from word
        LD      E,A             ; Get word
        LD      D,000h          ; Get word ($0000 + A) first table
L19DC:  CALL    L13C6           ; Call Speech Routine (word)
L19DF:  POP     HL              ;
        POP     DE
        POP     AF
        RET     






; ---------------------------------------------------
;             Unknown Table
; ---------------------------------------------------
L19E3:  .byte 25h   ; "Clear"
        .byte 02h   ; "Two"
        .byte 24h   ; "Enter"
        .byte 4Dh   ; "Space"





; ---------------------------------------------------
;             Check for "YES" or "NO"
; ---------------------------------------------------
;           Carry set   = Operation timed out
;           Z           = YES pressed
;           NZ          = NO pressed
; ---------------------------------------------------
L19E7:  PUSH    IY              ; Save IY Register
        PUSH    HL              ; Save HL Register 
        PUSH    DE              ; Save DE Register
L19EB:  LD      DE,001D5h       ; Programmable Timer = 001D5h
        CALL    L21A7           ; Set Programmable Timer
L19F1:  CALL    L2190           ; Keyboard Check routine
        JR      NC,L1A09                
        LD      A,(0BE48h)
        BIT     7,A
        JR      Z,L1A01                 
        LD      A,031h
        JR      L1A09                   
L1A01:  CALL    L21B3           ; Check if Programmable Timer expired
        JR      Z,L19F1                 
        SCF     
        JR      L1A35
L1A09:  LD      B,A
        LD      HL,0BE0Bh       ; Get Keyboard Buffer
        RES     0,(HL)
        CP      '1'             ; Character = '1'?
        JR      NZ,L1A1B        ; No, so skip ahead
        LD      DE,00026h       ; Get word ("Yes")
        CALL    L13C6           ; Call Speech Routine (word)
        JR      L1A30           ; Key pressed so leave
L1A1B:  CP      '0'             ; Character = '0'?
        JR      NZ,L1A27        ; No, so skip ahead
        LD      DE,00027h       ; Get word ("No")
        CALL    L13C6           ; Call Speech Routine (word)
        JR      L1A30           ; Key pressed so leave
L1A27:  LD      IY,012ABh
        CALL    L15EE
        JR      L19EB           ; No answer so continue looping

L1A30:  LD      A,B             ; A = 
        CP      031h            ; Character = '1'?
        SCF                     ; Carry = 1
        CCF                     ; Negate Carry
L1A35:  POP     DE              ; Restore DE Register
        POP     HL              ; Restore HL Register
        POP     IY              ; Restore IY Register
        RET                     ; Return







; ---------------------------------------------------
;     Check for user choice at decision points
; ---------------------------------------------------
L1A3A:  LD      HL,0BE0Bh       ; Check Keyboard Buffer
        BIT     0,(HL)          ; Has a key been pressed?
        RET     Z               ; No, so return
        LD      A,(IX+002h)     ; Get available choice from scene
        AND     00Fh            ; Check only lower nibble
        JP      Z,L1A54         ; No choices restricted, so jump ahead
        CP      005h            ; Check if 0101
        JR      C,L1A9D         ; 
        CP      00Ah            ; Check if 1010
        JP      C,L1AD3         ;
        JP      L1B0E           ;
; ---------------------------------------------------
;     Check user choice of "F1","F2","F3", or "F4"
; ---------------------------------------------------
L1A54:  LD      A,(0BE0Ah)      ; Get Keyboard Character
        CP      080h            ; Check key "F1" 
        LD      B,(IX+003h)     ; Get Scene choice 1
        JR      Z,L1A72         ; Go set scene pointer
        CP      081h            ; Check key "F2"
        LD      B,(IX+004h)     ; Get Scene Choice 2
        JR      Z,L1A72         ; Go set scene pointer
        CP      082h            ; Check key "F3"
        LD      B,(IX+005h)     ; Get Scene Choice 3
        JR      Z,L1A72         ; Go set scene pointer
        CP      083h            ; Check key "F4"
        LD      B,(IX+006h)     ; Get Scene Choice 4
        RET     NZ              ; Not a valid choice so leave
; ---------------------------------------------------
;               Check for valid scene 
; ---------------------------------------------------
L1A72:  LD      A,B             ; Get Next scene
        CP      000h            ; Is that a valid choice?
        JR      NZ,L1A81        ; Yes, so skip ahead
; ---------------------------------------------------
;         Not a valid user keyboard choice
; ---------------------------------------------------
L1A77:  RES     0,(HL)
        LD      IY,012C3h       ; Random Phrase = "Won't Work"
        CALL    L15EE           ; Speak Random Phrase
        RET                     ; Return

; ---------------------------------------------------
;        User keyboard choice has been made 
; ---------------------------------------------------
L1A81:  LD      HL,0BE0Bh       ; Get Keyboard Buffer
        RES     0,(HL)          ; Clear Keyboard Buffer
        LD      (0BC81h),A
        LD      HL,0BE03h
        SET     0,(HL)          ;
        RES     4,(HL)          ; Set Audio Track 1
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        RES     7,A             ; Remove MSB
        INC     A               ; A = Keyboard word
        LD      E,A             ; DE = A, Word
        LD      D,000h          ; DE = A, Word
        CALL    L13C6           ; Call Speech Routine (word)
        RET                     ; Return

; ---------------------------------------------------
;     Check user choice of "F1","F2","F3", or "F4"
; ---------------------------------------------------
L1A9D:  LD      A,(0BE0Ah)      ; Get Keyboard Character
        CP      080h            ; Check key "F1"
        LD      B,(IX+003h)
        JR      Z,L1A72                 
        CP      081h            ; Check key "F2"
        LD      B,(IX+004h)
        JR      Z,L1A72                 
        CP      083h            ; Check key "F4"
        JR      Z,L1A77                 
        CP      082h            ; Check key "F3"
        RET     NZ

        LD      B,004h
        LD      A,001h
        LD      HL,0BE18h
        LD      (HL),A
        LD      A,(IX+002h)
        AND     00Fh

L1AC2:  CP      (HL)
        JR      NZ,L1AD0          
        LD      A,R             ; Get Random Number
        AND     007h            ; Random number between 0 - 7
        CP      (HL)
        JP      C,L1B84
        JP      L1B8A

L1AD0:  INC     (HL)
        DJNZ    L1AC2                   

; ---------------------------------------------------
;     Check user choice of "F1","F2","F3", or "F4"
; ---------------------------------------------------
L1AD3:  LD      A,(0BE0Ah)      ; Get Keyboard Character 
        CP      080h            ; Check key "F1"
        LD      B,(IX+003h)
        RET     C
        JR      Z,L1A72               
        CP      081h            ; Check key "F2"
        JR      NZ,L1A77                
        LD      HL,0BE18h
        LD      A,(IX+002h)
        AND     00Fh
        CP      005h
        JR      NZ,L1AF2               
        LD      (HL),002h
        JR      L1B56                   
L1AF2:  CP      006h
        JR      NZ,L1AFA                
        LD      (HL),003h
        JR      L1B56                   

L1AFA:  CP      007h
        JR      NZ,L1B02                
        LD      (HL),004h
        JR      L1B56                   

L1B02:  CP      008h
        JR      NZ,L1B0A                
        LD      (HL),004h
        JR      L1B46                   

L1B0A:  LD      (HL),005h
        JR      L1B46                   

L1B0E:  LD      A,(0BE0Ah)      ; Get Keyboard Character
        CP      080h
        RET     C

        JP      NZ,L1A77
        LD      HL,0BE18h
        LD      DE,0BE19h
        LD      A,(IX+002h)
        AND     00Fh
        CP      00Ah
        JR      NZ,L1B2C                
        LD      (HL),002h
        LD      A,003h
        JR      L1B64                   

L1B2C:  CP      00Bh
        JR      NZ,L1B36                
        LD      A,004h
        LD      (HL),002h
        JR      L1B64                   

L1B36:  CP      00Ch
        JR      NZ,L1B40                
        LD      (HL),002h
        LD      A,005h
        JR      L1B64                   

L1B40:  LD      (HL),003h
        LD      A,005h
        JR      L1B64                   

L1B46:  LD      A,R             ; Get Random Number
        AND     007h
        CP      002h
        JP      C,L1B7E
        CP      (HL)
        JP      C,L1B84
        JP      L1B8A

L1B56:  LD      A,R             ; Get Random Number
        AND     007h            ; Make number between 0-7
        JP      Z,L1B7E         ; Do Scene Choice 2
        CP      (HL)
        JP      C,L1B84         ; Do Scene Choice 3
        JP      L1B8A           ; Else do Scene Choice 4

L1B64:  LD      (DE),A
        LD      A,R             ; Get Random Number
        AND     007h            ; Make number between 0-7
        JP      Z,L1B78         ; if zero, do Scene Choice 1
        CP      (HL)
        JP      C,L1B7E         ; Do Scene Choice 2
        EX      DE,HL
        CP      (HL)
        JP      C,L1B84         ; Do Scene Choice 3
        JP      L1B8A           ; else do Scene Choice 4

L1B78:  LD      A,(IX+003h)     ; Get Scene Choice 1
        JP      L1A81           ; Go set scene pointer
L1B7E:  LD      A,(IX+004h)     ; Get Scene Choice 2
        JP      L1A81           ; Go set scene pointer
L1B84:  LD      A,(IX+005h)     ; Get Scene Choice 3
        JP      L1A81           ; Go set scene pointer
L1B8A:  LD      A,(IX+006h)     ; Get Scene Choice 4
        JP      L1A81           ; Go set scene pointer








; ---------------------------------------------------
;                Attract Mode Loop: Routine #1
; ---------------------------------------------------
L1B90:  IN      A,(0F2h)        ; Get DIP Switch A
        LD      (0BE0Fh),A      ; Store DIP Switch A in BE0F
        LD      HL,0BE48h
        SET     6,(HL)
        RES     7,(HL)
        CALL    L1D54           ; Perform Attract Mode AUDIO Check
        LD      DE,(0C015h)     ; DE = Starting Frame Number for Attract Mode
        LD      BC,(0C017h)     ; BC = Scene Play Time for Attract Mode
        CALL    L1C11           ; Call Attract Mode Start
        JR      C,L1BBD         ; Skip ahead if coin was inserted        
        LD      DE,(0C019h)     ; Get Frame Number, "Insert 1 Token for 3 Units..." 
        CALL    L1C57           ; PAUSE on Frame Number
        LD      DE,0009Bh       ; Load Timer Value = 9B
        CALL    L1C1F           ; Wait for Timer or Coins
        JR      C,L1BBD         ; Enough coins for 1 credit so skip ahead        
        JR      L1B90           ; Loop back to Attract Mode                   
              
; ---------------------------------------------------
;  Show "Additional Coins" until timeout or keypress
; ---------------------------------------------------
L1BBD:  LD      DE,(0C01Bh)     ; Get Frame Number , "Insert additional quarters..."
        CALL    L1C57           ; PAUSE on Frame Number
        LD      HL,0BE0Bh       ; Check Keyboard Buffer
        RES     0,(HL)          ; Clear Keyboard Buffer
L1BC9:  LD      DE,00090h       ; Phrase="Press Any Key To Continue"
        CALL    L1363           ; Call Speech Routine (phrase)
        LD      DE,0009Bh       ; Programmable Timer = 09Bh
        CALL    L21A7           ; Set Programmable Timer     
; ---------------------------------------------------
;  Pause until Programmable Timer expires or Keypress
; ---------------------------------------------------
L1BD5:  BIT     0,(HL)          ; Check for key press
        JR      NZ,L1BE0        ; Key pressed, so jump ahead
        CALL    L1C4B           ; Check Programmable Timer expiration
        JR      Z,L1BD5         ; Wait until Programmable Timer expires
        JR      L1BC9           ; Loop back and Speak again       
L1BE0:  RES     0,(HL)          ; Clear Keyboard Buffer
        RET                     ; Return







; ---------------------------------------------------
;    SEARCH then PLAY Frame Number, Setup Timer
; ---------------------------------------------------
;          DE = Starting Frame Number
;          BC = Time of Scene
; ---------------------------------------------------
;   Return  Z =
;          NZ = 
; ---------------------------------------------------
L1BE3:  PUSH    BC              ; Save BC Register
        PUSH    DE              ; Save DE Register
        CALL    L1CC1           ; Setup AUDIO Channel(s)
        POP     DE              ; Get Frame Number
        CALL    L1C57           ; PAUSE on Frame Number
        POP     BC              ; Get Time of Scene
        LD      A,B             ; Check if time is zero
        OR      C               ; Check if time is zero
        JR      Z,L1C0F         ; If time is zero then just return        
        PUSH    BC
        CALL    L1F1E           ; Send PLAY command
        POP     DE              ; Get Programmable Timer Value
L1BF6:  CALL    L21A7           ; Set Programmable Timer
        LD      HL,0BE0Bh       ; Get Keyboard Buffer
        RES     0,(HL)          ; Clear Keyboard Buffer
L1BFE:  CALL    L1C4B           ; Check Programmable Timer expiration
        JR      Z,L1BFE         ; Wait until Programmable Timer expires
        CALL    L1F15           ; Send PAUSE Command
        LD      HL,0BE48h
        BIT     1,(HL)
        JR      NZ,L1C0F        ; Return (1)       
        LD      A,000h          ; Return (0)
L1C0F:  OR      A               ; Setup return value
        RET                     ; Return



; ---------------------------------------------------
;    SEARCH then PLAY Frame Number (Attract Mode)
;          DE = Frame Number
;          BC = Time of Scene
;    Return:  1 = Timer expired
;             0 = Timer running
; ---------------------------------------------------
L1C11:  PUSH    BC              ; Save BC Register temporarily
        CALL    L1C57           ; PAUSE on Frame Number
        POP     BC              ; Restore BC Register
        LD      A,B             ; Test Programmable Timer Value
        OR      C               ; Programmable Timer Value = 00000?
        JR      Z,L1C0F         ; Yes, Timer = 0 so return(1)
        PUSH    BC              ; Save Programmable Timer Value
        CALL    L1F1E           ; Send PLAY command
        POP     DE              ; Restore Programmable Timer Value

L1C1F:  CALL    L21A7           ; Set Programmable Timer
        LD      HL,0BE0Bh       ; Get Keyboard Buffer
        RES     0,(HL)          ; Clear Keyboard Buffer
L1C27:  CALL    L1C4B           ; Check Programmable Timer expiration
        JR      NZ,L1C46        ; Programmable Timer expired, jump to PAUSE
        LD      A,(0BE0Fh)      ; Get DIP Switch A
        LD      B,A             ; B = DIP Switch A
        AND     007             ; Check for Free Play 
        JR      NZ,L1C36        ; Not Free Play so skip ahead
        SCF                     ; Free Play set so Return (1)
        RET                     ; Return

L1C36:  LD      A,(0BE0Dh)      ; Get number of Credits
        LD      C,003h          ; C = 3
        BIT     3,B             ; Test A4, Coins per Credit
        JR      NZ,L1C41        ; One coin per coin game, so skip ahead
        LD      C,006h          ; C = 6
L1C41:  CP      C               ; Are there 3 or 6 coins?
        JR      C,L1C27         ; No, so loop back
        SCF                     ; Return (1)
        RET                     ; Return (1)

L1C46:  CALL    L1F15           ; Send PAUSE Command
        OR      A               ; Return (0)
        RET                     ; Return (0)





; ---------------------------------------------------
;       Check Programmable Timer Expiration 
; ---------------------------------------------------
;    Return  Z = Timer still running
;           NZ = Timer expired
; ---------------------------------------------------
L1C4B:  PUSH    HL              ; Save HL Register
        LD      HL,0BE07h       ; Check Programmable Timer Control Register
        BIT     1,(HL)          ; Has Timer expired?
        JR      Z,L1C55         ; No, Timer is still running so skip ahead
        RES     1,(HL)          ; Mark Timer as unexpired
L1C55:  POP     HL              ; Restore HL Register
        RET                     ; Return







; ---------------------------------------------------
;                SEARCH and PAUSE
; ---------------------------------------------------
;           DE = Frame Number
; ---------------------------------------------------
L1C57:  LD      (0A794h),DE     ; Store Frame Number for setup 
        LD      HL,0A791h
        RES     0,(HL)
        CALL    L1D9B           ; SEARCH to frame
        CALL    L1F15           ; Send PAUSE Command
        RET                     ; Return
                                



; ---------------------------------------------------
;               Initialize System
; ---------------------------------------------------
;   Send PLAY command and wait for disc to spin up
; ---------------------------------------------------
;          C = set ???
; ---------------------------------------------------
L1C67:  CALL    L1F27           ; Send REJECT Command to LDPlayer

        LD      DE,0003Fh       ; Phrase="Thank You (%)"
        CALL    L1363           ; Call Speech Routine (phrase)

        CALL    L1F27           ; Send REJECT Command to LDPlayer

        LD      DE,000B3h       ; Phrase="Initializing System"
        CALL    L1363           ; Call Speech Routine (phrase)
        LD      HL,0BE01h       ; 
        SET     6,(HL)          ; Enable both AUDIO Channels
        CALL    L1CA3           ; Check LDPLAYER type by checking the DIPs 
        LD      DE,00174h       ; Set Timer = 174h
        CALL    L2163           ; Wait until Timer Expires
        CALL    L1F1E           ; Send PLAY command
        LD      DE,000B2h       ; Phrase="Disc Spinning Up Please Wait"
        CALL    L1363           ; Call Speech Routine (phrase)
        CALL    L1F1E           ; Send PLAY command
        LD      DE,001D1h       ; Set Timer = 1D1h
        CALL    L2163           ; Wait until Timer Expires
        CALL    L1F30           ; Send DISPLAY DISABLE to LDPlayer
        LD      DE,L02B8        ; Get Frame Number, "Thayer's Quest" first scene
        CALL    L1C57           ; PAUSE on Frame Number
        RET                     ; Return






; ---------------------------------------------------
;     Check LDPLAYER type by checking the DIPs
; ---------------------------------------------------
;        A79A   bit3 = 0  LD-V1000
;               bit3 = 1  PR-7820
; ---------------------------------------------------
L1CA3:  LD      HL,0A79Ah       ; Get LDPlayer Status bit
        RES     3,(HL)          ; Clear LDPLAYER bit
        IN      A,(0F1h)        ; Get DIP Switch B
        BIT     3,A             ; Test B4, LDPlayer
        RET     Z               ; PR-7820 so return
        SET     3,(HL)          ; Else set the LDPLAYER bit
        RET                     ; Return





; ---------------------------------------------------
;                Send 2 Play Commands  
; ---------------------------------------------------
L1CB0:  PUSH    BC              ; Save Timer Value
        CALL    L1CC1           ; Setup AUDIO Channel(s)
        CALL    L1F1E           ; Send PLAY command
        CALL    L1F1E           ; Send PLAY command
        POP     BC              ; Restore Timer Value
        LD      D,B             ; Get Programmable Timer Value
        LD      E,C             ; Get Programmable Timer Value
        JP      L1BF6           ; Jump back and set timer
        RET                     ; Return






; ---------------------------------------------------
;              Setup AUDIO Channel(s)
; ---------------------------------------------------
L1CC1:  LD      A,(0BE01h)      ; Get Control Status Byte
        BIT     6,A             ; Do we need just one audio channel?
        JR      Z,L1CE1         ; Yes, so determine which channel
; ---------------------------------------------------
;          Turn ON both AUDIO 1 and AUDIO 2   
; ---------------------------------------------------               
L1CC8:  CALL    L1D4E           ; Check LDPlayer type
        JR      Z,L1CD8         ; PR-7820 selected so skip ahead
; ---------------------------------------------------
;        LD-V1000:   AUDIO 1 and AUDIO 2 ON
; ---------------------------------------------------
        LD      A,001h          ; Set AUDIO 1 to ON
        CALL    L1D30           ; Send AUDIO 1 Command
        LD      A,001h          ; Set AUDIO 2 to ON
        CALL    L1D3F           ; Send AUDIO 2 Command
        RET                     ; Return
; ---------------------------------------------------
;        PR-7820:    AUDIO 1 and AUDIO 2 ON
; ---------------------------------------------------
L1CD8:  LD      A,012h          ; Command = BOTH AUDIO SELECT (PR-7820)
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        RET                     ; Return





; ---------------------------------------------------
;      Determine which AUDIO channel 1 or 2
; ---------------------------------------------------
L1CE1:  BIT     7,A             ; Test which channel to turn on 
        JR      Z,L1CFE         ; Skip ahead and turn AUDIO 1 ON
; ---------------------------------------------------
;             Turn just AUDIO 2 ON
; ---------------------------------------------------                
        CALL    L1D4E           ; Check LDPlayer type
        JR      Z,L1CF5         ; PR-7820 selected so skip ahead
; ---------------------------------------------------
;        LD-V1000:   AUDIO 2 ON
; ---------------------------------------------------                
        LD      A,001h          ; Set AUDIO 2 to ON
        CALL    L1D3F           ; Send AUDIO 2 Command
        LD      A,000h          ; Set AUDIO 1 to OFF
        CALL    L1D30           ; Send AUDIO 1 Command
        RET                     ; Return
; ---------------------------------------------------
;        PR-7820:    AUDIO 2 ON
; ---------------------------------------------------
L1CF5:  LD      A,01Ah          ; Command = AUDIO 2 SELECT (PR-7820)
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        RET                     ; Return




; ---------------------------------------------------
;             Turn just AUDIO 1 ON
; ---------------------------------------------------
L1CFE:  CALL    L1D4E           ; Check LDPlayer type
        JR      Z,L1D0E         ; PR-7820 selected so skip ahead
; ---------------------------------------------------
;        LD-V1000:   AUDIO 1 ON
; ---------------------------------------------------
        LD      A,001h          ; Set AUDIO 1 to ON
        CALL    L1D30           ; Send AUDIO 1 Command
        LD      A,000h          ; Set AUDIO 2 to OFF
        CALL    L1D3F           ; Send AUDIO 2 Command
        RET                     ; Return
; ---------------------------------------------------
;        PR-7820:    AUDIO 1 ON
; ---------------------------------------------------
L1D0E:  LD      A,019h          ; Command = AUDIO 1 SELECT (PR-7820 A1)
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        RET                     ; Return





; ---------------------------------------------------
;                   MUTE AUDIO
; ---------------------------------------------------
L1D17:  CALL    L1D4E           ; Check LDPlayer type
        JR      Z,L1D27         ; PR-7820 selected so skip ahead
; ---------------------------------------------------
;        LD-V1000:   ALL AUDIO OFF
; ---------------------------------------------------
        LD      A,000h          ; Set AUDIO 1 to OFF
        CALL    L1D30           ; Send AUDIO 1 Command
        LD      A,000h          ; Set AUDIO 2 to OFF
        CALL    L1D3F           ; Send AUDIO 2 Command
        RET                     ; Return
; ---------------------------------------------------
;        PR-7820:    ALL AUDIO OFF
; ---------------------------------------------------
L1D27:  LD      A,013h          ; Command = ALL AUDIO OFF (PR-7820 A0)
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        RET                     ; Return





; ---------------------------------------------------
;       Send AUDIO 1 command to LDPlayer
;         A = 00, OFF       A= 01, ON
; ---------------------------------------------------
L1D30:  CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        LD      A,010h          ; Command = AUDIO 1 
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        RET                     ; Return



; ---------------------------------------------------
;       Send AUDIO 2 command to LDPlayer
;         A = 00, OFF       A= 01, ON
; ---------------------------------------------------
L1D3F:  CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        LD      A,011h          ; Command = AUDIO 2
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        RET     





; ---------------------------------------------------
;                Check LDPLAYER TYPE 
; ---------------------------------------------------
;       Return   Z  PR-7820
;               NZ  LD-V1000
; ---------------------------------------------------
L1D4E:  LD      HL,0A79Ah       ; Get LDPlayer Status Byte
        BIT     3,(HL)          ; Check LDPLAYER TYPE
        RET                     ; Return






; ---------------------------------------------------
;          Perform Attract Mode AUDIO Check
; ---------------------------------------------------
L1D54:  LD      A,(0BE0Fh)      ; Get DIP Switch A
        BIT     5,A             ; Test A6, Attract Mode Audio
        JR      NZ,L1D60        ; Attract Mode Audio ON, so skip ahead
L1D5B:  CALL    L1D17           ; MUTE audio
        JR      L1D70           ; Skip Attract Mode Count
L1D60:  BIT     6,A             ; Test A7, Attact Mode Count
        JR      NZ,L1D6D        ; Audio Always ON, so skip ahead
        LD      HL,0A788h       ; Point to Attract Mode Count
        INC     (HL)            ; Increment Attract Mode Count
        LD      A,(HL)          ; Get Attract Mode Count
        AND     007h            ; Test if it is equal to 8
        JR      NZ,L1D5B        ; Not equal to 8 so loop back
L1D6D:  CALL    L1CC8           ; Enable AUDIO
L1D70:  RET                     ; Return







; ---------------------------------------------------
;     Convert number (frame number or score) to BCD 
;     BCD is Binary-Coded Decimal
;               A794-A796   Number awaiting conversion to BCD
;               A7B5-A7B7   BCD, Number after converted to BCD
; ---------------------------------------------------
L1D71:
MakeBCD:
; ---------------------------------------------------
;            Clear out BCD area A7B5 - A7B7
; ---------------------------------------------------
        LD      HL,0A7B5h       ; Setup BCD location to A7B5
        LD      B,004h          ; B = 4, set Loop
L1D76:  LD      (HL),000h       ; Store a zeros in BCD location
        INC     HL              ; Increment byte pointer
        DJNZ    L1D76           ; B = B - 1, Loop until B = 0
; ---------------------------------------------------
;               Begin BCD conversion
; ---------------------------------------------------
        LD      B,018h          ; B = 24, set Loop
L1D7D:  LD      HL,0A794h       ; Number to convert starts at A794
        LD      C,003h          ; C = 3, set Loop
        XOR     A               ; Clear carry

L1D83:  RL      (HL)            ; Roll BCD bits to the left 
        INC     HL              ; Increment byte pointer
        DEC     C               ; C = C - 1
        JP      NZ,L1D83        ; Loop until C = 0

        LD      HL,0A7B5h       ; Set beginning of BCD area
        LD      C,004h          ; C = 4, set Loop
L1D8F:  LD      A,(HL)          ; Get BCD byte
        ADC     A,(HL)          ; BCD = BCD * 2 + Carry
        DAA     
        LD      (HL),A          ; Store calculation in BCD
        INC     HL              ; Go to next BCD byte 
        DEC     C               ; C = C - 1
        JP      NZ,L1D8F        ; Loop until C = 0, all BCD bytes
        DJNZ    L1D7D           ; B = B - 1, Get next bit until B = 0
        RET                     ; Return

   






; ---------------------------------------------------
;                 SEARCH to Frame
; ---------------------------------------------------
;        A7B7h hold Frame Number in BCD
; ---------------------------------------------------
L1D9B:  CALL    MakeBCD         ; Convert number to BCD
        LD      HL,0A787h       ; Point to Number of SEARCH Retries
        LD      (HL),000h       ; Clear Number of SEARCH Retries to zero

; ---------------------------------------------------
;             Send Frame Number to LDPlayer
; ---------------------------------------------------
;    Send the 5 numbers that make up the frame number
;    as separate commmands.
; ---------------------------------------------------
L1DA3:  LD      HL,0A7B7h       ; Point to Frame Number
        LD      A,(HL)          ; Get Frame Number
        AND     00Fh            ; Isolate lower nibble digit
        CALL    GetCommand      ; Convert data to LDPlayer Command Code
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        DEC     HL              ; Point to next digit
        LD      A,(HL)          ; Get next digit
        SRL     A               ; Shift right, Isolate upper nibble
        SRL     A               ; Shift right
        SRL     A               ; Shift right
        SRL     A               ; Shift right
        CALL    GetCommand      ; Convert data to LDPlayer Command Code
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        LD      A,(HL)          ; Get Frame Number
        AND     00Fh            ; Isolate lower nibble digit
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        DEC     HL              ; Send $FF then Command byte to LDPlayer
        LD      A,(HL)          ; Get next digit
        SRL     A               ; Shift right, Isolate upper nibble
        SRL     A               ; Shift right
        SRL     A               ; Shift right
        SRL     A               ; Shift right
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        LD      A,(HL)          ; Get Frame Number
        AND     00Fh            ; Command = DISPLAY
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
; ---------------------------------------------------
;                    Start SEARCH
; ---------------------------------------------------
        LD      A,00Ah          ; Command = SEARCH
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer

; ---------------------------------------------------
;            Wait for SEARCH to complete
; ---------------------------------------------------
        LD      HL,0A79Ah       ; Get LDPlayer Status Byte
        BIT     3,(HL)          ; Check LDPLAYER TYPE
        JP      Z,L1E67         ; PR-7820 selected so skip ahead
        PUSH    BC              ; Save BC Register
; ---------------------------------------------------
;            LD-V1000:  SEARCH wait
; ---------------------------------------------------
        LD      B,000h          ; Start SEARCH wait timer
L1DF4:  IN      A,(0F1h)        ; Get LDPlayer Status
        BIT     6,A             ; Is LDPlayer READY?
        JP      NZ,L1DF4        ; Wait here until data arrives
        IN      A,(0F0h)        ; Get LDPlayer Data Byte 
        CP      0D0h            ; Is SEARCH FINISHED?
        JR      NZ,L1E04        ; No, so skip ahead
        POP     BC              ; SEARCH done so restore BC Register
        JR      L1E54           ; Wait for STATUS toggle
; ---------------------------------------------------
;     Test for SEARCH ERROR or excessive wait time
; ---------------------------------------------------
L1E04:  CP      090h            ; Is there a SEARCH ERROR?
        JR      Z,L1E1A         ; Yes, so handle error
        INC     B               ; Count time waiting for SEARCH to complete
        LD      HL,0A787h       ; Get Number of SEARCH Retries
        LD      A,000h          ; Check number of retries
        CP      (HL)            ; Have we retried the SEARCH yet? 
        JR      Z,L1E15         ; No, so wait longer        
        LD      A,066h          ; Time to Wait = 66h
        JR      L1E17           ; Check wait time        
L1E15:  LD      A,0FFh          ; Time to Wait = FFh
L1E17:  CP      B               ; Have we waited long enough for SEARCH?
        JR      NZ,L1E4A        ; No, wait longer.  Loop back.        

; ---------------------------------------------------
;       Retry SEARCH if SEARCH ERROR encounter
; ---------------------------------------------------
L1E1A:  LD      HL,0A787h       ; Get Number of SEARCH Retries
        INC     (HL)            ; Increment number of retries
        LD      A,003h          ; Check for 3 retries
        CP      (HL)            ; Have we retried 3 times yet?
        JR      NZ,L1E3E        ; Not yet, so retry again
              
; ---------------------------------------------------
; LDPlayer FAULT occured, Check if Frame Number Valid 
; ---------------------------------------------------                  
        LD      C,(IY+003h)     ; BC = Scene Frame Number
        LD      B,(IY+004h)     ; BC = Scene Frame Number
        LD      HL,07BD4h       ; Check if frame number > 31700
        AND     A               ; Set Carry
        SBC     HL,BC           ; Compare Frame Number
        JP      C,L0000         ; Frame Number too high, so reset machine
        LD      HL,00064h       ; Check if frame number < 100
        AND     A               ; Set Carry
        SBC     HL,BC           ; Compare Frame Number
        JP      NC,L0000        ; Frame Number too low, so reset machine
        POP     BC              ; Restore BC Register
        JR      L1E54           ; Just start disc wherever it's at

; ---------------------------------------------------
;        Retry SEARCH with Frame Number + 1
; ---------------------------------------------------
L1E3E:  LD      HL,0A7B5h       ; Point to Frame Number
        LD      A,(HL)          ; Get Frame Number for addition
        ADD     A,001h          ; Add 1 to frame
        DAA                     ; Add decimal 1 to frame number
        LD      (HL),A          ; Store new frame
        POP     BC              ; Restore BC Register
        JP      L1DA3           ; Try SEARCH again

; ---------------------------------------------------
;       LD-V1000 wait for STATUS Bit
; ---------------------------------------------------
L1E4A:  IN      A,(0F1h)        ; Get LDPlayer Status
        BIT     6,A             ; Is LDPlayer READY?
        JP      Z,L1E4A         ; Wait here until SEARCH is finished
        JP      L1DF4           ; Loop back and wait for byte from LDPlayer

; ---------------------------------------------------
;       Frame found, now send PLAY Command
; ---------------------------------------------------
L1E54:  LD      HL,0A791h       ; Get LDPlayer Control Register
        SET     2,(HL)          ; Mark search as completed
        BIT     4,(HL)          ; Is it Freeze Frame?
        JP      Z,L1E66         ; Yes, so skip PLAY Command
        LD      A,00Bh          ; Get PLAY Command
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
L1E66:  RET                     ; Return

; ---------------------------------------------------
;            PR-8210:  SEARCH wait
; ---------------------------------------------------
L1E67:  IN      A,(0F1h)        ; Get LDPlayer Status
        BIT     7,A             ; Is LDPlayer READY?
        JP      NZ,L1E67        ; Wait here until SEARCH finished
        JP      L1E54           ; Frame found so continue








; ---------------------------------------------------
;         Get LDPlayer Command from Table
; ---------------------------------------------------
;         A = index to command
;     $1F65 = Start of Command Table (CommandTable)
;     $A784 = Gets loaded with Command Code
; ---------------------------------------------------
GetCommand:
        PUSH    HL              ; Save HL Register
        LD      HL,01F65h       ; Load HL with pointer to Command Table
        ADD     A,L             ; A = Index to add to Command Table
        LD      L,A             ; Add Index
        JR      NC,L1E7A        ; Check carry after add
        INC     H               ; Increment Command Table pointer if carry set
L1E7A:  LD      A,(HL)          ; Get Command Byte from Command Table
        LD      (0A784h),A      ; Store Command Byte
        POP     HL              ; Restore HL Register
        RET                     ; Return





; ---------------------------------------------------
;      Send command with $FF to LDPlayer
; ---------------------------------------------------
L1E80:  PUSH    HL              ; Temporarily save HL Register
        LD      HL,0A79Ah       ; Get LDPlayer Status Byte
        BIT     3,(HL)          ; Check LDPLAYER TYPE
        POP     HL              ; Restore HL Register
        JP      Z,L1ED8         ; PR-7820 selected so skip ahead
        PUSH    HL              ; Save HL Register
        PUSH    BC              ; Save BC Register
        LD      A,(0A784h)      ; Get Command from A784h
        LD      B,A             ; Store Command in B temporarily
        LD      A,0FFh          ; Load an FFh
        LD      (0A784h),A      ; Store FFh in Command spot
        CALL    L1EA2           ; Send FFh to LDPlayer
        LD      A,B             ; Restore Command from B
        LD      (0A784h),A      ; Store Command in A784h
        CALL    L1EA2           ; Send Command to LDPlayer
        POP     BC              ; Restore BC Register
        POP     HL              ; Restore HL Register                     
        RET                     ; Return





; ---------------------------------------------------
;       Output Command to LDPlayer (LD-V1000)
; ---------------------------------------------------
L1EA2:  PUSH    HL              ; Save HL Register
        LD      A,(0A784h)      ; Load Command byte
        OUT     (0F4h),A        ; Send Command byte to LDPlayer

L1EA8:  IN      A,(0F1h)        ; Get LDPlayer Register
        BIT     6,A             ; Test Command Strobe
        JP      NZ,L1EA8        ; Loop until Command Strobe goes low

L1EAF:  IN      A,(0F1h)        ; Get LDPlayer Register
        BIT     6,A             ; Test Command Strobe
        JP      Z,L1EAF         ; Loop until Command Strobe goes high
; ---------------------------------------------------
;        Set LDPlayer Communication Bus to Output
; ---------------------------------------------------
        LD      HL,0A783h       ; Use LDPlayer Hardware Register
        SET     5,(HL)          ; Set LDPlayer data bus as Output
        RES     7,(HL)          ; Clear INT/EXT
        LD      A,(HL)          ; Update LDPlayer Hardware Register
        OUT     (0F5h),A        ; Write to Hardware
; ---------------------------------------------------
;          Wait until LDPlayer is not BUSY
; ---------------------------------------------------
L1EC0:  IN      A,(0F1h)        ; Get LDPlayer Register
        BIT     7,A             ; Check if LDPlayer busy
        JP      NZ,L1EC0        ; Wait until LDPlayer is not busy
L1EC7:  IN      A,(0F1h)        ; Get LDPlayer Register
        BIT     7,A             ; Check if LDPlayer busy
        JP      Z,L1EC7         ; Wait until LDPlayer is not busy
; ---------------------------------------------------
;      Return LDPlayer Communication Bus to Input
; ---------------------------------------------------
        LD      HL,0A783h       ; Use LDPlayer Hardware Register
        RES     5,(HL)          ; Set LDPlayer data bus as Input
        LD      A,(HL)          ; Update LDPlayer Hardware Register
        OUT     (0F5h),A        ; Write to Hardware

        POP     HL              ; Restore HL Register
        RET                     ; Return






; ---------------------------------------------------
;       Send command with $FF  (PR-7820)
; ---------------------------------------------------
L1ED8:  PUSH    HL              ; Save HL Register
        LD      HL,0A783h       ; Use LDPlayer Hardware Register
        RES     7,(HL)          ; Clear INT/EXT
        LD      A,(HL)          ; Update LDPlayer Hardware Register
        OUT     (0F5h),A        ; Write to Hardware
        LD      A,(0A784h)      ; Get Command from A784h
        OUT     (0F4h),A        ; Send Command byte to LDPlayer
; ---------------------------------------------------
;     Return LDPlayer Communication Bus to Output
; ---------------------------------------------------
        LD      HL,0A783h       ; Use LDPlayer Hardware Register
        SET     5,(HL)          ; Set LDPlayer data bus as Output
        LD      A,(HL)          ; Update LDPlayer Hardware Register
        OUT     (0F5h),A        ; Write to Hardware
; ---------------------------------------------------
;         Press ENTER on LDPlayer then delay
; ---------------------------------------------------
        RES     6,(HL)          ; Press ENTER
        LD      A,(HL)          ; Update LDPlayer Hardware Register
        OUT     (0F5h),A        ; Write to Hardware

        CALL    L1F0B           ; Call Delay (0DF6)
; ---------------------------------------------------
;        Release ENTER on LDPlayer then delay
; ---------------------------------------------------
        LD      HL,0A783h       ; Use LDPlayer Hardware Register
        SET     6,(HL)          ; Release ENTER
        LD      A,(HL)          ; Update LDPlayer Hardware Register
        OUT     (0F5h),A        ; Write to Hardware

        CALL    L1F0B           ; Call Delay (0DF6)
; ---------------------------------------------------
;      Return LDPlayer Communication Bus to Input
; ---------------------------------------------------
        LD      HL,0A783h       ; Use LDPlayer Hardware Register
        RES     5,(HL)          ; Set LDPlayer data bus as Input
        LD      A,(HL)          ; Update LDPlayer Hardware Register
        OUT     (0F5h),A        ; Write to Hardware
        POP     HL              ; Restore HL Register
        RET                     ; Return



; ---------------------------------------------------
;          Delay for 0DF6h
; ---------------------------------------------------
L1F0B:  LD      DE,0FFFFh       ; DE = -1
L1F0E:  LD      HL,00DF6h       ; Timer = 0DF6h
L1F11:  ADD     HL,DE           ; Subtract 1 from timer
        JR      C,L1F11         ; Loop until timer expired       
        RET                     ; Return



; ---------------------------------------------------
;          Send PAUSE command to LDPlayer
; ---------------------------------------------------
L1F15:  LD      A,00Ch          ; Get PAUSE Command
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        RET                     ; Return



; ---------------------------------------------------
;              Send PLAY command to LDPlayer
; ---------------------------------------------------
SendPlay:
L1F1E:  LD      A,00Bh          ; Get PLAY Command
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        RET                     ; Return


; ---------------------------------------------------
;           Send REJECT command to LDPlayer
; ---------------------------------------------------
L1F27:  LD      A,01Bh          ; Get REJECT Command
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        RET                     ; Return


; ---------------------------------------------------
;        Send (unknown) command to LDPlayer
; ---------------------------------------------------
L1F30:  LD      HL,0A79Ah       ; Get LDPlayer Status Byte 
        BIT     3,(HL)          ; Check LDPLAYER TYPE
        JP      Z,L1F41         ; PR-7820 selected so skip ahead
        LD      A,014h          ; Get <> Command
L1F3A:  CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        RET                     ; Return;

; ---------------------------------------------------
;        Send (unknown) command to LDPlayer
; ---------------------------------------------------
L1F41:  LD      A,017h          ; Get <> Command
        JP      L1F3A           ; Jump back and send command
        LD      HL,0A79Ah       ; Get LDPlayer Status Byte 
        BIT     3,(HL)          ; Check LDPLAYER TYPE
        JP      Z,L1F57         ; PR-7820 selected so skip ahead
        LD      A,015h          ; Get <> Command
L1F50:  CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        RET                     ; Return
         
; ---------------------------------------------------
;        Send (unknown) command to LDPlayer
; ---------------------------------------------------
L1F57:  LD      A,018h          ; Get <> Command
        JP      L1F50           ; Go back and send command to LDPlayer
        LD      A,00Fh          ; Get <> Command
        CALL    GetCommand      ; Get LDPlayer Command Byte
        CALL    L1E80           ; Send $FF then Command byte to LDPlayer
        RET                     ; Return





; ---------------------------------------------------
;           Table of LDPlayer Commands
; ---------------------------------------------------
CommandTable:
                .byte   03Fh        ; A=00  0
                .byte   00Fh        ; A=01  1
                .byte   08Fh        ; A=02  2
                .byte   04Fh        ; A=03  3
                .byte   02Fh        ; A=04  4
                .byte   0AFh        ; A=05  5
                .byte   06Fh        ; A=06  6
                .byte   01Fh        ; A=07  7
                .byte   09Fh        ; A=08  8
                .byte   05Fh        ; A=09  9
                .byte   0F7h        ; A=0A  SEARCH
                .byte   0FDh        ; A=0B  PLAY
                .byte   0FBh        ; A=0C  PAUSE (STOP)
                .byte   0DFh        ; A=0D  (unknown)
                .byte   0EFh        ; A=0E  (unknown)
                .byte   0F1h        ; A=0F  DISPLAY
                .byte   0F4h        ; A=10  AUDIO 1
                .byte   0FCh        ; A=11  AUDIO 2
                .byte   0A3h        ; A=12  X1 FORWARD
                .byte   0A0h        ; A=13  X0 FORWARD (STOP)
                .byte   0CDh        ; A=14  DISPLAY DISABLE
                .byte   0CEh        ; A=15  DISPLAY ENABLE
                .byte   0FAh        ; A=16  (unknown)
                .byte   0E1h        ; A=17  (unknow)
                .byte   0E0h        ; A=18  (unknown)
                .byte   0A1h        ; A=19  X1/4 FORWARD
                .byte   0A2h        ; A=1A  X1/2 FORWARD
                .byte   0F9h        ; A=1B  REJECT
 




; ---------------------------------------------------
;          Diagnostic Test Addresses
; --------------------------------------------------- 
L1F81:   .word   02041h   ; RAM Test
         .word   0208Ah   ; ROM Test   
         .word   020E1h   ; Scoreboard Test
         .word   0211Ah   ; Keyboard Test
         .word   0214Ah   ; Communications Link Test
         .word   02151h   ; Monitor Test 
         .word   01F9Bh   ; Begin Diagnostics
         
; ---------------------------------------------------
;                  unknown
; --------------------------------------------------- 
L1F90:   .byte   060h, 071h, 060h, 071h, 060h, 071h
         .byte   060h, 071h, 060h, 071h, 060h, 071h





; ---------------------------------------------------
;                Begin Diagnostics
; --------------------------------------------------- 
L1F9B:  LD      DE,000A3h       ; Load Phrase (A3) "Diagnostic Tests"
        CALL    L1363           ; Call Speech Routine (phrase)           
        CALL    L210C           ; Blank out Scoreboard
        CALL    L1FD3           ; Check Keyboard for "M" pressed
        JR      C,L1FEE         ; If pressed jump to MENU MODE        
        LD      BC,01F81h       ; BC = Pointer to first Test
        LD      DE,(0C008h)     ; Get Frame Number, "Begin Diagnostics, RAM Test in Progress"
L1FB0:  LD      A,(BC)          ; A = Address Pointer
        LD      L,A             ; L = A
        INC     BC              ; Point to next byte 
        LD      A,(BC)          ; A = Next Byte 
        LD      H,A             ; H = A, HL = Test Address
        INC     BC              ; Increment Pointer to next test
        PUSH    DE              ; Save DE Register
        PUSH    BC              ; Save BC Register
        PUSH    HL              ; Save HL Register
        CALL    L1C57           ; PAUSE on Frame Number, "Begin Diagnostics"
        POP     HL              ; Restore HL Register
        LD      DE,01FC2h       ; DE = Return Address
        PUSH    DE              ; Store Return Address once test is complete
; ---------------------------------------------------
        JP      (HL)            ; Jump to Test Routine
; ---------------------------------------------------


L1FC2:  CALL    L1FD3           ; Check Keyboard for "M" pressed
        POP     BC              ; Restore BC Register (IY)
        POP     DE              ; Restore DE Register (DE)
        JR      C,L1FEE         ; If "M" pressed jump to MENU MODE        
        LD      A,(0C00Ah)      ; A = 0Ah, Add 0Ah to Return Address
        ADD     A,E             ; A = A + E      (DE = DE + 0Ah)
        LD      E,A             ; E = A
        JR      NC,L1FB0        ; Check if carry is set
        INC     D               ; Yes, so increment high byte D = D + 1
        JR      L1FB0           ; Continue Diagnostics




; ---------------------------------------------------
;       Check Keyboard for "M" Pressed
;      C=1, Pressed       C=0, Not Pressed
; --------------------------------------------------- 
L1FD3:  LD      HL,0BE0Bh       ; Check Keyboard Buffer
        BIT     0,(HL)          ; Has Key been pressed?
        JR      Z,L1FEC         ; No, so skip ahead
        RES     0,(HL)          ; Clear Keyboard Buffer
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        CP      04Dh            ; Was "M" Pressed?
        JR      NZ,L1FEC        ; No, so skip ahead        
        LD      DE,(0C013h)     ; Get Frame Number, "Thayer's Quest" Title
        CALL    L1C57           ; PAUSE on Frame Number
        SCF                     ; C = 1
        RET                     ; Return (1)
L1FEC:  XOR     A               ; C = 0 
        RET                     ; Return (0)






; ---------------------------------------------------
;              Diagnostics MENU MODE
; --------------------------------------------------- 
;           "A" = RAM Test
;           "B" = EPROM Test
;           "C" = Display Test
;           "D" = Keyboard Test
;           "E" = Communications Link Test
;           "F" = Monitor Test
;           "G" = Restart Dianostics from beginning
; --------------------------------------------------- 
L1FEE:  CALL    L2180           ; Reset Scoreboard to zero
        LD      DE,000A4h       ; Phrase="Menu Mode Press Key A Through G To Choose A Test"  
        CALL    L1363           ; Call Speech Routine (phrase)           
        LD      E,000h          ; DE = 0000h
        LD      D,000h          ; DE = 0000h
        LD      HL,0BE0Bh       ; Check Keyboard Buffer
L1FFE:  BIT     0,(HL)          ; Has a key been pressed?
        JR      Z,L1FFE         ; No key pressed so just loop
        RES     0,(HL)          ; Clear keypress buffer
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        SUB     041h            ; Subtract 65d
        JR      C,L200F         ; Key < "A" then Invalid Key
        CP      007h            ; Check for Key > "G"
        JR      C,L2017         ; No, so it is a Valid Key
; ---------------------------------------------------
;             Invalid Key Pressed
; --------------------------------------------------- 
L200F:  LD      DE,0003Eh       ; Phrase="That Won't Work Here (%)"
        CALL    L1363           ; Call Speech Routine (phrase)           
        JR      L1FEE           ; Continue monitoring keyboard

; ---------------------------------------------------
;             Valid Key Pressed
; --------------------------------------------------- 
L2017:  ADD     A,A             ; A = A*2
        LD      B,A             ; B = A
        LD      DE,000A5h       ; Initial phrase="Start of RAM Test"
        ADD     A,E             ; Index to correct phrase
        LD      E,A             ; Store new index to phrase
        JR      NC,L2021        ; Handle carry
        INC     D               ; Carry set, so bump upper byte
L2021:  PUSH    DE              ; Save Phrase Number to stack
        PUSH    DE              ; Save Phrase Number to stack
        CALL    L1363           ; Call Speech Routine (phrase)
        LD      A,B             ;
        LD      DE,01F81h       ;
        ADD     A,E             ;
        LD      E,A             ;
        JR      NC,L202F        ;
        INC     D
L202F:  LD      A,(DE)
        LD      L,A
        INC     DE
        LD      A,(DE)
        LD      H,A
        LD      DE,02039h       ; DE = Return Address 
        PUSH    DE              ; Save DE Register
        JP      (HL)            ; Jump to Test Routine
L2039:  POP     DE              ; Restore DE Register
        POP     DE              ; Restore DE Register
        INC     DE              ; Increment ?
        CALL    L1363           ; Call Speech Routine (phrase) 
        JR      L1FEE           ; Loop on MENU MODE







; ---------------------------------------------------
;                  Begin RAM Test
; --------------------------------------------------- 
L2041:  POP     IX              ; IX = Pointer to next test
        POP     IY
        POP     DE
; ---------------------------------------------------
;          Fill RAM A000-BFFF with 55h
; --------------------------------------------------- 
        LD      B,055h          ; B = 55h
        DI                      ; Disable Interrupts

L2049:  LD      HL,0A000h       ; Point to start of RAM
L204C:  LD      (HL),B          ; Put 55/AAh into RAM location
        INC     HL              ; Point to next RAM spot
        LD      A,H             ; A = H
        OR      L               ; A = A OR L, check HL = 0000h
        JR      NZ,0204C        ; Loop until end of bank        

        LD      HL,0A000h       ; Point to beginning of RAM
L2055:  LD      A,(HL)          ; Check to see if RAM was written correctly
        CP      B               ; Compare byte with 55/AAh
        JR      NZ,L2067        ; Not correct, show "FAILED" screen           
        INC     HL              ; Point to next RAM location
        LD      A,H             ; A = H
        CP      0C0h            ; Is address C000?
        JR      NZ,L2055        ; No, so loop until C000 is reached

        LD      A,0AAh          ; A = AAh
        CP      B               ; Have we done AA yet?
        JR      Z,L2074         ; Yes, so clear out RAM
        LD      B,A             ; B = AAh
        JR      L2049           ; Fill RAM with AAh





; ---------------------------------------------------
;      Display Message, "RAM Test failed"
; --------------------------------------------------- 
L2067:  CALL    L1CA3           ; Check LDPLAYER type by checking the DIPs
        LD      DE,(0C00Bh)     ; Get Frame Number, "RAM Test failed"
        CALL    L1C57           ; PAUSE on Frame Number
        JP      L218B           ; Wait for Diagnostic DIP to be switched OFF




; ---------------------------------------------------
;             Clear RAM A000-FFFF 
; --------------------------------------------------- 
L2074:  LD      HL,0A000h       ; HL = A000, first location of RAM
L2077:  LD      (HL),000        ; Clear out location
        INC     HL              ; Point to next location
        LD      A,H             ; A = H
        OR      L               ; HL = FFFF?
        JR      NZ,L2077        ; Loop until all spots cleared
; ---------------------------------------------------
;         Load pointer to next Test
; --------------------------------------------------- 
        CALL    L1CA3           ; Check LDPLAYER type by checking the DIPs
        LD      SP,0BFFFh       ; Set Stack Pointer to BFFF
        PUSH    DE              ; Save DE Register
        PUSH    IY              ; Save IY Register
        EI                      ; Enable Interrupts
        JP      (IX)            ; Jump to next test
                             ;77


; ---------------------------------------------------
;         Perform EPROM Checksum Test
; --------------------------------------------------- 
L2081:  LD      IY,0C006h
        LD      HL,L0000
        CALL    L20C1
        RET     Z

        LD      DE,(0C00Dh)     ; Frame # "ROM Checksum failed, Display indicates bad block"
        CALL    L1C57           ; PAUSE on Frame Number
        LD      C,0F7h
        LD      HL,01F8Fh
        LD      A,L
        ADD     A,B
        LD      L,A
        LD      B,002h
        JR      NC,L20A9                
        INC     H

L20A9:  OTIR    
        JP      L218B
        LD      HL,LC000
        LD      B,001h
        CALL    L20C1
        RET     Z

        LD      DE,(0C00F)      ; Get Frame Number, "Cartridge ROM Checksum Failed"
        CALL    L1C57           ; PAUSE on Frame Number
        JP      L218B

L20C1:  LD      DE,00000h
L20C4:  LD      A,(HL)
        ADD     A,E
        LD      E,A
        JR      NC,L20CA                
        INC     D
L20CA:  INC     HL
        LD      A,L
        CP      000h
        JR      NZ,L20C4                
        LD      A,H
        CP      080h
        JR      NZ,L20C4                
        LD      A,(IY+000h)
        CP      E
        INC     IY
        LD      A,(IY+000h)
        RET     NZ
        CP      D
        RET     





; ---------------------------------------------------
;           Begin Scoreboard Test
; ---------------------------------------------------
L20E1:  LD      C,000h          ; C = 0
L20E3:  LD      A,C             ; A = C
        LD      B,008h          ; Loop = 8
L20E6:  OUT     (0F6h),A        ; Output to Scoreboard
        OUT     (0F7h),A        ; Output to Scoreboard
        ADD     A,010h          ; Point to next spot
        DEC     B               ; Decrement Loop
        JR      NZ,L20E6        ; Loop until all spots filled     
        LD      HL,0BE0Bh       ; Get Keyboard Buffer
        BIT     0,(HL)          ; Has a key been pressed?
        RES     0,(HL)          ; Clear Keyboard Buffer
        JR      Z,L20FC         ; No key pressed, so skip ahead
        CALL    L2180           ; Reset Scoreboard to zero
        RET                     ; Return from test   
L20FC:  PUSH    BC              ; Save BC Register
        LD      DE,0001Fh       ; Timer = 1Fh
        CALL    L2163           ; Wait until Timer Expires
        POP     BC              ; Restore BC Register
        INC     C               ; C = C + 1, next digit
        LD      A,00Ah          ; A = 10
        CP      C               ; Have we done all digits?
        JR      NZ,L20E3        ; No, so continue loop
        JR      L20E1           ; Restart digits and loop again        






; ---------------------------------------------------
;          Blank out Scoreboard
; ---------------------------------------------------
L210C:  LD      A,00Fh          ; Get Blank character
        LD      B,008h          ; Loop = 8
L2110:  OUT     (0F6h),A        ; Send character to scoreboard
        OUT     (0F7h),A        ; Send character to scoreboard
        ADD     A,010h          ; Increment position
        DEC     B               ; Decrment Loop
        JR      NZ,L2110        ; Loop until all spots blanked
        RET                     ; Return





; ---------------------------------------------------
;          Begin Keyboard Test
; ---------------------------------------------------
L211A:  LD      DE,00592h       ; Programmable Timer = 592h
        CALL    L21A7           ; Set Programmable Timer
        LD      HL,0BE0Bh       ; Get Keyboard buffer
L2123:  CALL    L21B3           ; Check if Programmable Timer expired 
        JR      NZ,L2146        ; Timer expired so end test
        BIT     0,(HL)          ; Has a key been pressed?
        JR      Z,L2123         ; No, so just loop
; ---------------------------------------------------
;          Key has been pressed
; ---------------------------------------------------
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        RES     0,(HL)          ; Clear keypress buffer 
        BIT     7,A             ; Test if Character is Function Key
        JR      Z,L2141         ; No, so jump ahead
        AND     003h            ; AND Key with 3 (0-3)
        ADD     A,001h          ; Add 1 to Key (Function Keys1-4)
        LD      E,A             ; DE = Address of Key Speech
        LD      D,000h          ; Get word (key)
        CALL    L13C6           ; Call Speech Routine (word)
        JR      L2123           ; Continue Test

L2141:  CALL    L19B0           ;
        JR      L2123           ; Continue Test
; ---------------------------------------------------
;          2 minute Timer expired, End Test
; ---------------------------------------------------
L2146:  CALL    L2180           ; Reset Scoreboard to zero
        RET                     ; End of Test 






; ---------------------------------------------------
;       Begin Communications Link Test
; ---------------------------------------------------
L214A:  LD      DE,0005Dh       ; Load "M" key
        CALL    L2163           ; Check for "M" keypress
        RET                     ; Return




; ---------------------------------------------------
;       Begin Monitor Test
; ---------------------------------------------------
L2151:  LD      DE,0005Dh       ; Load "M" key?
        CALL    L2163           ; Check for "M" keypress
        LD      DE,(0C011h)     ; Get Frame Number, Underwater
        CALL    L1C57           ; PAUSE on Frame Number
L215E:  CALL    L216C           ; Check Diagnostic Mode DIP
        JR      L215E           ; Wait until Diagnostic Mode switched off





; ---------------------------------------------------
;              Programmable Timer
;         DE = Programmable Timer value
; ---------------------------------------------------
L2163:  CALL    L21A7           ; Set Programmable Timer
L2166:  CALL    L21B3           ; Check if Programmable Timer expired
        JR      Z,L2166         ; Loop until Timer expires
        RET                     ; Timer expired, so return




; ---------------------------------------------------
;           Check Diagnostic Mode DIP
; ---------------------------------------------------
L216C:  IN      A,(0F1h)        ; GetDIP Switch B
        BIT     0,A             ; Test B1, Diagnostic Mode
        JR      Z,L2178         ; Diagnostic Mode set, so skip ahead
        CALL    L2180           ; Reset Scoreboard to zero
        JP      L0000           ; RESET Program 

L2178:  CALL    L1FD3           ; Check Keyboard for "M" pressed
        RET     NC              ; "M" not pressed so return
        POP     HL              ; Restore HL Register
        JP      L1FEE           ; Jump Diagnostics MENU MODE


; ---------------------------------------------------
;              Reset Scoreboard to Zero
; ---------------------------------------------------
L2180:  XOR     A               ; A = 00h
        LD      (0BE0Dh),A      ; Store 0 in credits 
        LD      (0BE0Eh),A      ; Store 0 in credits
        CALL    L210C           ; Blank out Scoreboard
        RET                     ; Return



; ---------------------------------------------------
;     Loop unit Diagnostic Mode DIP switched OFF
; ---------------------------------------------------
L218B:  CALL    L216C           ; Check Diagnostic Mode DIP
        JR      L218B           ; Just keep looping        





; ---------------------------------------------------
;      Check Keyboard for a valid Keypress
;       A = Character, Z = Set, Z = Clear
; ---------------------------------------------------
L2190:  PUSH    BC              ; Save BC Register
        PUSH    DE              ; Save DE Register
        PUSH    HL              ; Save HL Register
        PUSH    IY              ; Save IY Register
        LD      HL,0BE0Bh       ; Check Keyboard Buffer
        BIT     0,(HL)          ; Check for keypress
        SCF                     ; Carry = set, no keypress
        JR      Z,L21A1         ; No keypress, so leave routine
        LD      A,(0BE0Ah)      ; Get Keyboard Character
        OR      A               ; Z = Clear
L21A1:  POP     IY              ; Restore IY Register
        POP     HL              ; Restore HL Register
        POP     DE              ; Restore DE Register
        POP     BC              ; Restore BC Register
        RET                     ; Return




; ---------------------------------------------------
;             Start Programmable Timer
; ---------------------------------------------------
;     DE = Timer Start Value
; ---------------------------------------------------
L21A7:  PUSH    HL              ; Save HL Register
        LD      HL,0BE07h       ; Get Programmable Timer Register
        LD      (HL),001h       ; Start Programmable Timer 
        INC     HL              ; Point to Timer
        LD      (HL),E          ; Load Value into Programmable Timer
        INC     HL              ; Point to Timer
        LD      (HL),D          ; Load Value into Programmable Timer
        POP     HL              ; Restore HL Register
        RET                     ; Return





; ---------------------------------------------------
;        Check if Timer expired
;            Z = 0, still running
;            Z = 1, expired
; ---------------------------------------------------
L21B3:  PUSH    HL              ; Save HL Register
        LD      HL,0BE07h       ; Check Programmable Timer Register
        BIT     1,(HL)          ; Is Timer still running?
        JR      Z,L21BF         ; Yes, return Z=0, skip ahead      
        RES     1,(HL)          ; Clear Timer
        OR      0FFh            ; return Z=1, Timer expired
L21BF:  POP     HL              ; Restore HL Register
        RET                     ; Return







; ---------------------------------------------------
;        Command Speech Chip to speak buffer
; ---------------------------------------------------
L21C1:  PUSH    IY              ; Save IY Register
        PUSH    HL              ; Save HL Register
        PUSH    DE              ; Save DE Register
        PUSH    BC              ; Save BC Register
        CALL    L225B           ; Replace string shortcuts in Speech Buffer
        CALL    L230D           ; Remove invalid characters in Speech Buffer
; ---------------------------------------------------
;   Make a copy of the Speech Buffer (A000 -> A500)
; ---------------------------------------------------
        LD      HL,0A000h       ; Source = A000
        LD      DE,0A500h       ; Destination = A500
        LD      BC,00100h       ; Number of bytes to copy
        LDIR                    ; Copy all bytes
; ---------------------------------------------------
; Do Inflection and Character Classification (A100,A200)
; ---------------------------------------------------
        LD      A,(0A614h)      ; Get number of characters in Speech buffer
        LD      (0A6D3h),A      ; Save number of characters
        LD      HL,0A000h       ; Get pointer to Speech buffer
        LD      (0A604h),HL     ; Save pointer to Speech buffer
        CALL    L25A2           ; Get Inflection Control Codes (A100) 
        CALL    L267A           ; Classify all characters VOWEL,CONST.,etc. (A200)

; ---------------------------------------------------
;    Setup loop in order to perform Phonetic Rules
; ---------------------------------------------------
        LD      HL,0A400h       ; HL = Phoneme pointer to A400
        LD      (0A608h),HL     ; Save A400 Phoneme pointer
        SUB     A               ; A = 0
        LD      (0A615h),A      ; Reset number of characters processed      
; ---------------------------------------------------
;  Check if all speech characters have rules checked
; ---------------------------------------------------
L21F3:  LD      HL,0A615h       ; Point to number of characters processed
        LD      A,(0A614h)      ; Get number of characters in Speech buffer
        LD      C,(HL)          ; Get number of characters processed
        CP      C               ; Have we processed all characters?
        JR      Z,L2238         ; No, process last character
        JR      NC,L2238        ; More characters to process so skip ahead

; ---------------------------------------------------
;            Apply voice characteristics
; ---------------------------------------------------
        CALL    L26CD           ; Apply voice characteristics

; ---------------------------------------------------
;    Prepare Speech Chip for speaking of Phonemes
; ---------------------------------------------------
        LD      HL,0A000h       ; Message Pointer = A000h
        LD      (0A60Ah),HL     ; Store pointer of Message
        DI                      ; Disable Interrupts
; ---------------------------------------------------
;         Request interrupt from Speech Chip
; ---------------------------------------------------          
        LD      A,080h          ; Raise Control bit in Register3
        OUT     (003h),A        ; Send to register3
        LD      A,0C0h          ; Set phoneme to PAUSE
        OUT     (000h),A        ; Send to register0
        LD      A,07Fh          ; Lower Control bit in Register3
        OUT     (003h),A        ; Send to register3
; ---------------------------------------------------
;           Send data packet to Speech Chip
; ---------------------------------------------------
        LD      HL,(0A60Ah)     ; Buffer Pointer = A000,A100,A200,...
        LD      C,004h          ; Output to Speech Registers 4,3,2,1,0
        LD      B,005h          ; Loop = 5 registers
L221C:  LD      A,(HL)          ; Get init code from buffer
        OUT     (C),A           ; Send value to register
        INC     H               ; Next locatoin (A000,A100,A200,...)
        DEC     C               ; Next register (port)
        DJNZ    L221C           ; Loop until all registers are written
        EI                      ; Enable Interrupts
; ---------------------------------------------------
;     Wait here until interrupt routine sends this
;     data packet to the Speech Chip    
; ---------------------------------------------------
L2224:  LD      A,(0A60Ah)      ; Get number of characters spoken
        LD      C,A             ; C = Number of characters spoken
        LD      A,(0A608h)      ; Get number of codes in buffer (A400)
        SUB     C               ; Has entire buffer been spoken?
        JR      C,L2232         ; Buffer has been spoken, so skip ahead
        JR      Z,L2232         ; Buffer has been spoken, so skip ahead
        JR      L2224           ; Loop until entire buffer is spoken 
                     
; ---------------------------------------------------
;    Speech complete, restore registers and return
; ---------------------------------------------------
L2232:  POP     BC              ; Restore BC Register
        POP     DE              ; Restore DE Register
        POP     HL              ; Restore HL Register
        POP     IY              ; Restore IY Register
        RET                     ; Return










; ---------------------------------------------------
;     Process Speech buffer before sending it out
; ---------------------------------------------------
;      C = Character spot being processed
; ---------------------------------------------------
;      Insert A100 Inflection Code into A400
; ---------------------------------------------------
L2238:  LD      B,000h          ; BC = Character spot being checked
        LD      HL,0A100h       ; Point to A100 inflection codes
        ADD     HL,BC           ; Index into A100 codes
        LD      A,(HL)          ; Get A100 Inflection Code
        OR      A               ; Is there an inflection code?
        JR      Z,L224A         ; No, so skip ahead
        LD      HL,(0A608h)     ; Get A400 Pointer
        LD      (HL),A          ; Save control code at Control Code Index (A400)
        INC     HL              ; Point to next A400 locaton
        LD      (0A608h),HL     ; Save Control Code Pointer
; ---------------------------------------------------
;           Check for Phoneme Rules
; ---------------------------------------------------
L224A:  LD      HL,0A000h       ; Point to A000 text
        ADD     HL,BC           ; Index into A000 text
        LD      A,(HL)          ; Get character
        SUB     020h            ; Does character follow Rules (32-96)?
        JP      NC,L2335        ; Yes, so apply Rules 
        LD      HL,0A615h       ; Get number of characters processed
        INC     (HL)            ; Increment number of speech characters processed
        JP      L21F3           ; Loop back until all speech characters processed








; ---------------------------------------------------
; Check for string shortcuts (*,$,%,#,n) in Speech Buffer
; ---------------------------------------------------
L225B:  LD      A,(0A64Ah)      ; Get Length of Player's Name
        LD      C,A             ; C = Length of Player's Name
        LD      A,(0A614h)      ; Get number of characters in Speech Buffer
        INC     A               ; Add one character
        LD      B,A             ; B = Number of characters + 1
; ---------------------------------------------------
;       Check if buffer has enough room for name
; ---------------------------------------------------
        ADD     A,C             ; Is there room for Player's Name?
        RET     C               ; Too many characters in buffer, so return

        ADD     A,014h          ; Is there room for a SPACE between words (20 chars)?
        RET     C               ; Too many characters in buffer, so return

; ---------------------------------------------------
;    Search buffer for string shortcuts (*,$,%,#,n)
; ---------------------------------------------------
        LD      HL,0A000h       ; HL = Start of Speech Buffer
L226C:  LD      A,02Ah          ; Check for Name shortcut (*)
        CP      (HL)            ; Is Name shortcut in Speech Buffer?
        JR      Z,L2289         ; Yes, so speak Name        
        LD      A,024h          ; Check for Name shortcut ($)
        CP      (HL)            ; Is Name shortcut in Speech Buffer?
        JR      Z,L2289         ; Yes, so speak Name         
        LD      A,025h          ; Check for Name shortcut (%)
        CP      (HL)            ; Is Name shortcut in Speech Buffer?
        JR      Z,L2289         ; Yes, so speak Name         
        LD      A,023h          ; Check for Name shortcut (#)
        CP      (HL)            ; Is Name shortcut in Speech Buffer?
        JR      Z,L2289         ; Yes, so speak Name               
        LD      A,06Eh          ; Check for Name shortcut (n)
        CP      (HL)            ; Is Name shortcut in Speech Buffer?
        JR      Z,L2289         ; Yes, so speak Name               
        INC     HL              ; Check next buffer character
        DJNZ    L226C           ; Loop until whole buffer is checked        
        RET                     ; Name shortcuts not found so return

; ---------------------------------------------------
;           Replace shortcut with String 
; ---------------------------------------------------
;      Save first part of Speech Buffer temporarily
; ---------------------------------------------------
L2289:  LD      C,L             ; BC = Spot where name occurs in buffer
        LD      B,000h          ; Copy up until occurance
        LD      HL,0A000h       ; Source = A000
        LD      DE,0A400h       ; Destination = A400
        LDIR                    ; Copy all bytes
; ---------------------------------------------------
;      Insert replacement string into temp buffer
; ---------------------------------------------------
        LD      A,(0A614h)      ; A = Number of characters in Speech Buffer
        SUB     L               ; Subtract where name occurs in buffer
        LD      C,A             ; BC = Number of characters after name
        INC     HL              ; Source HL = Start of remaining characters
        PUSH    HL              ; Save copy source
        PUSH    BC              ; Save copy number of characters
        CALL    L22B7           ; Setup string to replace shortcut with
        JR      C,L22A3         ; Do not copy string, just skip ahead        
        LDIR                    ; Copy Replacement String into buffer
; ---------------------------------------------------
;      Save last part of Speech Buffer temporarily
; ---------------------------------------------------
L22A3:  POP     BC              ; Restore number of characters to copy
        POP     HL              ; Restore source to copy from
        LDIR                    ; Restore characters after occurance
; ---------------------------------------------------
;            Restore whole Speech Buffer
; ---------------------------------------------------
        LD      C,E             ; BC = Total number of characters to copy back
        LD      HL,0A400h       ; Source = A400
        LD      DE,0A000h       ; Destination = A000
        LDIR                    ; Copy all bytes back
        LD      A,E             ; A = number of characters in buffer
        DEC     A               ; Subtract 1 character
        LD      (0A614h),A      ; Save new Speech Buffer size
        JR      L225B           ; Continue to check Speech Buffer        





; ---------------------------------------------------
;         Check what to replace shortcut with
; ---------------------------------------------------
;          (#) = Player's Full Name
;          (*) = Player's First Name
;          ($) = First Name -or- Full Name
;          (%) = First Name -or- nothing
;          (n) = Score
; ---------------------------------------------------
L22B7:  DEC     HL              ; Point to shortcut
        LD      A,(HL)          ; Get shortcut character
        CP      023h            ; Is it Player's Full Name (#)?
        JR      Z,L22E8         ; Yes, so replace shortcut with Player's full name       
        CP      024h            ; Is it Player's First name/Full name ($)?
        JR      Z,L22D2         ; Yes, so replace shortcut with Player's First name/Full name       
        CP      06Eh            ; Is it Score (n)?
        JR      Z,L22F5         ; Yes, so replace shortcut with Score
        CP      02Ah            ; Is it Player's first name (*)?
        SCF                     ; Set flag for just the first name
        JR      Z,L22D2         ; Yes, so replace shortcut with Player's first name
        LD      A,R             ; (%) First name or nothing, so get Random Number
        AND     008h            ; Check heads or tails
        JR      Z,L22D2         ; Tails so speak first name      
        SCF                     ; Speak nothing, disable string copy
        RET                     ; Return and continue copying characters

; ---------------------------------------------------
; Replace shortcut with Player's First name or Full name
; ---------------------------------------------------
L22D2:  LD      HL,0A68Bh       ; Point to length of Player's first name
        LD      A,(HL)          ; Get length of Player's first name
        LD      C,A             ; C = number of characters in first name
        LD      B,000h          ; BC = number of characters in first name
        INC     HL              ; HL = Pointer to Player's first name
        JR      NC,L22DF        ; Do First name or Full name ($)
        OR      A               ; Check length of first name
        JR      NZ,L22F3        ; First name length fine so continue with copy       
; ---------------------------------------------------
;  Randomly choose to use the First name or Full name         
; ---------------------------------------------------
L22DF:  OR      A               ; Check length of first name
        JR      Z,L22E8         ; First name missing so must use full name                        
        LD      A,R             ; Get random number
        AND     010h            ; Check heads or tails
        JR      Z,L22F3         ; If heads, then skip ahead and speak first name
; ---------------------------------------------------
;      Replace shortcut with Player's Full name         
; ---------------------------------------------------                       
L22E8:  LD      HL,0A64Ah       ; Get Length of Player's Full Name
        LD      A,(HL)          ; Get length of name 
        LD      C,A             ; BC = length of name
        INC     HL              ; HL = Pointer to Player's Name
        OR      A               ; Check if player name length is zero
        JR      NZ,L22F3        ; Name is not zero so do copy
; ---------------------------------------------------
;            Return but don't copy string        
; ---------------------------------------------------              
        SCF                     ; Disable string copy
        RET                     ; Return 
; ---------------------------------------------------
;              Return and copy string        
; ---------------------------------------------------
L22F3:  OR      A               ; Enable string copy
        RET                     ; Return 




; ---------------------------------------------------
;           Replace shortcut with Score
; ---------------------------------------------------
L22F5:  LD      (0A641h),DE     ; Save end of Speech Buffer
        LD      A,E             ; A = Number of characters pointing to
        DEC     A               ; Subtract shortcut character
        LD      (0A614h),A      ; Store new number of characters in buffer
        LD      HL,0A6D0h       ; HL = Speakable Number (n)
        PUSH    DE              ; Save Speech Buffer Pointer
        CALL    L146F           ; Copy Score (n)
        POP     DE              ; Restore Speech Buffer Pointer
        RET     C               ; Return if buffer overflow
        LD      DE,(0A641h)     ; Add characters to speech buffer
        SCF                     ; Disable copy because it's been done
        RET                     ; Return and continue buffer copy







; ---------------------------------------------------
;      Remove invalid characters in Speech Buffer
; ---------------------------------------------------
;       Valid ranges:  "0"-"9" 30h-3Ah
;                      "A"-"Z" 41h-5Bh
; ---------------------------------------------------
L230D:  LD      HL,(0A614h)     ; L = Number of characters in Speech Buffer
        LD      H,0A0h          ; HL = Pointer to the end of Speech Buffer
        LD      E,(HL)          ; E = last character in buffer (EOB)
L2313:  DEC     L               ; Check next character
        RET     Z               ; All characters checked so return
        LD      A,(HL)          ; Get character from buffer
        CP      030h            ; Is character > (0)?
        JR      C,L2313         ; No, continue checking buffer      
        CP      03Ah            ; Is character < (9+)?
        JR      C,L2326         ; Yes, so delete previous invalid character      
        CP      041h            ; Is character > (A)?
        JR      C,L2313         ; No, so continue checking buffer      
        CP      05Bh            ; Is character < (Z+)?
        JR      NC,L2313        ; No, so continue checking buffer
; ---------------------------------------------------
; Delete all characters up to the first valid character
; ---------------------------------------------------               
L2326:  LD      A,(0A614h)      ; A = Number of Characters in buffer
        SUB     L               ; Subtract valid character location
        DEC     A               ; Then subtract 1
        RET     Z               ; Return if there was one trailing invalid character
        RET     C               ; Return if there are no trailing invalid characters
        INC     L               ; Point to character after last valid character
        LD      (HL),E          ; Restore final buffer character (EOB)
        LD      A,L             ; Get length of buffer
        INC     A               ; Add the last character
        LD      (0A614h),A      ; Save new number of characters in buffer
        RET                     ; Return








; ---------------------------------------------------
;              Apply Rules to Speech
; ---------------------------------------------------
;   Find corresponding Rule in Rule Table, and 
;   then put the corresponding codes into A400 for
;   output to the speech chip.
;
;   example:  DISK matches
;            (DIS)=25h,07h,30h  (K)=29h,ADh,C0h
; ---------------------------------------------------
;       A = A000 Letter (1-64 subtracted 32)
; ---------------------------------------------------
L2335:  ADD     A,A             ; A = 2 * Number 
        LD      C,A             ; Put number into BC
        LD      B,000h          ; BC = Phoneme number
        LD      HL,029F2h       ; Start of Phoneme Table
        ADD     HL,BC           ; Index to correct Phoneme Bank
; ---------------------------------------------------
;           Setup Rules Table pointers
;     A612-A613   Start of entry
;     A606        Start of equation
;     A640        Length of entry
;     A616        ?
;     A61E        ?
; ---------------------------------------------------
        LD      C,(HL)          ; Get Rule Table index 
        INC     HL              ; Next byte
        LD      B,(HL)          ; Get Rule Table index
        LD      (0A612h),BC     ; Save Rule Table starting location

        INC     BC              ; Start of Phonetic Rule
        LD      (0A606h),BC     ; Save Phonetic Rule start
        LD      HL,(0A612h)     ; Point to rule length
        LD      A,(HL)          ; Get rule length
        LD      (0A640h),A      ; Save length of first Rule
        SUB     A               ; A = 0
        LD      (0A616h),A      ; Clear number of characters to the left
        LD      (0A61Eh),A      ; Clear A61E

; ---------------------------------------------------
;           Reset to check Phonetic Rule
; ---------------------------------------------------
L2357:  LD      A,(0A615h)      ; Get current speech characters being processed
        LD      (0A617h),A      ; Save this pointer so we can access A200 codes
        LD      A,001h          ; A = +1
        LD      (0A618h),A      ; Initially set Marker
        LD      (0A61Dh),A      ; Set X_Adder = +1
        DEC     A               ; A = 0
        LD      (0A61Ah),A      ; Clear Left Parenthesis
        LD      (0A619h),A      ; Clear Right Parenthesis
        LD      (0A61Bh),A      ; Clear (character) count
        DEC     A               ; A = -1
        LD      (0A61Ch),A      ; Set Z_Adder to -1
        CALL    L254E           ; Skip to next Phoneme Entry 

; ---------------------------------------------------
;             Process the Phonetic Rule
; ---------------------------------------------------
L2376:  LD      A,(0A616h)      ; Get Rule index
        LD      C,A             ; BC = Rule index
        LD      B,000h          ; BC = Rule index
        LD      HL,(0A606h)     ; Get Phonetic Rule pointer
        ADD     HL,BC           ; Add index to next character
        LD      A,(HL)          ; Get character
; ---------------------------------------------------
;        Check rule for control symbols !+#.^:=()
; ---------------------------------------------------
        CP      021h            ; Character = "!"?
        JR      Z,L23A8         ; Yes, jump ahead
        CP      02Bh            ; Character = "+"?
        JR      Z,L23AB         ; Yes, jump ahead 
        CP      023h            ; Character = "#"?
        JR      Z,L23AE         ; Yes, jump ahead
        CP      02Eh            ; Character = "."?
        JR      Z,L23B1         ; Yes, jump ahead
        CP      05Eh            ; Character = "^"?
        JR      Z,L23B4         ; Yes, jump ahead
        CP      03Ah            ; Character = ":"?
        JR      Z,L23B7         ; Yes, jump ahead
        CP      03Dh            ; Character = "="?
        JR      Z,L23BA         ; Yes, jump ahead
        CP      028h            ; Character = "("?
        JR      Z,L23BD         ; Yes, jump ahead
        CP      029h            ; Character = ")"?
        JR      Z,L23C0         ; Yes, jump ahead
        JP      L24D5           ; Any other characters

; ---------------------------------------------------
;       Jump ahead depending on the symbol 
; ---------------------------------------------------
L23A8:  JP      L23C3           ; "!"
L23AB:  JP      L23D1           ; "+"
L23AE:  JP      L23DF           ; "#"
L23B1:  JP      L2417           ; "."
L23B4:  JP      L2425           ; "^"
L23B7:  JP      L2437           ; ":"
L23BA:  JP      L2466           ; "="
L23BD:  JP      L24B5           ; "("
L23C0:  JP      L24C9           ; ")"


; ---------------------------------------------------
;       Control Symbol "!"   (non-alphabetic)
; ---------------------------------------------------
L23C3:  CALL    L2583           ; Get Character classification symbol (A200)
        CP      021h            ; Check for non-alphabetic character
        JR      Z,L23CE         ; Yes, symbol match
        SUB     A               ; A = 0
        LD      (0A618h),A      ; Clear Marker
L23CE:  JP      L24F4           ; Do Phonetic Rule match check


; ---------------------------------------------------
;       Control Symbol "+"   (Vowel EIY only)
; ---------------------------------------------------
L23D1:  CALL    L2583           ; Get Character classification symbol (A200)
        CP      02Bh            ; Check for vowel "+" (E,I,Y)
        JR      Z,L23DC         ; Yes, symbol match
        SUB     A               ; A = 0
        LD      (0A618h),A      ; Clear Marker
L23DC:  JP      L24F4           ; Do Phonetic Rule match check


; ---------------------------------------------------
;        Control Symbol "#"   (Any Vowel)
; ---------------------------------------------------
L23DF:  SUB     A               ; A = 0
        LD      (0A618h),A      ; Clear Match Check
L23E3:  CALL    L2583           ; Get Character classification symbol (A200)
        CP      023h            ; Check for a vowel "#" (Vowel)
        JR      Z,L23FF         ; Yes, symbol match       
        CP      02Bh            ; Check for vowel "+" (E,I,Y)
        JR      Z,L23FF         ; Yes, symbol match
        LD      A,(0A617h)      ;
        OR      A               ;
        JR      Z,L23FC         ;        
        LD      B,A             ;
        LD      A,(0A61Dh)      ; Get X_Adder direction (+1 or -1)
        ADD     A,B             ;
        LD      (0A617h),A      ;
L23FC:  JP      L24F4           ; Do Phonetic Rule match check


; ---------------------------------------------------
;         Vowel was found, so set marker
; ---------------------------------------------------
L23FF:  LD      A,001h          ; A = 1
        LD      (0A618h),A      ; Set Match Check
        LD      A,(0A617h)      ;
        OR      A               ;
        JR      Z,L23FC         ;        
        LD      B,A             ;
        LD      A,(0A61Ch)      ; Get Z_Adder direction (+1 or -1)
        ADD     A,B             ; Add/subtract 1
        LD      (0A617h),A      ;
        OR      A               ;
        JR      NZ,L23E3        ; No, recheck A200 codes        
        JR      Z,L23FC         ;        


; ---------------------------------------------------
;       Handle phoneme equation characters  "."
; ---------------------------------------------------
L2417:  CALL    L2583           ; Get Character classification symbol (A200)
        CP      02Eh            ; Is A200 code = "."?
        JR      Z,L2422                 
        SUB     A               ; A = 0
        LD      (0A618h),A      ; Clear Marker
L2422:  JP      L24F4           ; Do Phonetic Rule match check


; ---------------------------------------------------
;       Handle phoneme equation characters  "^"
; ---------------------------------------------------
L2425:  CALL    L2583           ; Get Character classification symbol (A200)
        CP      05Eh
        JR      Z,L2434                 
        CP      02Eh
        JR      Z,L2434                 
        SUB     A               ; A = 0
        LD      (0A618h),A      ; Clear Marker
L2434:  JP      L24F4           ; Do Phonetic Rule match check


; ---------------------------------------------------
;       Handle phoneme equation characters  ":"
; ---------------------------------------------------
L2437:  CALL    L2583           ; Get Character classification symbol (A200)
        CP      05Eh
        JR      Z,L2453                 
        CP      02Eh
        JR      Z,L2453                 
        LD      A,(0A617h)
        OR      A
        JR      Z,L2450                 
        LD      B,A
        LD      A,(0A61Dh)      ; Get X_Adder direction (+1 or -1)
        ADD     A,B             ; Add/subtract 1
        LD      (0A617h),A      ;
L2450:  JP      L24F4           ; Do Phonetic Rule match check
L2453:  LD      A,(0A617h)
        OR      A
        JR      Z,L2450                 
        LD      B,A
        LD      A,(0A61Ch)      ; Get Z_Adder direction (+1 or -1)
        ADD     A,B             ; Add/subtract 1
        LD      (0A617h),A
        OR      A
        JR      NZ,L2437                
        JR      Z,L2450                 



; ---------------------------------------------------
;       Handle phoneme equation characters  "="
; ---------------------------------------------------
;   If we match all the way up to the equals sign
;   then we have a complete match, now substitute
;   the phoneme codes for the matching text.
; ---------------------------------------------------
L2466:  LD      A,(0A61Ah)
        OR      A
        JR      NZ,L2470                
        LD      HL,0A61Bh       ; Number of characters in parenthesis
        INC     (HL)            ; Increment character count
L2470:  LD      A,(0A61Bh)      ; Get number of characters in parenthesis
        LD      B,A             ; B = Number of characters in parenthesis
        LD      A,(0A615h)
        ADD     A,B
        LD      (0A615h),A
; ---------------------------------------------------
;           Replace text with phoneme codes 
; ---------------------------------------------------
L247B:  LD      A,(0A616h)      ; Get phoneme character number
        INC     A               ; Point to next character
        LD      (0A616h),A      ; Save phoneme character number
        OR      A
        JR      NZ,L2489                
        LD      HL,0A607h
        INC     (HL)
; ---------------------------------------------------
;              Copy codes to A400 
; ---------------------------------------------------
L2489:  LD      A,(0A616h)      ; Get phoneme character number
        LD      C,A             ;
        LD      B,000h          ;
        LD      HL,(0A606h)     ; Get start of phoneme codes
        ADD     HL,BC           ; Index to spot after equals sign
        PUSH    HL              ; Save start of phoneme replacement codes
        POP     DE              ; DE = start of phoneme replacement codes
        PUSH    DE              ; Save start of phoneme replacement codes
        LD      HL,(0A612h)     ; Get pointer to Phoneme Bank
        LD      A,(0A640h)      ; Get length of first Entry
        LD      C,A             ; Prepare to skip entry
        ADD     HL,BC           ; Set index to skip to next Phoneme Entry in Bank
        EX      DE,HL
        AND     A               ;
        SBC     HL,DE           ; Have we copied all phoneme codes?
        JR      NC,L24B1        ; All codes copied, leave phoneme routine       
        POP     HL              ;
        LD      A,(HL)          ; Get phoneme replacement code
        LD      HL,(0A608h)     ; Get A400 pointer
        LD      (HL),A          ; Save replacement code 
        INC     HL              ; Point to next location
        LD      (0A608h),HL     ; Save A400 pointer
        JP      L247B           ; Get next phoneme replacement code

L24B1:  POP     HL              ;
        JP      L21F3           ; Loop back until all speech characters processed


; ---------------------------------------------------
;          Handle Characters  "("
; ---------------------------------------------------
L24B5:  LD      A,001h          ; Set Flag
        LD      (0A61Ah),A      ; Mark Left Parenthesis Mode
        LD      (0A61Ch),A      ; Z_Adder = +1
        DEC     A               ; A =  0
        DEC     A               ; A = -1
        LD      (0A61Dh),A      ; X_Adder = -1
        LD      HL,0A616h       ; Character Pointer in phoneme equation
        INC     (HL)            ; Point to next character in phoneme equation
        JP      L2376           ; Check next phoneme character


; ---------------------------------------------------
;             Handle Characters  ")"
; ---------------------------------------------------
L24C9:  LD      A,001h          ; Set Flag
        LD      (0A619h),A      ; Mark Right Parenthesis 
        LD      HL,0A616h       ; Character Pointer in Phoneme equation
        INC     (HL)            ; Point to next character in phoneme equation
        JP      L2376           ; Check next phoneme character



; ---------------------------------------------------
;         Handle all other characters
;    Check if phoneme equation matches letter code
; ---------------------------------------------------
L24D5:  CALL    L2583           ; Get A200 Code for current character
        LD      A,(0A617h)      ; Get current speech buffer pointer
        LD      C,A             ; C = index
        LD      B,000h          ; BC = index
        LD      HL,(0A604h)     ;
        ADD     HL,BC           ;
        LD      A,(HL)          ;
        LD      D,A             ; Check A000 character
        LD      A,(0A616h)      ;
        LD      C,A             ;
        LD      HL,(0A606h)     ; Get Phoneme Equation pointer
        ADD     HL,BC           ;
        LD      A,(HL)          ; Get phoneme character from table
        CP      D               ; Do phoneme characters match text characters?
        JR      Z,L24F4         ; Yes, match found skip ahead
        SUB     A               ; A = 0
        LD      (0A618h),A      ; Clear Match Check

; ---------------------------------------------------
;            Phonetic Rule match check
; ---------------------------------------------------
L24F4:  LD      A,(0A618h)      ; Get Match Check
        OR      A               ; Was there a match?
        JR      Z,L2534         ; No match found, skip to next Rule   
; ---------------------------------------------------
;            Phonetic Rule match found
; ---------------------------------------------------
        LD      A,(0A616h)      ; Number of characters to match
        OR      A               ; Have you matched any characters?
        JR      NZ,L2519        ; Yes, keep checking


; ---------------------------------------------------
;                     NO MATCH
; ---------------------------------------------------                       
;                  Reset Pointers
; ---------------------------------------------------
        LD      A,(0A61Eh)      ; Get previous start of Phonetic Rule
        LD      (0A616h),A      ; Reset rule character number
        LD      A,(0A615h)      ; Get previous speech buffer pointer
        LD      (0A617h),A      ; Reset speech buffer pointer
; ---------------------------------------------------
;               Reset directionals
; ---------------------------------------------------
        LD      A,001h          ; A = 1
        LD      (0A61Ch),A      ; Z_Adder = +1
        DEC     A               ; A = 0
        DEC     A               ; A = -1
        LD      (0A61Dh),A      ; X_Adder = -1
        JP      L2531           ; Loop back





; ---------------------------------------------------
;               A = phoneme characters to skip
; ---------------------------------------------------
L2519:  LD      C,A
        LD      B,000h
        LD      A,(0A61Ch)      ; Get Z_Adder direction (+1 or -1) 
        ADD     A,C             ; Increment/decrement number of characters that matched
        LD      (0A616h),A
        LD      A,(0A617h)
        OR      A
        JR      Z,L2531                 
        LD      C,A
        LD      A,(0A61Ch)      ; Get Z_Adder direction (+1 or -1)
        ADD     A,C
        LD      (0A617h),A
; ---------------------------------------------------
;      
; ---------------------------------------------------
L2531:  JP      L2376           ; Check next phoneme character

; ---------------------------------------------------
;     No match found skip to next phoneme entry
; ---------------------------------------------------
L2534:  LD      HL,(0A612h)     ; Get phoneme entry start
        LD      A,(HL)          ; Get length of entry
        LD      E,A             ; DE = number of characters to skip
        LD      D,000h          ; Setup to skip DE characters
        ADD     HL,DE           ; Skip to next entry
        LD      (0A612h),HL     ; Save new entry location
        LD      A,(HL)          ; Get length of phoneme entry
        LD      (0A640h),A      ; Save length of entry
        INC     HL              ; Point to start of phoneme entry
        LD      (0A606h),HL     ; Save start pointer
        SUB     A               ; A = 0
        LD      (0A616h),A      ; Reset back to first phoneme character
        JP      L2357           ; Skip to next Phoneme entry





; ---------------------------------------------------
;         Skip to the next/prev Phoneme Entry
; ---------------------------------------------------
;      Skip all characters up until "=" or "("
; ---------------------------------------------------
L254E:  LD      HL,(0A606h)     ; Get Phoneme Equation pointer
        LD      E,000h          ; Set counter to zero

L2553:  LD      A,(HL)          ; Get Phoneme equation character
        CP      028h            ; Have we found a new entry"("?
        JR      Z,L2562         ; Yes, so stop counting
        CP      03Dh            ; Is it equals sign "="?
        JR      Z,L2562         ; Yes, so stop counting        
        INC     E               ; Increment characters skipped
        INC     HL              ; Point to next character
        LD      A,E             ; Check character count
        OR      A               ; More than 255 characters?
        JR      NZ,L2553        ; No, so keep counting        
; ---------------------------------------------------
;        Next Phoneme entry found, update index
; ---------------------------------------------------
L2562:  LD      A,E             ; Get number characters skipped
        LD      (0A616h),A      ; Update number of characters
        LD      (0A61Eh),A      ; Save copy of number of characters
        OR      A               ; Are there any characters?
        JR      Z,L2582         ; No characters so just return
; ---------------------------------------------------
;          Check number of entries scanned
; ---------------------------------------------------                
        LD      C,A             ; C = number of characters
        LD      A,(0A61Ch)      ; Get Z_Adder direction (+1 or -1)
        ADD     A,C             ; Add/subtract 1
        LD      (0A616h),A      ; Save start of new entry
        LD      A,(0A617h)      ; Get character total
        OR      A               ; Are there any characters?
        JR      Z,L2582         ; No, so just return
        LD      C,A             ; C = total characters
        LD      A,(0A61Ch)      ; Get Z_Adder direction (+1 or -1)
        ADD     A,C             ; Add/subtract 1
        LD      (0A617h),A      ; Save total
L2582:  RET                     ; Return






; ---------------------------------------------------
;     Get Character classification symbol (A200)
; ---------------------------------------------------
;     Return A = Classification Symbol (!#+?^.)
; ---------------------------------------------------
L2583:  LD      A,(0A61Ah)      ; Check for left Parenthesis
        OR      A               ; Are we in left parenthesis?
        JR      Z,L2596         ; No, so skip ahead
        LD      A,(0A619h)      ; Check for right parenthesis 
        OR      A               ; Have we closed right parenthesis?
        JR      NZ,L2596        ; Yes, so skip ahead
; ---------------------------------------------------
;   Count number of characters inside parenthesis
; ---------------------------------------------------
        LD      A,(0A61Bh)      ; Get (character) count
        INC     A               ; Increment count
        LD      (0A61Bh),A      ; Save (character) count
; ---------------------------------------------------
;           Get A200 Classification Symbol
; ---------------------------------------------------
L2596:  LD      A,(0A617h)      ; Get current speech buffer pointer
        LD      C,A             ; C = index
        LD      B,000h          ; BC = index
        LD      HL,0A200h       ; Point to A200 table
        ADD     HL,BC           ; Index into A200 table
        LD      A,(HL)          ; Get A200 code
        RET                     ; Return






; ---------------------------------------------------
;          Process Speech for Inflection  
; ---------------------------------------------------
;  (A6D3)       Number of characters in Speech Buffer
;  (A604-A605)  Pointer to start of Speech Buffer A000
; ---------------------------------------------------
;  Insert Voice Control Codes (A100) based on
;  sentence inflection and punctuation.
;         CHAR          CODE
;         -------       ----
;         "!"           F9h, 1001, 1
;         ",;:"         FAh, 1010, 2
;         ".?"          FBh, 1011, 3
;         "/"           FCh, 1100, 4
;                       FFh  1111, OFF
; ---------------------------------------------------
L25A2:  SUB     A               ; A = 0
        LD      BC,00000h       ; Clear counter
        LD      (0A620h),A      ; Clear Backslash Flag
        LD      (0A621h),A      ; Clear Question Flag
        LD      HL,(0A604h)     ; Pointer to Speech Buffer
L25AF:  LD      E,(HL)          ; E = Character from Speech Buffer
        LD      A,(0A621h)      ; Get Question Flag
        OR      A               ; Are we asking a question already?
        JR      Z,L25BA         ; No, so check for "WH" occurance        
        LD      A,E             ; Get character
        JP      L25CF           ; Skip ahead and check for punctuation
; ---------------------------------------------------
;        Check if questions starts with "WH"        
;     ie. WHere, WHen, WHat, WHo 
; ---------------------------------------------------
L25BA:  LD      A,E             ; A = Character
        CP      057h            ; Character = "W"?
        JR      NZ,L25CF        ; No, so check for inflection         
        INC     HL              ; Point to next character
        LD      A,(HL)          ; Get next character
        CP      048h            ; Character = "H"?
        JR      NZ,L25CC        ; No, so skip ahead
        LD      A,(0A621h)      ; Get Question Flag
        INC     A               ; Increment Question Flag
        LD      (0A621h),A      ; Save Question Flag
L25CC:  LD      A,057h          ; Character = "W"
        DEC     HL              ; Point back to first character
; ---------------------------------------------------
;          Check for inflection identifiers         
; ---------------------------------------------------
L25CF:  PUSH    HL              ; Save character pointer
        CP      021h            ; Is character = "!"?
        JR      Z,L25F5         ; Yes, so jump ahead      
        CP      02Ch            ; Is character = ","?
        JR      Z,L2603         ; Yes, so jump ahead       
        CP      02Eh            ; Is character = "."?
        JR      Z,L2611         ; Yes, so jump ahead
        CP      02Fh            ; Is character = "/"?
        JR      Z,L263D         ; Yes, so jump ahead
        CP      03Ah            ; Is character = ":"?
        JR      Z,L2603         ; Yes, so jump ahead       
        CP      03Bh            ; Is character = ";"?
        JR      Z,L2603         ; Yes, so jump ahead
        CP      03Fh            ; Is character = "?"?
        JR      Z,L261F         ; Yes, so jump ahead

; ---------------------------------------------------
;             Not an inflection character 
; ---------------------------------------------------
        LD      E,A             ; Save normal character
        SUB     A               ; A = 0
        LD      (0A61Fh),A      ; No Control Code
        LD      A,E             ; Restore character
        JP      L264D           ; Write inflection control code


; ---------------------------------------------------
;              Handle Character  "!"      
; ---------------------------------------------------
L25F5:  LD      E,A             ; Save character
        LD      A,0F9h          ; A = Inflection Level 1 
        LD      (0A61Fh),A      ; Store Speech Control Code
        SUB     A               ; A = 0
        LD      (0A620h),A      ; Clear Backslash Flag
        LD      A,E             ; Restore character
        JP      L264D           ; Write inflection control code


; ---------------------------------------------------
;             Handle Characters  ",;:"
; ---------------------------------------------------
L2603:  LD      E,A             ; Save character
        LD      A,0FAh          ; A = Inflection Level 2
        LD      (0A61Fh),A      ; Store Speech Control Code
        SUB     A               ; A = 0
        LD      (0A620h),A      ; Clear Backslash Flag
        LD      A,E             ; Restore character
        JP      L264D           ; Write inflection control code


; ---------------------------------------------------
;       Handle Character  "."
; ---------------------------------------------------
L2611:  LD      E,A             ; Save character
        LD      A,0FBh          ; A = Inflection Level 3
        LD      (0A61Fh),A      ; Store Speech Control Code
        SUB     A               ; A = 0
        LD      (0A620h),A      ; Clear Backslash Flag
        LD      A,E             ; Restore character
        JP      L264D           ; Write inflection control code


; ---------------------------------------------------
;             Handle Character  "?"
; ---------------------------------------------------
L261F:  LD      E,A             ; Save character
        LD      A,(0A621h)      ; Get Question Flag
        OR      A               ; Is a questions being asked?
        JR      Z,L262D         ; No, so skip ahead
        LD      E,02Eh          ; Change "?" to a "."
        LD      A,0FBh          ; A = Inflection Level 3
        JP      L262F           ; Skip ahead
L262D:  LD      A,0FFh          ; A = Inflection Level Off
L262F:  LD      (0A61Fh),A      ; Store Speech Control Code
        SUB     A               ; A = 0
        LD      (0A620h),A      ; Clear Backslash Flag
        LD      (0A621h),A      ; Clear Question Flag
        LD      A,E             ; Restore character
        JP      L264D           ; Write inflection control code


; ---------------------------------------------------
;       Handle Character  "/" inflection
; ---------------------------------------------------
L263D:  LD      A,0FCh          ; A = Inflection Level 4
        LD      HL,0A100h       ; Point to A100 Voice Control codes
        ADD     HL,BC           ; Index into buffer
        LD      (HL),A          ; Save Voice Control Code
        DEC     BC              ; Erase the backslash character
        LD      A,001h          ; Note that backslash has been erased
        LD      (0A620h),A      ; Set Backslash Flag
        JP      L2667           ; Continue checking buffer



; ---------------------------------------------------
;       Write Inflection Control Code into A000
; ---------------------------------------------------
L264D:  LD      HL,0A000h       ; Point to speech buffer
        ADD     HL,BC           ; Index into buffer 
        LD      (HL),A          ; Save character
; ---------------------------------------------------
;     Skip A100 code if there was a backslash (/)
; ---------------------------------------------------
        LD      A,(0A620h)      ; Get Backslash Flag
        OR      A               ; Was there a backslash (/)?
        JR      Z,L265F         ; No, so record Voice Control Code
        SUB     A               ; A = 0
        LD      (0A620h),A      ; Clear Backslash Flag
        JP      L2667           ; Continue checking buffer
; ---------------------------------------------------
;         Store Voice Control Code at A100
; ---------------------------------------------------
L265F:  LD      A,(0A61Fh)      ; Get Speech Control Code
        LD      HL,0A100h       ; Point to A100 control codes
        ADD     HL,BC           ; Index into buffer
        LD      (HL),A          ; Save Speech Control Code
; ---------------------------------------------------
;    Increment loop to check all speech characters
; ---------------------------------------------------
L2667:  INC     BC              ; Increment loop counter
        POP     HL              ; Restore character pointer
        INC     HL              ; Point to next character
        LD      A,(0A614h)      ; Get length of buffer
        CP      L               ; Are we at the end of the buffer?
        JP      NC,L25AF        ; No, so loop back
        JP      Z,L25AF         ; No, so loop back
; ---------------------------------------------------
;           Finished checking speech buffer
; ---------------------------------------------------
        DEC     BC              ; Decrement loop counter
        LD      A,C             ; Get number of character
        LD      (0A614h),A      ; Save number of characters in speech buffer
        RET                     ; Return







; ---------------------------------------------------
;  Get Classification Symbol for all characters (A200)
; ---------------------------------------------------
;  (A604-A605)  Pointer to start of Speech Buffer
; ---------------------------------------------------
L267A:  LD      A,(0A614h)      ; Get number of characters in Speech Buffer
        LD      E,A             ; E = number of characters in buffer
        LD      D,000h          ; DE = number of characters in buffer
        LD      C,A             ; BC = number of characters in buffer
        LD      HL,(0A604h)     ; Pointer to start of Speech Buffer
        ADD     HL,DE           ; HL = Goto end of speech buffer
; ---------------------------------------------------
;        Make sure character is between "A"-"Z"
; ---------------------------------------------------
L2685:  PUSH    HL              ; Save pointer to Speech Buffer       
        PUSH    DE              ; Save loop counter
        LD      A,(HL)          ; Get character from speech buffer
        CP      041h            ; Is character > "A"?
        JR      C,L26A7         ; No, so use default code       
        CP      05Bh            ; Is character < "Z+"
        JR      NC,L26A7        ; No so use default code       
; ---------------------------------------------------
;     Get Character Classification Symbol (A200)
; ---------------------------------------------------
        SUB     041h            ; Get character number
        LD      E,A             ; DE = Character number (1-26)
        LD      HL,L26B3        ; Point to Character Classification Table
        ADD     HL,DE           ; Index into table
        LD      A,(HL)          ; Get classification symbol from table
        LD      HL,0A200h       ; Point to A200 
        POP     DE              ; Restore loop counter
        ADD     HL,BC           ; Index into A200 area
        LD      (HL),A          ; Save classification symbol
        POP     HL              ; Restore pointer to Speech Buffer
; ---------------------------------------------------
;      Decrement loop and continue checking buffer
; ---------------------------------------------------
L269F:  DEC     HL              ; Point to next character in buffer
        DEC     C               ; Decrement character count
        LD      A,C             ; Get character count
        CP      0FFh            ; Is remaining character count at zero?
        JR      NZ,L2685        ; No, so loop back
        RET                     ; Return

; ---------------------------------------------------
;  Store *out-of-range* Speech Control Code at A200
; ---------------------------------------------------
L26A7:  LD      A,021h          ; Default control code ("!")
        LD      HL,0A200h       ; Point to A200 control codes
        ADD     HL,BC           ; Index into A200 control area
        LD      (HL),A          ; Save Speech Control Code
        POP     DE              ; Restore loop count
        POP     HL              ; Restore pointer to Speech Buffer 
        JP      L269F           ; Continue with loop







; ---------------------------------------------------
;        A200 Character Classification Symbols
; ---------------------------------------------------
;      (#)    A,O,U
;      (+)    E,I,Y
;      (.)    B,D,G,J,L,M,N,R,V,W,Z
;      (^)    C,F,H,K,P,Q,S,T,X
; ---------------------------------------------------
L26B3:   DB   023h   ; "#"  A
         DB   02Eh   ; "."  B
         DB   05Eh   ; "^"  C 
         DB   02Eh   ; "."  D
         DB   02Bh   ; "+"  E
         DB   05Eh   ; "^"  F
         DB   02Eh   ; "."  G
         DB   05Eh   ; "^"  H
         DB   02Bh   ; "+"  I
         DB   02Eh   ; "."  J
         DB   05Eh   ; "^"  K
         DB   02Eh   ; "."  L
         DB   02Eh   ; "."  M
         DB   02Eh   ; "."  N
         DB   023h   ; "#"  O
         DB   05Eh   ; "^"  P
         DB   05Eh   ; "^"  Q
         DB   02Eh   ; "."  R
         DB   05Eh   ; "^"  S
         DB   05Eh   ; "^"  T
         DB   023h   ; "#"  U
         DB   02Eh   ; "."  V
         DB   02Eh   ; "."  W
         DB   05Eh   ; "^"  X
         DB   02Bh   ; "+"  Y
         DB   02Eh   ; "."  Z










; ---------------------------------------------------
;            Apply Voice Characteristics
; ---------------------------------------------------
L26CD:  LD      HL,0A400h       ; HL = A400 
        LD      (0A60Eh),HL     ; Reset Phoneme pointer
        LD      (0A610h),HL     ; Reset Phoneme pointer
; ---------------------------------------------------
;         Erase Voice Variables (A622-A641)
; ---------------------------------------------------
        LD      HL,0A622h       ; Start of variables to clear
        LD      B,01Fh          ; 31 bytes to erase
        SUB     A               ; A = 0
L26DC:  LD      (HL),A          ; Erase byte
        INC     HL              ; Go to next byte
        DJNZ    L26DC           ; Loop until all bytes erased
; ---------------------------------------------------
;           Setup Speech Rates (A200)
; ---------------------------------------------------               
        LD      A,(029EFh)      ; Get default Speech Rate (09h) 
        ADD     A,A             ; Shift bits left (shift it to the upper nibble)
        ADD     A,A             ; Shift bits left
        ADD     A,A             ; Shift bits left
        ADD     A,A             ; Shift bits left
        OR      008h            ; Add control bit to lower nibble (098h)
        LD      (0A630h),A      ; Save Speech Rate Low (098h)
        ADD     A,010h          ; Add 1 to rate, Speech Rate High (0A8h)
        LD      (0A62Ch),A      ; Save Speech Rate High (0A8h) copy of A628
        LD      (0A628h),A      ; Initialize Speech Rate to High (0A8h)
; ---------------------------------------------------
;            Setup Amplitude (Volume) (A300)
; ---------------------------------------------------
        LD      A,(029F0h)      ; Get default Amplitude (00Ch)
        OR      060h            ; Add control bit (06Ch)
        LD      (0A62Bh),A      ; Save Amplitude Level Low
        LD      (0A627h),A      ; Save Amplitude Level Low (copy)
        ADD     A,003h          ; Add 3 to level, Amplitude Level High (06Fh)
        LD      (0A62Fh),A      ; Save Amplitude Level High
; ---------------------------------------------------
;            Setup Filter Frequency (A000)
; --------------------------------------------------
        LD      A,(029F1h)      ; Get default Filter Frequency Low (0E6h)
        LD      (0A62Ah),A      ; Save Filter Frequency Low
        LD      (0A626h),A      ; Save Filter Frequency Low (copy)
        ADD     A,001h          ; Add 1 to value, Filter Frequency High
        LD      (0A62Eh),A      ; Save Filter Frequency High (0E7h)
; ---------------------------------------------------
;            Setup Inflection Levels (A100) 
; ---------------------------------------------------
        LD      A,(029EEh)      ; Get default Inflection Level pointer (008h)
        LD      E,A             ; Setup index into Inflection Table  
        LD      D,000h          ; DE = Index into Inflection Table
        LD      HL,029CFh       ; Get pointer to Inflection Table 
        ADD     HL,DE           ; Index into Table 
        LD      A,(HL)          ; Get Inflection Level (046h)
        LD      (0A622h),A      ; Save Inflection Level 1 (046h)
        ADD     A,018h          ; Add 018h for next level
        LD      (0A623h),A      ; Save Inflection Level 2 (05Eh)
        ADD     A,018h          ; Add 018h for next level
        LD      (0A624h),A      ; Save Inflection Level 3 (076h)
        ADD     A,018h          ; Add 018h for next level
        LD      (0A625h),A      ; Save Inflection Level 4 (08Eh)

; ---------------------------------------------------
;         Setup Voice Characterizing Loop
; --------------------------------------------------
L272F:  LD      A,(0A639h)      ; Get main loop (initially zero)
        LD      C,A             ; C = Loop
        LD      E,A             ; E = Loop
        LD      D,000h          ; DE = Loop
        LD      HL,(0A610h)     ; A400 pointer
        ADD     HL,DE           ; Index into A400 table
; ---------------------------------------------------
;       Main Loop - Check for inflection change (FC)
; ---------------------------------------------------
L273A:  LD      A,(HL)          ; Get Voice control code (A400)
        CP      0FCh            ; Is there an inflection change?
        JR      NZ,L2750        ; No, so skip ahead
; ---------------------------------------------------
;         Increase inflection and amplitude
; ---------------------------------------------------                
        LD      A,(0A634h)      ; Get voice volume
        INC     A               ; Increase voice volume
        LD      (0A634h),A      ; Save new voice volume
        LD      A,(0A63Bh)      ; Get voice volume
        INC     A               ; Increase voice volume
        LD      (0A63Bh),A      ; Save new voice volume
        JP      L2754           ; Skip ahead and increase ?
; ---------------------------------------------------
;          Check for inflection change (F9)
; ---------------------------------------------------
L2750:  CP      0F9h
        JR      NC,L277C        ; Process Equation Code        
L2754:  INC     HL
        INC     C
        EX      DE,HL
        LD      HL,(0A608h)
        LD      A,E
        CP      L
        JR      C,L2761                 
        JP      L2765           ; Use Equation #2
L2761:  EX      DE,HL           ; Next byte
        JP      L273A           ; Loop back
; ---------------------------------------------------
;            Setup to use Equation #2
; ---------------------------------------------------
L2765:  INC     HL              ; Next byte (A400)
        LD      (0A608h),HL     ; Save HL (A400)
        LD      A,0FBh          ; Equation code FB = #2
        JP      L277C           ; Process Equation Code  

; ---------------------------------------------------
;            Set stuff then return
; ---------------------------------------------------
L276E:  LD      A,(0A63Bh)      ;
        LD      B,A             ;
        LD      HL,(0A608h)     ;
        LD      A,L             ;
        SUB     B               ;
        LD      L,A             ;
        LD      (0A608h),HL     ;
        RET                     ; Process done, return to speech routine




; ---------------------------------------------------
;                Equation stuff
; ---------------------------------------------------
;       C = number?
;       A = Equation code to use
;           F9 Equation #
;           FA Equation #
;           FB Equation #2
; ---------------------------------------------------
L277C:  LD      (0A63Ch),A      ; Save Equation Code
        LD      A,C
        LD      (0A639h),A
        LD      A,(0A634h)
        SRL     A
        CP      002h
        JR      C,L279E                 
        LD      A,(0A623h)
        LD      (0A62Dh),A
        LD      (0A632h),A
        LD      A,(0A625h)
        LD      (0A631h),A
        JP      L27AD

L279E:  LD      A,(0A623h)
        LD      (0A62Dh),A
        LD      (0A632h),A
        LD      A,(0A624h)
        LD      (0A631h),A

L27AD:  LD      A,(0A63Ch)      ; Get Equation Code
        CP      0F9h
        JR      Z,L27C3         ; Use equation #0        
        CP      0FAh
        JR      Z,L27CB         ; Use equation #1        
        CP      0FBh
        JR      Z,L27D3         ; Use equation #2        
        CP      0FFh
        JR      Z,L27EB         ; Use equation #3        
        JP      L276E           ; Finish up and return
; ---------------------------------------------------
;            Use Equation #0
; ---------------------------------------------------
L27C3:  LD      E,000h          ; Equation #0
        CALL    L299A           ; Read equation
        JP      L27D8           ; Skip ahead
; ---------------------------------------------------
;            Use Equation #1
; ---------------------------------------------------
L27CB:  LD      E,001h          ; Equation #1
        CALL    L299A           ; Read equation
        JP      L27D8           ; Skip ahead
; ---------------------------------------------------
;            Use Equation #2
; ---------------------------------------------------
L27D3:  LD      E,002h          ; Equation #2
        CALL    L299A           ; Read equation
; ---------------------------------------------------
;             Continue with Equation
; ---------------------------------------------------
L27D8:  LD      A,(0A622h)      ;
        LD      (0A633h),A      ;
        LD      A,(0A632h)      ;
        LD      (0A629h),A      ;
        SUB     A               ;
        LD      (0A638h),A      ;
        JP      L2801           ;

L27EB:  LD      E,003h          ;
        CALL    L299A           ;
        LD      A,(0A625h)      ;
        LD      (0A633h),A      ;
        LD      A,(0A632h)
        LD      (0A629h),A
        LD      A,001
        LD      (0A638h),A

L2801:  LD      A,(0A63Eh)
        LD      C,A
        LD      B,000h
        LD      IY,(0A60Eh)
        ADD     IY,BC
        LD      A,(0A63Fh)
        LD      E,A
        LD      D,000h
        LD      HL,0A400h
        ADD     HL,DE
        LD      B,E             ;
        PUSH    BC              ;

; ---------------------------------------------------
;             Start Equation Loop
; ---------------------------------------------------
L2819:  LD      A,(IY+000h)     ;
        CP      0FCh            ;
        JR      NZ,L2823        ;        
        JP      L291D           ;

L2823:  CP      0F9h
        JR      C,L282A                 
        JP      L289F

L282A:  LD      (HL),A
        LD      A,(0A635h)
        OR      A
        JR      Z,L2877                 
        LD      A,(0A638h)
        OR      A
        JR      Z,L284B                 
        LD      A,(0A633h)
        LD      C,A
        LD      A,(0A629h)
        CP      C
        JR      Z,L285F                 
        JR      NC,L285F                
        ADD     A,008h
        LD      (0A629h),A
        JP      L2865

L284B:  LD      A,(0A633h)
        LD      C,A
        LD      A,(0A629h)
        CP      C
        JR      C,L285F                 
        JR      Z,L285F                 
        SUB     008h
        LD      (0A629h),A
        JP      L2865

L285F:  LD      A,(0A633h)
        LD      (0A629h),A

L2865:  LD      A,(0A62Ch)
        LD      (0A628h),A
        LD      A,(0A62Bh)
        LD      (0A627h),A
        LD      A,(0A62Ah)
        LD      (0A626h),A
L2877:  DEC     H
; ---------------------------------------------------
;        Replace all codes with new match (?)
;               A629 --> A300
;               A628 --> A200
;               A627 --> A100
;               A626 --> A000
; ---------------------------------------------------
        LD      A,(0A629h)      ; Get new code
        LD      (HL),A          ; Replace A300 code
        DEC     H               ; Next bank
        LD      A,(0A628h)      ; Get new code
        LD      (HL),A          ; Replace A200 code
        DEC     H               ; Next bank
        LD      A,(0A627h)      ; Get new code 
        LD      (HL),A          ; Replace A100 code
        DEC     H               ; Next bank
        LD      A,(0A626h)      ; Get new code
        LD      (HL),A          ; Replace A000 code
        LD      A,H             ; Return to beginning
        ADD     A,004h          ; Go back to A400
        LD      H,A             ; HL = A4xx
        INC     HL              ; Point to next byte
        INC     IY
        POP     BC
        INC     B               ;
        INC     C               ;
        PUSH    BC              ;
        LD      A,(0A639h)
        LD      E,A
        LD      A,C
        CP      E
        JP      C,L2819

L289F:  POP     BC
        INC     C
        INC     IY
        PUSH    BC
        LD      A,(0A63Ah)      ; Get characters right of equals sign
        OR      A               ; Are there any?
        JR      Z,L28EA         ; No, so leave        

L28AA:  LD      A,(IY+000h)
        LD      (HL),A
        DEC     H
        LD      A,(0A633h)
        LD      (HL),A          ; Replace A300 code
        DEC     H               ; Next bank
        LD      A,(0A628h)      ; Get new code
        LD      (HL),A          ; Replace A200 code
        DEC     H               ; Next bank
        LD      A,(0A627h)      ; Get new code
        LD      (HL),A          ; Replace A100 code
        DEC     H               ; Next bank
        LD      A,(0A626h)      ; Get new code
        LD      (HL),A          ; Replace A000 code
        INC     IY              ; Next byte
        INC     HL              ; Next byte
        LD      A,H
        ADD     A,004h
        LD      H,A

        POP     BC              ; Get counter
        INC     B               ; Increment counter
        INC     C               ; Increment counter
        PUSH    BC              ; Save counter
        LD      A,(0A63Ah)      ; Get characters right of equals sign
        LD      E,A             ; E = characters right of equals sign
        LD      A,(0A63Dh)
        INC     A
        LD      (0A63Dh),A
        CP      E
        JR      C,L28AA         ; Loop back until all bytes replaced        
        JR      Z,L28AA 
                
; ---------------------------------------------------
;        Finished replace codes for word
; ---------------------------------------------------                        
        LD      HL,(0A608h)     ;
        LD      A,C             ;
        CP      L               ;
        JR      C,L28EA         ;        
        JR      Z,L28EA         ;        
        POP     BC              ;
        JP      L276E           ; Finish up and return

L28EA:  POP     BC
        DEC     B
        DEC     C
        LD      A,C
        LD      (0A63Eh),A
        LD      (0A639h),A
        LD      A,B
        LD      (0A63Fh),A
        SUB     A
        LD      (0A634h),A
        LD      (0A637h),A
        LD      (0A63Ah),A
        LD      (0A63Dh),A
        LD      (0A635h),A
        LD      A,(0A62Ch)
        LD      (0A628h),A
        LD      A,(0A62Bh)
        LD      (0A627h),A
        LD      A,(0A62Ah)
        LD      (0A626h),A
        JP      L272F

L291D:  LD      A,(0A636h)
        OR      A
        JR      Z,L295C                 
        DEC     A
        LD      (0A636h),A
        LD      A,(0A637h)
        INC     A
        LD      (0A637h),A
        LD      C,A
        LD      A,(0A634h)
        LD      B,A
        LD      A,C
        CP      B
        JR      Z,L2954                 
        JR      NC,L2954                
        LD      A,(0A62Dh)
        LD      (0A629h),A
        LD      A,(0A62Ch)
        LD      (0A628h),A
        LD      A,(0A62Bh)
        LD      (0A627h),A
        LD      A,(0A62Ah)
        LD      (0A626h),A
        JP      L2992

L2954:  LD      A,001h
        LD      (0A635h),A
        JP      L2992

L295C:  LD      A,(0A631h)
        LD      (0A629h),A
        LD      A,(0A630h)      ; Get 098h
        LD      (0A628h),A
        LD      A,(0A62Fh)
        LD      (0A627h),A
        LD      A,(0A62Eh)
        LD      (0A626h),A
        LD      A,(0A636h)
        INC     A
        LD      (0A636h),A
        LD      A,(0A637h)
        INC     A
        LD      (0A637h),A
        LD      A,(0A625h)
        LD      C,A             ;
        LD      A,(0A629h)      ;
        CP      C               ;
        JR      NZ,L2992        ;        
        LD      A,(0A624h)      ;
        LD      (0A631h),A

L2992:  INC     IY
        POP     BC
        INC     C
        PUSH    BC
        JP      L2819









; ---------------------------------------------------
;              Analyze Word Phonemes
; ---------------------------------------------------
;         E = Word equation number (0,1,2,3)
; ---------------------------------------------------
L299A:  LD      D,000h          ; DE = Equation Number
        LD      HL,L29EA        ; Point to data jumpers
        ADD     HL,DE           ; Add equation number
        LD      A,(HL)          ; Get data jumper
        SUB     020h            ; Subtract 32 for some reason
        ADD     A,A             ; Multiply by 2 for table
        LD      E,A             ; E = result
        LD      HL,029F2h       ; Point to Equation Pointers
        ADD     HL,DE           ; Add jumper 
        LD      A,(HL)          ; Get low-byte address
        LD      (0A60Ch),A      ; Save low-byte addres
        INC     HL              ; Point to high-byte address
        LD      A,(HL)          ; Get high-byte address
        LD      (0A60Dh),A      ; Save high-byte address
; ---------------------------------------------------
;   Count phonemes to the left of the equals sign
; ---------------------------------------------------
        LD      HL,(0A60Ch)     ; HL = Equation Pointer
        LD      A,(HL)          ; Get first byte of equation
        LD      E,A             ; E = Number of bytes in total equation
        INC     HL              ; Point to next byte in equation
        LD      C,001h          ; Count number of bytes left of equals sign
L29BA:  LD      A,(HL)          ; Get next byte in equations
        CP      03Dh            ; Check for equals sign (=)
        JR      Z,L29C4         ; Equal sign has been found, so skip ahead        
        INC     HL              ; No equals sign so check next byte
        INC     C               ; Increment number of bytes of left equals sign
        JP      L29BA           ; Continue checking for equals sign (=)
; ---------------------------------------------------
;               Equals sign found 
; ---------------------------------------------------
L29C4:  INC     C               ; Sum number of bytes until equals sign
        LD      A,E             ; A = length of phoneme equation
        SUB     C               ; Subtract characters left of equals sign
        LD      (0A63Ah),A      ; Save number of characters right of equals sign
        LD      HL,0A63Bh       ; Point to ??
        INC     (HL)            ; Increment ??
        RET                     ; Return







; ---------------------------------------------------
;            Inflection Level Data Table 
; ---------------------------------------------------
L29CF:   DB  006h, 00Eh, 016h, 01Eh, 026h, 02Eh, 036h, 03Eh, 046h                  
         DB  04Eh, 056h, 05Eh, 066h, 06Eh, 076h, 07Eh, 086h, 08Eh
         DB  096h, 09Eh, 0A6h, 0AEh, 0B6h, 0BEh, 0C6h, 0CEh, 0D6h

; ---------------------------------------------------
;             Base Equations Pointers
; ---------------------------------------------------
L29EA:   DB  021h
         DB  02Ch
         DB  02Eh   ; Equation #2  2A8Dh
         DB  03Fh

; ---------------------------------------------------
;               Default Voice Settings
; ---------------------------------------------------
L29EE:   DB    8   ; Inflection (0-26) 
L29EF:   DB    9   ; Speech Rate (0-13) 
L29F0:   DB   12   ; Amplitude (Volume) (0-11)
L29F1:   DB  230   ; Filter Frequency (0-253)

; ---------------------------------------------------
;             Phonetic Rule Pointers (64)
; ---------------------------------------------------
L29F2:   DW  02A74h, 02A8Dh, 02A72h, 02A72h
         DW  02A72h, 02A72h, 02A72h, 02A77h
         DW  02A72h, 02A72h, 02A72h, 02A72h
         DW  02A89h   ; 2C base equation 
         DW  02A72h, 02A8Dh, 02A72h

         DW  02A92h   ; Number "0" Rule
         DW  02A9Bh   ; Number "1" Rule
         DW  02AA3h   ; Number "2" Rule
         DW  02AAAh   ; Number "3" Rule
         DW  02AB2h   ; Number "4" Rule
         DW  02ABAh   ; Number "5" Rule
         DW  02AC3h   ; Number "6" Rule
         DW  02ACCh   ; Number "7" Rule
         DW  02AD6h   ; Number "8" Rule
         DW  02ADEh   ; Number "9" Rule

         DW  02A72h, 02A72h, 02A72h, 02A72h, 02A72h
         DW  02A8Dh, 02A72h   

         DW  02AE7h   ; Letter "A" Rules
         DW  03045h   ; Letter "B" Rules
         DW  0321Eh   ; Letter "C" Rules
         DW  03501h   ; Letter "D" Rules
         DW  036E1h   ; Letter "E" Rules
         DW  03B6Bh   ; Letter "F" Rules
         DW  03BE8h   ; Letter "G" Rules
         DW  03DBDh   ; Letter "H" Rules
         DW  03F36h   ; Letter "I" Rules
         DW  042E6h   ; Letter "J" Rules
         DW  043D0h   ; Letter "K" Rules
         DW  0444Eh   ; Letter "L" Rules
         DW  045C1h   ; Letter "M" Rules
         DW  0480Bh   ; Letter "N" Rules
         DW  04935h   ; Letter "O" Rules
         DW  04D01h   ; Letter "P" Rules
         DW  04F12h   ; Letter "Q" Rules
         DW  04F87h   ; Letter "R" Rules
         DW  05146h   ; Letter "S" Rules
         DW  05495h   ; Letter "T" Rules
         DW  057B4h   ; Letter "U" Rules
         DW  05943h   ; Letter "V" Rules
         DW  059CFh   ; Letter "W" Rules
         DW  05B28h   ; Letter "X" Rules
         DW  05B64h   ; Letter "Y" Rules
         DW  05C55h   ; Letter "Z" Rules

         DW  02A72h, 02A72h, 02A72h, 02A72h, 02A72h
         
; ---------------------------------------------------
;             Phoneme Definitions
; ---------------------------------------------------
;                  Consonants          
; ---------------------------------------------------
_B    EQU    024h ; bat, tab
_D    EQU    025h ; dub, bud
_F    EQU    034h ; fat, ruff, photo, laugh
_HV   EQU    02Ah ; eh!
_HVC  EQU    02Bh ; d(h)ouble
_HF   EQU    02Ch ; hat, home       
_HFC  EQU    02Dh ; P(h)ad, fluff(h), black(h)      
_HN   EQU    02Eh ; hnh-hnh
_J    EQU    031h ; job, rage        
_K    EQU    029h ; kit, tick
_KV   EQU    026h ; big, gag
_L    EQU    020h ; lab, ball
_LI   EQU    021h ; plan, club, slam
_LF   EQU    022h ; bott/e, channe/
_M    EQU    037h ; mad, dam
_N    EQU    038h ; not, ton        
_NG   EQU    039h ; ring, rang
_P    EQU    027h ; pat, tap
_R    EQU    01Dh ; rat
_S    EQU    030h ; sat, lass
_SCH  EQU    032h ; shop, push
_T    EQU    028h ; tap, pat
_THV  EQU    035h ; bathe, the
_TH   EQU    036h ; bath, theory
_V    EQU    033h ; vow, pave
_W    EQU    023h ; why, quake
_Y1   EQU    004h ; you
_Z    EQU    02Fh ; zap, maze

; ---------------------------------------------------
;                 Vowels          
; ---------------------------------------------------
_A    EQU    008h ; day         
_AI   EQU    009h ; care
_AE   EQU    00Ch ; dad
_AEI  EQU    00Dh ; laugh
_AH   EQU    00Eh ; top, about
_AHI  EQU    00Fh ; father
_AW   EQU    010h ; saw, caught
_E    EQU    001h ; beet, be
_EI   EQU    002h ; advent
_EH   EQU    00Ah ; leg, said
_EHI  EQU    00Bh ; silent
_ER   EQU    01Ch ; third, urn, heard
_I    EQU    007h ; sit, bid
_O    EQU    011h ; boat
_OO   EQU    013h ; put, pull, look
_OU   EQU    012h ; orb
_U    EQU    016h ; boot, you
_UI   EQU    017h ; poor
_UH   EQU    018h ; cup
_UH1  EQU    019h ; circus
_UH2  EQU    01Ah ; nation
_UH3  EQU    01Bh ; nation
    
    
; ---------------------------------------------------
;                 Foreign Sounds          
; ---------------------------------------------------        
_AY   EQU    005h ; francais    French
_A1   EQU    03Ah ; etre        French or umlauted A in German
_E2   EQU    03Eh ; schn       German
_IE   EQU    006h ; il          French
_IU   EQU    014h ; peut        French
_IUI  EQU    015h ; Goethe      German
_OH   EQU    03Bh ; menu, tu    French
_U2   EQU    03Ch ; fiihlen     German
_UH4  EQU    03Dh ; menu, tu    French
_Y    EQU    003h ; y           French
_LB   EQU    03Fh ; il          French
_Rl   EQU    01Eh ; rponse     French
_R2   EQU    01Fh ; richtig     German
  


; ---------------------------------------------------
;              General Phonetic Rules
; ---------------------------------------------------
L2A72:   DB  2, "="
L2A74:   DB  3, "=", 040h
L2A77:   DB  9, "S('S)=" ,04Ah, _Z
L2A80:   DB  7, "('S)=", _Z
L2A87:   DB  2, "="
L2A89:   DB  4, "=", 000h, 000h        ; Double <PAUSE>                      
L2A8D:   DB  5, "=", 000h, 000h, 000h  ; Triple <PAUSE>  Equation #2

; ---------------------------------------------------
;                Number Phonetic Rules
; ---------------------------------------------------
;         #bytes  Rule     Phonetics
; ---------------------------------------------------
L2A92:   DB  9,  "(0)=",_Z,_EI,_ER,_O
L2A9B:   DB  8,  "(1)=",_W,_AH,_N
L2AA3:   DB  7,  "(2)=",_T,_U
L2AAA:   DB  8,  "(3)=",_TH,_ER,_E
L2AB2:   DB  8,  "(4)=",_F,_O,_ER
L2ABA:   DB  9,  "(5)=",_F,_AHI,_E,_V              
L2AC3:   DB  9,  "(6)=",_S,_I,_K,_S 
L2ACC:   DB  10, "(7)=",_S,_EHI,_V,_EHI,_N
L2AD6:   DB  8,  "(8)=",_EHI,_E,_T
L2ADE:   DB  9,  "(9)=",_N,_AHI,_Y,_N

; ---------------------------------------------------
;                 "A" Phonetic Rules
; ---------------------------------------------------
L2AE7:    
   DB   9,   "!(A)!=",8,4
   DB   7,   "(A)!=",1Ah
   DB   14,  "!(AARON)=",0Ch,1Dh,047h,038h
   DB   7,   "(AA)=",0Eh
   DB   16,  "!(ABI)GAIL!=",0Ch,"$",047h
   DB   9,   "!(A)BO=",18h
   DB   12,  "!(A)CROSS=",18h
   DB   25,  "!(ACTIVITIES)=LL)(H3H(",1,"/"
   DB   14,  "!(ADAM)=LL",025h,"X7"   
   DB   15,  "!(AFRI)CA=",0Ch,"4",1Dh,047h
   DB   14,  "(AGAIN)=",1Ah,"",0Ah, 038h
   DB   12,  "#:(AG)E=",7,041h,"1"
   DB   14,  "!(AGO)!=XT",0E6h,11h,"c"
   DB   18,  "!(AGREED)=",18h,0E9h,0E6h,1Dh,1,"A",041h
   DB   14,  "!(AHEAD)=",18h,"",0Ah,041h
   DB   12,  "OUNT(AI)N=",0Ah
   DB   11,  "#:^(AI)N=",0Ah
   DB   8,   "(A)IR=",8
   DB   10,  "(AI).=HH",4
   DB   8,   "(AI)=",8,4
   DB   13,  "!(ALAN)=",0Ch," ",047h,038h
   DB   10,  "(AL)F!=L"
   DB   15,  "!(ALICE)!=",0Ch," ",047h,"0"
   DB   9,   "(AL)K=PP"
   DB   19,  "!(ALLISON)!=",0Ch," ",047h,"0X",038h
   DB   10,  "#:(A)LLY="
   DB   15,  "!(ALON)E=X ",11h,"c",038h
   DB   10,  "#:(AL)!= "
   DB   12,  "#:(ALS)!= /"
   DB   9,   "(AL)M=PP"
   DB   9,   "(AL)V=LL"
   DB   9,   "(A)LLI=",0Dh
   DB   9,   "(A)L.=PP"
   DB   9,   "(A)LL=PP"
   DB   8,   "(A)L^=",10h
   DB   9,   "!(A)L#=",1Ah
   DB   18,  "!(AMANDA)!=X7",0Ch, 038h,041h,"X"
   DB   10,  "(A)MENT=N"
   DB   21,  "!(AMERICAN)=X",038h,0Ah,1Dh,047h,")",047h,038h
   DB   11,  "!(A)MONG=",18h
   DB   13,  "!(AM)OUNT=",18h,"7"
   DB   13,  "!(AMY)!=",8,"7",1
   DB   19,  "!(ANDREA)!=NN8",041h,1Dh,1,"X"
   DB   9,   "!(A)ND=",0Ah
   DB   12,  "#:(A)NCE!=",0Ah
   DB   20,  "!(ANCIENT)=",8,"8h2",047h,038h,"("
   DB   17,  "!(ANGELA)=",0Ch,038h,"1",047h," X"
   DB   12,  "(ANG)+=",8,4,038h,"1"
   DB   16,  "!(ANIMAL)=",0Ch,038h,047h,038h," "
   DB   16,  "!(ANITA)!=X",038h,1,"(X"
   DB   11,  "#^(A)NT!=G"
   DB   10,  "^^(A)NT=J"
   DB   18,  "!:(ANYONE)=",0Ah,038h,1,"c",18h,038h
   DB   10,  "!:(A)NY=",0Ah
   DB   15,  "!(APART)=X",27h,0Eh,05Ch,"("
   DB   18,  "!(APPEARED)=X",27h,1,05Ch,041h
   DB   15,  "!(APPEAR)=X",27h,1,05Ch
   DB   12,  "!:(AR)!=NN",05Ch
   DB   8,   "(AR)!=",1Ch
   DB   11,  "^(ARA)=",0Bh,05Ch,""
   DB   10,  "(AR)D=NN",05Ch
   DB   12,  "!(ARE)!=NN",05Ch
   DB   13,  "!(ARE)N",27h,"T=",0Fh,""
   DB   9,   "!(A)RO=",1Ah
   DB   10,  "!(A)RRO=",0Ch
   DB   9,   "!(A)RR=",1Ah
   DB   8,   "(A)RR=",0Ch
   DB   9,   "(AR)#=",8,05Ch
   DB   10,  "(AR).=NN",05Ch
   DB   8,   "(AR)=",0Eh,05Ch
   DB   14,  "!(ASIA)=",8,"o2X"
   DB   10,  "!(A)SS#=",0Eh
   DB   11,  "!^(A)S#=",8,4
   DB   13,  "(ATEAU)=",0Ch,"(",11h,"c"
   DB   11,  "(ATE)=",8,"(+"
   DB   12,  "(ATH)E!=HH5"
   DB   9,   "(A)TIN=",0Ch
   DB   14,  "!^(A)TIONAL=",0Ch
   DB   22,  "!(ATLANTIC)=",0Dh,"( ",0Ch,"L8(",047h,")"
   DB   13,  "!(ATOM)=",0Ch,"(",18h,"7"
   DB   10,  "(A)TORY=X"
   DB   10,  "(A)TURE=",18h
   DB   11,  "(AUSE)=PP/"
   DB   9,   "(AU).=PP"
   DB   25,  "!(AUTOMOBILE)=",10h,"(",11h,"c7",11h,"c$",1," "
   DB   7,   "(AU)=",10h
   DB   8,   "(A)WA=",1Ah
   DB   8,   "(AW)=PP"
   DB   13,  "(AXES)=",0Ch,")0",047h,"/"
   DB   8,   "!(A)X=",0Ch
   DB   9,   "(AY)=HH",4
   DB   10,  "(A)^ACE=",0Eh
   DB   10,  "(A)^AT=LL"
   DB   12,  "(A)^EFUL=",8,4
   DB   13,  "(A)^EMENT=",8,4
   DB   10,  "(A)^ET=LL"
   DB   10,  "(A)^ID=LL"
   DB   11,  "(A)^ISH=LL"
   DB   10,  "(A)^IT=LL"
   DB   11,  "(A)^ITE=LL"
   DB   10,  "(A)^OON=",0Ch,0Dh,"(A)^OROUS=LL"
   DB   10,  "(A)^OT=LL"
   DB   10,  "!(A)^T#=",0Ch
   DB   10,  "(A)^UT=LL"
   DB   11,  "!(A):^##=",0Eh
   DB   10,  "(A)^+#=",8,4
   DB   10,  "(A)^+:#=",0Ch
   DB   11,  "^(A)^IC=L"
   DB   10,  ":(A)^#=",8,4
   DB   12,  "!:(A)^L#=",8,4
   DB   10,  "(A)^RIC=",0Ch
   DB   12,  "!:(A)^R#=",8,4
   DB   9,   "(A)^LE=",1Bh
   DB   11,  "(A)^RE!=HH"
   DB   8,   "(A).=L",0Ch
   DB   6,   "(A)=",0Ch
  
     
   DB   9,   "!(B)!=$",1
   DB   18,  "!(BALANCE)=$",0Dh," ",047h,038h,"0"
   DB   19,  "!(BARBARA)!=$",0Eh,05Ch,"$",1Dh,"X"
   DB   12,  "!(BEAR)=$",0Ah,05Ch
   DB   13,  "!(BED):=$JJ",041h
   DB   13,  "!(BENE)=$",0Ah,038h,7
   DB   21,  "!(BENJAMIN)=$",0Ah,038h,"1X7",047h,038h
   DB   12,  "!(BE):^#=$A"
   DB   11,  "(BE)ING=$",1
   DB   18,  "!(BERNICE)!","=$",1Ch,038h,1,"0"
   DB   12,  "!(BIG)=$",7,0E6h,"+"
   DB   16,  "!(BILLIE)!=$",047h," ",1
   DB   13,  "!(BI)^#=$NN"
   DB   10,  "(BIO)=$",1,0Eh
   DB   11,  "!(BI)#=$",0Eh,""
   DB   13,  "!(BONE)=$",11h,"c",038h
   DB   13,  "!(BO)TH!=$QQ"
   DB   14,  "(BOUGH)!=$NN",16h
   DB   11,  "(BOW)L=$QQ"
   DB   10,  "(BOW)=$",10h,16h
   DB   19,  "!(BRADLEY)!=$",1Dh,0Ch,041h,"`",1
   DB   18,  "!(BRANDI)!=$",1Dh,0Ch,038h,041h,1
   DB   18,  "!(BRANDON)=$",1Dh,0Ch,038h,041h,038h
   DB   13,  "!(BREA)K=$",1Dh,8
   DB   12,  "(BROW)=$", 1Dh,10h,16h
   DB   7,   "(BT)=("
   DB   18,  "!(BUSIN)ESS=$",7,"/",047h,038h
   DB   12,  "!(BUS)#=$",7,"/"
   DB   8,   "!(B)L=$"
   DB   15,  "!(BRIA)N=$",1Dh,0Eh,"",047h
   DB   8,   "!(B)R=$"
   DB   8,   "!(B):^="
   DB   10,  "M(B)ING!="
   DB   8,   "M(B)S!="
   DB   7,   "M(B)!="
   DB   7,   "(BB)=$"
   DB   10,  "!(BY)=$",0Eh,4
   DB   6,   "(B)=$"
  
     
   DB   9,   "!(C)!=0",1
   DB   15,  "!(CABIN)=)",0Ch,"$",047h,038h
   DB   14,  "!(CAL)VIN=)",0Ch,"`"
   DB   13,  "!(CAPI)=)",0Ch,27h,047h
   DB   21,  "!(CAROLINE)!=)",0Ch,1Dh,"X ",047h,038h
   DB   21,  "!(CATHERINE)!=)",0Ch,"6",1Dh,047h,038h
   DB   9,   "(CC)+=)0"
   DB   10,  "(CEA)N=2",18h
   DB   11,  "(CES)!=0K/"
   DB   17,  "!(CERTAIN)=0",1Ch,"h",0Ah, 038h
   DB   7,   "EX(C)="
   DB   22,  "!(CHRISTIN)#!=)",1Dh,047h,"0(",1,038h
   DB   9,   "!(CH)^=)"
   DB   15,  "!(CH)ARACTER=)"
   DB   19,  "!(CHARLES)!=(2",0Eh,05Ch,"`/"
   DB   17,   "!(CHERYL)!=2",0Ah, 1Dh,047h," "
   DB   16,  "!(CHINA)=(2",0Eh,"8X"
   DB   15,  "!(CHOIR)=)c",0Eh,"",05Ch
   DB   10,  "!(CH)OR=)"
   DB   9,   "^+(CH)=)"
   DB   10,  "(CH)!=(2"
   DB   8,   "(CH)=(2"
   DB   13,  "!S(CI)#=0NN"
   DB   9,   "(CI)AL=2"
   DB   11,  "(CIA)N!=2",18h
   DB   9,   "(CI)A=2",1
   DB   16,  "!(CINDY)!=0",047h,038h,041h,01h
   DB   8,   "(CI)O=2"
   DB   9,   "(CI)EN=2"
   DB   18,  "!(CITIZEN)=0",047h,"(",047h,"/",038h
   DB   7,   "(C)+=0"
   DB   9,   "(CKG)=",0E6h,"+"
   DB   9,   "(CK)=)+"
   DB   16,  "!(CLARA)!=) ",0Ch,1Dh,"X"
   DB   16,  "!(CLE)MENT!=) ",0Ah
   DB   19,  "!(CLIMATE)=) ",0Eh,"7",047h,"("
   DB   15,  "!(CLIMB)=) ",0Eh,"7"
   DB   18,  "!(COMPAN)Y=)",18h, "7",27h,047h,038h
   DB   11,  "(CO)M=)ZZ"
   DB   16,  "!(CONNIE)!=)",0Eh,038h,1
   DB   20,  "!(CONSIDER)=)",18h,038h,"0",047h,041h,1Ch
   DB   20,  "!(CONTAIN)=)",18h,038h,"(",8,"",038h
   DB   11,  "!(CO)PY=)",0Eh
   DB   13,  "(CO)ST=",")+PP"
   DB   14,  "(COU)NTR+=)",18h
   DB   14,  "(COUR)SE=)",11h,1Ch
   DB   13,  "(COUS)IN=)",18h,"/"
   DB   10,  "(COW)=)Oc"
   DB   14,  "(CRACY)=)",1Dh,18h,"0",1
   DB   13,  "(CREA)TU=)",1Dh,1
   DB   15,  "(CREA)T#=)",1Dh,1,8,4
   DB   16,  "!(CRIED)!=)",1Dh,0Eh,"",041h
   DB   9,   "!(CZ)#=/"
   DB   10,  "!(CZ)+=(2"
   DB   8,   "!(C)=)-"
   DB   7,   "(CC)=i"
   DB   6,   "(C)=)"
  
   
   DB   9,   "!(D)!=",041h,1
   DB   16,  "!(DANIE)L=",041h,0Ch,038h,"",047h
   DB   14,  "!(DAV)ID=",041h,8,"D3"
   DB   12,  "(DDED)!=",041h,7,041h
   DB   13,  "#:(DED)!=",041h,7,041h
   DB   9,   ".E(D)!=",041h
   DB   11,  "#:^E(D)!=("
   DB   12,  "!(DEA)TH=",041h,0Ah
   DB   19,  "!(DEBORAH)!=",041h,0Ah,"$",12h,1Dh,"X"
   DB   16,  "!(DECI)MAL=",041h,0Ah,"0",047h
   DB   13,  "!(DELI)=",041h,0Ah," ",7
   DB   17,  "!(DENISE)!=",041h,0Ah,038h,1,"0"
   DB   11,  "!(DE)^#=",041h,7
   DB   13,  "!(DIA)L=",041h,0Eh,"X"
   DB   14,  "!(DIA)NA=",041h,0Eh,"L"
   DB   13,  "!(DIAR)=",041h,0Eh,"D"
   DB   12,  ":(DIER)=",041h,"1",1Ch
   DB   11,  "!(DIO)=",041h,1,0Eh
   DB   15,  "!(DIR)ECT=",041h,0Eh,"]"
   DB   11,  "!(DIS)=",041h,7,"0"
   DB   8,   "(DG)=",041h,"1"
   DB   8,   "(DJ)=",041h,"1"
   DB   12,  "!(DO)!=e",16h,""
   DB   17,  "(DOCTRI)N=",041h,"X)(",1Dh,047h
   DB   15,  "!(DO)ING!=e",16h,""
   DB   13,  "!(DOES)=ѽ",18h,"/"
   DB   12,  "!(DO)NE=ѽ",18h
   DB   16,  "!(DORO)THY!=",041h,12h,05Ch
   DB   13,  "!(DOUG)=",041h,18h,0E6h,"+"
   DB   12,  "(DOUGH)=",041h, 12h,"V"
   DB   11,  "!(DOW)=",041h,0Fh,17h
   DB   13,  "!(DR)!=",041h,0Eh,")(",1Ch
   DB   10,  "!(DR)=eq",05Ch
   DB   11,  "!(DU)A=",041h,"VV"
   DB   9,   "(DU)A=1",16h
   DB   10,  "#(DUR)=",1Ch
   DB   8,   "!(D)=ѽ"
   DB   8,   "(D)!=e+"
   DB   7,   "(DD)=e"
   DB   6,   "(D)=",041h
  
   
   DB   9,   "!(E)!=AA"
   DB   8,   "#:(E)!="
   DB   9,   "(E)MENT="
   DB   9,   "!:(E)!=",1
   DB   10,  ":(EA)!=",1,1Ah
   DB   13,  "!(EARS)!=",1,05Ch,"/"
   DB   11,  "!(EAR)!=",1,05Ch
   DB   12,  "!(E)DITH!=",1
   DB   11,  "!(ED)!=JJ",041h
   DB   8,   "(ED)!=",041h
   DB   13,  "!(E)LAINE!=",1
   DB   19,  "!(ELEANOR)!=",0Ah," ",047h,038h,12h,05Ch
   DB   12,  "#:(ELY)!= ",1
   DB   9,   "(EA)D=JJ"
   DB   10,  "(EAR)N=",05Ch,05Ch
   DB   10,  "!(EAR)^=",1Ch
   DB   9,   "(EA)RT=",0Eh
   DB   11,  "(EA)TURE=",1
   DB   10,  "(EAU)!=",11h,"c"
   DB   9,   "(EAU)=",16h
   DB   10,  "!(EA).=AA"
   DB   9,   "!(EA)=",1,""
   DB   10,  "(EA):E!=",1
   DB   11,  "(EA):ED!=",1
   DB   10,  "(EA):EE=",1
   DB   11,  "(EA):ES!=",1
   DB   11,  "(EA):ING=",1
   DB   11,  "(EA).ON","=AA"
   DB   10,  "(EA)^ON=",1
   DB   11,  "(EA)^TH!=",0Ah
   DB   9,   "(EA):#=",0Ah
   DB   8,   "(EA)=-",1
   DB   9,   "(EE).=",1,"A"
   DB   7,   "(EE)=",1
   DB   9,   "(EF)UL=4"
   DB   8,   "(EH)#=",1
   DB   10,  "(EIGH)=",8,4
   DB   10,  "(EIN)=",8,"D",038h
   DB   7,   "(EI)=",1
   DB   12,  "!(ELA)B=",1," ",0Eh
   DB   11,  "!(ELE)=",0Ah," J"
   DB   19,  "!(ELIZA)BETH=",1," ",047h,"/X"
   DB   10,  "(EL).=",0Ah,"J`"
   DB   9,   "(EL)^=",0Ah,"`"
   DB   13,  "!(EN)ERGY=",0Ah,038h
   DB   9,   "(ENE)=",1,038h
   DB   12,  "#:EM(E)NT=",0Ah
   DB   11,  "!:(EN)!=",0Ah,038h
   DB   9,   "(EN)!=xx"
   DB   10,  "(EN)S!=xx"
   DB   21,  "!(ENGLAND)!=",047h,038h,0E9h,0E6h," ",047h,038h,041h
   DB   7,   "(E)O=",1
   DB   18,  "!(EQUA)TION=",1,")c",8,""
   DB   8,   "(E)QU=",2
   DB   11,  "^(ERE)!=",2,1Ch
   DB   11,  "(ERE)LY=A",1Ch
   DB   11,  "(ERI)#=",1,1Dh,1
   DB   10,  "(ERI)=",0Ah, 1Dh,7
   DB   11,  "#:(ER)#=",0Ah,1Dh
   DB   12,  ":^(ERR)Y=",0Ah,1Dh
   DB   10,  "!(ERR)=",0Ah,05Ch
   DB   12,  "!(ER):#^=",0Bh,1Dh
   DB   9,   "(ER)#=",0Ah,1Dh
   DB   9,   "(ER).=",1Ch,05Ch
   DB   7,   "(ER)=",1Ch
   DB   10,  "H(ES)!=",0Ah,"/"
   DB   10,  "(E)SIVE=",1
   DB   21,  "!(ESPECIAL)LY=",0Ah,"0",27h,0Ah,"2 "
   DB   9,   "#:(E)S!="
   DB   14,  "!(ETHEL)!=",0Ah,"6 "
   DB   8,   "L(EU)=",16h
   DB   8,   "R(EU)=",16h
   DB   15,  "!(EURO)PE=",16h,1Dh,"X"
   DB   8,   "(EU)=",16h
   DB   14,  "!(EVE)NING=",1,"3"
   DB   10,  "!(E)VEN=",1
   DB   19,  "!(EVERYO)NE=",0Ah,"3",1Dh,1,"cX"
   DB   11,  "(EVER)=",0Ah,"3",1Ch
   DB   8,   "#:(E)W="
   DB   9,   "L(EW)=VV"
   DB   9,   "R(EW)=VV"
   DB   9,   "(EW)=VV"
   DB   19,  "!(EXAMINE)=",0Ah,")0",0Dh,"7",047h,"7"
   DB   16,  "!(EXCIT)=",0Ah,")0",0Eh,"("
   DB   20,  "!(EXPLAIN)=",0Ah,")0",27h,"`",8,"",038h
   DB   16,  "!(EXTRA)=",0Ah,")0(",1Dh,"N"
   DB   11,  "!(EYE)=NN"
   DB   8,   "(EY)=",8,""
   DB   10,  "^(E)^AL=",1
   DB   11,  "^(E)^EA:=",1
   DB   11,  "^(E)^EOU=",1
   DB   10,  "^(E)^EO=",1
   DB   10,  "^(E)^ET=",0Ah
   DB   11,  "(E).E:!=AA"
   DB   10,  "(E)^E:!=",1
   DB   10,  "^(E)^EU=",1
   DB   11,  "^(E)^IA:=",1
   DB   10,  "^(E)^IE=",1
   DB   11,  "^(E)^IOU=",1
   DB   11,  "^(E)^IO:=",1
   DB   11,  "^(E)^ISH=",0Ah
   DB   10,  "^(E)^IU=",1
   DB   12,  "!:(E)^RIC=",0Ah
   DB   11,  "!:(E)^L#=",1
   DB   11,  "!:(E)^R#=",1
   DB   8,   "(E).=JJ"
   DB   6,   "(E)=",0Ah

    
   DB   9,   "!(F)!=K4"
   DB   13,  "(FA)THER=4OO"
   DB   16,  "!(FING)ER=4",7,"9",0E6h,"+"
   DB   11,  "(FOO)D=4Vc"
   DB   11,  "(FOOT)=4"
   DB   19,  "(",0Ch,"!(FORE)=4",11h,1Dh
   DB   11,  "(FOUR)=4",11h,1Ch
   DB   11,  "!(FUL)=tX`"
   DB   9,   "(FUL)=t "
   DB   8,   "!(F)=4,"
   DB   8,   "(FF)=t"
   DB   6,   "(F)=4"

   
   DB   9,   "!(G)!=1",01h
   DB   9,   "B#(G)=",0E6h,"+"
   DB   11,  "!(GE)N=",041h,"1", 0Ah
   DB   12,  "(GE)OUS=ee1"
   DB   17,  "!(GEO)FFREY!=",041h,"1", 0Ah 
   DB   20,  "!(GEORGIA)!=",041h,"1",11h,05Ch,041h,"1X"
   DB   16,  "!(GEOR)GE!=",041h,"1",12h,05Ch
   DB   12,  "!(GEO)=",041h,"1",1,0Eh
   DB   16,  "!(G)ERTRUDE!=",0E6h,0E9h
   DB   17,  "!(GERMAN)=",041h,"1",1Ch,"7",047h,038h
   DB   11,  "!(GER)=",041h,"1",1Ch
   DB   10,  "(G)ER!=",0E6h,0E9h
   DB   12,  "!(GES)=",041h,"1",0Ah,"0"
   DB   10,  "(GE)T=",0E6h,"+",0Ah
   DB   15,  "SU(GGES)=",041h,"1q",0Ah,"0"
   DB   8,   "(GG)=",0E6h,"+"
   DB   9,   "!(GH)=",0E6h,0E9h
   DB   7,   "#(GH)="
   DB   17,  "!(GIANT)=",041h,"1",0Eh,"",047h,038h,"("
   DB   10,  "!(GI)N=1",7
   DB   10,  "(GI)V=",0E6h,0E9h,7
   DB   10,  "!(G)I^=T",0E6h
   DB   7,   "!(G)N="
   DB   7,   "(G)N!="
   DB   12,  "!(GO)!=T",0E6h,11h,"c"
   DB   13,  "!(GO)NE=T",0E6h,"NN"
   DB   15,  "#(GRA)PHY=T",0E6h,1Eh,""
   DB   14,  "(GREA)T=T",0E6h,05Ch,"H"
   DB   15,  "!(GROW)N=T",0E6h,"]",11h,"c"
   DB   10,  "(GUE)!=",0E6h,"+"
   DB   14,  "!(GUI)D=T",0E6h,"XX"
   DB   14,  "(GUIS)=T",0E6h,"XX/"
   DB   13,  "(GURE)!=",0E6h,"TD",05Ch
   DB   12,  "!(GYM)=e1",7,"7"
   DB   13,  "!(GYR)=e1",0Eh,4,1Dh
   DB   12,  "!(GY)=T",0E6h,"NN"
   DB   8,   "!(G)=T",0E6h
   DB   7,   "(G)+=1"
   DB   8,   "(G)!=",0E6h,"+"
   DB   7,   "(G)=T",0E6h

   
   DB   11,  "!(H)!=",9,4,"(2"
   DB   13,  "!(HABI)=", 0Ch, "$",047h
   DB   19,  "!(HAPPEN)ED=LL",27h,047h,038h
   DB   19,  "!(HAPPI)NESS=LL", 27h,047h
   DB   13,  "!(HA)STE=BB"
   DB   14,  "!(HAVE)=LL3+"
   DB   13,  "!(HEAR)D=",1Ch,05Ch
   DB   14,  "(HEARS)#=",05Ch,05Ch,"0"
   DB   16,  "!(HEIDI)!=",0Eh,"",041h,1
   DB   12,  "!(HE)IGHT="
   DB   11,  "!(HEIR)=",0Ah,1Ch
   DB   16,  "!(HELEN)!=",0Ah, " ",047h,038h
   DB   13,  "!(HEMA)=",1,"7N"
   DB   13,  "!(HEN)RY=",0Ah, 038h
   DB   12,  "!(HER)!=",05Ch,05Ch
   DB   13,  "!(HERE)#=",1,1Ch
   DB   13,  "!(HERE)!=",1,1Ch
   DB   13,  "!(HOLI)=",0Eh," ",047h
   DB   15,  "!(HOLLY)!=",0Eh," ",1
   DB   13,  "(HOME)=QQc7"
   DB   15,  "!(HONE)ST=NN8J"
   DB   15,  "!(HOSPI)=",0Eh,"0",27h,7
   DB   12,  "!(HOUR)=",0Fh,16h,1Ch
   DB   11,  "(HOW)=",0Fh,16h,""
   DB   16,  "!(HUMAN)=",16h,"7",047h,038h
   DB   12,  "!(HY)DR=",0Eh,4
   DB   8,   "!EX(H)="
   DB   7,   "(H)#=,"
   DB   5,   "(H)="


   DB   11,  "(I",27h,"M)=NN7"
   DB   10,  "!(I)!=NN"
   DB   7,   "(I)!=",1
   DB   9,   "(IA)L=A",18h
   DB   9,   "(IA)N=",1,""
   DB   10,  "(IARY)=",1Ch,1
   DB   12,  "(IA)TE=",1,"",8,""
   DB   11,  "!(ICE)=",0Eh,"","0"
   DB   9,   "(I)CY=",0Eh,""
   DB   13,  "!(IDIO)=",047h,041h,"AQ"
   DB   9,   "!(I)DI=",7
   DB   11,  "!(I)DL=NN"
   DB   11,  "(IGM):=",0Eh,4,"7"
   DB   8,   "!(I)M=",7
   DB   10,  "(I)LDA!=",7
   DB   9,   "(I)NA!=",1
   DB   10,  "(I)NDY!=",7
   DB   8,   "!(I)N=",047h
   DB   10,  "!(I)O=NN"
   DB   13,  "(IRED)!=ND",05Ch,041h
   DB   13,  "(IRES)!=ND",05Ch,"/"
   DB   11,  "(IRE)!=ND",05Ch
   DB   14,  "(IRE)MENT=ND",05Ch
   DB   12,  "!(IRO)N=N",05Ch
   DB   15,  "!(ISA)BEL!=",047h,"/X"
   DB   16,  "!(ISA)DORA!=",047h,"/X"
   DB   11,  "!(IS)L=NN"
   DB   12,  "!(ISO)=",0Eh,"0Q"
   DB   12,  "!(ITER)=",7,"(",05Ch
   DB   11,  "!(I)^#=NN"
   DB   8,   "(I)A!=",1
   DB   9,   "(I)A=NN"
   DB   11,  "(IC)AL!=",047h,"i"
   DB   12,  "#:(ICE)!=",0Ah,"0"
   DB   8,   "(IE)!=",1
   DB   10,  "RR(IE)^=",1
   DB   11,  "(IE)D!=NN"
   DB   9,   "(IE)ND=",0Bh
   DB   10,  "(IE)N^=",4,0Bh
   DB   13,  "!:(I)ER!=NN"
   DB   11,  "(IE)S!=NN"
   DB   11,  "(IE)T=NN",0Ah 
   DB   8,   "(IEU)=",16h
   DB   9,   "(IE).=AA"
   DB   7,   "(IE)=",1
   DB   10,  "(IGH)T=",0Eh,""
   DB   11,  "(IGH)!=NN"
   DB   16,  "(IGNING)=NN",4,038h,047h,"9"
   DB   12,  "(IGN)^=NN",038h
   DB   12,  "(IGN)!=NN",038h
   DB   10,  "(I)LDER=",7
   DB   10,  "(I)LDR=",047h,047h
   DB   10,  "(I)LD=NN"
   DB   9,   "(I)L.=",047h,047h
   DB   8,   "(I)L^=",7
   DB   12,  "PR(I)^A=NN"
   DB   10,  "(I)MENT=",047h
   DB   9,   "(I)NDL=",7
   DB   10,  "(I)ND=NN"
   DB   9,   "G(I)NE=",7
   DB   13,  "(I)NING!=NN"
   DB   9,   "(I)NG=",7,"-"
   DB   11,  "#:(IO)T=",4,1Bh
   DB   10,  "(IO)T=",0Eh,"",0Ah
   DB   10,  "(I)PHE=",0Eh,""
   DB   9,   "(I)QUE=",1
   DB   9,   "(IR).=",1Ch,05Ch
   DB   8,   "(IR)=",05Ch,05Ch
   DB   11,  "!(I)TI=NN"
   DB   11,  "(IT",27h,"S)=",047h,"(0"
   DB   10,  "(I)VEN!=",7
   DB   9,   "(I)VER=",7
   DB   13,  "(IXED)!=",047h,")0",041h
   DB   10,  "(I)ZE=NN"
   DB   10,  "(I)^ACY=",047h
   DB   10,  "(I)^ANT=",047h
   DB   10,  "(I)^ARY=",047h
   DB   13,  "(I)^EFUL=NN"
   DB   13,  "(I)^EMENT=",0Eh,""
   DB   10,  "(I)^ENT=",047h
   DB   9,   "(I)^ET=",7
   DB   10,  "(I)^+:#=",047h
   DB   10,  "(I)^AT+=",047h
   DB   10,  "(I)^A=NN"
   DB   10,  "(I)^E=N"
   DB   12,  "#:^(I)^LE=",047h
   DB   10,  "(I)^L#=",0Eh,4
   DB   10,  "(I)^R#=",0Eh,4
   DB   8,   "(I)!=",0Eh,4
   DB   8,   "(I).=",047h,047h
   DB   6,   "(I)=",7
   DB   11,  "!(J)!=",041h,"1",9,4
   DB   16,  "!(JACKIE)!=1",0Ch,")",1
   DB   22,  "!(JACQUELINE)!=1",0Ch,") ",047h,038h
   DB   16,  "!(JAMIE)!=1",8,"7",1
   DB   15,  "!(JAPAN)=1",0Ch,27h,0Ch,038h
   DB   19,  "!(JENNIFER)=1",0Ah,038h,047h,"4",05Ch
   DB   17,  "!(JEREMY)=1",0Ah,"]",047h,"7",1
   DB   15,  "!(JESSE)!=1",0Ah,"0",1
   DB   19,  "!(JESSICA)!=1",0Ah,"0",047h,")X"
   DB   17,  "!(JOANNA)!=1",11h,"L8X"
   DB   15,  "!(JOSE)!=",11h,"/",8,""
   DB   16,  "!(JOSHUA)=1",0Eh,"2",16h,"X"
   DB   14,  "!(JUAN)!=#",0Eh,"N",038h
   DB   16,  "!(JULY)!=1",14h," NN"
   DB   6,   "(J)=1"

  
   DB   10,  "!(K)!=)",9,4
   DB   10,  "(KEY)=)",1,""
   DB   21,  "!(KATHERINE)!=)",0Ch,"6",1Dh,047h,038h
   DB   15,  "!(KATI)!=)",8,"(",1
   DB   8,   "!(KH)=)"
   DB   13,  "!(KNOW)N=",038h,11h,"c"
   DB   7,   "!(K)N="
   DB   9,   "(K)!=)+"
   DB   7,   "(KK)=)"
   DB   20,  "!(KRISTEN)!=)",1Dh,047h,"0(",047h,038h
   DB   6,   "(K)=)"

     
   DB   9,   "!(L)!=",0Bh," "
   DB   13,  "!(LABI)= ",2,"$",1
   DB   12,  "#(LACE)= ",18h,"0"
   DB   14,  "!(LARA)!= ",12h,1Dh,"X"
   DB   14,  "!(LAUGH)= MM4"
   DB   10,  "(LEA)D= ",1
   DB   13,  "!(LEAH)!= ",1,"X"
   DB   12,  "!(LED)!= ",0Ah,041h
   DB   15,  "!(LEGI)^= ",0Ah,041h,"1",047h
   DB   13,  "!(LENS)= ",0Ah,038h,"/"
   DB   14,  "!(LEO)NARD= ",0Ah
   DB   17,  "!(LESLIE)!= ",0Ah,"/ ",1
   DB   14,  "!(LEVEL)= ",0Ah,"3 "
   DB   13,  "!(LIAR)= ",0Eh,4,1Ch
   DB   11,  "(LIAR)= D",1Ch
   DB   14,  "!(LIED)!= ",0Eh,"e"
   DB   12,  "!(LIE)!= ",0Eh,""
   DB   13,  "!(LIFE)= ",0Eh,4,"4"
   DB   13,  "!(LIKE)= N)"
   DB   13,  "(LIND)A= ",047h,038h,041h
   DB   14,  "!(LISA)!= ",1,"0","X"
   DB   10,  "(LO)C#= ",11h
   DB   12,  "#(LOG)+=`X"
   DB   11,  "(LOP)E= ",11h,27h
   DB   10,  "(LOP)= ",19h,27h
   DB   14,  "!(LORI)!= ",12h,1Dh,1
   DB   16,  "!(LOUISE)!= ",16h,"A/"
   DB   12,  "!(LOVE)= ",18h,"3"
   DB   7,   "(LL)=`"
   DB   6,   "(L)= "

    
   DB   9,   "!(M)!=",0Ah,"7"
   DB   17,  "!(MACHI)NE=7",0Eh,"2AA"
   DB   14,  "!(MADA)M=7",0Ch,041h,"X"
   DB   13,  "!(MALA)=7",0Ch," ",18h
   DB   14,  "!(MALE)!=7BB "
   DB   14,  "!(MALE)S=7BB "
   DB   13,  "!(MALE)=7",0Ch," J"
   DB   13,  "!(MAMA)=7",0Eh,"7",0Eh
   DB   13,  "!(MANE)=7BB",038h
   DB   13,  "!(MANI)=7",0Ch,038h,047h
   DB   11,  "!(MAN)=7",0Ch,038h
   DB   16,  "!(MARIA)!=7X",1Dh,1,"X"
   DB   15,  "!(MARIE)!=7X",1Dh,1
   DB   13,  "!(MARY",")=7",9,1Dh,1
   DB   14,  "!(MATE)!=7BB("
   DB   13,  "!(MATE)=7N(",0Ah
   DB   18,  "!(MATTHEW)=7",0Ch,"6",16h
   DB   17,  "!(MAYBE)!=7",2,"DD$",1
   DB   12,  "!(MEA)NT=7",0Ah
   DB   12,  "!(MEN)!=7",0Ah,038h
   DB   13,  "!(META)=7",0Ah,"(",18h
   DB   16,  "(MICHAEL)=7",0Eh,") "
   DB   19,  "!(MICHELLE)!=7",1,"2",0Ah," "
   DB   12,  "^(MINE)=7",047h,038h
   DB   15,  "!(MINU)TE=7",7,038h,18h
   DB   16,  "!(MIRIA)M=7",047h,1Dh,"AX"
   DB   15,  "!(MODE)!=7QQc",041h
   DB   11,  "!(MOD)=7",0Eh,041h
   DB   14,  "!(MONEY)=7",19h,038h,1
   DB   16,  "!(MONI)CA!=7",0Eh,038h,047h
   DB   14,  "!(MONK)=7",18h,038h,")+"
   DB   11,  "!(MON)=7",0Eh,038h
   DB   10,  "(MOV)=7",16h,"3"
   DB   11,  "!(MI)C=wN"
   DB   13,  "!(MILI)=7",7," ",047h
   DB   10,  "!I(MM)=77"
   DB   7,   "(MM)=7"
   DB   7,   "!(M)N="
   DB   7,   "(M)N!="
   DB   13,  "!(MR)!=7",7,"0(",1Ch
   DB   14,  "!(MRS)!=7",7,"0",047h,"/"
   DB   18,  "!(MULTI)PLY=7",18h,"`(",047h
   DB   15,  "!(MUSCLE)=7",18h,"0 "
   DB   9,   "!(M)Y!=7"
   DB   6,   "(M)=7"

   
   DB   9,   "!(N)!=",0Ah,038h
   DB   17,  "!(NATA)LIE!=",038h,0Ch,"(X"
   DB   22,  "!(NATHANIEL)!=8X6",0Ch,038h," "
   DB   17,  "!(NATHAN)=",038h,8,"6",047h,038h
   DB   18,  "!(NATURAL)=",038h,0Ch,"(2] "
   DB   14,  "!(NA)TURE!=",038h,8
   DB   10,  "E(NG)+=81"
   DB   16,  "!(NICOLE)=",038h,047h,")",11h," "
   DB   8,   "(NK)=x"
   DB   19,  "!(NOBODY)!=",038h,11h,"c$X",041h,1
   DB   13,  "!(NOMI)=",038h,0Eh,"7",047h
   DB   13,  "!(NO)NE!=8XX"
   DB   9,   "(NO)N=",038h,0Eh
   DB   9,   "!(N)OT=",038h
   DB   14,  "(NO)THING=8XX"
   DB   18,  "!(NOWHERE)!=",038h,11h,"#",0Ah,1Dh
   DB   11,  "!(NOW)=",038h,10h,16h
   DB   8,   "I(NG)=+"
   DB   8,   "(NG)=9"
   DB   10,  "(N",27h,"T)=8(+"
   DB   7,   "(NN)=",038h
   DB   10,  "(NQU)=xc"
   DB   12,  "!(NUIS)=",038h,16h,"0"
   DB   6,   "(N)=",038h

     
   DB   9,   "!(O)!=",11h,17h
   DB   8,   "(O)!=",11h,"c"
   DB   8,   "(OA)=",11h,"c"
   DB   17,  "!(OBTAIN)=",10h,"$(",8,"",038h
   DB   14,  "!(OCCUR)=",11h,")",05Ch,05Ch
   DB   10,  "!(O)DD=NN"
   DB   8,   "(O)E=",11h,""
   DB   10,  "(OF)!=",1Ah,"3+"
   DB   12,  "!(OFFI)=",10h,"4",047h
   DB   8,   "(O)F^=",10h
   DB   10,  "!(OH)!=",11h,"c"
   DB   10,  "(OI).=QQ",1
   DB   8,   "(OI)=",11h,1
   DB   9,   "(O)LD=QQ"
   DB   10,  "(OLK)=",11h,"c)"
   DB   10,  "(O)LOG=",0Eh,""
   DB   10,  "^#:(O)L=",18h
   DB   8,   "(O)LL=",11h
   DB   9,   "(OL)M=QQ"
   DB   9,   "(O)L.=QQ"
   DB   10,  "#:^(O)M=",18h
   DB   10,  "!(ON)!=",0Eh,038h
   DB   11,  "!(O)NCE=#",18h
   DB   10,  "!(O)NE=#", 18h
   DB   10,  "!(O)NLY=",11h
   DB   8,   "I(O)N=Z"
   DB   8,   "(O)NT=",11h
   DB   9,   "(O)N",27h,"T=",11h
   DB   10,  "!:^(O)N=",0Eh
   DB   8,   "S(O)R=",0Eh
   DB   10,  "(ON)S!=xx"
   DB   10,  "#:(O)N!=Z"
   DB   9,   "#^(O)N=Z"
   DB   9,   "(ON)!=xx"
   DB   12,  "!T(ONE)=",11h,"c",038h
   DB   11,  "(ONE)!=",11h,"c",038h
   DB   10,  "L(OO)D=XX"
   DB   9,   "(OO)D=RR"
   DB   9,   "(OO)F=VV"
   DB   8,   "(OO)K=",13h
   DB   9,   "(OOR)=",11h,05Ch
   DB   8,   "(OO)=Vc"
   DB   23,  "!(OPERATION)=",0Eh,27h,1Ch,"]",8,"2X",038h
   DB   19,  "!(OPPOSITE)=",0Eh,27h,18h,"0",047h,"("
   DB   20,  "!(ORIGINAL)=",11h,1Dh,047h,"1",047h,038h," "
   DB   14,  "(OROUGH)=",05Ch,1Eh,"Qc"
   DB   10,  "#:(OR)!=",1Ch
   DB   12,  "#:(ORS)!=",1Ch,"/"
   DB   8,   "(O)RR=",11h
   DB   13,  "!(ORDI)=Q",05Ch,041h,047h
   DB   10,  "(OR).=QQ",05Ch
   DB   8,   "(OR)=",11h,05Ch
   DB   9,   "(O)S+=",11h,"c"
   DB   9,   "(O)SS!=",10h
   DB   9,   "(O)ST!=",11h
   DB   14,  "(OTHES)!=",11h,"c5/"
   DB   10,  "(O)THER=",18h
   DB   10,  "!(O)VER=",11h
   DB   8,   "R(O)V=",11h
   DB   8,   "T(O)V=",11h
   DB   7,   "(O)V=",18h
   DB   12,  "!ALL(OW)=",0Eh,"c"
   DB   10,  "!(OW)L=",10h,16h
   DB   9,   "!(OW)=",11h,"c"
   DB   9,   "(OW)!=",11h,"p"
   DB   8,   "(OW)=",10h,16h
   DB   11,  "(O)XED!=",0Eh,"N"
   DB   12,  "!(OXY)=N)0",047h
   DB   10,  "(O)^AGE=",0Eh
   DB   9,   "(O)^A=",11h,"c"
   DB   9,   "(O)^E=",11h,""
   DB   10,  "(O)^I#=",11h,"c"
   DB   11,  "(O)^ICE=Q"
   DB   9,   "(O)^L#=",11h
   DB   9,   "(O)^R#=",11h
   DB   8,   "(O)^U=",11h
   DB   8,   "(O)^Y=",11h
   DB   11,  "(OUGHT)=",10h,"("
   DB   11,  "(OUGH)=PP4"
   DB   15,  "(OULDER)=",11h,"c`",041h,05Ch
   DB   11,  "(OULD)=Ue"
   DB   11,  "(OU)N^#=",0Eh,"c"
   DB   9,   "(OU)PL=",18h
   DB   8,   "(OU)P=",16h
   DB   11,  "!(OUR)=",0Eh,"c",05Ch
   DB   10,  "(OUR):#=",1Ch
   DB   10,  "(OUR)^=",11h,1Ch
   DB   10,  "(OU)S#=",0Eh,12h
   DB   8,   "(OU)S=",1Ah
   DB   15,  "(OUTED)!=",10h,16h,"(",047h,"e"
   DB   11,  "!(OUT)=",10h,16h, "("
   DB   10,  "^(OU)^L=",18h
   DB   9,   "(OU):#=",16h
   DB   8,   "(OU)=",0Eh,"c"
   DB   8,   "(OY)=",11h, 1
   DB   6,   "(O)=",0Eh

   
   DB   9,   "!(P)!=",27h,1
   DB   9,   "(P)!=",27h,038h,"+"
   DB   16,  "!(PARLIA)=",27h,18h,1Ch," ",18h
   DB   12,  "(PA)STE=",27h,8,4
   DB   13,  "!(PATE)=",27h
   DB   14,  "(X",0Ah,"#:(PB)#=$"
   DB   14,  "!(PECU)=",27h,7,")",4,16h
   DB   13,  "!(PENE)=",27h,0Ah, 038h,"J"
   DB   16,  "!(PHOTO)=4",11h, "#(Qc"
   DB   13,  "!(PHYS)=4",047h,047h,"/"
   DB   7,   "(PH)=4"
   DB   8,   "(PPH)=4"
   DB   11,  "(PEOP)=",27h,1,27h
   DB   16,  "!(PLURAL)=",27h," ",13h,1Dh," "
   DB   8,   "!(PN)=",038h
   DB   12,  "(POEM)=",27h,11h,"c7"
   DB   12,  "!(POE)T=",27h,11h,0Ah
   DB   10,  "(PO)P+=",27h,11h
   DB   9,   "(PO)P=",27h,0Eh
   DB   15,  "!(POSSE)=",27h,11h,"#","/",0Ah
   DB   14,  "!(POSSI)=",27h,0Eh,"0",047h
   DB   11,  "(POUL)=",27h,11h," "
   DB   11,  "(POUR)=",27h,11h,1Ch
   DB   10,  "(POW)=",27h,10h,16h
   DB   7,   "(PP)=",27h
   DB   14,  "!(PRETT)=",27h,1Dh,047h,"("
   DB   17,  "!(PROBA)BLY=",27h,1Dh,0Eh,"$"
   DB   18,  "!(PROMISE)=",27h,1Dh,0Eh,"7",047h,"0"
   DB   15,  "!(PROU)D=",27h,"]",0Dh,"cV"
   DB   12,  "(PRO)VE=",27h,1Dh,16h
   DB   12,  "(PROO)F=",27h,1Dh,16h
   DB   10,  "(PRO)=",27h,1Dh,11h
   DB   16,  "(PSEUDO)=0WWe"
   DB   14,  "(PSYCH)=0NN)"
   DB   8,   "!(PS)=0"
   DB   8,   "!(PT)=("
   DB   10,  "CEI(PT)=("
   DB   11,  "(PU)BLI=",27h,18h
   DB   13,  "!(PU)NISH=",27h,18h
   DB   17,  "!(PURPOSE)=",27h,1Ch,27h,047h,"0"
   DB   12,  "(PUT)!=",27h,13h,"(+"
   DB   10,  "(PY):A=",27h,7
   DB   12,  "(PY):O=",27h,"NN"
   DB   8,   "!(P)=",27h,"m"
   DB   6,   "(P)=",27h

    
   DB   10,  "!(Q)!=)",3,16h
   DB   12,  "(QUAR)=)c",11h,""
   DB   12,  "(QUAI)=)c",8,""
   DB   10,  "(QUA)=)#",0Fh
   DB   12,  "#(QUET)!=)",8
   DB   13,  "^(QUET)!=)Jh"
   DB   14,  "!(QUEUE)=)DVV"
   DB   9,   "(QUE)!=)"
   DB   11,  "(QUI)V=)#",7
   DB   8,   "(QU)=)#"
   DB   6,   "(Q)=)"

    
   DB   9,   "!(R)!=",0Eh,05Ch
   DB   18,  "!(RACHEL)!=",1Dh,8,"H(2 "
   DB   12,  "!(RE)ACT=",1Dh,1
   DB   15,  "!(READY)=",1Dh,"JJ",041h,1
   DB   13,  "!(READ)=",1Dh,"AA",041h
   DB   18,  "!(REBECCA)=",1Dh,"X$",0Ah,")X"
   DB   12,  "!(REC)+=",1Dh,1,"0"
   DB   11,  "!(REC)=",1Dh,0Ah,")"
   DB   20,  "!(REGULAR)=",1Dh,0Ah,0E9h,0E6h,"",16h,"`",1Ch
   DB   20,  "!(RELATIVE)=",1Dh,0Ah," X(",047h,"3"
   DB   16,  "!(REMAI)N=",1Dh,1,"7",8,""
   DB   15,  "!(RENE)!=",1Dh,0Ah,038h,8,""
   DB   16,  "!(RENEE)!=",1Dh,0Ah,038h,8,""
   DB   19,  "!(REPRE)SENT=",1Dh,0Ah,27h,1Dh,047h
   DB   11,  "!(RE)^#=",1Dh,1
   DB   9,   "(RE)D=",1Dh,0Ah
   DB   10,  "(RHO)M=",1Dh,0Eh
   DB   15,  "!(RHON)DA!=",1Dh,0Eh,038h
   DB   10,  "(RHO)=",1Dh,11h,"c"
   DB   11,  "(RHY)TH=",1Dh,7
   DB   7,   "(RH)=",1Dh
   DB   17,  "!(RICHAR)D=",1Dh,7,"(2",05Ch
   DB   12,  "(RINE)!=",1Dh,1,038h
   DB   10,  "!(RI)V=",1Dh,7
   DB   14,  "!(ROB)ERT=",1Dh,0Eh,"$"
   DB   15,  "!(ROGER)!=",1Dh,0Eh,"1",05Ch
   DB   13,  "TH(ROUGH)=",1Dh,16h
   DB   15,  "!(RO)XANNE!=",1Dh,0Eh
   DB   7,   "OR(R)="
   DB   7,   "UR(R)="
   DB   7,   "(RR)=",1Dh
   DB   11,  "!(RUN)=",1Dh,18h,038h
   DB   15,  "!(RUSSIA)=",1Dh,18h,"2X"
   DB   11,  "!(RU)TH=",1Dh,16h
   DB   6,   "(R)=",1Dh

   
   DB   9,   "!(S)!=",0Ah,"0"
   DB   11,  "(SAI)D=0JJ"
   DB   15,  "!(SARAH)!=0",0Ch,1Dh,"X"
   DB   12,  "!(SAT)U=0",0Ch,"("
   DB   13,  "!(SAYS)=0JJ/"
   DB   10,  "!(SCH)=0)"
   DB   7,   "(S)C+="
   DB   16,  "!(SEARCH)=0",05Ch,05Ch,"(2"
   DB   11,  "!(SEA)=0",1,"A"
   DB   13,  "!(SEAN)!=2",10h,038h
   DB   11,  "#(SED)!=/",041h
   DB   13,  "!(SEMI)=0",0Ah,"7",047h
   DB   17,  "!(SERVICE)=0",1Ch,"3",047h,"0"
   DB   12,  "!(SEW)!=0",11h,"c"
   DB   16,  "!(SHADOW)=2",0Dh,041h,11h,"c"
   DB   13,  "!(SHALL)=2",0Ch," "
   DB   15,  "!(SHARI)!=2",0Ch,1Dh,1
   DB   13,  "!(SHOE)=2<VV"
   DB   13,  "!(SHOW)N=2",11h,16h
   DB   7,   "(SH)=2"
   DB   15,  "!(SIL)ENT=0",0Eh," "
   DB   19,  "!(SIMILIAR)=0",047h,"7",047h," ",05Ch
   DB   14,  "!(SI)MON!=0",0Eh,""
   DB   17,  "!(SIMPLY)=0",047h,"7",27h," ",1
   DB   9,   "(SSI)O=2"
   DB   8,   "(SI)O=2"
   DB   10,  "(SI)VE=0",047h
   DB   8,   "#(S)M=/"
   DB   18,  "!(SOMEO)NE=0XX7c",0Eh
   DB   12,  "(SOME)=0XX7"
   DB   11,  "!(SON)=0",18h,038h
   DB   10,  "(SOU)L=0",11h
   DB   12,  "(SO)URCE=0",11h
   DB   16,  "!(SOUTH)ERN=0",18h,"5"
   DB   15,  "!(SPE)CIAL=0",27h,0Ah
   DB   16,  "!(SQUARE)=0)c",0Ah,1Ch
   DB   16,  "!(STACY)=0(",8,"0",1
   DB   21,  "!(STEFANIE)!=0(",0Ah,"4X",038h,1
   DB   10,  "#(ST)EN=0"
   DB   16,  "!(STEVE)N=0(",1,"3",047h
   DB   10,  "(STHM)=07"
   DB   10,  "(ST)LE!=0"
   DB   14,  "!(STO)NE=0(",11h,"c"
   DB   13,  "!(STU)DY=0(",18h
   DB   11,  "!(SUB)=0",18h,"$"
   DB   12,  "!(SUE)!=0",16h,"V"
   DB   15,  "!(SUGAR)=2",13h,0E9h,0E6h,1Ch
   DB   13,  "(SUPER)= ",16h,27h,1Ch
   DB   17,  "!(SURFAC)#=0",1Ch,"4",047h,"0"
   DB   11,  "#(SUR)#=1",1Ch
   DB   12,  "(SUR)#=rl",16h,""
   DB   14,  "!(SUSAN)=0",16h,"0",038h
   DB   17,  "!(SUZA)NNE!=0",16h,"/",0Ch
   DB   11,  "#(SU)#=/,",16h
   DB   11,  "#(SSU)#=2",16h
   DB   8,   ".(S)!=/"
   DB   10,  "CE(S)!=J/"
   DB   10,  "SE(S)!=J/"
   DB   11,  "#:.E(S)!=/"
   DB   12,  "#:^##(S)!=/"
   DB   11,  "#:^#(S)!=","0"
   DB   8,   "U(S)!=0"
   DB   10,  "!:#(S)!=/"
   DB   9,   "!(SW)O=0"
   DB   9,   "(SY)^=0",047h
   DB   8,   "#(S).=/"
   DB   8,   "(S)!.=/"
   DB   9,   "(SSH)=02"
   DB   7,   "(SS)=0"
   DB   6,   "(S)=0"
 
      
   DB   9,   "!(T)!=(",1
   DB   8,   "(T)!=h+"
   DB   14,  "!(TAXI)=(",0Ch, ")0A"
   DB   15,  "!(TEA)CHER=)",1,"A"
   DB   12,  "!(TED)!=(",0Ah,041h
   DB   12,  "!(TEN)!=(",0Ah,038h
   DB   14,  "(THAT",27h,"S)=5",0Ch, "(0"
   DB   16,  "!(THOMAS)=(",0Eh,"7X","0"
   DB   19,  "!(THOUSAND)=6Nc/",047h,038h
   DB   19,  "!(TIFFANY)!=(",047h,"4X",038h,1
   DB   13,  "!(TIN)Y=(",0Eh,"",038h
   DB   12,  "!(TIR)=(",0Eh,"D",1Ch
   DB   13,  "!(TO)DAY=","(",16h,"c"
   DB   11,  "!(TO)!=(",16h,"c"
   DB   13,  "!(TODD)!=(",0Eh,041h
   DB   16,  "!(TOM)ORROW=(",16h,"7"
   DB   13,  "!(TONE)=(",11h, "c",038h
   DB   14,  "!(TONI)!=(",11h,038h,1
   DB   14,  "!(TONY)!=(",11h,038h,1
   DB   12,  "!(TON)!=(",18h,038h
   DB   16,  "!(TOWARD)=(cQ",05Ch,041h
   DB   10,  "!(TWO)=(",16h
   DB   12,  "(TA)STE=(",8,4
   DB   7,   "(T)CH="
   DB   13,  "#:(TED)!=(",7,041h
   DB   11,  "!(TH)AN!=5"
   DB   10,  "(TH)AT!=5"
   DB   13,  "!(THE)!#=55",1
   DB   12,  "!(THE)!=55",1Ah
   DB   11,  "(THEI)R=5",0Ah
   DB   11,  "!(TH)EM!=5"
   DB   10,  "!(TH)EN=5"
   DB   16,  "!(THEORY)=5",1,05Ch,1Dh,1
   DB   14,  "!(THERA)=6",0Ah, "]"
   DB   13,  "!(THERE)=5",0Ah,1Dh
   DB   11,  "(TH)ERLY=5"
   DB   14,  "(THESE)!=5AA/"
   DB   13,  "!(THEY)=5HH"
   DB   13,  "!(THIS)!=5",7,"0"
   DB   12,  "(THOSE)=5",11h,"/"
   DB   14,  "(THOUGH)!=5",11h,"c"
   DB   10,  "(THS)!=5o"
   DB   10,  "!(TH)US=5"
   DB   8,   "(TH)Y=5"
   DB   8,   "(TH)=66"
   DB   11,  "S(TI)#N=(2"
   DB   9,   "(TI)AL=2"
   DB   9,   "(TI)A=2",1
   DB   10,  "(TIE)N=2",1Ah
   DB   9,   "(TI)O^=r"
   DB   9,   "(TI)O=r<"
   DB   9,   "(TI)V=(", 0Ah
   DB   11,  "(TOU)CH=(",18h
   DB   11,  "(TOUR)=(",16h,1Ch
   DB   18,  "!(TRACY)!=hr]",8,"0",1
   DB   21,  "!(TRIANGLE)=(",1Dh,0Eh,"",8,"9 "
   DB   14,  "!(TRIU)=(",1Dh,0Eh,4,"X"
   DB   15,  "!(TRA)VEL=(r]",0Ch
   DB   9,   "(TR)=hr]"
   DB   7,   "(TT)=("
   DB   10,  "(TU)A=(2",16h
   DB   15,  "!(TUES)DAY=(",16h,"/"
   DB   11,  "(TUR)#=hr",05Ch
   DB   16,  "!(TWICE)!=(c",0Eh,4,"0"
   DB   8,   "(TZ)=(0"
   DB   6,   "(T)=("

    
   DB   9,   "!(U)!=D",16h
   DB   7,   "(UH)="
   DB   10,  "(UI)L.=",7,047h
   DB   9,   "(UI)L^=",7
   DB   10,  "R(UI)T=VV"
   DB   10,  "(UI)TE=c",1
   DB   10,  "(UI)^E=VV"
   DB   10,  "S(UI)T=VV"
   DB   9,   "(U)L.=XX"
   DB   15,  "!(ULTRA)=",18h," (",1Dh,"X"
   DB   8,   "(U)LY=",16h
   DB   9,   "(U)M.=XX"
   DB   11,  "(U)NION=D",14h
   DB   12,  "(U)NITE=DVV"
   DB   13,  "!(UNIN)=",18h,038h,7,038h
   DB   10,  "!(U)NI=D",16h
   DB   9,   "(U)N.=XX"
   DB   9,   "!(UN)=",18h,038h
   DB   14,  "!(UPON)=",1Ah,27h,"PP",038h
   DB   10,  "(UR)#=D",16h,""
   DB   9,   "(UR).=",05Ch,05Ch
   DB   8,   "(UR)^=",1Ch
   DB   9,   "(U).!=XX"
   DB   8,   "(U)^!=",18h
   DB   10,  "R(U)TH!=",16h
   DB   10,  "R(U)^L#=",16h
   DB   9,   "(U)^L#=",16h
   DB   10,  "R(U)^R#=",16h
   DB   9,   "(U)^R#=",16h
   DB   8,   "(U)^^=",18h
   DB   9,   "^^(U)+=",16h
   DB   9,   "(UY)=NN", 4
   DB   8,   "!G(U)#="
   DB   8,   "G(U)#=#"
   DB   10,  "L(U).#=VV"
   DB   9,   "L(U)^#=",16h
   DB   9,   "#N(U)=",4,16h
   DB   8,   "R(U)#=",16h
   DB   10,  "R(U).#=VV"
   DB   9,   "R(U)^#=",16h
   DB   9,   "!(U)=VV"
   DB   7,   "(U)=",16h

    
   DB   9,   "!(V)!=3",1
   DB   20,  "!(VARIETY)=3",0Fh,1Dh,0Eh,"D",047h,"(",1
   DB   13,  "!(VEGE)=3",0Ah,"1J"
   DB   20,  "!(VERONI)CA!=3",0Ah,1Dh,"N",038h,047h
   DB   12,  "!(VIB)=3",0Eh,4,"$"
   DB   12,  "(VIEW)=3VV"
   DB   13,  "!(VIND)=3",7,038h,041h
   DB   12,  "!(VIO)=3",0Eh,4,18h
   DB   13,  "(VI)^E!=3NN"
   DB   10,  "(VOW)=3",10h,16h
   DB   6,   "(V)=3"

    
   DB   13,  "!(W)!=",041h,1Bh,"$ ",4,16h
   DB   11,  "!(WERE)=#",1Ch
   DB   16,  "!(WAGON)=c",0Dh,0E9h,0E6h,047h,038h
   DB   10,  "(WA)NT=#",0Eh
   DB   11,  "(WARE)=#",8,"]"
   DB   10,  "(WAR)=#",11h,05Ch
   DB   12,  "(WA)STE=#",8,4
   DB   9,   "(WA)S=#",19h
   DB   9,   "(WA)T=#",0Fh
   DB   19,  "!(WEDNES)DAY=cJJ8/"
   DB   9,   "S(W)ER!="
   DB   10,  "(WHA)T=c",19h
   DB   11,  "!(WHE)N=c",0Ah 
   DB   12,  "(WHERE)=#",0Ah,1Dh
   DB   14,  "!(WHICH)=c",7,"(2"
   DB   11,  "(WHOL)=-",12h," "
   DB   9,   "(WHO)=#",16h
   DB   7,   "(WH)=#"
   DB   18,  "!(WILLIAM)=c",7," X7"
   DB   14,  "!(WIN)DOW=c",047h,038h
   DB   11,  "!(WIZ)=#",7,"/"
   DB   14,  "!(WOLF)!=#X`4"
   DB   14,  "!(WOMA)N=#X7",047h
   DB   15,  "!(WOMEN)=#",047h,"7J",038h
   DB   10,  "(WON)=#Xx"
   DB   11,  "(WOR).=",1Ch,05Ch
   DB   11,  "(WOR)^=",05Ch,05Ch
   DB   11,  "(WOW)!=#",10h,16h
   DB   7,   "(WR)=",1Dh
   DB   6,   "(W)=#"

    
   DB   10,  "!(X)!=",0Bh,")0"
   DB   7,   "!(X)=/"
   DB   12,  "(XIOUS)=2",18h,"0"
   DB   8,   "(X)U=",")2"
   DB   8,   "(X)^=)0"
   DB   8,   "(XX)=)0"
   DB   7,   "(X)=)0"

   
   DB   11,  "!(Y)!=#NN"
   DB   13,  "!(YEAR)!=D",1,1Ch
   DB   11,  "!(YES)=",4,0Ah,"0"
   DB   11,  "(YOU)NG=",4,"X"
   DB   12,  "!(YOUR)=",4,11h,05Ch
   DB   10,  "!(YOU)=",4,16h
   DB   10,  "(Y)PHE=",0Eh,""
   DB   7,   "!(Y)=",4
   DB   9,   "!C(Y)N=",7
   DB   9,   "!C(Y)=",0Eh,4
   DB   9,   "F(Y)!=",0Eh,""
   DB   9,   "PL(Y)=",0Eh,""
   DB   10,  "^(YR)^=",05Ch,05Ch
   DB   12,  "!:(Y)!=NNN"
   DB   11,  "!:(Y)#=NN"
   DB   11,  "!:(Y)^E=",0Eh,""
   DB   11,  "!:(Y)^+:=",7
   DB   9,   "^(Y):#=",7
   DB   11,  "(Y)^L#=NN"
   DB   11,  "(Y)^R#=NN"
   DB   12,  "!:(Y)^#=NN"
   DB   9,   "!^(Y):=",7
   DB   7,   "(Y)!=",1
   DB   6,   "(Y)=",7

    
   DB   10,  "!(Z)!=/",1,1
   DB   15,  "!(ZACH)ARY=/",0Ch,")"
   DB   7,   "(ZZ)=/"
   DB   6,   "(Z)=/A"


  
 
;----------------------------------------------------
;             Word Index Table 1
;----------------------------------------------------
L5C7B:   .word  321       ; Total words in this table
L5C7D:   .word  WORD000, WORD001
L5C80:   .word  WORD002, 05F0Bh, 05F0Dh, 05F0Fh
L5C88:   .word  05F13h, 05F15h, 05F17h, 05F19h
L5C90:   .word  05F1Bh, 05F1Fh, 05F23h, 05F27h
L5C98:   .word  05F2Bh, 05F2Fh, 05F33h, 05F37h
L5CA0:   .word  05F3Bh, 05F3Fh, 05F41h, 05F45h
L5CA8:   .word  05F49h, 05F4Dh, 05F51h, 05F55h
L5CB0:   .word  05F5Eh, 05F62h, 05F66h, 05F6Ah    
L5CB8:   .byte  06Eh, 05Fh, 072h, 05Fh, 076h, 05Fh, 078h
L5CC0:   .byte  05Fh, 07Ch, 05Fh, 080h, 05Fh, 082h, 05Fh, 08Ah
L5CC8:   .byte  05Fh, 091h, 05Fh, 097h, 05Fh, 09Ch, 05Fh, 0A2h
L5CD0:   .byte  05Fh, 0A9h, 05Fh, 0B0h, 05Fh, 0B5h, 05Fh, 0B9h
L5CD8:   .byte  05Fh, 0C0h, 05Fh, 0C7h, 05Fh, 0CDh, 05Fh, 0D7h
L5CE0:   .byte  05Fh, 0E3h, 05Fh, 0EDh, 05Fh, 0F7h, 05Fh, 0FAh
L5CE8:   .byte  05Fh, 004h, 060h, 010h, 060h, 018h, 060h, 01Ch
L5CF0:   .byte  060h, 022h, 060h, 029h, 060h, 030h, 060h, 037h
L5CF8:   .byte  060h, 03Eh, 060h, 042h, 060h, 04Fh, 060h, 052h
L5D00:   .byte  060h, 05Ah, 060h, 061h, 060h, 066h, 060h, 06Bh
L5D08:   .byte  060h, 073h, 060h, 078h, 060h, 07Dh, 060h, 087h
L5D10:   .byte  060h, 08Ch, 060h, 091h, 060h, 098h, 060h, 0A1h
L5D18:   .byte  060h, 0A9h, 060h, 0B1h, 060h, 0B9h, 060h, 0C0h
L5D20:   .byte  060h, 0CAh, 060h, 0D3h, 060h, 0D6h, 060h, 0DFh
L5D28:   .byte  060h, 0E6h, 060h, 0E9h, 060h, 0EFh, 060h, 0F5h
L5D30:   .byte  060h, 0FBh, 060h, 002h, 061h, 00Bh, 061h, 012h
L5D38:   .byte  061h, 018h, 061h, 020h, 061h, 028h, 061h, 02Eh
L5D40:   .byte  061h, 034h, 061h, 03Bh, 061h, 042h, 061h, 047h
L5D48:   .byte  061h, 04Eh, 061h, 053h, 061h, 059h, 061h, 062h
L5D50:   .byte  061h, 069h, 061h, 070h, 061h, 075h, 061h, 07Eh
L5D58:   .byte  061h, 085h, 061h, 08Ch, 061h, 095h, 061h, 09Dh
L5D60:   .byte  061h, 0A8h, 061h, 0AFh, 061h, 0B8h, 061h, 0BEh
L5D68:   .byte  061h, 0C4h, 061h, 0CCh, 061h, 0D3h, 061h, 0DBh
L5D70:   .byte  061h, 0E6h, 061h, 0F0h, 061h, 0F7h, 061h, 0FCh
L5D78:   .byte  061h, 007h, 062h, 012h, 062h, 01Bh, 062h, 022h
L5D80:   .byte  062h, 028h, 062h, 02Dh, 062h, 036h, 062h, 03Eh
L5D88:   .byte  062h, 044h, 062h, 04Ch, 062h, 054h, 062h, 05Ah
L5D90:   .byte  062h, 064h, 062h, 06Bh, 062h, 073h, 062h, 07Ch
L5D98:   .byte  062h, 085h, 062h, 090h, 062h, 098h, 062h, 0A3h
L5DA0:   .byte  062h, 0A9h, 062h, 0AEh, 062h, 0B5h, 062h, 0BFh
L5DA8:   .byte  062h, 0C6h, 062h, 0CFh, 062h, 0DBh, 062h, 0E9h
L5DB0:   .byte  062h, 0F2h, 062h, 0F8h, 062h, 0FCh, 062h, 006h
L5DB8:   .byte  063h, 00Fh, 063h, 020h, 063h, 027h, 063h, 02Bh
L5DC0:   .byte  063h, 031h, 063h, 038h, 063h, 042h, 063h, 047h
L5DC8:   .byte  063h, 052h, 063h, 05Ah, 063h, 063h, 063h, 06Bh
L5DD0:   .byte  063h, 074h, 063h, 07Fh, 063h, 085h, 063h, 08Dh
L5DD8:   .byte  063h, 093h, 063h, 09Ah, 063h, 09Fh, 063h, 0A8h
L5DE0:   .byte  063h, 0B4h, 063h, 0BEh, 063h, 0C8h, 063h, 0D1h
L5DE8:   .byte  063h, 0D8h, 063h, 0DFh, 063h, 0E7h, 063h, 0EFh
L5DF0:   .byte  063h, 0F8h, 063h, 0FFh, 063h, 008h, 064h, 011h
L5DF8:   .byte  064h, 018h, 064h, 01Fh, 064h, 029h, 064h, 032h
L5E00:   .byte  064h, 036h, 064h, 03Bh, 064h, 043h, 064h, 04Bh
L5E08:   .byte  064h, 052h, 064h, 05Ah, 064h, 062h, 064h, 069h
L5E10:   .byte  064h, 070h, 064h, 07Bh, 064h, 084h, 064h, 08Eh
L5E18:   .byte  064h, 096h, 064h, 09Ch, 064h, 0A9h, 064h, 0B5h
L5E20:   .byte  064h, 0BCh, 064h, 0C6h, 064h, 0CFh, 064h, 0D8h
L5E28:   .byte  064h, 0DFh, 064h, 0E8h, 064h, 0EFh, 064h, 0F8h
L5E30:   .byte  064h, 0FFh, 064h, 011h, 065h, 018h, 065h, 01Eh
L5E38:   .byte  065h, 025h, 065h, 02Eh, 065h, 035h, 065h, 03Ch
L5E40:   .byte  065h, 044h, 065h, 050h, 065h, 05Ah, 065h, 060h
L5E48:   .byte  065h, 067h, 065h, 069h, 065h, 070h, 065h, 078h
L5E50:   .byte  065h, 07Fh, 065h, 085h, 065h, 08Ch, 065h, 094h
L5E58:   .byte  065h, 09Bh, 065h, 0A3h, 065h, 0B0h, 065h, 0B4h
L5E60:   .byte  065h, 0B9h, 065h, 0CAh, 065h, 0D3h, 065h, 0D9h
L5E68:   .byte  065h, 0E3h, 065h, 0EEh, 065h, 0F7h, 065h, 0FCh
L5E70:   .byte  065h, 004h, 066h, 00Ah, 066h, 011h, 066h, 01Bh
L5E78:   .byte  066h, 025h, 066h, 02Ah, 066h, 034h, 066h, 03Bh
L5E80:   .byte  066h, 042h, 066h, 047h, 066h, 04Eh, 066h, 052h
L5E88:   .byte  066h, 057h, 066h, 05Fh, 066h, 066h, 066h, 06Fh
L5E90:   .byte  066h, 079h, 066h, 07Eh, 066h, 082h, 066h, 088h
L5E98:   .byte  066h, 091h, 066h, 09Ah, 066h, 0A3h, 066h, 0A8h
L5EA0:   .byte  066h, 0B0h, 066h, 0BAh, 066h, 0C3h, 066h, 0CDh
L5EA8:   .byte  066h, 0D6h, 066h, 0DEh, 066h, 0E8h, 066h, 0EFh
L5EB0:   .byte  066h, 0F7h, 066h, 0FEh, 066h, 009h, 067h, 01Ah
L5EB8:   .byte  067h, 01Eh, 067h, 02Eh, 067h, 03Bh, 067h, 042h
L5EC0:   .byte  067h, 059h, 067h, 05Dh, 067h, 067h, 067h, 072h
L5EC8:   .byte  067h, 077h, 067h, 07Ch, 067h, 082h, 067h, 087h
L5ED0:   .byte  067h, 08Dh, 067h, 099h, 067h, 0A1h, 067h, 0ACh
L5ED8:   .byte  067h, 0B0h, 067h, 0B8h, 067h, 0C7h, 067h, 0CDh
L5EE0:   .byte  067h, 0D6h, 067h, 0DEh, 067h, 0E5h, 067h, 0E9h
L5EE8:   .byte  067h, 0EDh, 067h, 0FBh, 067h, 002h, 068h, 007h
L5EF0:   .byte  068h, 011h, 068h, 01Bh, 068h, 02Dh, 068h, 033h
L5EF8:   .byte  068h, 037h, 068h, 042h, 068h, 054h, 068h, 05Dh
L5F00:   .byte  068h 
     

;----------------------------------------------------
;          Word Table 1
;----------------------------------------------------
WORD000:  .byte 1   ; (5F01)              
          .STRING "0"

WORD001:  .byte 1                
          .STRING "1"

WORD002:  .byte 5                
          .STRING "/TOO/"

WORD003:  .byte 1                
          .STRING "3"

WORD004:  .byte 1                
          .STRING "4"

WORD005:  .byte 3                
          .STRING "/5/"

WORD006:  .byte 1                
          .STRING "6"

WORD007:  .byte 1                
          .STRING "7"

WORD008:  .byte 1                
          .STRING "8"

WORD009:  .byte 1                
          .STRING "9"

WORD00A:  .byte 3                
          .STRING "/A/"

WORD00B:  .byte 3                
          .STRING "/B/"

WORD00C:  .byte 3                
          .STRING "/C/"          
          
WORD00D:  .byte 3                
          .STRING "/D/"

WORD00E:  .byte 3                
          .STRING "/E/"

WORD00F:  .byte 3                
          .STRING "/F/"

WORD010:  .byte 3                
          .STRING "/G/"

WORD011:  .byte 3                
          .STRING "/H/"

WORD012:  .byte 3                
          .STRING "/I/"

WORD013:  .byte 1                
          .STRING "J"

WORD014:  .byte 3                
          .STRING "/K/"

WORD015:  .byte 3                
          .STRING "/L/"

WORD016:  .byte 3                
          .STRING "/M/"

WORD017:  .byte 3                
          .STRING "/N/"

WORD018:  .byte 3                
          .STRING "/O/"

WORD019:  .byte 8                
          .STRING "/PEE-EE/"

WORD01A:  .byte 3                
          .STRING "/Q/"

WORD01B:  .byte 3                
          .STRING "/R/"

WORD01C:  .byte 3                
          .STRING "/S/"

WORD01D:  .byte 3                   
          .STRING "/T/"

WORD01E:  .byte 3                
          .STRING "/U/"

WORD01F:  .byte 3                
          .STRING "/V/"

WORD020:  .byte 1                
          .STRING "W"

WORD021:  .byte 3                
          .STRING "/X/"

WORD022:  .byte 3                
          .STRING "/Y/"

WORD023:  .byte 1                
          .STRING "Z"

WORD024:  .byte 7                
          .STRING "/EN/TER"

WORD025:  .byte 6                
          .STRING "KL-EAR"

WORD026:  .byte 5                
          .STRING "/YES/"        

WORD027:  .byte 4                
          .STRING "/NO/"         

WORD028:  .byte 5                
          .STRING "/TEN/"

WORD029:  .byte 6                
          .STRING "ELEV-N"

WORD02A:  .byte 6                
          .STRING "TWELVV"

WORD02B:  .byte 4                
          .STRING "THIR"

WORD02C:  .byte 3                
          .STRING "FIF"

WORD02D:  .byte 6                
          .STRING "T/EE/N"

WORD02E:  .byte 6                
          .STRING "TW/E/N"

WORD02F:  .byte 5                
          .STRING "T/EE/"

WORD030:  .byte 9                
          .STRING "/H/UNDRED"

WORD031:  .byte 11                
          .STRING "/TH/-OUSEND"

WORD032:  .byte 9                
          .STRING "/M/ILLION"

WORD033:  .byte 9                
          .STRING "/P/OINTER"

WORD034:  .byte 2                
          .STRING "TH"

WORD035:  .byte 9                
          .STRING "/WEL/COME"

WORD036:  .byte 11                
          .STRING "/H/AL-C-YON"

WORD037:  .byte 7                
          .STRING "PL/EEZ/"

WORD038:  .byte 3                
          .STRING "YER"

WORD039:  .byte 5                
          .STRING "/THE/"

WORD03A:  .byte 6                
          .STRING "/N/AME"

WORD03B:  .byte 6                
          .STRING "/O/NLY"

WORD03C:  .byte 6                
          .STRING "DAY-TT"

WORD03D:  .byte 6                
          .STRING "T/I/ME"

WORD03E:  .byte 3                
          .STRING "DAY"

WROD03F:  .byte 12   ; 06042h             
          .STRING "/DDTH/-A-NCK"

WORD040:  .byte 2                
          .STRING "OR"

WORD041:  .byte 7                
          .STRING "/TH/ROO"

WORD042:  .byte 6                
          .STRING "T/Y/PE"

WORD043:  .byte 4                
          .STRING "/I/N"

WORD044:  .byte 4                
          .STRING "M/E/"

WORD045:  .byte 7                
          .STRING "/SP/ELL"

WORD046:  .byte 4                
          .STRING "/ON/"

WORD047:  .byte 4                
          .STRING "M/Y/"

WORD048:  .byte 9                
          .STRING "/KEY/BORD"

WORD049:  .byte 4                
          .STRING "NEED"

WORD04A:  .byte 4                
          .STRING "LESS"

WORD04B:  .byte 6                
          .STRING "/MAN/Y"

WORD04C:  .byte 8                
          .STRING "/L/ETTER"

WORD04D:  .byte 7                
          .STRING "SP/A/CE"

WORD04E:  .byte 7                
          .STRING "/A/GAIN"

WORD04F:  .byte 7                
          .STRING "/SORR/Y"

WORD050:  .byte 6                
          .STRING "/THAT/"

WORD051:  .byte 9                
          .STRING "/SH/ORTER"

WORD052:  .byte 8                
          .STRING "/PL/AYER"

WORD053:  .byte 2                
          .STRING "DH"

WORD054:  .byte 8                
          .STRING "CK/A/N'T"

WORD055:  .byte 6
          .STRING "/H/OLD"

WORD056:  .byte 2
          .STRING "UH"

WORD057:  .byte 5
          .STRING "/BUT/"

WORD058:  .byte 5
          .STRING "/TR/Y"

WORD059:  .byte 5
          .STRING "/AND/"

WORD05A:  .byte 6                
          .STRING "M/U/CH"

WORD05B:  .byte 8
          .STRING "/ST/-ART"

WORD05C:  .byte 6                   
          .STRING "OV/ER/"

WORD05D:  .byte 5
          .STRING "D/UZ/"

WORD05E:  .byte 7
          .STRING "S/OUN/D"

WORD05F:  .byte 7
          .STRING "/RI/GHT"

WORD060:  .byte 5                    
          .STRING "W/UZ/"

WORD061:  .byte 5
          .STRING "D/I/D"

WORD062:  .byte 6
          .STRING "/SZA/Y"

WORD063:  .byte 6
          .STRING "/LIKE/"

WORD064:  .byte 4
          .STRING "/OV/"

WORD065:  .byte 6
          .STRING "/CKA/N"

WORD066:  .byte 4
          .STRING "WANT"

WORD067:  .byte 5
          .STRING "/NOT/"

WORD068:  .byte 8
          .STRING "/N/UMBER"

WORD069:  .byte 6
          .STRING "/JU/ST"

WORD06A:  .byte 6
          .STRING "/TH/IS"

WORD06B:  .byte 4
          .STRING "/IT/"

WORD06C:  .byte 8
          .STRING "/S/IMPLE"

WORD06D:  .byte 6                   
          .STRING "CHOICE"

WORD06E:  .byte 6                   
          .STRING "NAA-OW"

WORD06F:  .byte 8
          .STRING "/DDO/N'T"

WORD070:  .byte 7                   
          .STRING "/SH/SHY"

WORD071:  .byte 10
          .STRING "/SL/EEPING"

WORD072:  .byte 6
          .STRING "/ACKT/"

WORD073:  .byte 8
          .STRING "L/Y/VELY"

WORD074:  .byte 5
          .STRING "D/OO/"

WORD075:  .byte 5                  
          .STRING "HA/V/"

WORD076:  .byte 7                  
          .STRING "F/IR/ST"

WORD077:  .byte 6                  
          .STRING "/GIHV/"

WORD078:  .byte 7
          .STRING "/AIR/ER"

WORD079:  .byte 10
          .STRING "/SP/ELLING"

WORD07A:  .byte 9
          .STRING "NU/TH/ING"

WORD07B:  .byte 6
          .STRING "/W/ILL"

WORD07C:  .byte 4
          .STRING "/IS/"

WORD07D:  .byte 10
          .STRING "/LIGH/TEST"

WORD07E:  .byte 10
          .STRING "/BUR/DDEHN"

WORD07F:  .byte 8
          .STRING "/CKAUST/"

WORD080:  .byte 6                 
          .STRING "HANDED"

WORD081:  .byte 5                  
          .STRING "L/O/T"

WORD082:  .byte 4                  
          .STRING "/A/N"

WORD083:  .byte 8
          .STRING "M/I/NETT"

WORD084:  .byte 7
          .STRING "/AW/WER"

WORD085:  .byte 5
          .STRING "MONTH"

WORD086:  .byte 7
          .STRING "/Y/E-ER"

WORD087:  .byte 7
          .STRING "/SM/ALL"

WORD088:  .byte 5
          .STRING "/BIG/"

WORD089:  .byte 9
          .STRING "/P/OINTSS"

WORD08A:  .byte 6                 
          .STRING "WHE/N/"

WORD08B:  .byte 7
          .STRING "/GUESS/"

WORD08C:  .byte 8
          .STRING "/BEAU/TY"

WORD08D:  .byte 8
          .STRING "/WOE-NT/"

WORD08E   .byte 10
          .STRING "/DIFF/RENT"

WORD08F:  .byte 7
          .STRING "CH/ECK/"

WORD090:  .byte 10
          .STRING "/KRE/8EVLY"

WORD091:  .byte 5
          .STRING "CLOCK"

WORD092:  .byte 4
          .STRING "WORK"

WORD093:  .byte 6
          .STRING "/H/ERE"

WORD094:  .byte 9
          .STRING "W/OO/NDED"

WORD095:  .byte 6                  
          .STRING "/MUST/"

WORD096:  .byte 8          
          .STRING "DR/O/PPP"

WORD097:  .byte 11          
          .STRING "SOME/TH/ING"

WORD098:  .byte 13                  
          .STRING "CAAN-/TT/IN-U"

WORD099:  .byte 8                   
          .STRING "CH/OO/SE"

WORD09A:  .byte 5                
          .STRING "ITE-M"

WORD09B:  .byte 3
          .STRING "(*)"

WORD09C:  .byte 9
          .STRING "DR/O/PPTT"

WORD09D:  .byte 8
          .STRING "/SCK/OOR"

WORD09E:  .byte 16
          .STRING "ENTER-/T/AINMENT"

WORD09F:  .byte 6                
          .STRING "/KHET/"

WORD0A0:  .byte 3                
          .STRING "(%)"

WORD0A1:  .byte 5
          .STRING "U-U-1"

WORD0A2:  .byte 6
          .STRING "/M/AKE"

WORD0A3:  .byte 9                   
          .STRING "AN/UTH/OR"

WORD0A4:  .byte 4
          .STRING "G/O/"

WORD0A5:  .byte 10
          .STRING "BA/TH/ROOM"

WORD0A6:  .byte 7
          .STRING "PL/UCG/"

WORD0A7:  .byte 8
          .STRING "REP/EAT/"

WORD0A8:  .byte 7
          .STRING "/AFT/ER"

WORD0A9:  .byte 8
          .STRING "JAHNUARY"

WORD0AA:  .byte 10
          .STRING "FEBH/U/ARY"

WORD0AB:  .byte 5
          .STRING "MARCH"

WORD0AC:  .byte 7
          .STRING "/A/PRUL"

WORD0AD:  .byte 5
          .STRING "/M/AY"

WORD0AE:  .byte 6
          .STRING "J/U/NE"

WORD0AF:  .byte 4
          .STRING "JULY"

WORD0B0:  .byte 8
          .STRING "/AU/GUST"

WORD0B1:  .byte 11
          .STRING "SEPT/EM/BER"

WORD0B2:  .byte 9
          .STRING "OCT/O/BER"

WORD0B3:  .byte 9
          .STRING "NO-VEMBER"

WORD0B4:  .byte 8
          .STRING "D-CEMBER"

WORD0B5:  .byte 6
          .STRING "SUNDAY"

WORD0B6:  .byte 6
          .STRING "MUNDAY"

WORD0B7:  .byte 7
          .STRING "TOOZDAY"

WORD0B8:  .byte 7
          .STRING "WENZDAY"

WORD0B9:  .byte 8
          .STRING "THURZDAY"

WORD0BA:  .byte 6
          .STRING "FRIDAY"

WORD0BB:  .byte 8
          .STRING "SATURDAY"

WORD0BC:  .byte 8
          .STRING "/S/ECOND"

WORD0BD:  .byte 6
          .STRING "TTHERD"

WORD0BE:  .byte 6
          .STRING "N/O/DE"

WORD0BF:  .byte 9
          .STRING "/SPE/CIAL"

WORD0C0:  .byte 8
          .STRING "REG-ULAR"

WORD0C1:  .byte 3
          .STRING "(#)"

WORD0C2:  .byte 4
          .STRING "/I/F"

WORD0C3:  .byte 3             ; <---
          .STRING "/V/OICE"

WORD0C4:  .byte 3
          .STRING "PPRINTT"

WORD0C5:  .byte 3
          .STRING "/ELSE/"

WORD0C6:  .byte 3              
          .STRING "/PRESS/"     

WORD0C7:  .byte 3              
          .STRING "/KEE/EE"

WORD0C8:  .byte 3              
          .STRING "/C/OME"

WORD0C9:  .byte 3              
          .STRING "/WH/AT"

WORD0CA:  .byte 3              
          .STRING "/REM/EMBER"

WORD0CB:  .byte 3               
          .STRING "/PL/AYED"

WORD0CC:  .byte 3               
          .STRING "/PL/AYING"

WORD0CD:  .byte 3              
          .STRING "/R/EADY"

WORD0CE:  .byte 3
          .STRING "/USE/"

WORD0CF:  .byte 3                 
          .STRING "MI/CR/OPHONE"

WORD0D0:  .byte 3                
          .STRING "/C/ARTRIDGE"

WORD0D1:  .byte 3                 
          .STRING "/G/AME"

WORD0D2:  .byte 3
          .STRING "/UP/-DATE"

WORD0D3:  .byte 3
          .STRING "/IN/SERT"

WORD0D4:  .byte 3
          .STRING "/RE/MOVE"

WORD0D5:  .byte 3
          .STRING "D/I/SK"

WORD0D6:  .byte 3
          .STRING "S/OU/NDS"

WORD0D7:  .byte 3
          .STRING "FRENCH"

WORD0D8   .byte 3
          .STRING "P/AR/DON"

WORD0D9:  .byte 3
          .STRING "/PLAY/"

WORD0DA:  .byte 3               
          .STRING "/IN/STRU/CC/SHUNS"

WORD0DB:  .byte 3
          .STRING "L/A/ST"

WORD0DC:  .byte 3
          .STRING "/H/AZ"

WORD0DD:  .byte 3
          .STRING "/M/ADE"

WORD0DE:  .byte 3
          .STRING "/L/AW-ST"

WORD0DF:  .byte 3
          .STRING "T/U/RN"

WORD0E0:  .byte 3               
          .STRING "/AWFF/"

WORD0E1:  .byte 3               
          .STRING "/POW/ER"

WORD0E2:  .byte 3
          .STRING "RE/I/NSERT"

WORD0E3:  .byte 3                
          .STRING "CO/M/BINE"

WORD0E4:  .byte 3                
          .STRING "U-U-2"

WORD0E5:  .byte 3
          .STRING "/P/ART"

WORD0E6:  .byte 3
          .STRING "n"

WORD0E7:  .byte 3
          .STRING "/C/ALL"

WORD0E8:  .byte 3          
          .STRING "/L/Y-VZ"

WORD0E9:  .byte 3               
          .STRING "/L/IFE"

WORD0EA:  .byte 3               
          .STRING "/ALL/"

WORD0EB:  .byte 3
          .STRING "/L/EFT"

WORD0EC:  .byte 3                
          .STRING "/IN/-EE"

WORD0ED:  .byte 3               
          .STRING "/TH/EM"

WORD0EE:  .byte 3               
          .STRING "/S/AVED"

WORD0EF:  .byte 3
          .STRING "/P/AA-SCEHBL"

WORD0F0:  .byte 3                
          .STRING "OUT"

WORD0F1:  .byte 3
          .STRING "WAIT"

WORD0F2:  .byte 3
          .STRING "/V/ERIFI/C/ATION"

WORD0F3:  .byte 3
          .STRING "/CH/ANCE"

WORD0F4:  .byte 3
          .STRING "WWORD"

WORD0F5:  .byte 3          
          .STRING "/M/ESSIDJ"

WORD0F6:  .byte 3
          .STRING "/C/UNTROAL"

WORD0F7:  .byte 3
          .STRING "RE/M/OTE"

WORD0F8:  .byte 3
          .STRING "MODE"

WORD0F9:  .byte 3
          .STRING "SHER-ER"

WORD0FA:  .byte 3                
          .STRING "/L/AY"

WORD0FB:  .byte 3
          .STRING "/H/INT"

WORD0FC:  .byte 3
          .STRING "BE/L/IEVE"

WORD0FD:  .byte 3              
          .STRING "/L/ER-ERN"

WORD0FE:  .byte 3              
          .STRING "OWWN"

WORD0FF:  .byte 3              
          .STRING "/RE/-PLAY"

WORD100:  .byte 3
          .STRING "D/IED/"

WORD101:  .byte 3
          .STRING "S/A/VE"

WORD102:  .byte 3
          .STRING "NEXT"

WORD103:  .byte 3
          .STRING "/TAKE/"

WORD104:  .byte 3
          .STRING "SOE"

WORD105:  .byte 3
          .STRING "FROM"

WORD106:  .byte 3
          .STRING "/WERNT/"

WORD107:  .byte 3
          .STRING "TH/EY/"

WORD108:  .byte 3
          .STRING "DISCRIBE"

WORD109:  .byte 3
          .STRING "F/I/TTING"

WORD10A:  .byte 3
          .STRING "WELL"

WORD10B:  .byte 3
          .STRING "LET"

WORD10C:  .byte 3
          .STRING "WOULD"

WORD10D:  .byte 3
          .STRING "/F/UTURE"

WORD10E:  .byte 3
          .STRING "U/SS/OOM"

WORD10F:  .byte 3
          .STRING "/CKALMM/"

WORD110:  .byte 3
          .STRING "DOWN"

WORD111:  .byte 3
          .STRING "SPEA/K/"

WORD112:  .byte 3
          .STRING "/PL/AINLY"

WORD113:  .byte 3
          .STRING "RI/LL/AX"

WORD114:  .byte 3
          .STRING "/CK/ALMLY"

WORD115:  .byte 3
          .STRING "B-/W/AIR"

WORD116:  .byte 3
          .STRING "/H/EEEE"

WORD117:  .byte 3
          .STRING "/F/AH-AST"

WORD118:  .byte 3
          .STRING "WAH-ER"

WORD119:  .byte 3
          .STRING "/W/UZNT"

WORD11A:  .byte 3
          .STRING "/N/ICE"

WORD11B:  .byte 3
          .STRING "/B/AH-AHCK"

WORD11C:  .byte 3
          .STRING "CUNS/I/STAN/T/LY"

WORD11D:  .byte 3
          .STRING "BIN"

WORD11E:  .byte 3
          .STRING "X-PL-N-/A/-SHON"

WORD11F:  .byte 3
          .STRING "FUH/NCK/SHUN"

WORD120:  .byte 3
          .STRING "UH-UHP"

WORD121:  .byte 3
          .STRING "CUNNGRADJULL-/A/-SHUNS"

WORD122:  .byte 3
          .STRING "WUN"

WORD123:  .byte 3
          .STRING "/B/OANESS"

WORD124:  .byte 3
          .STRING "/IM/PROVED"

WORD125   .byte 3
          .STRING "/H/Y"

WORD126:  .byte 3
          .STRING "OALD"

WORD127:  .byte 3
          .STRING "/NN/U"

WORD128:  .byte 3
          .STRING "WITH"

WORD129:  .byte 3
          .STRING "TESST"

WORD12A:  .byte 3
          .STRING "SYNTHESIZER"

WORD12B:  .byte 3
          .STRING "/L/AZER"

WORD12C:  .byte 3
          .STRING "COM/PL/ETE"

WORD12D:  .byte 3
          .STRING "END"

WORD12E:  .byte 3
          .STRING "THROUGH"

WORD12F:  .byte 3
          .STRING "RECUG-/N/ISHUN"

WORD130:  .byte 3
          .STRING "FRASE"

WORD131:  .byte 3
          .STRING "/A/CTION"

WORD132:  .byte 3
          .STRING "/ST/ILL"

WORD133   .byte 3
          .STRING "VERIFY"

WORD134:  .byte 3
          .STRING "RAM"

WORD135:  .byte 3
          .STRING "ROM"

WORD136:  .byte 3
          .STRING "DIAGN/O/STICS"

WORD137:  .byte 3
          .STRING "/M/ENU"

WORD138:  .byte 3
          .STRING "CHIP"

WORD139:  .byte 3
          .STRING "DIS/PL/AY"

WORD13A:  .byte 3
          .STRING "M/O/NITOR"

WORD13B:  .byte 3
          .STRING "CO/MM/UNIC/A/TION"

WORD13C:  .byte 5
          .STRING "LEENK"

WORD13D:  .byte 3
          .STRING "EDD"

WORD13E:  .byte 10
          .STRING "/SP/INNING"

WORD13F:  .byte 17
          .STRING "/I/NI/SH/AL-IZING"

WORD140:  .byte 8
          .STRING "/SY/STUM"

WORD141:  .byte 13
          .STRING "/RE/-STARTING"


        
        
; ---------------------------------------------------
;           Phrase Table 1 Size
; ---------------------------------------------------
L686B:  DW   000B3h    ; Number of Phrases in this table
; ---------------------------------------------------
;          Phrase Table 1 Indexes
; ---------------------------------------------------
L686D:  DW   069D5h, 069E2h
L6870:  DW   069EFh, 069F8h, 06A01h, 06A0Eh
L6878:  DW   06A19h, 06A2Ch, 06A37h, 06A48h  
L6880:  DW   06A55h, 06A66h, 06A79h, 06A88h 
L6888:  DW   06A99h, 06AA8h, 06AB3h, 06ABEh
L6890:  DW   06AD1h, 06ADCh, 06AE9h, 06AF2h
L6898:  DW   06B01h, 06B0Ah, 06B13h, 06B22h
L68A0:  DW   06B2Dh, 06B38h, 06B3Fh, 06B48h
L68A8:  DW   06B53h, 06B60h, 06B6Dh, 06B76h   
L68B0:  DW   06B7Fh, 06B96h, 06BA3h, 06BACh
L68B8:  DW   06BB7h, 06BC6h, 06BCFh, 06BDAh
L68C0:  DW   06BE7h, 06BF8h, 06C09h, 06C1Ch  ;46+1
L68C8:  DW   06C25h, 06C30h, 06C35h, 06C40h  ;50+1
L68D0:  DW   06C49h, 06C58h, 06C61h, 06C72h  ;54+1
L68D8:  .byte   07Dh, 06Ch, 086h, 06Ch, 08Dh, 06Ch, 098h  ;58+1
L68E0:  .byte   06Ch, 0A7h, 06Ch, 0AAh, 06Ch, 0B3h, 06Ch, 0BCh  ;62+1
L68E8:  .byte   06Ch, 0C5h, 06Ch, 0D0h, 06Ch, 0D7h, 06Ch, 0E4h
L68F0:  .byte   06Ch, 0EDh, 06Ch, 0F6h, 06Ch, 0FBh, 06Ch, 002h
L68F8:  .byte   06Dh, 007h, 06Dh, 00Ah, 06Dh, 00Dh, 06Dh, 010h
L6900:  .byte   06Dh, 015h, 06Dh, 01Ah, 06Dh, 01Fh, 06Dh, 024h  ;94+1
L6908:  .byte   06Dh, 029h, 06Dh, 02Eh, 06Dh, 033h, 06Dh, 038h
L6910:  .byte   06Dh, 03Dh, 06Dh, 044h, 06Dh, 04Bh, 06Dh, 052h
L6918:  .byte   06Dh, 059h, 06Dh, 060h, 06Dh, 067h, 06Dh, 06Eh
L6920:  .byte   06Dh, 075h, 06Dh, 07Eh, 06Dh, 09Dh, 06Dh, 0A8h
L6928:  .byte   06Dh, 0BBh, 06Dh, 0CCh, 06Dh, 0D5h, 06Dh, 0DAh
L6930:  .byte   06Dh, 0EBh, 06Dh, 0FEh, 06Dh, 00Fh, 06Eh, 01Ch
L6938:  .byte   06Eh, 029h, 06Eh, 038h, 06Eh, 041h, 06Eh, 04Ch
L6940:  .byte   06Eh, 057h, 06Eh, 064h, 06Eh, 06Bh, 06Eh, 070h  ;126+1
L6948:  .byte   06Eh, 07Dh, 06Eh, 088h, 06Eh, 093h, 06Eh, 09Ah
L6950:  .byte   06Eh, 0A5h, 06Eh, 0ACh, 06Eh, 0B7h, 06Eh, 0D4h
L6958:  .byte   06Eh, 0F3h, 06Eh, 004h, 06Fh, 00Fh, 06Fh, 018h
L6960:  .byte   06Fh, 02Bh, 06Fh, 036h, 06Fh, 041h, 06Fh, 04Eh
L6968:  .byte   06Fh, 059h, 06Fh, 064h, 06Fh, 071h, 06Fh, 07Ch
L6970:  .byte   06Fh, 087h, 06Fh, 090h, 06Fh, 0A3h, 06Fh, 0A8h
L6978:  .byte   06Fh, 0ADh, 06Fh, 0BEh, 06Fh, 0D9h, 06Fh, 0E2h
L6980:  .byte   06Fh, 0F3h, 06Fh, 00Ah, 070h, 015h, 070h ; 158
        .word   07028h  ;159
L6988:  .byte   03Bh, 070h, 04Ah, 070h, 053h, 070h, 05Eh
L6990:  .byte   070h, 06Dh, 070h, 07Ch, 070h, 08Fh, 070h, 0A2h
L6998:  .byte   070h, 0B7h, 070h, 0BEh, 070h, 0C5h, 070h, 0D0h
L69A0:  .byte   070h, 0D7h, 070h, 0E4h, 070h, 0EBh, 070h, 0FAh
L69A8:  .byte   070h, 015h, 071h, 020h, 071h, 02Fh, 071h, 044h
L69B0:  .byte   071h
L69B1:  DW   07151h   ; A3 "Diag"
        DW   07160h, 07165h, 0717Ch
L69B8:  .byte   085h, 071h, 08Ch, 071h, 095h, 071h, 09Ch
L69C0:  .byte   071h, 0A5h, 071h, 0ACh, 071h, 0BBh, 071h, 0C2h
L69C8:  DB   071h, 0CDh, 071h, 0D6h, 071h, 0DFh, 071h, 0E6h, 071h
L69D0:  DW   071EBh, 071F6h


; ---------------------------------------------------
;               Phrase Variables
; ---------------------------------------------------
PAUSE    EQU  01000h
PLURAL   EQU  04000h
; ---------------------------------------------------
;                   Phrases
; ---------------------------------------------------
PHRASE00:
L69D5:  DB   6  ; "Type In Your Name For Me"
        DW   PAUSE|WORD042, PAUSE|00043h, PAUSE|00038h, 0203Ah, 01804h, 00844h
PHRASE01:
L69E2:  DB   6  ; "Spell Your Name On My Keyboard"
        DW   PAUSE|WORD045, 00838h, 0203Ah, PAUSE|00846h, 00847h, 00048h
PHRASE02:
L69EF:  DB   4  ; "Enter Your Name Please"
        DW   PAUSE|00024h, PAUSE|00038h, 0203Ah, 00837h 
PHRASE03:
L69F8:  DB   4  ; "Please Enter Your Name"
        DW   02037h, PAUSE|00824h, 00838h, 0003Ah         
PHRASE04:
L6A01:  DB   6  ; "That Too Many Letter Try Again"
        DW   PLURAL|00850h, 01802h, 0084Bh, PLURAL|0204Ch, 00058h, 0084Eh
PHRASE05:
L6A0E:  DB   5  ; "Sorry Make It Shorter Please"
        DW   0204Fh, PAUSE|008A2h, 0086Bh, 00051h, 00837h
PHRASE06:
L6A19:  DB   9  ; "I Can't Hold That Many Letter Try Again And" 
        DW   PAUSE|00012h, 00054h, 01055h, 01850h, 0084Bh, PLURAL|0204Ch, 00058h
        DW   0084Eh, 00859h
PHRASE07:
L6A2C:  DB   5  ; "That Too Much For Me"
        DW   PLURAL|00850h, PAUSE|00002h, 0085Ah, PAUSE|00804h, 02844h
PHRASE08:        
L6A37:  DB   8  ; "(#) Does That Sound Right Too You (#)"
        DW   020C1h, 0005Dh, 01850h, 0185Eh
        DW   0185Fh, 01802h, 0201Eh, 030C1h
PHRASE09:
L6A48:  DB   6  ; "(#) Was That O K (#)"
        DW   020C1h, 00860h, 00850h, 01018h, 00014h, 030C1h
PHRASE0A:
L6A55:  DB   8  ; "(#) Did I Say Your Name Right (#)"
        DW   020C1h, 01861h, 01012h, 01862h
        DW   00038h, 0003Ah, 0285Fh, 030C1h
PHRASE0B:        
L6A66:  DB   9  ; "(#) Do You Like The Sound Of That (#)"
        DW   020C1h, 01074h, 0381Eh, 01863h
        DW   00839h, 0105Eh, 01864h, 02850h, 030C1h
PHRASE0C:
L6A79:  DB   7  ; "You Can Spell Your Name Can't You"
        DW   0101Eh, 00065h, 00845h
        DW   00838h, 0203Ah, 01854h, 0301Eh
PHRASE0D:
L6A88:  DB   8  ; "Only Letter A Thru Z Please Try Again"
        DW   0003Bh, 0484Ch, 0000Ah, 00841h
        DW   00023h, 02837h, 00058h, 0204Eh
PHRASE0E:        
L6A99:  DB   7  ; "I Want Your Name Not Your Number"
        DW   01012h, 01866h, 00838h
        DW   0203Ah, 01067h, 00838h, 00068h
PHRASE0F:
L6AA8:  DB   5  ; "Just The Letter This Time"
        DW   01069h, 01839h, 0604Ch, 0106Ah, 0083Dh
PHRASE10:
L6AB3:  DB   5  ; "Enter Yes Or No (%)"
        DW   00024h, 01026h, 01040h, 02027h, 000A0h
PHRASE11:        
L6ABE:  DB   9  ; "It A Simple Choice (%) Enter Yes Or No"
        DW   PLURAL|0006Bh, 0180Ah, 0106Ch, 0206Dh
        DW   020A0h, 00824h, 01026h, 01040h, 00827h
PHRASE12:
L6AD1:  DB   5  ; "Yes Or No Only Please"
        DW   01026h, 01040h, 00027h, 0203Bh, 00837h
PHRASE13:        
L6ADC:  DB   6  ; "Please Enter Yes Or No (%)"
        DW   00837h, 00024h, 01026h
        DW   01040h, 00027h, 000A0h
PHRASE14:
L6AE9:  DB   4  ; "Don't Be Shy (%)"
        DW   0186Fh, 0000Bh, 00070h, 000A0h
PHRASE15:        
L6AF2:  DB   7  ; "Did You Go To The Bathroom (%)"
        DW   01861h, 0001Eh, 010A4h
        DW   00002h, 00839h, 020A5h, 030A0h
PHRASE16:
L6B01:  DB   4  ; "Are You Sleeping (%)"
        DW   0101Bh, 0001Eh, 02871h, 030A0h
PHRASE17:        
L6B0A:  DB   4  ; "Act Lively Now (%)"
        DW   00072h, 00073h, 0286Eh, 000A0h
PHRASE18:        
L6B13:  DB   7  ; "You Do Have A Name Don't You"
        DW   0181Eh, 01074h, 00075h, 01056h
        DW   0203Ah, 0086Fh, 0301Eh
PHRASE19:        
L6B22:  DB   5  ; "Type In Your Name First"
        DW   01042h, 01843h, 01038h, 0003Ah, 00876h
PHRASE1A:        
L6B2D:  DB   5  ; "That Won't Do Name Less"
        DW   01850h, 0088Dh, 02074h, 0183Ah, 0004Ah
PHRASE1B:
L6B38:  DB   3  ; "Try Again (%)"
        DW   00058h, 0284Eh, 000A0h
PHRASE1C:
L6B3F:  DB   4  ; "You Have Nothing (%)"
        DW   0101Eh, 00875h, 0207Ah, 000A0h
PHRASE1D:
L6B48:  DB   5  ; "You Have No Item (%)"
        DW   0001Eh, 00075h, 00827h, 0609Ah, 000A0h
PHRASE1E:
L6B53:  DB   6  ; "You Are Empty Handed"
        DW   0001Eh, 0001Bh, 01016h
        DW   0001Dh, 02080h, 000A0h
PHRASE1F:
L6B60:  DB   6  ; "You Have Lot Of Nothing (%)"
        DW   0101Eh, 00075h, 04881h
        DW   01864h, 0207Ah, 000A0h
PHRASE20:
L6B6D:  DB   4  ; "(%) You Only Have"
        DW   020A0h, 0101Eh, 0183Bh, 02875h
PHRASE21:
L6B76:  DB   4  ; "(%) You Now Have"
        DW   020A0h, 0181Eh, 0006Eh, 02875h
PHRASE22:
L6B7F:  DB   11 ; "Type An A For AM Or P For PM"
        DW   00042h, 00882h, 0000Ah, 00804h
        DW   0180Ah, 02816h, 00040h, 00019h
        DW   01804h, 01819h, 00816h
PHRASE23:
L6B96:  DB   6  ; "Please Type A Number For The"
        DW   00037h, 01842h, 0080Ah
        DW   00068h, 01004h, 00839h
PHRASE24:        
L6BA3:  DB   4  ; "Please Type Number Only"
        DW   00037h, 00842h, 04068h, 0003Bh
PHRASE25:
L6BAC:  DB   5  ; "Sorry Your Number Is Too"
        DW   0204Fh, 00038h, 00068h, 0087Ch, 00002h
PHRASE26:
L6BB7:  DB   7  ; "I Have A Pointer For You (%)"
        DW   00012h, 01875h, 0080Ah, 00033h
        DW   01804h, 0281Eh, 000A0h
PHRASE27:
L6BC6:  DB   4 ; "Do You Want It"
        DW   01074h, 0081Eh, 01066h, 0386Bh
PHRASE28:
L6BCF:  DB   5 ; "But It Will Cost You"
        DW   00057h, 0186Bh, 0087Bh, 0007Fh, 0001Eh
PHRASE29:
L6BDA:  DB   6  ; "(n) Points Do You Want It"
        DW   000E6h, 02089h, 01074h
        DW   0081Eh, 00866h, 0306Bh
PHRASE2A: 
L6BE7:  DB   8  ; "I Guess You Don't Want A Pointer (%)"
        DW   00012h, 0188Bh, 0081Eh, 0086Fh
        DW   01066h, 0000Ah, 02833h, 000A0h
PHRASE2B:
L6BF8:  DB   8  ; "O K  Sleeping Beauty No Pointer For You"
        DW   01018h, 02014h, 00071h, 0288Ch
        DW   01827h, 00033h, 00804h, 0201Eh
PHRASE2C:
L6C09:  DB   9  ; "O K I Won't Give You The Pointer (%)"
        DW   01018h, 02014h, 00812h, 0088Dh, 01077h
        DW   0181Eh, 01039h, 02033h, 000A0h
PHRASE2D:
L6C1C:  DB   4  ; "Try A Different Spelling"
        DW   00058h, 0180Ah, 0008Eh, 00079h
PHRASE2E:
L6C25:  DB   5  ; "Spell It Like It Sound"
        DW   00045h, 0186Bh, 01863h, 0086Bh, 0405Eh
PHRASE2F:
L6C30:  DB   2  ; "Spell Creatively"
        DW   00045h, 00090h
PHRASE30:
L6C35:  DB   5  ; "Sorry (%) You Don't Have"
        DW   0004Fh, 020A0h, 0101Eh, 0086Fh, 00075h
PHRASE31:
L6C40:  DB   4  ; "Won't Work Here (%)"
        DW   0088Dh, 00092h, 02093h, 000A0h
PHRASE32:
L6C49:  DB   7  ; "You Don't Have That Choice Here (%)"
        DW   0101Eh, 0086Fh, 00075h
        DW   00850h, 0006Dh, 02893h, 000A0h
PHRASE33:
L6C58:  DB   4  ; "(%) You Are Wounded"
        DW   020A0h, 0101Eh, 0081Bh, 00094h
PHRASE34:
L6C61:  DB   8  ; "Choose The Item You Want To Drop (%)"
        DW   00099h, 00839h, 0009Ah, 0101Eh
        DW   01066h, 00802h, 02896h, 000A0h
PHRASE35:
L6C72:  DB   5  ; "Press The Key To Update"
        DW   000C6h, 00839h, 000C7h, 00802h, 000D2h
PHRASE36:
L6C7D:  DB   4  ; "(%) You Have Dropped"
        DW   020A0h, 0001Eh, 00875h, 0089Ch
PHRASE37:
L6C86:  DB   3  ; "Welcome To Halcyon"
        DW   00035h, 00802h, 02036h
PHRASE38:
L6C8D:  DB   5  ; "(%) Your Score Is (n)"
        DW   020A0h, 00038h, 0009Dh, 0087Ch, 000E6h
PHRASE39:
L6C98:  DB   7  ; "(%) You Must Drop Something To Get"
        DW   020A0h, 0001Eh, 00895h, 00096h
        DW   00097h, 00802h, 0089Fh
PHRASE3A:
L6CA7:  DB   1  ; "(#)"
        DW   000C1h
PHRASE3B:  
L6CAA:  DB   4  ; "Please Insert The Disc"
        DW   00037h, 000D3h, 00839h, 000D5h
PHRASE3C:  
L6CB3:  DB   4  ; "Please Remove The Disc"
        DW   00837h, 000D4h, 00839h, 000D5h
PHRASE3D:          
L6CBC:  DB   4  ; "Make Another Choice (%)"
        DW   000A2h, 000A3h, 0206Dh, 000A0h
PHRASE3E:          
L6CC5:  DB   5  ; "That Won't Work Here (%)"
        DW   00050h, 0008Dh, 00092h, 02893h, 000A0h
PHRASE3F: 
L6CD0:  DB   3  ; "Thank You (%)"
        DW   0003Fh, 0281Eh, 000A0h
PHRASE40:
L6CD7:  DB   6  ; "Please Plug In The Keyboard (%)"
        DW   00037h, 008A6h, 00043h
        DW   00839h, 02048h, 000A0h
PHRASE41:
L6CE4:  DB   4  ; "(%) Repeat After Me"
        DW   020A0h, 000A7h, 000A8h, 02044h
PHRASE42:
L6CED:  DB   4  ; "(%) Can You Say"
        DW   020A0h, 01865h, 0101Eh, 02862h
PHRASE43:
L6CF6:  DB   2  ; "(%) Say"
        DW   020A0h, 02062h
PHRASE44:
L6EFB:  DB   3  ; "(%) Please Say"
        DW   020A0h, 00037h, 02062h
PHRASE45:
L6D02:  DB   2  ; "Come Again"
        DW   008C8h, 0304Eh
PHRASE46:              
L6D07:  DB   1  ; "First"
        DW   00076h
PHRASE47:
L6D0A:  DB   1  ; "Second"
        DW   000BCh
PHRASE48:
L6D0D:  DB   1  ; "Third"
        DW   000BDh
PHRASE49:
L6D10:  DB   2  ; "Four Th"
        DW   01004h, 00034h
PHRASE4A:
L6D15:  DB   2  ; "Fif Th"
        DW   0102Ch, 00034h
PHRASE4B:
L6D1A:  DB   2  ; "Six Th"
        DW   01006h, 00034h
PHRASE4C: 
L6D1F:  DB   2  ; "Seven Th"
        DW   01007h, 00034h
PHRASE4D:
L6D24:  DB   2  ; "Eight Th"
        DW   01008h, 00034h
PHRASE4E:
L6D29:  DB   2  ; "Nine Th"
        DW   01009h, 00034h
PHRASE4F:
L6D2E:  DB   2  ; "Ten Th"
        DW   01028h, 00034h
PHRASE50:
L6D33:  DB   2  ; "Eleven Th"
        DW   01029h, 00034h
PHRASE51:
L6D38:  DB   2  ; "Twelve Th"
        DW   0102Ah, 00034h
PHRASE52:
L6D3D:  DB   3  ; "Thir Teen Th"
        DW   0102Bh, 0102Dh, 00034h
PHRASE53:
L6D44:  DB   3  ; "Four Teen Th"
        DW   01004h, 0102Dh, 00034h
PHRASE54:
L6D4B:  DB   3  ; "Fif Teen Th"
        DW   0102Ch, 0102Dh, 00034h
PHRASE55:
L6D52:  DB   3  ; "Six Teen Th"
        DW   01006h, 0102Dh, 00034h
PHRASE56:
L6D59:  DB   3  ; "Seven Teen Th"
        DW   01007h, 0102Dh, 00034h
PHRASE57:
L6D60:  DB   3  ; "Eight Teen Th"
        DW   01008h, 0102Dh, 00034h
PHRASE58:
L6D67:  DB   3  ; "Nine Teen Th"
        DW   01009h, 0102Dh, 00034h
PHRASE59:
L6D6E:  DB   3  ; "Too Day Is"
        DW   01002h, 0003Eh, 0007Ch
PHRASE5A:
L6D75:  DB   4  ; "You Are Now In"
        DW   0101Eh, 0081Bh, 0086Eh, 00043h
PHRASE5B:
L6D7E:  DB   15 ; "If I Have Your Voice Print Please Say Your Name Or Else Press Any Key"
        DW   000C2h, 01012h, 01875h, 00038h, 010C3h
        DW   020C4h, 00837h, 01862h, 00038h, 0203Ah
        DW   00040h, 010C5h, 008C6h, 008ECh, 008C7h
PHRASE5C:
L6D9D:  DB   5  ; "I Don't Remember Your Voice"
        DW   00012h, 0086Fh, 000CAh, 00038h, 000C3h
PHRASE5D:
L6DA8:  DB   9  ; "Do You Want To Make A Voice Print (%)"
        DW   01074h, 0001Eh, 01066h, 00002h
        DW   000A2h, 0000Ah, 000C3h, 000C4h, 030A0h
PHRASE5E:
L6DBB:  DB   8  ; "I See You Have Played Be Fore (#)"
        DW   01012h, 0000Ch, 0001Eh, 00875h
        DW   000CBh, 0180Bh, 02804h, 000C1h
PHRASE5F:
L6DEC:  DB   4  ; "What Did You Say"
        DW   000C9h, 01861h, 0181Eh, 03862h
PHRASE60:
L6DD5:  DB   2  ; "Say Again"
        DW   00062h, 0384Eh
PHRASE61:
L6DDA:  DB   8  ; "Do You Want To Continue Your Game (%)"
        DW   00074h, 0101Eh, 01066h, 00002h
        DW   00898h, 00038h, 000D1h, 030A0h
PHRASE62:
L6DEB:  DB   9  ; "O K (%) I Will Start You Over Again"
        DW   01018h, 00014h, 020A0h, 00012h, 0087Bh
        DW   0185Bh, 0101Eh, 0005Ch, 0084Eh
PHRASE63:
L6DEE:  DB   8  ; "Do You Want To See Your Item (%)"
        DW   00074h, 0101Eh, 01066h, 01802h
        DW   0080Ch, 00038h, 0609Ah, 030A0h
PHRASE64:
L6E0F:  DB   6  ; "Give Me A Number For The"
        DW   00077h, 01844h, 0080Ah
        DW   00068h, 00004h, 00839h
PHRASE65:
L6E1C:  DB   6  ; "Type In A Number For The"
        DW   00042h, 00843h, 0080Ah
        DW   00068h, 00804h, 00839h
PHRASE66:
L6E29:  DB   7  ; "Your Name Sounds French To Me (%)"
        DW   00038h, 0083Ah, 000D6h
        DW   000D7h, 01002h, 02044h, 000A0h
PHRASE67:
L6E38:  DB   4  ; "Are You French (%)"
        DW   0101Bh, 0001Eh, 020D7h, 030A0h
PHRASE68:
L6E41:  DB   5  ; "(%) Sounds Fitting To Me"
        DW   000A0h, 0405Eh, 00109h, 00802h, 00844h
PHRASE69:
L6E4C:  DB   5  ; "Do You Want To Play"
        DW   00074h, 0001Eh, 01066h, 00002h, 008D9h
PHRASE6A:
L6E57:  DB   6  ; "Press The Halycon Key For Instructions"
        DW   000C6h, 00839h, 00036h
        DW   000C7h, 01804h, 000DAh
PHRASE6B:
L6E64:  DB   3  ; "The Time Is"
        DW   00839h, 0003Dh, 0087Ch
PHRASE6C:
L6E6B:  DB   2  ; "Last Played"
        DW   010DBh, 000CBh
PHRASE6D:
L6E70:  DB   6  ; "And Has Made A Voice Print"
        DW   00859h, 000DCh, 010DDh
        DW   0080Ah, 010C3h, 000C4h
PHRASE6E:
L6E7D:  DB   5  ; "You Have (n) Lives Left"
        DW   0001Eh, 00075h, 000E6h, 008E8h, 000EBh
PHRASE6F:
L6E88:  DB   5  ; "Please Insert The Disk For"
        DW   00037h, 010D3h, 00839h, 000D5h, 00804h
PHRASE70:
L6E93:  DB   3  ; "Part (n) Of"
        DW   000E5h, 000E6h, 00864h
PHRASE71:
L6E9A:  DB   5  ; "Can I Call You (*)"
        DW   01865h, 00012h, 018E7h, 0081Eh, 0009Bh
PHRASE72:
L6EA5:  DB   3  ; "O K (*)"
        DW   01018h, 02014h, 0009Bh
PHRASE73:
L6EAC:  DB   5  ; "Player Error Check The Player"
        DW   00052h, 02078h, 0108Fh, 01839h, 00052h
PHRASE74:
L6EB7:  DB   14  ; "I See You All Ready Have A Voice Print You May Use The Microphone"
        DW   01012h, 0080Ch, 0081Eh, 000EAh
        DW   008CDh, 00075h, 0180Ah, 010C3h
        DW   020C4h, 0181Eh, 000ADh, 008CEh
        DW   01839h, 000CFh
PHRASE75:
L6ED4:  DB   15  ; "Last Time You Played You Lost All Your Lives For I Will Start You Over"
        DW   000DBh, 0183Dh, 0081Eh, 000CBh, 0081Eh
        DW   000DEh, 018EAh, 00038h, 020E8h, 00104h
        DW   00012h, 0087Bh, 0105Bh, 0081Eh, 0085Ch
PHRASE76:
L6EE3:  DB   8  ; "Last Time You Played Your Score Was (n)"
        DW   018DBh, 0103Dh, 0001Eh, 008CBh
        DW   01038h, 0189Dh, 00860h, 000E6h
PHRASE77:
L6F04:  DB   5  ; "Choose The Item To Combine"
        DW   00099h, 00839h, 0489Ah, 01802h, 000E3h
PHRASE78
L6F0F:  DB   4  ; "Is Not Here (%)"
        DW   0007Ch, 00867h, 00893h, 000A0h
PHRASE79:
L6F18:  DB   9  ; "Please Turn Off The Power And Reinsert The Cartridge"
        DW   02037h, 000DFh, 018E0h, 01839h, 000E1h
        DW   01859h, 000E2h, 01839h, 000D0h
PHRASE7A:
L6F2B   DB   5  ; "You Can Continue Now (%)" 
        DW   0101Eh, 00865h, 00098h, 0286Eh, 000A0h
PHRASE7B:
L6F36:  DB   5  ; "I Have Saved Your Game"
        DW   00012h, 00075h, 000EEh, 01038h, 000D1h
PHRASE7C:
L6F41:  DB   6  ; "Do You Want To Continue Playing"
        DW   01074h, 0081Eh, 01066h
        DW   00802h, 00898h, 000CCh
PHRASE7D:
L6F49:  DB   5  ; "Out Of A Possible (n)"
        DW   000F0h, 01864h, 0080Ah, 000EFh, 000E6h
PHRASE7E:
L6F59:  DB   5  ; "Please Wait For Player Verification"
        DW   00037h, 010F1h, 00804h, 00052h, 000F2h
PHRASE7F:
L6F64:  DB   6  ; "You Have But One Life Left"
        DW   0001Eh, 00075h, 00857h
        DW   00001h, 000E9h, 008EBh
PHRASE80:
L6F71:  DB   5  ; "This Is Your Last Chance"
        DW   0086Ah, 0187Ch, 00038h, 000DBh, 000F3h
PHRASE81:
L6F7C:  DB   5  ; "That Was Your Last Chance"
        DW   00050h, 01860h, 00038h, 008DBh, 000F3h
PHRASE82:
L6F87:  DB   4  ; "Please Enter The Date"
        DW   00037h, 00824h, 00839h, 0003Ch
PHRASE83:
L6F90:  DB   9  ; "I See You Have No Disc In The Player"
        DW   01012h, 0180Ch, 0081Eh, 00075h, 00827h
        DW   008D5h, 00843h, 00839h, 00052h
PHRASE84:
L6FA3:  DB   2  ; "Sorry The"
        DW   0004Fh, 00839h
PHRASE85:
L6FA8:  DB   2  ; "Is To"
        DW   0087Ch, 00002h
PHRASE86:
L6FAD:  DB   8  ; "Do You Want To Update All The Word"
        DW   01074h, 0081Eh, 01066h, 00802h
        DW   008D2h, 000EAh, 00839h, 040F4h
PHRASE87:
        DB   13  ; "Do You Have An R D I Or L D 7 Hundred Player"
        DW   01074h, 0081Eh, 00075h, 02882h, 0081Bh
        DW   0080Dh, 02812h, 02040h, 00815h, 0080Dh
        DW   01807h, 00830h, 03052h
PHRASE88:
L6FD9:  DB   4  ; "Type In Your Message"
        DW   00042h, 01843h, 00038h, 000F5h
PHRASE89:
        DB   8  ; "You Need A Voice Print To Update (%)"
        DW   0101Eh, 00049h, 00056h, 010C3h
        DW   000C4h, 00802h, 000D2h, 000A0h
PHRASE8A:        
L6FF3:  DB   11  ; "Remote Control Mode Make Sure The Over Lay Is Remove Dh"
        DW   000F7h, 000F6h, 020F8h, 000A2h
        DW   010F9h, 00039h, 0185Ch, 000FAh
        DW   0007Ch, 000D4h, 00053h
PHRASE8B:
        DB   5  ; "Sorry (%) No Pointer Here"
        DW   0204Fh, 000A0h, 00827h, 04033h, 00893h
PHRASE8C:
L7015:  DB   9  ; "I Do Not Believe You Need A Pointer (%)"
        DW   00012h, 01874h, 00867h, 000FCh, 0181Eh
L7020:  DW   00849h, 0080Ah, 02033h, 000A0h
PHRASE8D:
L7028:  DB   9  ; "(%) I Only Give Pointer When You Need Them"
        DW   000A0h, 00012h, 0083Bh, 00077h
        DW   04033h, 0108Ah, 0181Eh, 00849h
        DW   000EDh
PHRASE8E:
        DB   7  ; "You Must Learn On Your Own (%)"
        DW   0001Eh, 00895h, 000FDh, 01846h
        DW   00038h, 020FEh, 000A0h
PHRASE8F:
L704A:  DB   4  ; "(#) Describe You Well"
        DW   000C1h, 04108h, 0081Eh, 0090Ah
PHRASE90:
L7053:  DB   5   ; "Press Any Key To Continue"
        DW   000C6h, 000ECh, 000C7h, 00802h, 00898h
PHRASE91:
L705E:  DB   7   ; "I Am Halcyon Welcome To The Future"
        DW   00012h, 00816h, 02036h, 00035h
        DW   00802h, 00839h, 0090Dh
PHRASE92:
        DB   7  ; "Would You Like To Play Halcyon (#)"
        DW   0010Ch, 0081Eh, 00863h, 00802h
        DW   000D9h, 00036h, 030C1h
PHRASE93:
        DB   9  ; "O K Let Me Know When You Are Ready"
        DW   00018h, 02814h, 0010Bh, 00844h, 00827h
        DW   0108Ah, 0081Eh, 0081Bh, 008CDh
PHRASE94:
        DB   9  ; "Do You Have A V P 1 Thousand Player" 
L7090:  DW   01074h, 0081Eh, 00075h, 0080Ah, 0001Fh
        DW   00819h, 00801h, 00031h, 03052h
PHRASE95:
        DB   10  ; "I Assume You Have An L D Eleven Hundred Player"
        DW   00012h, 0010Eh, 0081Eh, 00075h, 00082h
        DW   00015h, 0080Dh, 00029h, 00830h, 00052h
PHRASE96:
L70B7:  DB   3  ; "Speak Consistently (%)"
        DW   00111h, 0211Ch, 000A0h
PHRASE97:
        DB   3  ; "Speak Plainly (%)"
        DW   00111h, 02112h, 000A0h
PHRASE98:
        DB   5  ; "Relax And Try Again (%)"
        DW   00113h, 00059h, 00058h, 0204Eh, 000A0h
PHRASE99:
L70D0:  DB   3  ; "Speak Calmly (%)"
        DW   00111h, 02114h, 000A0h
PHRASE9A:
L70D7:  DB   6  ; "Nice To See You Again (#)"
        DW   0011Ah, 00802h, 0100Ch
        DW   0081Eh, 0204Eh, 000C1h
PHRASE9B:  ; <-------- 9C?
        DB   3  ; "Welcome Back (#)" 
        DW   00035h, 0211Bh, 000C1h
PHRASE9C:
        DB   7  ; "Nice To Have You Here Again (#)"
        DW   0011Ah, 00802h, 01075h, 0081Eh
        DW   00093h, 0284Eh, 000C1h
PHRASE9D:
        DB   13  ; "Enter A Key From Five To An Nine For An Explanation Of The Function"
        DW   00024h, 0080Ah, 000C7h, 00905h, 00002h
        DW   00082h, 02009h, 00004h, 00882h, 0011Eh
        DW   00864h, 00839h, 0011Fh
PHRASE9E:
        DB   5  ; "Your Time Is Up (*)"
        DW   00038h, 0083Dh, 0087Ch, 02120h, 0009Bh
PHRASE9F:
L7120:  DB   7  ; "Congratulations (*) You Have Won Bonus Time"
        DW   02121h, 0209Bh, 0081Eh, 00875h
        DW   00122h, 00123h, 0003Dh
PHRASEA0:
        DB   10  ; "Contratulations (*) You Have Improved Your Old High Score Of" 
        DW   02121h, 0209Bh, 0001Eh, 00875h
        DW   00124h, 00838h, 00126h, 00125h
        DW   0009Dh, 00864h
PHRASEA1:
L7144:  DB   6  ; "With A New High Score Of"
        DW   00128h, 0080Ah, 00127h
        DW   00125h, 0009Dh, 00864h
PHRASEA2:
L7151:  DB   7  ; "(%) You Must Drop Still Another Item" 
        DW   020A0h, 0001Eh, 00895h, 00096h
        DW   00132h, 008A3h, 0009Ah
PHRASEA3:
L7160:  DB   2  ; "Diagnostic Test"
        DW   00136h, 04129h
PHRASEA4:
L7165:  DB   11  ; "Menu Mode Press Key A Through G To Choose A Test"
        DW   00137h, 020F8h, 000C6h, 048C7h, 0000Ah, 0012Eh
        DW   00010h, 00802h, 01099h, 0080Ah, 00129h
PHRASEA5:
L717C:  DB   4  ; "Start Of RAM Test"
        DW   0005Bh, 00864h, 00134h, 00129h
PHRASEA6:
L7185:  DB   3  ; "RAM Test Complete"
        DW   00134h, 00129h, 0012Ch
PHRASEA7:
L718C:  DB   4  ; "Start Of ROM Test"
        DW   0005Bh, 00864h, 00135h, 00129h
PHRASEA8:
L7195:  DB   3  ; "ROM Test Complete"
        DW   00135h, 00129h, 0012Ch
PHRASEA9:
        DB   4  ; "Start Of Display Test"
        DW   0005Bh, 00864h, 00139h, 00129h
PHRASEAA:        
        DB   3  ; "Display Test Complete"
        DW   00139h, 00129h, 0012Ch
PHRASEAB:
        DB   7  ; "Test All The Key On The Keyboard"
        DW   00129h, 008EAh, 00839h, PLURAL|000C7h
        DW   00846h, 00839h, 00048h
PHRASEAC:        
        DB   3  ; "Keyboard Test Complete"
        DW   00048h, 00129h, 0012Ch
PHRASEAD:        
        DB   5  ; "Start Of Communication Link Test"
        DW   0005Bh, 00864h, 0413Bh, 0013Ch, 00129h
PHRASEAE:        
        DB   4  ; "Communication Link Test Complete"
        DW   0413Bh, 0013Ch, 00129h, 0012Ch
PHRASEAF:        
        DB   4  ; "Start Of Monitor Test"
        DW   0005Bh, 00864h, 0013Ah, 00129h
PHRASEB0:
        DB   3  ; "Monitor Test Complete"
L71E0:  DW   0013Ah, 00129h, 0012Ch
PHRASEB1:
        DB   2  ; "Restarting Diagnostics"
        DW   00141h, 00136h
PHRASEB2:        
        DB   5  ; "Disc Spinning Up Please Wait"
        DW   000D5h, 0013Eh, 02120h, 00037h, 008F1h
PHRASEB3:
L71F6:  DB   2  ; "Initializing System"
        DW   0013Fh, 00140h





; ---------------------------------------------------
;                   Garbage
; ---------------------------------------------------
        DB   0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
L7202:  DB   0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh








;----------------------------------------------------
; Disassembly of the Thayer's Quest Cartridge ROM
;----------------------------------------------------
        org     0C000h
        CPU     = Z180
        globals on

;----------------------------------------------------
;           Definitions
;----------------------------------------------------
FREE      EQU  000h


;----------------------------------------------------
;            LaserDisc Frame Numbers
;----------------------------------------------------
LC000:  DB  002h    ; Number of lives at continue
LC001:  DB  003h    ; Number of lives at start
LC002:  DB  002h    ; unknown 
LC003:  DB  000h, 0C3h, 050h  ; 50,000 Possible Points
LC006:  DW  0FF45h  ; Cartridge ROM Checksum
LC008:  DW  0C06Dh  ; "Begin Diagnostics, RAM Test in Progress"
LC00A:  DB  00Ah    ; Number of Frames between Diagnostic Message Scenes
LC00B:  DW  0C0A9h  ; "RAM Test failed"
LC00D:  DW  0C0B3h  ; "ROM Checksum failed, Display indicates bad block"
LC00F:  DW  0C0BDh  ; "Cartridge ROM Checksum Failed"
LC011:  DW  03015h  ; Scene of Thayer Underwater used for Monitor Test
LC013:  DW  002B8h  ; "Thayer's Quest" first scene
LC015:  DW  0C0D1h  ; Attract Mode beginning
LC017:  DW  004CEh  ; Attract Mode time (40.5 sec)
LC019:  DW  0C00Bh  ; "Insert 1 Token for 3 units of play time" 
LC01B:  DW  0BFCFh  ; "Insert additional quarters for more play"
LC01D:  DW  0C033h  ; "Congrats, you've mastered 1st part"
LC01F:  DW  0C1B2h  ; Phrase Table 2 Location
LC021:  DW  0C4E7h  ; Word Table 2 Location
LC023:  DW  0C0F7h  ; Hint Table Location (Audio Track 1)
LC025:  DW  0C170h  ; Hint Table Location (Audio Track 2)
LC027:  DW  0D000h  ; Start of Scene Data (Audio Track 1)
LC029:  DW  0D800h  ; Start of Scene Data (Audio Track 2)
LC02B:  DW  0C743h  ;
LC02D:  DB  0DFh, 0C7h
        DW  05Fh, 0C9h
LC033:  DW  087h, 0C9h
                    ; extra DW  0C996h
LC037:  DW  0C9A5h  ; Combine Item Table
LC039:  DW  0C9CDh  ; Item Frame Number Table
        DW  0CA05h  ; Player Ranking Frame Number Table


;----------------------------------------------------
;          Address Jump Table A (8 Routines)
;----------------------------------------------------
LC03D:  DW  01B90h  ; #0 Attract Mode Loop
        DW  00868h  ; #1 Enter Name in Keyboard
        DW  00E4Bh  ; #2 Unknown
        DW  00471h  ; #3 Unknown
        DW  005EEh  ; #4 Unknown
        DW  00AD5h  ; #5 Begin Play Scene with Timer
        DW  001B0h  ; #6 Unknown
        DW  00173h  ; #7 Begin Jump Table B

;----------------------------------------------------
;          Address Jump Table B (25 Routines)
;----------------------------------------------------
LC04D:  DW  L0BB9   ; #0 Test for Game Over (Clock Expired)
LC04F:  DW  L0E66   ; #1 Giving Hints
        DW  L0B01   ; #2 Check if Player has Died

        DW  L0BB9   ; #3 Test for Game Over (Clock Expired)
        DW  L06A3   ; #4 Check for Wounds
        DW  L0BD8   ; #5 Finished 1st part of Game
        DW  L05BC   ; #6 Healing Place gives Full Strength
        DW  L067B   ; #7 Unknown
        DW  L0542   ; #8 Unknown

        DW  L0516   ; #9 Unknown
        DW  L04FF   ; #10 Setup Timed Decision Timer

        DW  L0BB9   ; #11 Test for Game Over (Clock Expired)
        DW  L0DBF   ; #12 Check Keyboard
        DW  L1A3A   ; #13 Get Choice at Decision Point
        DW  L07AB   ; #14 Check if player pressed an ITEM key
        DW  L04E4   ; #15 Check if Decision Timer is running
        DW  L0574   ; #16 Unknown

        DW  L0CE7   ; #17 Check Button: ITEMS
        DW  L0D89   ; #18 Check Button: GIVE SCORE
        DW  L0828   ; #19 Check Button: DROP ITEM
        DW  L05D3   ; #20 Check Button: REPLAY
        DW  L0E97   ; #21 Check Button: COMBINE ACTION
        DW  L0DE6   ; #22 Check Button: SAVE GAME
        DW  L0E31   ; #23 Check Button: UPDATE
        DW  L0DCC   ; #24 Check Button: HINT




; ---------------------------------------------------
;            Begin Main Routine Cycle
; ---------------------------------------------------
LC07F:  JP      L013B        ; #1 Start Main Loop
LC082:  JP      L176C        ; #2 Enter Name in Keyboard
LC085:  JP      L1711        ; #3 Check if First Name Basis is okay
LC088:  JP      L0976        ; #4 Look for a Saved Game
LC08B:  JP      L089E        ; #5 Wait until System is Initialized
LC08E:  JP      L08C6        ; #6 Welcome Player Back, Check lives
LC091:  JP      L08B3        ; #7 Call BATCH 2

; ---------------------------------------------------
;           BATCH 2:  Saving BANKS
; ---------------------------------------------------
LC094:  JP      L09DA        ; #8
LC097:  JP      L09BE        ;
LC09A:  JP      L0A4E        ; #10 Initialize data in a Game BANK
LC09D:  JP      L09A0        ; #11 routine
LC0A0:  JP      L0924        ;
LC0A3:  JP      L09CE        ; #13 Retrieve Saved BANK data

; ---------------------------------------------------
;           BATCH 3:  Handling Items
; ---------------------------------------------------
LC0A6:  JP      L09FB        ;
LC0A9:  JP      L0733        ; Dropping Items
LC0AC:  JP      L0ECD        ; Combining Items
LC0AF:  JP      L1058        ; Using or Picking up Items
LC0B2:  JP      L0F64        ;


; ---------------------------------------------------
;               Text Table Pointers
; ---------------------------------------------------
LC0B5:  DW  0C1B2h     ; Start of Phrase Table 2
LC0B7:  DW  0C4E7h     ; Word Index Table 2
LC0B9:  DW  0C0F7h     ; Hint Table (Audio Track 1)
LC0BB:  DW  0C170h     ; Hint Table (Audio Track 2)

        DB  07Bh, 002h, 07Bh
LC0C0:  DB  002h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC0C8:  DB  000h, 000h, 000h, 000h, 000h, 00Ah, 000h, 068h
LC0D0:  DB  001h, 024h, 080h, 081h, 082h, 083h


;----------------------------------------------------
;                Keyboard Keys
;----------------------------------------------------
LC0D6:  .STRING "1234567890WERTYUIOSDFGHJKZXCVBNM"
LC0F6:  DB  000h




;----------------------------------------------------
;                Hint Table (Audio Track 1)
;----------------------------------------------------
LC0F7:  DB  24   ; Number of hint in this table

        DB  048h, 001h
        DB  FREE    ; Cost
        DW  08047h  ; Hint Phrase 47h (2)

        DB  048h, 002h
        DB  0FAh    ; Cost
        DW  08048h  ; Hint Phrase 48h (2)

        DB  005h, 001h, 000h
        DW  08049h
        DB  04Eh, 001h, 000h, 04Ah, 080h
        DB  04Eh, 002h, 0FAh, 04Dh, 080h
        DB  00Ch, 001h, 000h, 04Eh, 080h
        DB  016h, 001h, 000h, 051h, 080h
        DB  00Bh, 002h, 000h, 058h, 080h
        DB  00Eh, 001h, 000h, 059h, 080h
        DB  01Eh, 001h, 000h, 053h, 080h
        DB  026h, 001h, 000h, 052h, 080h
        DB  02Ah, 001h, 000h, 05Bh, 080h
        DB  047h, 001h, 000h, 05Ch, 080h
        DB  056h, 001h, 000h, 04Ah, 080h
        DB  056h, 002h, 0DCh, 04Ch, 080h
        DB  056h, 003h, 0FAh, 04Bh, 080h
        DB  04Ch, 001h, 000h, 047h, 080h
        DB  050h, 001h, 000h, 04Fh, 080h
        DB  04Fh, 001h, 000h, 04Ah, 080h
        DB  051h, 001h, 000h, 04Ah, 080h
        DB  053h, 001h, 000h, 057h, 080h
        DB  052h, 001h, 000h, 04Ah, 080h
        DB  054h, 001h, 000h, 04Ah, 080h
        DB  055h, 001h, 000h, 04Ah, 080h




;----------------------------------------------------
;                 Hint Table (Audio Track 2)
;----------------------------------------------------
LC170:  DB  00Dh  ; Number of hints in this table (13)

        DB  012h, 001h
        DB  FREE
        DW  08050h

        DB  01Dh, 001h
        DB  FREE    ; Cost
        DW  08063h  ; Hint: "To Get The Quiod Use An Item"

        DB  008h, 003h
        DB  FREE
        DW  0805Eh

        DB  00Dh, 002h, 000h, 05Fh, 080h
        DB  030h, 003h, 000h, 060h, 080h
        DB  037h, 003h, 000h, 060h, 080h
        DB  03Ah, 003h, 000h, 060h, 080h
        DB  041h, 001h, 000h, 05Fh, 080h
        DB  014h, 003h, 000h, 062h, 080h
        DB  017h, 003h, 000h, 060h, 080h
        DB  021h, 003h, 000h, 060h, 080h
        DB  029h, 003h, 000h, 060h, 080h
        DB  02Bh, 001h, 000h, 061h, 080h



;----------------------------------------------------
;         Phrase Table 2
;----------------------------------------------------
LC1B2:  DW  99              ; Number of phrases in this table?

        DW  0C27Ch, 0C281h, 0C284h, 0C28Bh
        DW  0C294h, 0C299h, 0C2A0h, 0C2A7h
        DW  0C2AEh, 0C2B3h, 0C2B8h, 0C2BFh
        DW  0C281h, 0C2C8h, 0C2D1h, 0C2D6h
        DW  0C281h, 0C281h, 0C2DBh, 0C2E2h
        DW  0C2E7h, 0C2ECh, 0C2F3h, 0C2F8h
        DW  0C2FDh, 0C302h, 0C307h, 0C310h
        DW  0C313h, 0C316h, 0C319h, 0C31Ch
        DW  0C31Fh, 0C322h
LC1F8:  DB  027h, 0C3h, 02Ch, 0C3h, 02Fh, 0C3h, 034h, 0C3h
LC200:  DB  039h, 0C3h, 03Ch, 0C3h, 03Fh, 0C3h, 042h, 0C3h ; 41
LC208:  DB  045h, 0C3h, 04Ah, 0C3h, 04Fh, 0C3h, 052h, 0C3h ; 44
LC210:  DB  055h, 0C3h, 05Ah, 0C3h, 05Dh, 0C3h, 060h, 0C3h
LC218:  DB  063h, 0C3h, 068h, 0C3h, 06Dh, 0C3h, 072h, 0C3h
LC220:  DB  075h, 0C3h, 07Ah, 0C3h, 081h, 0C3h, 084h, 0C3h
LC228:  DB  087h, 0C3h, 08Ah, 0C3h, 08Dh, 0C3h, 092h, 0C3h
LC230:  DB  095h, 0C3h, 081h, 0C2h, 081h, 0C2h, 081h, 0C2h
LC238:  DB  081h, 0C2h, 098h, 0C3h, 0A1h, 0C3h, 0AAh, 0C3h ; 68
LC240:  DB  0B7h, 0C3h, 0C4h, 0C3h, 0CDh, 0C3h, 0D6h, 0C3h
LC248:  DB  0E1h, 0C3h, 0EAh, 0C3h, 0F3h, 0C3h, 0FEh, 0C3h
LC250:  DB  009h, 0C4h, 010h, 0C4h, 01Bh, 0C4h, 01Eh, 0C4h ; 80
LC258:  DB  029h, 0C4h, 032h, 0C4h, 03Dh, 0C4h, 042h, 0C4h
LC260:  DB  04Bh, 0C4h, 054h, 0C4h, 05Bh, 0C4h, 062h, 0C4h
LC268:  DB  069h, 0C4h, 076h, 0C4h, 081h, 0C4h, 088h, 0C4h
LC270:  DB  091h, 0C4h, 0A2h, 0C4h, 0ABh, 0C4h, 0B4h, 0C4h
LC278:  DW  0C4C5h, 0C4D8h ;98


; ---------------------------------------------------
;                   Phrases
; ---------------------------------------------------
PHRASEX000:
LC27C:  DB  2  ; "Thayer's Quest"
        DW  0C02Bh, 0802Ch
PHRASEX001:
        DB  1  ; "No"
        DW  00027h
PHRASEX002:
        DB  3  ; "The Silver Path"
        DW  00839h, 08006h, 08028h
PHRASE        
        DB  4  ; "The Spell Of Shield" <V>
        DW  00839h, 00045h, 00864h, 0801Dh
        
        DB  2  ; "The Fire" <U>
        DW  00839h, 08010h 
        
        DB  3  ; "The Black Mace" <E>
        DW  00839h, 09000h, 08001h

LC2A0:  DB  3  ; "The Hunting Horn" <F>
        DW  02839h, 08002h, 08003h

        DB  3  ; "The Oasis GuildHall" <G>
LC2A8:  DW  00839h, 0802Eh, 08023h

        DB  2  ; "The Medallion" <H> (coming in TQ2)
        DW  02839h, 08007h

        DB  2  ; "The Crown" <I> (coming in TQ2)
        DW  00839h, 08008h

LC2B8:  DB  003h, 039h, 008h, 018h, 080h, 019h, 080h, 004h
LC2C0:  DB  039h, 008h, 004h, 080h, 064h, 000h, 005h, 080h
LC2C8:  DB  004h, 039h, 008h, 045h, 000h, 064h, 000h, 01Ch
LC2D0:  DB  080h, 002h, 039h, 028h, 021h, 080h, 002h, 039h
LC2D8:  DB  008h, 00Eh, 080h, 003h, 039h, 008h, 00Ah, 090h
LC2E0:  DB  00Bh, 080h, 002h, 039h, 008h, 01Ah, 080h, 002h
LC2E8:  DB  039h, 008h, 027h, 080h, 003h, 039h, 008h, 015h
LC2F0:  DB  090h, 016h, 080h, 002h, 039h, 008h, 029h, 080h
LC2F8:  DB  002h, 039h, 018h, 012h, 080h, 002h, 039h, 000h
LC300:  DB  014h, 080h, 002h, 039h, 008h, 025h, 0C0h, 004h
LC308:  DB  039h, 008h, 045h, 000h, 064h, 000h, 01Eh, 080h
LC310:  DB  001h, 001h, 000h, 001h, 002h, 000h, 001h, 003h
LC318:  DB  000h, 001h, 004h, 000h, 001h, 026h, 010h, 001h
LC320:  DB  09Ah, 050h, 002h, 096h, 018h, 09Ah, 010h, 002h
LC328:  DB  077h, 018h, 09Dh, 010h, 001h, 0FFh, 010h, 002h
LC330:  DB  0E3h, 010h, 031h, 011h, 002h, 001h, 001h, 0D1h
LC338:  DB  018h, 001h, 0D2h, 010h, 001h, 0FBh, 000h, 001h
LC340:  DB  027h, 010h, 001h, 012h, 080h, 002h, 000h, 090h
LC348:  DB  001h, 080h, 002h, 00Ah, 090h, 00Bh, 080h

LC34F:  DB  1  ; "Misty"
LC350:  DW  08027h

LC352:  DB  1  ; "Great"
        DW  0C025h

        DB  2  ; "Seeing, Release"
        DW  08015h, 08016h
        
        DB  1  ; "Crown"
        DW  08008h
        
        DB  001h, 00Eh, 080h
LC360:  DB  001h, 01Ah, 080h, 002h, 034h, 080h, 010h, 080h
LC368:  DB  002h, 002h, 080h, 003h, 080h, 002h, 02Eh, 080h
LC370:  DB  023h, 080h, 001h, 007h, 080h, 002h, 018h, 080h
LC378:  DB  019h, 080h, 003h, 004h, 080h, 064h, 000h, 005h
LC380:  DB  080h, 001h, 01Eh, 080h, 001h, 014h, 080h, 001h
LC388:  DB  01Dh, 080h, 001h, 029h, 080h, 002h, 006h, 080h
LC390:  DB  028h, 080h, 001h, 021h, 080h, 001h, 01Ch, 080h
LC398:  DB  004h, 01Eh, 000h, 069h, 000h, 000h, 029h, 0A0h
LC3A0:  DB  000h

PHRASEX043:
LC3A1:  DB  4  ; "(%) You Just Died"
        DW  020A0h, 0001Eh, 00069h, 00900h 

PHRASEX044:
        DB  6  ; "You Just Lost A Life (%)"
        DW  0001Eh, 00069h, 010DEh, 0080Ah, 020E9h, 000A0h 
      
PHRASEX045:  
LC3B7:  DB  6  ; "(%) That Cost You A Life"
        DW  020A0h, 00850h, 0107Fh, 0001Eh, 0080Ah, 000E9h

PHRASEX046:
LC3C4:  DB  4  ; "Act Lively Next Time"
        DW  00072h, 00073h, 01102h, 0083Dh
        
PHRASEX047:
        DB  4  ;
        DW  003h, 001h, 039h, 008h, 0EBh, 010h, 02Fh, 088h, 000h

PHRASEX048:       
        DB  5
        DB  030h, 088h, 031h, 080h, 005h, 011h, 039h, 008h, 032h, 080h

LC3E1:  DB  4 ; phrasex04A
        DW  0CEh, 000h, 097h, 008h, 002h, 011h, 03Dh, 008h

        DB  4
        DW  058h, 008h, 039h, 008h, 015h, 090h, 016h, 080h

        DB  5
        DW  058h, 000h, 039h, 008h, 045h, 010h, 064h, 018h, 01Eh, 080h
        
        DB  5
        DW  058h, 000h, 039h, 008h, 00Eh, 080h, 002h, 011h, 03Dh, 008h
        
        DB  3
        DW  006h, 019h, 007h, 001h, 033h, 0B0h

LC410:  DB  5
        DW  058h, 000h, 097h, 000h, 0C5h, 010h, 002h, 011h, 03Dh, 008h
        
        DB  1 ; 50
        DW  035h, 080h

        DB  5
        DW  015h, 001h, 064h, 008h, 039h, 008h, 036h, 080h, 037h, 080h
        
        DB  4
        DW  015h, 001h, 064h, 008h, 039h, 008h, 03Eh, 0C0h
        
        DB  5
        DW  015h, 001h, 064h, 008h, 039h, 008h, 03Ch, 080h, 03Dh, 080h
        
        DB  2
        DW  072h, 010h, 017h, 001h
        
        DB  4
        DW  01Eh, 000h, 03Bh, 080h, 050h, 008h, 045h, 000h
        
        DB  4
        DW  01Eh, 000h, 03Bh, 080h, 050h, 008h, 09Ah, 000h

        DB  3
        DW  018h, 061h, 039h, 008h, 027h, 0B0h
        
        DB  3
        DW  019h, 001h, 016h, 001h, 038h, 0B0h
        
        DB  3
        DW  06Fh, 000h, 039h, 080h, 093h, 000h
        
        DB  6
        DW  0CEh, 000h, 039h, 008h, 00Eh, 080h
LC470:  DW  03Bh, 008h, 004h, 008h, 03Ah, 0C0h

        DB  5
        DW  061h, 010h, 01Eh, 008h, 03Fh, 080h, 056h, 000h, 0FBh, 030h
        
        DB  3
        DW  019h, 001h, 016h, 001h, 040h, 0B0h

PHRASEX05D: 
LC488:  DB  4  ; "You Have Been Healed" (805D) 
        DW  0001Eh, 00075h, 0011Dh, 08041h

PHRASEX05E:
LC491:  DB  8  ; "To Get The - Press The - Key"
        DW  00802h, 0009Fh, 00839h, 0A021h
        DW  000C6h, 00839h, 08021h, 000C7h
        
PHRASEX05F:
        DB  4
        DW  00Ah, 028h, 042h, 0A0h, 07Ch, 000h, 093h, 008h
        
        DB  4
        DW  082h, 008h, 09Ah, 000h, 07Ch, 000h, 093h, 008h
        
        DB  8
        DW  002h, 008h, 09Fh, 000h, 039h, 008h, 002h, 080h
        DW  003h, 0A0h, 0CEh, 000h, 039h, 008h, 027h, 080h

        DB  9  ; "To Get The Septer Use The Spell Of ?Thayer?"
        DW  00802h, 0009Fh, 00839h, 0A00Eh, 000CEh
        DW  00839h, 00045h, 00864h, 0801Eh

PHRASEX063:
LC4D8:  DB  7  ; "To Get The Quoid Use An Item"
        DW  00802h, 0009Fh, 00839h, 0A023h
        DW  000CEh, 00882h, 0009Ah


        org 0C4E7h
;----------------------------------------------------
;             Word Index Table 2
;----------------------------------------------------
LC4E7:  DW  00042h  ; Number of words in Table 2
LC4E8:  DW  0C56Fh, 0C577h, 0C57Ch, 0C586h
LC4F0:  DB  08Dh, 0C5h, 091h, 0C5h, 099h, 0C5h, 0A2h
LC4F8:  DB  0C5h, 0B1h, 0C5h, 08Dh, 0C5h, 0B7h, 0C5h, 0BEh
LC500:  DB  0C5h, 08Dh, 0C5h, 08Dh, 0C5h, 0C6h, 0C5h, 08Dh
LC508:  DB  0C5h, 0D1h, 0C5h, 08Dh, 0C5h, 0DBh, 0C5h, 08Dh
LC510:  DB  0C5h, 0E4h, 0C5h, 0EEh, 0C5h, 0F6h, 0C5h, 08Dh
LC518:  DB  0C5h, 0FBh, 0C5h, 003h, 0C6h, 008h, 0C6h, 08Dh ; 2B-> C58D
LC520:  DB  0C5h, 00Fh, 0C6h, 01Fh, 0C6h, 028h, 0C6h, 08Dh
LC528:  DB  0C5h, 08Dh, 0C5h, 032h, 0C6h, 08Dh, 0C5h, 040h
LC530:  DB  0C6h, 08Dh, 0C5h, 044h, 0C6h, 08Dh, 0C5h, 04Ch
LC538:  DB  0C6h, 056h, 0C6h, 05Ch, 0C6h, 08Dh, 0C5h, 065h
LC540:  DB  0C6h, 06Ch, 0C6h, 08Dh, 0C5h, 074h, 0C6h, 07Dh
LC548:  DB  0C6h, 083h, 0C6h, 088h, 0C6h, 08Dh, 0C6h, 09Ah
LC550:  DB  0C6h, 0A2h, 0C6h, 0A8h, 0C6h, 0C3h, 0C6h, 0CBh
LC558:  DB  0C6h, 0D5h, 0C6h, 0DDh, 0C6h, 0E6h, 0C6h, 0F4h
LC560:  DB  0C6h, 0FBh, 0C6h, 009h, 0C7h, 011h, 0C7h, 019h
LC568:  DB  0C7h, 022h, 0C7h, 02Eh, 0C7h, 03Ah, 0C7h



;----------------------------------------------------
;             Word Table 2:  Objects
;----------------------------------------------------
LC56F: 
WORDX000:   DB  7,  "BL/A/CK" 
WORDX001:   DB  4,  "MACE"
WORDX002:   DB  9,  "/H/UNTING"
WORDX003:   DB  6,  "/H/ORN"
WORDX004:   DB  3,  "ORB"
WORDX005:   DB  7,  "/KW/OED"
WORDX006:   DB  8,  "/S/ILVER"
WORDX007:   DB  14, "MEHD-A/L/-YUHN"
WORDX008:   DB  5,  "CROWN"
WORDX009:   DB  6,  "/BL/UD"
WORDX00A:   DB  7,  "/S/OERD"
WORDX00B:   DB  10, "/CRY/STULL"
WORDX00C:   DB  9,  "C/IRC/LET"
WORDX00D:   DB  8,  "AM-U-LET"
WORDX00E:   DB  9,  "SS/E/PTER"
WORDX00F:   DB  7,  "/CK/OLD"
WORDX010:   DB  4,  "FIRE"
WORDX01F:   DB  7,  "/ON/-IX"
WORDX020:   DB  4,  "SEAL"
WORDX013:   DB  6,  "DAGGER"
WORDX014:   DB  15, "UNDER/ST/ANDING"
WORDX015:   DB  8,  "/SEA/ING"
WORDX024:   DB  9,  "R/E/LEASE"
WORDX025:   DB  13, "/ST/AH-AHPHFF"
WORDX026:   DB  3,  "BOE"
WORDX027:   DB  7,  "/CK/OIN"
WORDX028:   DB  9,  "/CHA/LICE"
WORDX029:   DB  5,  "WHEAT"
WORDX02A:   DB  8,  "/SH/IELD"
WORDX02B:   DB  6,  "THAYER"
WORDX02C:   DB  7,  "QU/E/ST"
WORDX02E:   DB  8,  "/L/AANNG"
WORDX02F:   DB  5,  "/DOR/"
WORDX030:   DB  4,  "STAY"
WORDX031:   DB  4,  "AWAY"
WORDX032:   DB  12, "G/IHLD/ HALL"
WORDX033:   DB  7,  "/Q/-OOT"
WORDX034:   DB  5,  "GREAT"
WORDX035:   DB  26, "/SUH/-UH-UH/CKER-ER-ER-ER/"
WORDX036:   DB  7,  "/M/ISTY"
WORDX037:   DB  9,  "/PAH/-ATH"
WORDX038:   DB  7,  "/R/OOHD"
WORDX039:   DB  8,  "RE/T/URN"
WORDX03A:   DB  13, "IMER/J/-N-CEE"
WORDX03B:   DB  6,  "WASTED"
WORDX03C:   DB  13, "/SH/IMMER-ING"
WORDX03D:   DB  7,  "O-A-SIS"
WORDX03E:   DB  7,  "/CL/IPH"
WORDX03F:   DB  8,  "X-/P/ECT"
WORDX040:   DB  11, "FLAY-/CK/-E"
WORDX041:   DB  11, "/H/EE-EALED"
WORDX042:   DB  8,  "RE/L/-IC"



    org 0C743h
;----------------------------------------------------
;             Item Swap Properties
;----------------------------------------------------
;    3 Swap Possiblities, 2 bytes per possibility
;    Rightmost bytes checked first.
;          Byte 1 = Required Item + swap properties 
;          Byte 2 = New Scene to play
;----------------------------------------------------
LC743:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (A)  NONE
LC749:  DB  032h, 032h,   000h, 000h,   000h, 000h    ; (B) "Silver Wheat"
LC74F:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (C) "Spell of Seeing"
LC755:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (D)  NONE
LC75B:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (E) "Black Mace"
LC761:  DB  0F4h, 02Dh,   000h, 000h,   000h, 000h    ; (F) "Hunting Horn"
LC767:  DB  038h, 01Eh,   000h, 000h,   000h, 000h    ; (G) "Enchanted Bow"
LC76D:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (H)  NONE
LC773:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (I)  NONE
LC779:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (J) "Great Onyx Seal"
LC77F:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (K) "Orb of Quoid" 
LC785:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (L)  NONE
LC78B:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (M) "Spell of Understanding"
LC791:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (N) "Wood Elf Staff"
LC797:  DB  0FAh, 013h,   000h, 000h,   000h, 000h    ; (O) "Crystal of Lothar"
LC79D:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (P)  NONE
LC7A3:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (Q)  NONE
LC7A9:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (R) "Blood Sword of Elder Kings"
LC7AF:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (S)  NONE
LC7B5:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (T) "Golden Chalice"
LC7BB:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (U) "Cold Fire"
LC7C1:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (V)  NONE
LC7C7:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (W)  NONE
LC7CD:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (X) "Talisman Scepter" 
LC7D3:  DB  02Bh, 03Fh,   000h, 000h,   000h, 000h    ; (Y) "Pentacle Coins" 
LC7D9:  DB  000h, 000h,   000h, 000h,   000h, 000h    ; (Z) "Spell of Release"

;----------------------------------------------------
;          32 rows of data (12 bytes per row)
;----------------------------------------------------
LC7DF:  DB  055h, 00Ah,  02Fh, 00Bh,  0DAh, 00Ch,  0C3h, 00Ch,  0CDh, 00Ch,  000h, 000h ; (A)  NONE
LC7EB:  DB  00Fh, 001h,  000h, 000h,  0C3h, 006h,  000h, 000h,  000h, 000h,  000h, 000h ; (B) "Silver Wheat"
LC7F7:  DB  02Fh, 01Ah,  055h, 01Bh,  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h ; (C) "Spell of Seeing"
LC803:  DB  0DAh, 005h,  075h, 004h,  0C3h, 005h,  0CDh, 005h,  000h, 000h,  000h, 000h ; (D)  NONE
LC80F:  DB  000h, 000h,  038h, 025h,  0CDh, 024h,  0DAh, 026h,  0C5h, 01Fh,  0C3h, 026h ;
        DB  025h, 028h,  0CFh, 02Eh,  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h ;
        DB  0CFh, 033h,  006h, 036h,  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h ; 
        DB  0C3h, 03Dh,  0C7h, 03Ch,  0CDh, 03Dh,  0DAh, 03Dh,  000h, 000h,  000h, 000h ; 
        DB  0D9h, 049h,  0E2h, 043h,  0C5h, 04Bh,  012h, 04Ah,  000h, 000h,  000h, 000h ;
        DB  0D9h, 04Fh,  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h ;
        DB  0CEh, 003h,  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h ;
        DB  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h ;
LC86F:  DB  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h ;
        DB  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h ;
LC887:  DB  000h, 000h,  000h, 000h,  000h, 000h,  000h, 000h,  000h
LC890:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC898:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC8A0:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC8A8:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC8B0:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC8B8:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC8C0:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC8C8:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC8D0:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC8D8:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC8E0:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC8E8:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC8F0:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC8F8:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC900:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC908:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC910:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC918:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC920:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC928:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC930:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC938:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC940:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC948:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC950:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC958:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h



; ---------------------------------------------------
;         Item Property Table
; ---------------------------------------------------
LC95F:  DB  040h   ; 01000000 (A)  NONE
        DB  01Bh   ; 00011011 (B) "Silver Wheat"
        DB  03Bh   ; 00111011 (C) "Spell of Seeing"
        DB  01Bh   ; 00011011 (D)  NONE
        DB  01Bh   ; 00011011 (E) "Black Mace"
        DB  01Bh   ; 00011011 (F) "Hunting Horn"
        DB  01Eh   ; 00011110 (G) "Enchanted Bow"
        DB  01Bh   ; 00011011 (H)  NONE
        DB  01Eh   ; 00011110 (I)  NONE
        DB  01Bh   ; 00011011 (J) "Great Onyx Seal"
        DB  01Bh   ; 00011011 (K) "Orb of Quoid" 
        DB  040h   ; 01000000 (L)  NONE
        DB  03Bh   ; 01000000 (M) "Spell of Understanding"
        DB  01Eh   ; 00011110 (N) "Wood Elf Staff"
        DB  01Bh   ; 00011011 (O) "Crystal of Lothar"
        DB  040h   ; 01000000 (P)  NONE
        DB  040h   ; 01000000 (Q)  NONE
        DB  01Eh   ; 00011110 (R) "Blood Sword of Elder Kings"
        DB  01Bh   ; 00011011 (S)  NONE
        DB  01Eh   ; 00011110 (T) "Golden Chalice"
        DB  01Eh   ; 00011110 (U) "Cold Fire"
        DB  01Bh   ; 00011011 (V)  NONE
        DB  01Bh   ; 00011011 (W)  NONE
        DB  01Eh   ; 00011110 (X) "Talisman Scepter" 
        DB  01Bh   ; 00011011 (Y) "Pentacle Coins" 
        DB  03Bh   ; 00111011 (Z) "Spell of Release"
                   ; ||||||||
                   ; |||||----- 0-2:Item Weight (0-7)
                   ; ||||------ 3:
                   ; |||------- 4:
                   ; ||-------- 5:Start Game with
                   ; |--------- 6:No item for key
                   ; ---------- 7:
LC979:  DB  000h, 000h, 000h, 000h, 000h


; ---------------------------------------------------
;                 Health Table
; --------------------------------------------------- 
LC97E:  DB  0,4,8,12,16,20,24,28,32


; ---------------------------------------------------
;                   Table
; ---------------------------------------------------
LC986:  DB  20

LC988:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LC990:  DB  000h, 000h, 000h, 000h, 000h


; ---------------------------------------------------
;             Marker Table
; ---------------------------------------------------
LC995:  DB  000h, 053h, 000h, 000h, 000h, 000h, 000h, 000h
LC99D:  DB  000h


; ---------------------------------------------------
;              Combine (?) Table
; ---------------------------------------------------
LC99E:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h
        
        
; ---------------------------------------------------
;              Combining Items Table
; ---------------------------------------------------
LC9A5:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h   ; Row 1
LC9AD:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h   ; Row 2
LC9B5:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h   ; Row 3
LC9BD:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h   ; Row 4
LC9C5:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h   ; Row 5


; ---------------------------------------------------
;          Item Frame Number Table: 26 items
; ---------------------------------------------------
LC9CD:  DW  0BE38h  ; 48696 "You Have Nothing"
        DW  0BE2Eh  ; 48686 "You Have Aquired the Following Items..."

        DW  00001h  ; none  (A)  NO OBJECT
        DW  0BEDBh  ; 48859 (B) "Silver Wheat"
        DW  0BEACh  ; 48812 (C) "Spell of Seeing"
        DW  00001h  ; none  (D)  NONE
        DW  0BE4Bh  ; 48715 (E) "Black Mace"
        DW  0BE50h  ; 48720 (F) "Hunting Horn"
        DW  0BEBFh  ; 48831 (G) "Enchanted Bow"
        DW  00001h  ; none  (H)  NONE
        DW  00001h  ; none  (I)  NONE
        DW  0BE8Dh  ; 48781 (J) "Great Onyx Seal"
        DW  0BE5Bh  ; 48731 (K) "Orb of Quoid" 
        DW  00001h  ; none  (L)  NO OBJECT
        DW  0BE97h  ; 48791 (M) "Spell of Understanding"
        DW  0BEB6h  ; 48822 (N) "Wood Elf Staff"
        DW  0BE6Ch  ; 48748 (O) "Crystal of Lothar"
        DW  00001h  ; none  (P)  NO OBJECT
        DW  00001h  ; none  (Q)  NO OBJECT
        DW  0BE63h  ; 48739 (R) "Blood Sword of Elder Kings"
        DW  00001h  ; none  (S)  NONE
        DW  0BED3h  ; 48851 (T) "Golden Chalice"
        DW  0BE84h  ; 48772 (U) "Cold Fire"
        DW  00001h  ; none  (V)  NONE
        DW  00001h  ; none  (W)  NONE
        DW  0BE77h  ; 48759 (X) "Talisman Scepter" 
        DW  0BEC6h  ; 48838 (Y) "Pentacle Coins" 
        DW  0BE9Dh  ; 48797 (Z) "Spell of Release"
        
        
        
         
; ---------------------------------------------------
;            Player Ranking Frame Numbers 
; ---------------------------------------------------
LCA05:  DW  0BEE2h  ; 48866  Wanderer
        DW  0BEECh  ; 48876  Adventurer
        DW  0BEF6h  ; 48886  Initiate
        DW  0BF00h  ; 48896  Novice Illusionist
        DW  0BF0Ah  ; 48906  Journey Class Illusionist
        DW  0BF14h  ; 48916  Master Class Illusionist
        DW  0BF1Eh  ; 48926  Novice Spell Weaver
        DW  0BF28h  ; 48936  Journey Class Spell Weaver
        DW  0BF32h  ; 48946  Master Class Spell Weaver
        DW  0BF3Ch  ; 48956  Novice SoothSayer
        DW  0BF46h  ; 48966  Journey Class SoothSayer
        DW  0BF50h  ; 48976  Master Class SoothSayer
        DW  0BF5Ah  ; 48986  Novice Diviner
        DW  0BF64h  ; 48996  Journey Class Diviner
        DW  0BF6Eh  ; 49006  Master Class Diviner
        DW  0BF78h  ; 49016  Novice Mystic
        DW  0BF82h  ; 49026  Journey Class Mystic
        DW  0BF8Dh  ; 49037  Master Class Mystic




; ---------------------------------------------------
;                  Garbage
; ---------------------------------------------------
        DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA30:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA38:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA40:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA48:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA50:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA58:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA60:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA68:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA70:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA78:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA80:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA88:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA90:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCA98:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCAA0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCAA8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCAB0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCAB8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCAC0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCAC8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCAD0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCAD8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCAE0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCAE8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCAF0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCAF8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB00:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB08:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB10:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB18:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB20:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB28:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB30:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB38:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB40:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB48:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB50:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB58:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB60:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB68:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB70:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB78:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB80:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB88:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB90:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCB98:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCBA0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCBA8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCBB0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCBB8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCBC0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCBC8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCBD0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCBD8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCBE0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCBE8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCBF0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCBF8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC00:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC08:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC10:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC18:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC20:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC28:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC30:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC38:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC40:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC48:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC50:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC58:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC60:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC68:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC70:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC78:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC80:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC88:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC90:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCC98:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCCA0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCCA8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCCB0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCCB8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCCC0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCCC8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCCD0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCCD8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCCE0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCCE8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCCF0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCCF8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD00:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD08:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD10:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD18:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD20:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD28:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD30:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD38:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD40:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD48:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD50:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD58:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD60:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD68:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD70:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD78:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD80:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD88:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD90:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCD98:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCDA0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCDA8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCDB0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCDB8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCDC0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCDC8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCDD0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCDD8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCDE0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCDE8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCDF0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCDF8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE00:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE08:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE10:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE18:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE20:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE28:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE30:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE38:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE40:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE48:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE50:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE58:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE60:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE68:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE70:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE78:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE80:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE88:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE90:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCE98:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCEA0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCEA8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCEB0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCEB8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCEC0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCEC8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCED0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCED8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCEE0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCEE8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCEF0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCEF8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF00:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF08:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF10:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF18:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF20:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF28:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF30:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF38:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF40:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF48:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF50:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF58:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF60:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF68:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF70:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF78:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF80:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF88:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF90:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCF98:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCFA0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCFA8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCFB0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCFB8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCFC0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCFC8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCFD0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCFD8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCFE0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCFE8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCFF0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LCFF8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh






; ---------------------------------------------------
;              Beginning of Scene Data
;       Var00 = Frame Number LSB
;       Var01 = Frame Number MSB
;       Var02 = bit4  Healing Place
;               bit5
;               bit6  Health/Invincible
;               bit7  Audio Track
;       Var03 = Function Key 1
;       Var04 = Function Key 2
;       Var05 = Function Key 3
;       Var06 = Function Key 4
;       Var07 = bit3  0 = Single AUDIO, 1 = Dual AUDIO
;       Var08 = Bonus Points
;       Var09 = unknown
;       Var0A = Item info
;       Var0B = bit 0-2  Combine Action         
;               bit 3
;               bit 4
;               bit 5-6  unknown            
;               bit 7    Timed Scene
;       Var0C = Next Scene
;       Var0D = Health Cost/Timer Value
;       Var0E = Timer LSB
;       Var0F = Timer MSB
; ---------------------------------------------------
;             (00) Introduction
; ---------------------------------------------------
LD000:  DW  00001h  ; Frame Number
        DB  000h    ; Not Healing Place
        DB  000h    ; F1 =
        DB  000h    ; F2 =
        DB  002h    ; F3 =
        DB  057h    ; F4 = 
        DB  008h    ; Dual AUDIO
        DB  080h    ; Point Bonus
        DB  000h
        DB  000h    ; Item = NONE
        DB  080h    ; Timed Scene = YES
        DB  048h    ; Next Scene
        DB  026h    ; Health/Time
        DW  00457h  ; Scene Time



; ---------------------------------------------------
;             (01) Door Choice
; ---------------------------------------------------
LD010:  DW  002F6h  ; Door Choice
        DB  000h
        DB  000h    ; F1 = none
        DB  000h    ; F2 = none
        DB  002h    ; F3 = Left
        DB  057h    ; F4 = Right
        DB  008h    ; Dual AUDIO
        DB  080h    ; Point Bonus
        DB  000h    ;
        DB  000h    ; Item = NONE
        DB  080h    ; Timed Scene = YES 
        DB  048h    ; Next Scene
        DB  026h    ; Health/Time
        DW  00155h  ; Scene Time



; ---------------------------------------------------
;             (02) Magic Shop
; ---------------------------------------------------
LD020:  DW  00590h  ; Frame Number
        DB  000h    ;
        DB  000h    ; F1 = none
        DB  004h    ; F2 = Glendoe
        DB  013h    ; F3 = Waterfalls
        DB  008h    ; F4 = Forest
        DB  008h    ; Dual AUDIO
        DB  0C9h    ; Point Bonus
        DB  000h    ;
        DB  000h    ; Item = NONE
        DB  000h    ; Timed Scene = NO
        DB  000h    ; Next Scene
        DB  000h    ; Timer/Health
        DW  00629h  ; Scene Time



; ---------------------------------------------------
;             (03) City of  
; ---------------------------------------------------
LD030:  DW  00DBDh  ; Frame number 3517
        DB  000h
        DB  008h    ; F1 = Overgrown Path
        DB  00Bh    ; F2 = Bare Path
        DB  004h    ; F3 = Village Center
        DB  000h    ; F4 = none
        DB  000h    ; Single AUDIO
        DB  080h    ; Point Bonus
        DB  000h
        DB  000h    ; Item = NONE
        DB  000h    ; Timed Scene = NO
        DB  000h    ; Next Scene
        DB  000h    ; Timer/Health
        DW  00223h  ; Scene Time



; ---------------------------------------------------
;                (04) Village Center
; ---------------------------------------------------
LD040:  DW  00B8Dh  ; Frame Number 2957
        DB  000h
        DB  000h    ; F1 = none 
        DB  00Bh    ; F2 = Forest
        DB  003h    ; F3 = Outskirts
        DB  005h    ; F4 = Guild Hall
        DB  000h    ; Single AUDIO
        DB  080h    ; Point Bonus
        DB  000h
        DB  000h    ; Item = NONE
        DB  000h    ; Timed Scene = NO
        DB  000h    ; Next Scene
        DB  000h    ; Timer/Health
        DW  00235h  ; Scene Timer



; ---------------------------------------------------
;             (05) Guild Hall
; ---------------------------------------------------
LD050:  DW  00FDBh  ; Frame Number 4059
        DB  040h    ; Invincible here
        DB  004h    ; F1 = 
        DB  000h    ; F2 = none
        DB  000h    ; F3 = none
        DB  000h    ; F4 = none
        DB  008h    ; Dual AUDIO
        DB  032h    ; Point Bonus
        DB  000h
        DB  000h    ; Item = NONE
        DB  000h    ; Timed Scene = NO
        DB  000h    ; Next Scene
        DB  000h    ; Timer/Health
        DW  00151h  ; Scene Timer 



; ---------------------------------------------------
;             (06) Inside Castle
; ---------------------------------------------------
LD060:  DW  02708h  ; Frame Number 9992
        DB  009h
        DB  009h    ; F1 = Open Door 
        DB  062h    ; F2 = Closed Door
        DB  063h    ; F3 =
        DB  00Fh    ; F4 =
        DB  000h    ; Single AUDIO
        DB  083h    ; Point Bonus
        DB  000h
        DB  000h    ; Item = NONE
        DB  000h    ; Timed Scene = NO
        DB  000h    ; Next Scene
        DB  000h    ; Timer/Health
        DW  00134h  ; Scene Timer 



; ---------------------------------------------------
;                (07) Vortex to Forest
; ---------------------------------------------------
LD070:  DW  0112Bh  ; Frame Number 4395
        DB  040h    ; Invincible here
        DB  010h    ; F1 =
        DB  000h    ; F2 = none
        DB  000h    ; F3 = none
        DB  000h    ; F4 = none
        DB  008h    ; Dual AUDIO
        DB  035h    ; Point Bonus
        DB  000h
        DB  000h    ; Item = NONE
        DB  000h    ; Timed Scene = NO
        DB  001h    ; Next Scene = Door Choice
        DB  000h    ; Timer/Health
        DW  00072h  ; Scene Timer



; ---------------------------------------------------
;     (08) Overgrown Path/Barren Path/Forest Path
; ---------------------------------------------------
LD080:  DW  013E1h  ; Frame Number 5089
        DB  001h
        DB  010h    ; F1 = Forest Clearing
        DB  00Bh    ; F2 = Forest Path
        DB  012h    ; F3 = Rockey Path
        DB  00Ch    ; F4 =
        DB  000h    ; Single AUDIO
        DB  07Fh    ; Point Bonus
        DB  000h
        DB  06Eh    ; Item = (N) "Wood Elf Staff" 
        DB  000h    ; Timed Scene = NO
        DB  000h    ; Next Scene
        DB  000h    ; Timer/Health
        DW  0014Dh  ; Scene Timer



; ---------------------------------------------------
;             (09) Outside Castle
; ---------------------------------------------------
LD090:  DW  021F6h  ; Frame Number 8694
        DB  000h
        DB  00Bh    ; F1 = Bare Path
        DB  008h    ; F2 = Overgrown Path
        DB  000h    ; F3 = none
        DB  006h    ; F4 = Into Castle
        DB  000h    ; Single AUDIO
        DB  080h    ; Point Bonus
        DB  000h
        DB  020h    ; Item = NONE
        DB  000h    ; Timed Scene = NO
        DB  000h    ; Next Scene
        DB  000h    ; Timer/Health
        DW  0009Fh  ; Scene Timer



; ---------------------------------------------------
;             (0A) Forest Path
; ---------------------------------------------------
LD0A0:  DW  01B92h  ; Frame number 7058
        DB  001h    ; Mask Option 4
        DB  008h    ; F1 = Barren Path
        DB  010h    ; F2 = Forest clearing
        DB  00Eh    ; F3 = Overgrown Path
        DB  017h    ; F4 = 
        DB  000h    ; Single AUDIO
        DB  07Dh    ; Point Bonus
        DB  000h
        DB  000h    ; Item = NONE
        DB  000h    ; Timed Scene = NO
        DB  000h    ; Next Scene
        DB  000h    ; Timer/Health
        DW  0022Ah  ; Scene Timer



; ---------------------------------------------------
;               (0B) Bare Path
; ---------------------------------------------------
LD0B0:  DW  01956h  ; Frame Number 6486
        DB  000h
        DB  000h    ; F1 = none
        DB  004h    ; F2 = Village Center
        DB  005h    ; F3 = Guild Hall
        DB  00Ah    ; F4 = Forest Path
        DB  000h    ; Single AUDIO
        DB  080h    ; Point Bonus
        DB  000h
        DB  000h    ; Item = NONE
        DB  000h    ; Timed Scene = NO
        DB  000h    ; Next Scene
        DB  000h    ; Timer/Health
        DW  00244h  ; Scene Timer



; ---------------------------------------------------
;               (0C) xxx
; ---------------------------------------------------
LD0C0:  DW  01DB4h  ; Frame Number
        DB  000h
        DB  008h    ; F1 = 
        DB  012h    ; F2 =
        DB  000h    ; F3 =
        DB  013h    ; F4 =
        DB  000h    ; Single AUDIO
        DB  07Fh    ; Point Bonus
        DB  000h
        DB  000h    ; Item = NONE
        DB  000h    ; Timed Scene = NO
        DB  000h    ; Next Scene
        DB  000h    ; Timer/Health
        DW  00130h  ; Scene Timer



; ---------------------------------------------------
;               (0D) xxx
; ---------------------------------------------------
LD0D0:  DW  02299h  ; Frame Number
        DB  000h
        DB  000h    ; F1 =
        DB  007h    ; F2 =
        DB  013h    ; F3 =
        DB  00Fh    ; F4 =
        DB  000h    ;
        DB  089h    ; Point Bonus
        DB  000h    ; Single AUDIO
        DB  065h    ; Item = (E) "Black Mace"
        DB  000h    ; Timed Scene = NO
        DB  000h    ; Next Scene
        DB  000h    ; Health/Time
        DW  00096h  ; Scene Timer



; ---------------------------------------------------
;               (0E) xxxx
; ---------------------------------------------------
LD0E0:  DW  02333h  ; Frame Number
        DB  000h
        DB  017h    ; F1 = 
        DB  014h    ; F2 = 
        DB  00Ah    ; F3 =
        DB  016h    ; F4 =
        DB  008h
        DB  04Dh, 000h, 000h, 010h
        DB  04Bh    ; Next Scene = ?
        DB  006h    ; Health/Time
        DW  00172h  ; Scene Timer



; ---------------------------------------------------
;               (0F) xxxx
; ---------------------------------------------------
LD0F0:  DW  025F6h  ; Frame Number
        DB  000h
        DB  00Dh    ; F1 = 
        DB  000h    ; F2 = none     
        DB  013h    ; F3 = 
        DB  009h    ; F4 = 
        DB  000h
        DB  07Eh, 000h, 000h, 000h, 000h, 000h
        DW  00111h  ; Timer



; ---------------------------------------------------
;               (10) xxx
; ---------------------------------------------------
LD100:  DW  0283Dh  ; Frame Number 
        DB  003h
        DB  011h    ; F1 = 
        DB  00Bh    ; F2 =
        DB  007h    ; F3 =
        DB  018h    ; F4 =
        DB  008h    
        DB  08Dh, 000h, 000h, 080h, 049h, 026h
        DW  000B9h  ; Timer



; ---------------------------------------------------
;               (11) xxxx
; ---------------------------------------------------
LD110:  DW  02E7Ch  ; Frame Number
        DB  001h
        DB  008h    ; F1 = xx
        DB  009h    ; F2 = xx
        DB  05Ch    ; F3 = xx
        DB  00Ah    ; F4 = xx
        DB  000h
        DB  0C1h
        DB  000h
        DB  021h
        DB  000h, 000h, 000h
        DW  000DEh  ; Timer



; ---------------------------------------------------
;               (12) xxxxx
; ---------------------------------------------------
LD120:  DW  02F6Ch  ; Frame Number
        DB  040h
        DB  00Ch    ; F1 = xxx
        DB  000h    ; F2 = none
        DB  000h    ; F3 = none
        DB  000h    ; F4 = none
        DB  008h
        DB  01Fh    ; Point Bonus
        DB  000h, 000h, 000h, 000h, 000h
        DW  000DDh  ; Timer



; ---------------------------------------------------
;               (13) Waterfalls
; ---------------------------------------------------
LD130:  DW  03054h  ; Frame Number
        DB  010h    ; Healing Place
        DB  000h    ; F1 = none
        DB  008h    ; F2 = Forest Path
        DB  012h    ; F3 = Rocky Path
        DB  00Ch    ; F4 = Sandy Path
        DB  000h
        DB  0CBh    ; Point Bonus
        DB  010h, 000h, 000h, 000h, 000h
        DW  00141h  ; Timer




LD140:  DB  02Ch, 035h, 000h, 004h, 016h, 000h, 017h, 000h
LD148:  DB  087h, 000h, 06Fh, 000h, 000h, 000h, 04Bh, 001h

LD150:  DB  0F9h, 039h, 000h, 017h, 000h, 00Eh, 014h, 000h
LD158:  DB  08Dh, 000h, 023h, 000h, 000h, 000h, 0A3h, 001h

LD160:  DB  0A2h, 03Bh, 040h, 010h, 000h, 000h, 000h, 000h
LD168:  DB  023h, 000h, 000h, 000h, 000h, 000h, 0DFh, 000h

LD170:  DB  004h, 03Fh, 000h, 01Dh, 016h, 015h, 00Eh, 008h
LD178:  DB  093h, 000h, 075h, 000h, 000h, 000h, 0BCh, 000h

LD180:  DB  0CEh, 03Fh, 001h, 01Eh, 019h, 01Bh, 025h, 008h
LD188:  DB  07Fh
        DB  000h
        DB  000h
        DB  080h    ; Timed Scene = YES
        DB  04Ch    ; Next Scene
        DB  026h    ; Timer/Health
        DW  00117h  ; Scene Timer

LD190:  DB  07Ah, 046h, 000h, 023h, 018h, 01Eh, 01Ah, 000h
LD198:  DB  07Fh, 000h, 022h, 000h, 000h, 000h, 0EBh, 000h

LD1A0:  DB  06Fh, 047h, 000h, 01Ch, 000h, 019h, 023h, 000h
LD1A8:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 075h, 001h

LD1B0:  DB  0ECh, 048h, 021h, 01Ch, 01Eh, 01Ah, 024h, 008h
LD1B8:  DB  032h, 000h, 000h, 000h, 000h, 000h, 056h, 002h

LD1C0:  DB  0C3h, 04Fh, 000h, 019h, 01Ah, 000h, 01Dh, 000h
LD1C8:  DB  08Fh, 000h, 067h, 000h, 000h, 000h, 004h, 002h

LD1D0:  DB  0D2h, 051h, 000h, 01Eh, 01Ch, 023h, 022h, 008h
LD1D8:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 08Bh, 000h

LD1E0:  DB  06Fh, 052h, 040h, 01Dh, 000h, 000h, 000h, 008h
LD1E8:  DB  023h, 000h, 000h, 000h, 000h, 000h, 023h, 001h

LD1F0:  DB  09Dh, 053h, 000h, 019h, 025h, 026h, 000h, 000h
LD1F8:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 03Eh, 002h

LD200:  DB  0E4h, 055h, 010h, 01Fh, 026h, 000h, 05Fh, 000h
LD208:  DB  0A1h, 000h, 000h, 000h, 000h, 000h, 00Bh, 002h

LD210:  DB  0F6h, 059h, 000h, 000h, 028h, 020h, 01Ah, 008h
LD218:  DB  093h, 000h, 078h, 000h, 000h, 000h, 039h, 001h

LD220:  DB  036h, 05Bh, 000h, 000h, 01Bh, 05Fh, 01Dh, 008h
LD228:  DB  04Dh, 000h, 000h, 010h, 050h, 006h, 0F9h, 000h

LD230:  DB  0A7h, 066h, 004h, 022h, 01Dh, 029h, 02Fh, 000h
LD238:  DB  097h, 000h, 024h, 000h, 000h, 000h, 0A7h, 002h

LD240:  DB  057h, 069h, 000h, 000h, 02Bh, 020h, 01Bh, 008h
LD248:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 0BDh, 000h

LD250:  DB  020h, 06Ah, 000h, 026h, 000h, 024h, 05Fh, 008h
LD258:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 0EDh, 000h

LD260:  DB  016h, 06Bh, 040h, 01Dh, 000h, 000h, 000h, 008h
LD268:  DB  021h, 000h, 000h, 000h, 000h, 000h, 011h, 001h
LD270:  DB  069h, 070h, 001h, 02Dh, 025h, 02Dh, 02Eh, 000h
LD278:  DB  099h, 000h, 000h, 000h, 000h, 000h, 091h, 001h
LD280:  DB  004h, 072h, 000h, 02Eh, 000h, 02Dh, 027h, 000h
LD288:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 054h, 001h
LD290:  DB  076h, 075h, 002h, 01Bh, 02Fh, 022h, 018h, 000h
LD298:  DB  099h, 000h, 06Ah, 000h, 000h, 000h, 0CFh, 000h
LD2A0:  DB  0E1h, 07Bh, 003h, 000h, 013h, 034h, 02Ch, 000h
LD2A8:  DB  097h, 000h, 066h, 000h, 000h, 000h, 0DCh, 001h
LD2B0:  DB  0C8h, 07Dh, 000h, 024h, 000h, 02Ah, 000h, 000h
LD2B8:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 0BEh, 000h
LD2C0:  DB  085h, 086h, 000h, 000h, 000h, 033h, 03Ch, 000h
LD2C8:  DB  093h, 000h, 079h, 000h, 000h, 000h, 094h, 001h
LD2D0:  DB  091h, 07Eh, 040h, 05Fh, 000h, 000h, 000h, 008h
LD2D8:  DB  021h, 000h, 000h, 000h, 000h, 000h, 03Ah, 001h
LD2E0:  DB  0D3h, 07Fh, 001h, 027h, 02Dh, 02Dh, 028h, 000h
LD2E8:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 0DEh, 000h
LD2F0:  DB  0BCh, 080h, 000h, 000h, 000h, 01Ah, 025h, 000h
LD2F8:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 021h, 002h
LD300:  DB  077h, 08Bh, 009h, 036h, 038h, 02Ch, 024h, 008h
LD308:  DB  07Fh, 000h, 074h, 000h, 000h, 000h, 0ECh, 000h
LD310:  DB  06Eh, 08Ch, 000h, 034h, 000h, 02Ch, 038h, 000h
LD318:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 0C1h, 001h
LD320:  DB  038h, 08Eh, 000h, 000h, 000h, 033h, 034h, 000h
LD328:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 0BDh, 002h
LD330:  DB  0FFh, 090h, 000h, 000h, 032h, 034h, 038h, 000h
LD338:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 07Bh, 001h
LD340:  DB  084h, 092h, 000h, 030h, 035h, 000h, 000h, 008h
LD348:  DB  07Fh, 000h, 000h, 080h, 04Dh, 026h, 0BCh, 000h
LD350:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LD358:  DB  000h, 000h, 026h, 000h, 000h, 000h, 000h, 000h
LD360:  DB  0CEh, 097h, 000h, 000h, 000h, 025h, 031h, 000h
LD368:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 09Bh, 000h
LD370:  DB  033h, 09Ch, 000h, 038h, 039h, 000h, 02Ch, 000h
LD378:  DB  08Eh, 000h, 062h, 000h, 000h, 000h, 0A0h, 001h
LD380:  DB  0E0h, 09Dh, 000h, 031h, 000h, 044h, 064h, 000h
LD388:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 071h, 002h
LD390:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h

LD398:  DB  000h, 000h, 027h, 000h, 000h, 000h, 000h, 000h
LD3A0:  DB  0C9h, 0A6h, 000h, 000h, 035h, 000h, 03Bh, 000h

LD3A8:  DB  08Dh, 000h, 072h, 000h, 000h, 000h, 030h, 001h
LD3B0:  DB  001h, 0A8h, 000h, 000h, 035h, 038h, 000h, 000h
LD3B8:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 029h, 002h
LD3C0:  DB  032h, 0AAh, 000h, 02Ch, 042h, 000h, 039h, 000h
LD3C8:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 0EDh, 001h
LD3D0:  DB  055h, 060h, 000h, 045h, 000h, 044h, 03Fh, 000h
LD3D8:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 029h, 002h
LD3E0:  DB  016h, 062h, 000h, 043h, 03Fh, 044h, 000h, 000h
LD3E8:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 0BFh, 002h

; ---------------------------------------------------
;               (YY) xxxxx
; ---------------------------------------------------
LD3F0:  DW  06451h  ; Frame Number
        DB  020h    ; Lose all items
        DB  000h    ; 1 = none
        DB  03Eh    ; 2 = 
        DB  000h    ; 3 =   
        DB  044h    ; 4 = 
        DB  000h
        DB  00Dh    ; Point Bonus
        DB  000h
        DB  000h
        DB  000h    ; Timed Scene = NO
        DB  000h    ; Next Scene
        DB  000h    ; Health/Time
        DW  00145h  ; Scene Timer

LD400:  DB  029h, 0ACh, 040h, 031h, 000h, 000h, 000h, 008h
LD408:  DB  021h, 000h, 000h, 000h, 000h, 000h, 0ADh, 000h
LD410:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LD418:  DB  000h, 000h, 06Bh, 000h, 000h, 000h, 000h, 000h
LD420:  DB  082h, 0B4h, 040h, 031h, 000h, 000h, 000h, 008h
LD428:  DB  021h, 000h, 028h, 010h, 000h, 006h, 0AFh, 001h
LD430:  DB  06Dh, 06Dh, 000h, 044h, 03Dh, 000h, 038h, 000h
LD438:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 0CFh, 001h
LD440:  DB  07Bh, 075h, 000h, 045h, 03Dh, 000h, 03Eh, 000h
LD448:  DB  093h, 000h, 029h, 000h, 000h, 000h, 0C6h, 001h
LD450:  DB  0F8h, 07Ah, 000h, 000h, 044h, 03Fh, 03Dh, 000h
LD458:  DB  07Fh, 000h, 02Ah, 000h, 000h, 000h, 0CEh, 000h
LD460:  DB  025h, 0BAh, 006h, 03Ch, 039h, 040h, 047h, 000h
LD468:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 0AEh, 001h
LD470:  DB  0DEh, 0BBh, 002h, 046h, 040h, 040h, 039h, 000h
LD478:  DB  07Fh, 000h, 000h, 000h, 000h, 000h, 045h, 002h
LD480:  DB  049h, 004h, 040h, 001h, 000h, 000h, 000h, 008h
LD488:  DB  032h, 000h, 000h, 020h, 000h, 000h, 046h, 001h
LD490:  DB  0F9h, 028h, 000h, 000h, 00Bh, 000h, 007h, 008h
LD498:  DB  03Eh, 000h, 000h, 030h, 04Ah, 006h, 097h, 000h
LD4A0:  DB  093h, 029h, 040h, 011h, 000h, 000h, 000h, 008h
LD4A8:  DB  021h, 000h, 000h, 010h, 001h, 006h, 096h, 000h
LD4B0:  DB  0A8h, 024h, 040h, 017h, 000h, 000h, 000h, 008h
LD4B8:  DB  032h, 000h, 000h, 010h, 001h, 006h, 04Eh, 001h
LD4C0:  DB  0E8h, 040h, 040h, 01Dh, 000h, 000h, 000h, 008h
LD4C8:  DB  023h, 000h, 000h, 020h, 000h, 000h, 0BBh, 000h
LD4D0:  DB  045h, 093h, 040h, 031h, 000h, 000h, 000h, 008h
LD4D8:  DB  021h, 000h, 000h, 020h, 000h, 000h, 007h, 001h
LD4E0:  DB  040h, 016h, 040h, 004h, 000h, 000h, 000h, 008h
LD4E8:  DB  026h, 000h, 000h, 020h, 002h, 000h, 0B5h, 000h
LD4F0:  DB  0AFh, 042h, 040h, 01Dh, 000h, 000h, 000h, 008h
LD4F8:  DB  023h, 000h, 000h, 020h, 000h, 000h, 0A0h, 000h
LD500:  DB  03Dh, 05Ch, 040h, 01Dh, 000h, 000h, 000h, 008h
LD508:  DB  021h, 000h, 000h, 010h, 000h, 006h, 0BAh, 000h
LD510:  DB  0E9h, 05Eh, 040h, 01Dh, 000h, 000h, 000h, 008h
LD518:  DB  021h, 000h, 000h, 020h, 000h, 000h, 07Dh, 000h
LD520:  DB  093h, 06Dh, 040h, 01Dh, 000h, 000h, 000h, 008h
LD528:  DB  023h, 000h, 000h, 020h, 000h, 000h, 082h, 000h
LD530:  DB  059h, 0A0h, 040h, 024h, 000h, 000h, 000h, 008h
LD538:  DB  021h, 000h, 000h, 010h, 000h, 000h, 0BCh, 000h
LD540:  DB  01Fh, 095h, 040h, 031h, 000h, 000h, 000h, 008h
LD548:  DB  021h, 000h, 000h, 020h, 000h, 000h, 0B9h, 000h
LD550:  DB  0C3h, 0B7h, 040h, 031h, 000h, 000h, 000h, 008h
LD558:  DB  021h, 000h, 000h, 020h, 000h, 000h, 0BFh, 000h
LD560:  DB  072h, 037h, 040h, 010h, 000h, 000h, 000h, 008h
LD568:  DB  023h, 000h, 000h, 020h, 000h, 000h, 070h, 000h
LD570:  DB  02Bh, 011h, 040h, 001h, 000h, 000h, 000h, 008h
LD578:  DB  035h, 000h, 000h, 000h, 001h, 000h, 073h, 000h
LD580:  DB  0BAh, 006h, 000h, 001h, 000h, 000h, 000h, 000h
LD588:  DB  001h, 000h, 000h, 000h, 000h, 000h, 03Eh, 012h
LD590:  DB  04Ah, 07Ah, 000h, 001h, 058h, 000h, 000h, 000h
LD598:  DB  005h, 000h, 000h, 080h, 000h, 026h, 08Ch, 03Ch
LD5A0:  DB  0ADh, 08Ah, 000h, 05Bh, 000h, 000h, 000h, 000h
LD5A8:  DB  0C8h, 000h, 000h, 008h, 000h, 000h, 000h, 000h
LD5B0:  DB  030h, 06Ch, 000h, 000h, 000h, 000h, 000h, 001h
LD5B8:  DB  07Fh, 000h, 025h, 080h, 052h, 02Dh, 062h, 001h
LD5C0:  DB  03Dh, 028h, 000h, 000h, 000h, 000h, 000h, 008h
LD5C8:  DB  032h, 000h, 000h, 080h, 05Dh, 001h, 096h, 000h
LD5D0:  DB  0F9h, 028h, 000h, 000h, 008h, 000h, 01Dh, 008h
LD5D8:  DB  03Eh, 000h, 000h, 010h, 04Ah, 005h, 095h, 000h
LD5E0:  DB  030h, 06Ch, 000h, 000h, 000h, 000h, 000h, 000h
LD5E8:  DB  07Fh, 000h, 025h, 080h, 052h, 02Dh, 062h, 001h
LD5F0:  DB  0F6h, 059h, 000h, 000h, 028h, 020h, 01Ah, 008h
LD5F8:  DB  093h, 000h, 000h, 000h, 000h, 000h, 039h, 001h
LD600:  DB  0C9h, 0A6h, 000h, 000h, 035h, 000h, 03Ah, 000h
LD608:  DB  08Dh, 000h, 000h, 000h, 000h, 000h, 030h, 001h
LD610:  DB  0C9h, 0A6h, 000h, 000h, 035h, 000h, 03Bh, 000h
LD618:  DB  08Dh, 000h, 000h, 000h, 000h, 000h, 030h, 001h
LD620:  DB  099h, 022h, 000h, 000h, 007h, 013h, 00Fh, 000h
LD628:  DB  089h, 000h, 000h, 000h, 000h, 000h, 096h, 000h
LD630:  DB  07Ch, 02Eh, 001h, 008h, 009h, 05Ch, 00Ah, 000h
LD638:  DB  0C1h, 000h, 000h, 000h, 000h, 000h, 0DEh, 000h
LD640:  DB  033h, 09Ch, 000h, 038h, 039h, 000h, 02Ch, 000h
LD648:  DB  08Eh, 000h, 000h, 000h, 000h, 000h, 0A0h, 001h
LD650:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD658:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD660:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD668:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD670:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD678:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD680:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD688:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD690:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD698:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD6A0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD6A8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD6B0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD6B8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD6C0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD6C8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD6D0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD6D8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD6E0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD6E8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD6F0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD6F8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD700:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD708:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD710:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD718:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD720:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD728:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD730:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD738:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD740:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD748:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD750:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD758:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD760:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD768:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD770:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD778:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD780:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD788:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD790:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD798:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD7A0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD7A8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD7B0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD7B8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD7C0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD7C8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD7D0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD7D8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD7E0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD7E8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD7F0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LD7F8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh





; ---------------------------------------------------
;              Start of Scene Data (Audio Track 2)
; ---------------------------------------------------
LD800:  DB  001h, 000h
        DB  080h     ; Audio Track 2
        DB  000h
        DB  000h, 000h, 000h, 000h
LD808:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h

LD810:  DB  041h, 02Bh, 080h, 00Ah, 008h, 000h, 010h, 008h
LD818:  DB  05Bh, 000h, 041h, 020h, 000h, 000h, 0B6h, 000h

LD820:  DB  0F8h, 02Bh, 080h, 008h, 00Ah, 000h, 010h, 008h
LD828:  DB  05Bh, 000h, 041h, 000h, 000h, 000h, 0B5h, 000h

LD830:  DB  0B0h, 02Ch, 080h, 000h, 010h, 000h, 009h, 008h
LD838:  DB  0FFh, 000h, 041h, 000h, 000h, 000h, 0BDh, 001h

LD840:  DB  0EFh, 037h, 084h, 00Eh, 017h, 017h, 014h, 008h
LD848:  DB  0EBh, 000h, 043h, 000h, 000h, 000h, 0DFh, 000h

LD850:  DB  0CFh, 038h, 080h, 000h, 00Eh, 017h, 000h, 008h
LD858:  DB  0A2h, 000h, 043h, 000h, 000h, 000h, 01Ch, 001h

LD860:  DB  000h, 000h, 080h, 000h, 000h, 000h, 000h, 000h
LD868:  DB  000h, 000h, 000h, 0A0h, 045h, 001h, 001h, 000h
LD870:  DB  00Dh, 013h, 081h, 010h, 00Ah, 012h, 00Ch, 000h
LD878:  DB  0C9h, 000h, 08Eh, 020h, 000h, 000h, 0D4h, 000h
LD880:  DB  0A3h, 011h, 080h, 00Bh, 00Ch, 012h, 000h, 000h
LD888:  DB  080h, 000h, 06Eh, 000h, 007h, 001h, 069h, 001h
LD890:  DB  02Dh, 015h, 080h, 000h, 010h, 007h, 000h, 008h
LD898:  DB  080h, 000h, 020h, 080h, 04Eh, 026h, 012h, 001h
LD8A0:  DB  0CFh, 017h, 080h, 000h, 000h, 010h, 00Bh, 008h
LD8A8:  DB  0B1h, 000h, 040h, 000h, 000h, 000h, 0B6h, 000h
LD8B0:  DB  0F7h, 016h, 080h, 00Bh, 006h, 010h, 000h, 008h
LD8B8:  DB  0DFh, 000h, 040h, 000h, 000h, 000h, 0D3h, 000h
LD8C0:  DB  088h, 018h, 080h, 000h, 000h, 010h, 00Bh, 008h
LD8C8:  DB  093h, 000h, 040h, 000h, 000h, 000h, 0C5h, 000h
LD8D0:  DB  0E5h, 01Eh, 080h, 007h, 000h, 00Fh, 017h, 008h
LD8D8:  DB  080h, 000h, 065h, 000h, 00Eh, 001h, 095h, 000h
LD8E0:  DB  07Fh, 01Fh, 080h, 007h, 000h, 013h, 00Fh, 008h
LD8E8:  DB  0C9h, 000h, 085h, 020h, 003h, 000h, 084h, 002h
LD8F0:  DB  000h, 000h, 080h, 000h, 000h, 000h, 000h, 000h
LD8F8:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LD900:  DB  000h, 000h, 080h, 000h, 000h, 000h, 000h, 000h
LD908:  DB  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
LD910:  DB  02Eh, 02Ah, 080h, 000h, 010h, 00Ah, 008h, 000h
LD918:  DB  080h, 000h, 021h, 005h, 000h, 000h, 012h, 001h
LD920:  DB  0ADh, 034h, 0C0h, 014h, 000h, 000h, 000h, 008h
LD928:  DB  023h, 000h, 08Fh, 000h, 000h, 000h, 06Fh, 000h
LD930:  DB  0E2h, 032h, 080h, 000h, 017h, 015h, 00Eh, 000h
LD938:  DB  0C9h, 000h, 0AFh, 020h, 000h, 000h, 0C0h, 001h
LD940:  DB  0A1h, 031h, 080h, 016h, 000h, 00Eh, 017h, 000h
LD948:  DB  093h, 000h, 06Fh, 000h, 012h, 000h, 040h, 001h
LD950:  DB  07Eh, 036h, 080h, 000h, 000h, 000h, 000h, 008h
LD958:  DB  07Fh, 000h, 023h, 080h, 056h, 028h, 0DFh, 000h
LD960:  DB  089h, 03Dh, 080h, 00Eh, 016h, 015h, 000h, 000h
LD968:  DB  0C9h, 000h, 095h, 020h, 000h, 000h, 073h, 001h
LD970:  DB  08Ah, 03Ch, 080h, 000h, 00Eh, 015h, 016h, 000h
LD978:  DB  07Fh, 000h, 075h, 000h, 016h, 001h, 0FBh, 000h
LD980:  DB  0ADh, 02Dh, 080h, 025h, 000h, 000h, 021h, 000h
LD988:  DB  05Ch, 000h, 045h, 000h, 000h, 000h, 0AFh, 001h
LD990:  DB  0B1h, 041h, 080h, 01Bh, 000h, 000h, 000h, 008h
LD998:  DB  07Fh, 000h, 022h, 080h, 04Fh, 028h, 0FAh, 000h
LD9A0:  DB  05Bh, 043h, 080h, 000h, 018h, 025h, 01Eh, 008h
LD9A8:  DB  0EDh, 000h, 042h, 000h, 000h, 000h, 0FAh, 000h
LD9B0:  DB  060h, 044h, 080h, 000h, 018h, 021h, 01Eh, 008h
LD9B8:  DB  05Fh, 000h, 042h, 010h, 050h, 001h, 01Bh, 001h
LD9C0:  DB  04Ch, 04Bh, 080h, 01Dh, 019h, 000h, 01Ah, 000h
LD9C8:  DB  07Fh, 000h, 067h, 000h, 01Dh, 000h, 0AEh, 001h
LD9D0:  DB  0D2h, 04Eh, 0C0h, 01Dh, 000h, 000h, 000h, 008h
LD9D8:  DB  023h, 000h, 087h, 000h, 000h, 000h, 0E6h, 000h
LD9E0:  DB  0FCh, 04Ch, 084h, 01Dh, 019h, 01Ah, 025h, 008h
LD9E8:  DB  0C9h, 000h, 0A7h, 020h, 000h, 000h, 0CFh, 001h
LD9F0:  DB  061h, 064h, 0C0h, 01Dh, 000h, 000h, 000h, 008h
LD9F8:  DB  023h, 000h, 044h, 000h, 000h, 000h, 0A0h, 000h
LDA00:  DB  031h, 059h, 080h, 000h, 027h, 028h, 000h, 008h
LDA08:  DB  0C9h, 000h, 098h, 020h, 000h, 000h, 0BAh, 000h
LDA10:  DB  0F7h, 057h, 080h, 020h, 000h, 01Ah, 028h, 008h
LDA18:  DB  085h, 000h, 078h, 000h, 020h, 001h, 039h, 001h
LDA20:  DB  00Dh, 065h, 080h, 022h, 025h, 01Bh, 000h, 008h
LDA28:  DB  08Fh, 000h, 044h, 000h, 000h, 000h, 091h, 001h
LDA30:  DB  006h, 05Dh, 080h, 000h, 000h, 000h, 000h, 000h
LDA38:  DB  07Fh, 000h, 024h, 080h, 051h, 028h, 0E4h, 001h
LDA40:  DB  048h, 061h, 080h, 000h, 01Dh, 022h, 019h, 008h
LDA48:  DB  08Fh, 000h, 044h, 000h, 000h, 000h, 0A4h, 001h
LDA50:  DB  076h, 05Fh, 080h, 01Ah, 000h, 029h, 019h, 008h
LDA58:  DB  0E3h, 000h, 044h, 000h, 000h, 000h, 0CBh, 001h
LDA60:  DB  0F5h, 062h, 084h, 01Dh, 01Ah, 019h, 01Bh, 008h
LDA68:  DB  08Fh, 000h, 044h, 000h, 000h, 000h, 063h, 001h
LDA70:  DB  069h, 070h, 080h, 02Dh, 025h, 02Eh, 000h, 000h
LDA78:  DB  099h, 000h, 000h, 000h, 000h, 000h, 091h, 001h
LDA80:  DB  022h, 06Eh, 080h, 000h, 021h, 025h, 02Eh, 008h
LDA88:  DB  0FFh, 000h, 045h, 008h, 000h, 000h, 028h, 001h
LDA90:  DB  062h, 073h, 080h, 022h, 018h, 01Eh, 000h, 008h
LDA98:  DB  07Fh, 000h, 06Ah, 000h, 02Fh, 001h, 0EBh, 000h
LDAA0:  DB  04Eh, 076h, 080h, 013h, 000h, 02Ch, 000h, 000h
LDAA8:  DB  07Fh, 001h, 066h, 000h, 02Bh, 000h, 033h, 002h
LDAB0:  DB  033h, 07Bh, 0C0h, 02Ah, 000h, 000h, 000h, 008h
LDAB8:  DB  021h, 000h, 086h, 000h, 000h, 000h, 0A0h, 000h
LDAC0:  DB  0E6h, 082h, 080h, 000h, 000h, 03Ch, 033h, 000h
LDAC8:  DB  07Fh, 000h, 079h, 000h, 03Eh, 000h, 076h, 001h
LDAD0:  DB  083h, 078h, 080h, 013h, 000h, 02Ch, 025h, 008h
LDAD8:  DB  0C9h, 010h, 0A6h, 000h, 000h, 000h, 0A7h, 002h
LDAE0:  DB  053h, 06Fh, 0C0h, 021h, 000h, 000h, 000h, 008h
LDAE8:  DB  023h, 000h, 045h, 000h, 000h, 000h, 00Dh, 001h
LDAF0:  DB  052h, 074h, 080h, 000h, 018h, 022h, 02Fh, 000h
LDAF8:  DB  0C9h, 000h, 08Ah, 020h, 000h, 000h, 01Eh, 001h
LDB00:  DB  023h, 088h, 080h, 038h, 031h, 036h, 000h, 000h
LDB08:  DB  07Fh, 000h, 074h, 000h, 031h, 001h, 0F7h, 001h
LDB10:  DB  01Ch, 08Ah, 080h, 031h, 000h, 038h, 036h, 000h
LDB18:  DB  0C9h, 000h, 094h, 020h, 000h, 000h, 054h, 001h
LDB20:  DB  0FDh, 099h, 080h, 039h, 038h, 02Ch, 000h, 000h
LDB28:  DB  0C9h, 000h, 0A2h, 020h, 000h, 000h, 018h, 001h
LDB30:  DB  0CDh, 096h, 080h, 034h, 000h, 03Bh, 061h, 008h
LDB38:  DB  08Fh, 000h, 046h, 000h, 000h, 000h, 0F4h, 000h
LDB40:  DB  00Eh, 02Fh, 080h, 000h, 01Ah, 026h, 000h, 000h
LDB48:  DB  047h, 000h, 045h, 000h, 000h, 000h, 0D0h, 001h
LDB50:  DB  058h, 094h, 080h, 000h, 000h, 000h, 000h, 008h
LDB58:  DB  07Fh, 000h, 026h, 080h, 054h, 02Dh, 0C3h, 000h
LDB60:  DB  0E7h, 095h, 080h, 060h, 03Bh, 034h, 000h, 008h
LDB68:  DB  0EDh, 000h, 046h, 000h, 000h, 000h, 0DBh, 000h
LDB70:  DB  076h, 098h, 080h, 039h, 02Ch, 038h, 000h, 000h
LDB78:  DB  07Fh, 000h, 062h, 000h, 038h, 000h, 082h, 001h
LDB80:  DB  096h, 09Bh, 0C0h, 031h, 000h, 000h, 000h, 008h
LDB88:  DB  021h, 000h, 082h, 000h, 000h, 000h, 091h, 000h
LDB90:  DB  023h, 0A1h, 080h, 000h, 040h, 046h, 047h, 000h
LDB98:  DB  07Fh, 000h, 027h, 000h, 000h, 000h, 0AEh, 001h
LDBA0:  DB  003h, 0A5h, 080h, 03Bh, 000h, 000h, 035h, 008h
LDBA8:  DB  07Fh, 000h, 072h, 000h, 03Bh, 001h, 0BFh, 000h
LDBB0:  DB  0C7h, 0A5h, 080h, 03Bh, 000h, 035h, 000h, 000h
LDBB8:  DB  0C9h, 000h, 092h, 000h, 000h, 000h, 0FAh, 000h
LDBC0:  DB  0D4h, 0A2h, 084h, 000h, 041h, 040h, 047h, 008h
LDBC8:  DB  0DDh, 000h, 047h, 020h, 000h, 000h, 07Dh, 001h
LDBD0:  DB  059h, 0A4h, 0C0h, 031h, 000h, 000h, 000h, 008h
LDBD8:  DB  021h, 000h, 047h, 000h, 000h, 000h, 09Dh, 000h
LDBE0:  DB  0CAh, 085h, 0C0h, 02Ch, 000h, 000h, 000h, 008h
LDBE8:  DB  021h, 000h, 099h, 000h, 000h, 000h, 0B1h, 000h
LDBF0:  DB  05Ch, 084h, 089h, 03Ch, 033h, 030h, 03Ch, 008h
LDBF8:  DB  0C9h, 000h, 0B9h, 020h, 000h, 000h, 066h, 001h
LDC00:  DB  0A5h, 0ADh, 080h, 000h, 000h, 040h, 046h, 000h
LDC08:  DB  0C9h, 000h, 08Bh, 020h, 000h, 000h, 056h, 001h
LDC10:  DB  0E4h, 0ACh, 080h, 040h, 000h, 046h, 000h, 008h
LDC18:  DB  07Fh, 000h, 06Bh, 000h, 040h, 001h, 0BCh, 000h
LDC20:  DB  001h, 0AFh, 080h, 042h, 000h, 000h, 03Ch, 000h
LDC28:  DB  07Fh, 000h, 028h, 002h, 000h, 000h, 04Fh, 001h
LDC30:  DB  052h, 0B0h, 080h, 000h, 05Eh, 03Ch, 000h, 008h
LDC38:  DB  0FFh, 000h, 048h, 020h, 000h, 000h, 047h, 001h
LDC40:  DB  03Eh, 0B6h, 080h, 000h, 000h, 000h, 000h, 000h
LDC48:  DB  07Fh, 000h, 029h, 080h, 055h, 028h, 084h, 001h
LDC50:  DB  0F8h, 02Bh, 080h, 008h, 00Ah, 000h, 010h, 008h
LDC58:  DB  07Fh, 000h, 02Ah, 000h, 000h, 000h, 0B5h, 000h
LDC60:  DB  089h, 077h, 080h, 03Eh, 03Dh, 044h, 000h, 000h
LDC68:  DB  0D5h, 000h, 04Ah, 020h, 000h, 000h, 073h, 001h
LDC70:  DB  0B9h, 078h, 080h, 044h, 000h, 000h, 045h, 000h
LDC78:  DB  049h, 000h, 04Ah, 000h, 000h, 000h, 085h, 001h
LDC80:  DB  0F8h, 079h, 080h, 045h, 044h, 000h, 000h, 000h
LDC88:  DB  049h, 000h, 04Ah, 000h, 000h, 000h, 037h, 001h
LDC90:  DB  09Fh, 0B1h, 080h, 000h, 000h, 042h, 03Ch, 008h
LDC98:  DB  07Fh, 000h, 048h, 000h, 000h, 000h, 02Bh, 001h
LDCA0:  DB  0D2h, 0B2h, 0C0h, 031h, 000h, 000h, 000h, 008h
LDCA8:  DB  021h, 000h, 048h, 000h, 000h, 000h, 0BBh, 000h
LDCB0:  DB  09Ch, 0B3h, 088h, 03Ch, 042h, 034h, 018h, 008h
LDCB8:  DB  04Bh, 000h, 048h, 000h, 000h, 000h, 0D9h, 000h
LDCC0:  DB  0C1h, 070h, 080h, 03Eh, 043h, 03Dh, 000h, 000h
LDCC8:  DB  0F1h, 000h, 049h, 000h, 000h, 000h, 0AAh, 001h
LDCD0:  DB  01Eh, 072h, 080h, 03Eh, 000h, 03Dh, 000h, 000h
LDCD8:  DB  0F1h, 000h, 049h, 000h, 000h, 000h, 091h, 001h
LDCE0:  DB  067h, 073h, 0C0h, 031h, 000h, 000h, 000h, 000h
LDCE8:  DB  021h, 000h, 049h, 000h, 000h, 000h, 002h, 001h
LDCF0:  DB  091h, 0B8h, 080h, 000h, 037h, 044h, 000h, 008h
LDCF8:  DB  089h, 000h, 049h, 000h, 000h, 000h, 084h, 001h
LDD00:  DB  084h, 045h, 040h, 01Dh, 000h, 000h, 000h, 008h
LDD08:  DB  023h, 000h, 000h, 010h, 000h, 006h, 0EBh, 000h
LDD10:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD18:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD20:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD28:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD30:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD38:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD40:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD48:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD50:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD58:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD60:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD68:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD70:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD78:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD80:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD88:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD90:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDD98:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDDA0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDDA8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDDB0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDDB8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDDC0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDDC8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDDD0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDDD8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDDE0:  DB  030h, 06Ch, 080h, 000h, 000h, 000h, 000h, 000h
LDDE8:  DB  07Fh, 000h, 025h, 080h, 052h, 02Dh, 062h, 001h

; ---------------------------------------------------
;                   Garbage
; ---------------------------------------------------
LDDF0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDDF8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE00:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE08:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE10:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE18:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE20:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE28:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE30:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE38:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE40:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE48:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE50:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE58:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE60:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE68:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE70:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE78:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE80:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE88:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE90:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDE98:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDEA0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDEA8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDEB0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDEB8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDEC0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDEC8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDED0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDED8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDEE0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDEE8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDEF0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDEF8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF00:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF08:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF10:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF18:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF20:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF28:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF30:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF38:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF40:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF48:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF50:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF58:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF60:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF68:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF70:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF78:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF80:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF88:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF90:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDF98:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDFA0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDFA8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDFB0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDFB8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDFC0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDFC8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDFD0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDFD8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDFE0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDFE8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDFF0:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
LDFF8:  DB  0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh

     






















                                                                     























                                         